import { defineComponent as je, ref as B, watch as oe, onMounted as dt, createVNode as D, isVNode as pt, computed as V, inject as ht, reactive as mt } from "vue";
import { isPlainObject as we, cloneDeep as yt } from "lodash-es";
import { FButtonEdit as gt } from "../button-edit/index.esm.js";
import bt, { FLayoutPane as Ee } from "../layout/index.esm.js";
import wt from "../tree-view/index.esm.js";
import Et from "../data-grid/index.esm.js";
import { FLoadingService as St } from "../loading/index.esm.js";
import { F_NOTIFY_SERVICE_TOKEN as Rt } from "../notify/index.esm.js";
import { withInstall as Tt } from "../common/index.esm.js";
const Ot = {}, Ct = {};
function Ue(e) {
  const { properties: t, title: n, ignore: r } = e, o = r && Array.isArray(r), s = Object.keys(t).reduce((i, u) => ((!o || !r.find((d) => d === u)) && (i[u] = t[u].type === "object" && t[u].properties ? Ue(t[u]) : yt(t[u].default)), i), {});
  if (n && (!o || !r.find((i) => i === "id"))) {
    const i = n.toLowerCase().replace(/-/g, "_");
    s.id = `${i}_${Math.random().toString().slice(2, 6)}`;
  }
  return s;
}
function Nt(e, t) {
  const n = Ue(t);
  return Object.keys(n).reduce((r, o) => (Object.prototype.hasOwnProperty.call(e, o) && (r[o] && we(r[o]) && we(e[o] || !e[o]) ? Object.assign(r[o], e[o] || {}) : r[o] = e[o]), r), n), n;
}
function Me(e, t) {
  return Object.keys(e).filter((r) => e[r] != null).reduce((r, o) => {
    if (t.has(o)) {
      const s = t.get(o);
      if (typeof s == "string")
        r[s] = e[o];
      else {
        const i = s(o, e[o], e);
        Object.assign(r, i);
      }
    } else
      r[o] = e[o];
    return r;
  }, {});
}
function At(e, t, n = /* @__PURE__ */ new Map()) {
  const r = Nt(e, t);
  return Me(r, n);
}
function xt(e = {}) {
  function t(a, l, f, m) {
    if (typeof f == "number")
      return m[a].length === f;
    if (typeof f == "object") {
      const y = Object.keys(f)[0], p = f[y];
      if (y === "not")
        return Number(m[a].length) !== Number(p);
      if (y === "moreThan")
        return Number(m[a].length) >= Number(p);
      if (y === "lessThan")
        return Number(m[a].length) <= Number(p);
    }
    return !1;
  }
  function n(a, l, f, m) {
    return m[a] && m[a].propertyValue && String(m[a].propertyValue.value) === String(f);
  }
  const r = /* @__PURE__ */ new Map([
    ["length", t],
    ["getProperty", n]
  ]);
  Object.keys(e).reduce((a, l) => (a.set(l, e[l]), a), r);
  function o(a, l) {
    const f = a;
    return typeof l == "number" ? [{ target: f, operator: "length", param: null, value: Number(l) }] : typeof l == "boolean" ? [{ target: f, operator: "getProperty", param: a, value: !!l }] : typeof l == "object" ? Object.keys(l).map((m) => {
      if (m === "length")
        return { target: f, operator: "length", param: null, value: l[m] };
      const y = m, p = l[m];
      return { target: f, operator: "getProperty", param: y, value: p };
    }) : [];
  }
  function s(a) {
    return Object.keys(a).reduce((f, m) => {
      const y = o(m, a[m]);
      return f.push(...y), f;
    }, []);
  }
  function i(a, l) {
    if (r.has(a.operator)) {
      const f = r.get(a.operator);
      return f && f(a.target, a.param, a.value, l) || !1;
    }
    return !1;
  }
  function u(a, l) {
    return s(a).reduce((y, p) => y && i(p, l), !0);
  }
  function d(a, l) {
    const f = Object.keys(a), m = f.includes("allOf"), y = f.includes("anyOf"), p = m || y, S = (p ? a[p ? m ? "allOf" : "anyOf" : "allOf"] : [a]).map((E) => u(E, l));
    return m ? !S.includes(!1) : S.includes(!0);
  }
  return { parseValueSchema: d };
}
const Pt = {}, Lt = {};
xt();
function Dt(e, t, n = /* @__PURE__ */ new Map(), r = (i, u, d, a) => u, o = {}, s = (i) => i) {
  return Ot[t.title] = t, Ct[t.title] = r, Pt[t.title] = o, Lt[t.title] = s, (i = {}, u = !0) => {
    if (!u)
      return Me(i, n);
    const d = At(i, t, n), a = Object.keys(e).reduce((l, f) => (l[f] = e[f].default, l), {});
    return Object.assign(a, d);
  };
}
const Ft = "https://json-schema.org/draft/2020-12/schema", _t = "https://farris-design.gitee.io/menu-lookup.schema.json", Bt = "menu-lookup", kt = "A Farris Component", jt = "object", Ut = {
  type: {
    description: "The type string of menu-lookup",
    type: "string",
    default: "menu-lookup"
  },
  targetType: {
    description: "",
    type: "string",
    enum: [
      "menu",
      "app"
    ],
    default: "menu"
  },
  fetchNodeApi: {
    description: "",
    type: "function"
  }
}, Mt = [
  "type",
  "fetchNodeApi"
], vt = [], qt = {
  $schema: Ft,
  $id: _t,
  title: Bt,
  description: kt,
  type: jt,
  properties: Ut,
  required: Mt,
  ignore: vt
}, It = /* @__PURE__ */ new Map([]);
function Ht(e, t, n) {
  return t;
}
const ve = {
  /** 选择的目标类型 */
  targetType: { type: String, default: "menu" },
  /** 获取“菜单树”或“应用树”数据的接口地址 */
  fetchNodeApi: { type: [String, Function], require: !0 },
  /** 组件值 */
  modelValue: { type: String, default: "" }
}, zt = Dt(ve, qt, It, Ht), Vt = {
  targetType: { type: String, default: "menu" },
  useTreeGridCoordinatorComposition: { type: Object, default: {} }
};
function Se(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !pt(e);
}
const Gt = /* @__PURE__ */ je({
  name: "FMenuLookupModalContainer",
  props: Vt,
  emits: [],
  setup(e) {
    const t = B(), n = B(), {
      treeData: r,
      gridData: o,
      onNavTreeExpandNode: s,
      onNavTreeSelectionChange: i,
      onDataGridSelectionChange: u,
      onDataGridUnSelectItem: d,
      initialize: a
    } = e.useTreeGridCoordinatorComposition, l = {
      parentIdField: "parentId",
      collapseField: "collapse",
      hasChildrenField: "hasChildren"
    }, f = {
      enableSelectRow: !0,
      clearSelectionOnEmpty: !0,
      keepSelectingOnClick: !1,
      keepSelectingOnPaging: !1,
      multiSelect: !1,
      showCheckbox: !1
    }, m = [{
      field: "code",
      title: "编号",
      dataType: "string",
      resizable: !0
    }, {
      field: "name",
      title: "名称",
      dataType: "string",
      resizable: !0
    }], y = [{
      field: "code",
      title: "编号",
      dataType: "string",
      resizable: !0
    }, {
      field: "name",
      title: "名称",
      dataType: "string",
      resizable: !0
    }, {
      field: "appEntrance",
      title: "入口",
      dataType: "string",
      resizable: !0
    }], p = e.targetType === "app" ? y : m;
    function b() {
      t.value && t.value.updateDataSource(r.value);
    }
    oe(r, b);
    function h() {
      n.value && n.value.updateDataSource(o.value);
    }
    oe(o, h);
    function S() {
      return D(wt, {
        ref: t,
        data: r.value,
        hierarchy: l,
        virtualized: !1,
        onSelectionChange: i,
        onExpandNode: s
      }, null);
    }
    function g({
      cell: T
    }) {
      return D("span", {
        title: T.data ?? ""
      }, [T.data]);
    }
    function E() {
      return D(Et, {
        ref: n,
        columns: p,
        data: o.value,
        fit: !0,
        showStripe: !1,
        columnOption: {
          fitColumns: !0
        },
        rowNumber: {
          enable: !1
        },
        selection: f,
        virtualized: !0,
        onSelectionChange: u,
        onUnSelectItem: d
      }, {
        cellTemplate: g
      });
    }
    return dt(() => {
      a();
    }), () => {
      let T, R;
      return D(bt, null, {
        default: () => [D(Ee, {
          position: "left",
          width: 300,
          "min-width": 200
        }, Se(T = S()) ? T : {
          default: () => [T]
        }), D(Ee, {
          position: "center",
          "min-width": 400
        }, Se(R = E()) ? R : {
          default: () => [R]
        })]
      });
    };
  }
});
function qe(e, t) {
  return function() {
    return e.apply(t, arguments);
  };
}
const { toString: Jt } = Object.prototype, { getPrototypeOf: pe } = Object, X = /* @__PURE__ */ ((e) => (t) => {
  const n = Jt.call(t);
  return e[n] || (e[n] = n.slice(8, -1).toLowerCase());
})(/* @__PURE__ */ Object.create(null)), x = (e) => (e = e.toLowerCase(), (t) => X(t) === e), K = (e) => (t) => typeof t === e, { isArray: M } = Array, I = K("undefined");
function $t(e) {
  return e !== null && !I(e) && e.constructor !== null && !I(e.constructor) && A(e.constructor.isBuffer) && e.constructor.isBuffer(e);
}
const Ie = x("ArrayBuffer");
function Wt(e) {
  let t;
  return typeof ArrayBuffer < "u" && ArrayBuffer.isView ? t = ArrayBuffer.isView(e) : t = e && e.buffer && Ie(e.buffer), t;
}
const Xt = K("string"), A = K("function"), He = K("number"), Q = (e) => e !== null && typeof e == "object", Kt = (e) => e === !0 || e === !1, G = (e) => {
  if (X(e) !== "object")
    return !1;
  const t = pe(e);
  return (t === null || t === Object.prototype || Object.getPrototypeOf(t) === null) && !(Symbol.toStringTag in e) && !(Symbol.iterator in e);
}, Qt = x("Date"), Zt = x("File"), Yt = x("Blob"), en = x("FileList"), tn = (e) => Q(e) && A(e.pipe), nn = (e) => {
  let t;
  return e && (typeof FormData == "function" && e instanceof FormData || A(e.append) && ((t = X(e)) === "formdata" || // detect form-data instance
  t === "object" && A(e.toString) && e.toString() === "[object FormData]"));
}, rn = x("URLSearchParams"), [on, sn, an, cn] = ["ReadableStream", "Request", "Response", "Headers"].map(x), un = (e) => e.trim ? e.trim() : e.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
function H(e, t, { allOwnKeys: n = !1 } = {}) {
  if (e === null || typeof e > "u")
    return;
  let r, o;
  if (typeof e != "object" && (e = [e]), M(e))
    for (r = 0, o = e.length; r < o; r++)
      t.call(null, e[r], r, e);
  else {
    const s = n ? Object.getOwnPropertyNames(e) : Object.keys(e), i = s.length;
    let u;
    for (r = 0; r < i; r++)
      u = s[r], t.call(null, e[u], u, e);
  }
}
function ze(e, t) {
  t = t.toLowerCase();
  const n = Object.keys(e);
  let r = n.length, o;
  for (; r-- > 0; )
    if (o = n[r], t === o.toLowerCase())
      return o;
  return null;
}
const k = typeof globalThis < "u" ? globalThis : typeof self < "u" ? self : typeof window < "u" ? window : global, Ve = (e) => !I(e) && e !== k;
function se() {
  const { caseless: e } = Ve(this) && this || {}, t = {}, n = (r, o) => {
    const s = e && ze(t, o) || o;
    G(t[s]) && G(r) ? t[s] = se(t[s], r) : G(r) ? t[s] = se({}, r) : M(r) ? t[s] = r.slice() : t[s] = r;
  };
  for (let r = 0, o = arguments.length; r < o; r++)
    arguments[r] && H(arguments[r], n);
  return t;
}
const ln = (e, t, n, { allOwnKeys: r } = {}) => (H(t, (o, s) => {
  n && A(o) ? e[s] = qe(o, n) : e[s] = o;
}, { allOwnKeys: r }), e), fn = (e) => (e.charCodeAt(0) === 65279 && (e = e.slice(1)), e), dn = (e, t, n, r) => {
  e.prototype = Object.create(t.prototype, r), e.prototype.constructor = e, Object.defineProperty(e, "super", {
    value: t.prototype
  }), n && Object.assign(e.prototype, n);
}, pn = (e, t, n, r) => {
  let o, s, i;
  const u = {};
  if (t = t || {}, e == null) return t;
  do {
    for (o = Object.getOwnPropertyNames(e), s = o.length; s-- > 0; )
      i = o[s], (!r || r(i, e, t)) && !u[i] && (t[i] = e[i], u[i] = !0);
    e = n !== !1 && pe(e);
  } while (e && (!n || n(e, t)) && e !== Object.prototype);
  return t;
}, hn = (e, t, n) => {
  e = String(e), (n === void 0 || n > e.length) && (n = e.length), n -= t.length;
  const r = e.indexOf(t, n);
  return r !== -1 && r === n;
}, mn = (e) => {
  if (!e) return null;
  if (M(e)) return e;
  let t = e.length;
  if (!He(t)) return null;
  const n = new Array(t);
  for (; t-- > 0; )
    n[t] = e[t];
  return n;
}, yn = /* @__PURE__ */ ((e) => (t) => e && t instanceof e)(typeof Uint8Array < "u" && pe(Uint8Array)), gn = (e, t) => {
  const r = (e && e[Symbol.iterator]).call(e);
  let o;
  for (; (o = r.next()) && !o.done; ) {
    const s = o.value;
    t.call(e, s[0], s[1]);
  }
}, bn = (e, t) => {
  let n;
  const r = [];
  for (; (n = e.exec(t)) !== null; )
    r.push(n);
  return r;
}, wn = x("HTMLFormElement"), En = (e) => e.toLowerCase().replace(
  /[-_\s]([a-z\d])(\w*)/g,
  function(n, r, o) {
    return r.toUpperCase() + o;
  }
), Re = (({ hasOwnProperty: e }) => (t, n) => e.call(t, n))(Object.prototype), Sn = x("RegExp"), Ge = (e, t) => {
  const n = Object.getOwnPropertyDescriptors(e), r = {};
  H(n, (o, s) => {
    let i;
    (i = t(o, s, e)) !== !1 && (r[s] = i || o);
  }), Object.defineProperties(e, r);
}, Rn = (e) => {
  Ge(e, (t, n) => {
    if (A(e) && ["arguments", "caller", "callee"].indexOf(n) !== -1)
      return !1;
    const r = e[n];
    if (A(r)) {
      if (t.enumerable = !1, "writable" in t) {
        t.writable = !1;
        return;
      }
      t.set || (t.set = () => {
        throw Error("Can not rewrite read-only method '" + n + "'");
      });
    }
  });
}, Tn = (e, t) => {
  const n = {}, r = (o) => {
    o.forEach((s) => {
      n[s] = !0;
    });
  };
  return M(e) ? r(e) : r(String(e).split(t)), n;
}, On = () => {
}, Cn = (e, t) => e != null && Number.isFinite(e = +e) ? e : t, ee = "abcdefghijklmnopqrstuvwxyz", Te = "0123456789", Je = {
  DIGIT: Te,
  ALPHA: ee,
  ALPHA_DIGIT: ee + ee.toUpperCase() + Te
}, Nn = (e = 16, t = Je.ALPHA_DIGIT) => {
  let n = "";
  const { length: r } = t;
  for (; e--; )
    n += t[Math.random() * r | 0];
  return n;
};
function An(e) {
  return !!(e && A(e.append) && e[Symbol.toStringTag] === "FormData" && e[Symbol.iterator]);
}
const xn = (e) => {
  const t = new Array(10), n = (r, o) => {
    if (Q(r)) {
      if (t.indexOf(r) >= 0)
        return;
      if (!("toJSON" in r)) {
        t[o] = r;
        const s = M(r) ? [] : {};
        return H(r, (i, u) => {
          const d = n(i, o + 1);
          !I(d) && (s[u] = d);
        }), t[o] = void 0, s;
      }
    }
    return r;
  };
  return n(e, 0);
}, Pn = x("AsyncFunction"), Ln = (e) => e && (Q(e) || A(e)) && A(e.then) && A(e.catch), $e = ((e, t) => e ? setImmediate : t ? ((n, r) => (k.addEventListener("message", ({ source: o, data: s }) => {
  o === k && s === n && r.length && r.shift()();
}, !1), (o) => {
  r.push(o), k.postMessage(n, "*");
}))(`axios@${Math.random()}`, []) : (n) => setTimeout(n))(
  typeof setImmediate == "function",
  A(k.postMessage)
), Dn = typeof queueMicrotask < "u" ? queueMicrotask.bind(k) : typeof process < "u" && process.nextTick || $e, c = {
  isArray: M,
  isArrayBuffer: Ie,
  isBuffer: $t,
  isFormData: nn,
  isArrayBufferView: Wt,
  isString: Xt,
  isNumber: He,
  isBoolean: Kt,
  isObject: Q,
  isPlainObject: G,
  isReadableStream: on,
  isRequest: sn,
  isResponse: an,
  isHeaders: cn,
  isUndefined: I,
  isDate: Qt,
  isFile: Zt,
  isBlob: Yt,
  isRegExp: Sn,
  isFunction: A,
  isStream: tn,
  isURLSearchParams: rn,
  isTypedArray: yn,
  isFileList: en,
  forEach: H,
  merge: se,
  extend: ln,
  trim: un,
  stripBOM: fn,
  inherits: dn,
  toFlatObject: pn,
  kindOf: X,
  kindOfTest: x,
  endsWith: hn,
  toArray: mn,
  forEachEntry: gn,
  matchAll: bn,
  isHTMLForm: wn,
  hasOwnProperty: Re,
  hasOwnProp: Re,
  // an alias to avoid ESLint no-prototype-builtins detection
  reduceDescriptors: Ge,
  freezeMethods: Rn,
  toObjectSet: Tn,
  toCamelCase: En,
  noop: On,
  toFiniteNumber: Cn,
  findKey: ze,
  global: k,
  isContextDefined: Ve,
  ALPHABET: Je,
  generateString: Nn,
  isSpecCompliantForm: An,
  toJSONObject: xn,
  isAsyncFn: Pn,
  isThenable: Ln,
  setImmediate: $e,
  asap: Dn
};
function w(e, t, n, r, o) {
  Error.call(this), Error.captureStackTrace ? Error.captureStackTrace(this, this.constructor) : this.stack = new Error().stack, this.message = e, this.name = "AxiosError", t && (this.code = t), n && (this.config = n), r && (this.request = r), o && (this.response = o, this.status = o.status ? o.status : null);
}
c.inherits(w, Error, {
  toJSON: function() {
    return {
      // Standard
      message: this.message,
      name: this.name,
      // Microsoft
      description: this.description,
      number: this.number,
      // Mozilla
      fileName: this.fileName,
      lineNumber: this.lineNumber,
      columnNumber: this.columnNumber,
      stack: this.stack,
      // Axios
      config: c.toJSONObject(this.config),
      code: this.code,
      status: this.status
    };
  }
});
const We = w.prototype, Xe = {};
[
  "ERR_BAD_OPTION_VALUE",
  "ERR_BAD_OPTION",
  "ECONNABORTED",
  "ETIMEDOUT",
  "ERR_NETWORK",
  "ERR_FR_TOO_MANY_REDIRECTS",
  "ERR_DEPRECATED",
  "ERR_BAD_RESPONSE",
  "ERR_BAD_REQUEST",
  "ERR_CANCELED",
  "ERR_NOT_SUPPORT",
  "ERR_INVALID_URL"
  // eslint-disable-next-line func-names
].forEach((e) => {
  Xe[e] = { value: e };
});
Object.defineProperties(w, Xe);
Object.defineProperty(We, "isAxiosError", { value: !0 });
w.from = (e, t, n, r, o, s) => {
  const i = Object.create(We);
  return c.toFlatObject(e, i, function(d) {
    return d !== Error.prototype;
  }, (u) => u !== "isAxiosError"), w.call(i, e.message, t, n, r, o), i.cause = e, i.name = e.name, s && Object.assign(i, s), i;
};
const Fn = null;
function ie(e) {
  return c.isPlainObject(e) || c.isArray(e);
}
function Ke(e) {
  return c.endsWith(e, "[]") ? e.slice(0, -2) : e;
}
function Oe(e, t, n) {
  return e ? e.concat(t).map(function(o, s) {
    return o = Ke(o), !n && s ? "[" + o + "]" : o;
  }).join(n ? "." : "") : t;
}
function _n(e) {
  return c.isArray(e) && !e.some(ie);
}
const Bn = c.toFlatObject(c, {}, null, function(t) {
  return /^is[A-Z]/.test(t);
});
function Z(e, t, n) {
  if (!c.isObject(e))
    throw new TypeError("target must be an object");
  t = t || new FormData(), n = c.toFlatObject(n, {
    metaTokens: !0,
    dots: !1,
    indexes: !1
  }, !1, function(b, h) {
    return !c.isUndefined(h[b]);
  });
  const r = n.metaTokens, o = n.visitor || l, s = n.dots, i = n.indexes, d = (n.Blob || typeof Blob < "u" && Blob) && c.isSpecCompliantForm(t);
  if (!c.isFunction(o))
    throw new TypeError("visitor must be a function");
  function a(p) {
    if (p === null) return "";
    if (c.isDate(p))
      return p.toISOString();
    if (!d && c.isBlob(p))
      throw new w("Blob is not supported. Use a Buffer instead.");
    return c.isArrayBuffer(p) || c.isTypedArray(p) ? d && typeof Blob == "function" ? new Blob([p]) : Buffer.from(p) : p;
  }
  function l(p, b, h) {
    let S = p;
    if (p && !h && typeof p == "object") {
      if (c.endsWith(b, "{}"))
        b = r ? b : b.slice(0, -2), p = JSON.stringify(p);
      else if (c.isArray(p) && _n(p) || (c.isFileList(p) || c.endsWith(b, "[]")) && (S = c.toArray(p)))
        return b = Ke(b), S.forEach(function(E, T) {
          !(c.isUndefined(E) || E === null) && t.append(
            // eslint-disable-next-line no-nested-ternary
            i === !0 ? Oe([b], T, s) : i === null ? b : b + "[]",
            a(E)
          );
        }), !1;
    }
    return ie(p) ? !0 : (t.append(Oe(h, b, s), a(p)), !1);
  }
  const f = [], m = Object.assign(Bn, {
    defaultVisitor: l,
    convertValue: a,
    isVisitable: ie
  });
  function y(p, b) {
    if (!c.isUndefined(p)) {
      if (f.indexOf(p) !== -1)
        throw Error("Circular reference detected in " + b.join("."));
      f.push(p), c.forEach(p, function(S, g) {
        (!(c.isUndefined(S) || S === null) && o.call(
          t,
          S,
          c.isString(g) ? g.trim() : g,
          b,
          m
        )) === !0 && y(S, b ? b.concat(g) : [g]);
      }), f.pop();
    }
  }
  if (!c.isObject(e))
    throw new TypeError("data must be an object");
  return y(e), t;
}
function Ce(e) {
  const t = {
    "!": "%21",
    "'": "%27",
    "(": "%28",
    ")": "%29",
    "~": "%7E",
    "%20": "+",
    "%00": "\0"
  };
  return encodeURIComponent(e).replace(/[!'()~]|%20|%00/g, function(r) {
    return t[r];
  });
}
function he(e, t) {
  this._pairs = [], e && Z(e, this, t);
}
const Qe = he.prototype;
Qe.append = function(t, n) {
  this._pairs.push([t, n]);
};
Qe.toString = function(t) {
  const n = t ? function(r) {
    return t.call(this, r, Ce);
  } : Ce;
  return this._pairs.map(function(o) {
    return n(o[0]) + "=" + n(o[1]);
  }, "").join("&");
};
function kn(e) {
  return encodeURIComponent(e).replace(/%3A/gi, ":").replace(/%24/g, "$").replace(/%2C/gi, ",").replace(/%20/g, "+").replace(/%5B/gi, "[").replace(/%5D/gi, "]");
}
function Ze(e, t, n) {
  if (!t)
    return e;
  const r = n && n.encode || kn, o = n && n.serialize;
  let s;
  if (o ? s = o(t, n) : s = c.isURLSearchParams(t) ? t.toString() : new he(t, n).toString(r), s) {
    const i = e.indexOf("#");
    i !== -1 && (e = e.slice(0, i)), e += (e.indexOf("?") === -1 ? "?" : "&") + s;
  }
  return e;
}
class Ne {
  constructor() {
    this.handlers = [];
  }
  /**
   * Add a new interceptor to the stack
   *
   * @param {Function} fulfilled The function to handle `then` for a `Promise`
   * @param {Function} rejected The function to handle `reject` for a `Promise`
   *
   * @return {Number} An ID used to remove interceptor later
   */
  use(t, n, r) {
    return this.handlers.push({
      fulfilled: t,
      rejected: n,
      synchronous: r ? r.synchronous : !1,
      runWhen: r ? r.runWhen : null
    }), this.handlers.length - 1;
  }
  /**
   * Remove an interceptor from the stack
   *
   * @param {Number} id The ID that was returned by `use`
   *
   * @returns {Boolean} `true` if the interceptor was removed, `false` otherwise
   */
  eject(t) {
    this.handlers[t] && (this.handlers[t] = null);
  }
  /**
   * Clear all interceptors from the stack
   *
   * @returns {void}
   */
  clear() {
    this.handlers && (this.handlers = []);
  }
  /**
   * Iterate over all the registered interceptors
   *
   * This method is particularly useful for skipping over any
   * interceptors that may have become `null` calling `eject`.
   *
   * @param {Function} fn The function to call for each interceptor
   *
   * @returns {void}
   */
  forEach(t) {
    c.forEach(this.handlers, function(r) {
      r !== null && t(r);
    });
  }
}
const Ye = {
  silentJSONParsing: !0,
  forcedJSONParsing: !0,
  clarifyTimeoutError: !1
}, jn = typeof URLSearchParams < "u" ? URLSearchParams : he, Un = typeof FormData < "u" ? FormData : null, Mn = typeof Blob < "u" ? Blob : null, vn = {
  isBrowser: !0,
  classes: {
    URLSearchParams: jn,
    FormData: Un,
    Blob: Mn
  },
  protocols: ["http", "https", "file", "blob", "url", "data"]
}, me = typeof window < "u" && typeof document < "u", ae = typeof navigator == "object" && navigator || void 0, qn = me && (!ae || ["ReactNative", "NativeScript", "NS"].indexOf(ae.product) < 0), In = typeof WorkerGlobalScope < "u" && // eslint-disable-next-line no-undef
self instanceof WorkerGlobalScope && typeof self.importScripts == "function", Hn = me && window.location.href || "http://localhost", zn = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  hasBrowserEnv: me,
  hasStandardBrowserEnv: qn,
  hasStandardBrowserWebWorkerEnv: In,
  navigator: ae,
  origin: Hn
}, Symbol.toStringTag, { value: "Module" })), C = {
  ...zn,
  ...vn
};
function Vn(e, t) {
  return Z(e, new C.classes.URLSearchParams(), Object.assign({
    visitor: function(n, r, o, s) {
      return C.isNode && c.isBuffer(n) ? (this.append(r, n.toString("base64")), !1) : s.defaultVisitor.apply(this, arguments);
    }
  }, t));
}
function Gn(e) {
  return c.matchAll(/\w+|\[(\w*)]/g, e).map((t) => t[0] === "[]" ? "" : t[1] || t[0]);
}
function Jn(e) {
  const t = {}, n = Object.keys(e);
  let r;
  const o = n.length;
  let s;
  for (r = 0; r < o; r++)
    s = n[r], t[s] = e[s];
  return t;
}
function et(e) {
  function t(n, r, o, s) {
    let i = n[s++];
    if (i === "__proto__") return !0;
    const u = Number.isFinite(+i), d = s >= n.length;
    return i = !i && c.isArray(o) ? o.length : i, d ? (c.hasOwnProp(o, i) ? o[i] = [o[i], r] : o[i] = r, !u) : ((!o[i] || !c.isObject(o[i])) && (o[i] = []), t(n, r, o[i], s) && c.isArray(o[i]) && (o[i] = Jn(o[i])), !u);
  }
  if (c.isFormData(e) && c.isFunction(e.entries)) {
    const n = {};
    return c.forEachEntry(e, (r, o) => {
      t(Gn(r), o, n, 0);
    }), n;
  }
  return null;
}
function $n(e, t, n) {
  if (c.isString(e))
    try {
      return (t || JSON.parse)(e), c.trim(e);
    } catch (r) {
      if (r.name !== "SyntaxError")
        throw r;
    }
  return (0, JSON.stringify)(e);
}
const z = {
  transitional: Ye,
  adapter: ["xhr", "http", "fetch"],
  transformRequest: [function(t, n) {
    const r = n.getContentType() || "", o = r.indexOf("application/json") > -1, s = c.isObject(t);
    if (s && c.isHTMLForm(t) && (t = new FormData(t)), c.isFormData(t))
      return o ? JSON.stringify(et(t)) : t;
    if (c.isArrayBuffer(t) || c.isBuffer(t) || c.isStream(t) || c.isFile(t) || c.isBlob(t) || c.isReadableStream(t))
      return t;
    if (c.isArrayBufferView(t))
      return t.buffer;
    if (c.isURLSearchParams(t))
      return n.setContentType("application/x-www-form-urlencoded;charset=utf-8", !1), t.toString();
    let u;
    if (s) {
      if (r.indexOf("application/x-www-form-urlencoded") > -1)
        return Vn(t, this.formSerializer).toString();
      if ((u = c.isFileList(t)) || r.indexOf("multipart/form-data") > -1) {
        const d = this.env && this.env.FormData;
        return Z(
          u ? { "files[]": t } : t,
          d && new d(),
          this.formSerializer
        );
      }
    }
    return s || o ? (n.setContentType("application/json", !1), $n(t)) : t;
  }],
  transformResponse: [function(t) {
    const n = this.transitional || z.transitional, r = n && n.forcedJSONParsing, o = this.responseType === "json";
    if (c.isResponse(t) || c.isReadableStream(t))
      return t;
    if (t && c.isString(t) && (r && !this.responseType || o)) {
      const i = !(n && n.silentJSONParsing) && o;
      try {
        return JSON.parse(t);
      } catch (u) {
        if (i)
          throw u.name === "SyntaxError" ? w.from(u, w.ERR_BAD_RESPONSE, this, null, this.response) : u;
      }
    }
    return t;
  }],
  /**
   * A timeout in milliseconds to abort a request. If set to 0 (default) a
   * timeout is not created.
   */
  timeout: 0,
  xsrfCookieName: "XSRF-TOKEN",
  xsrfHeaderName: "X-XSRF-TOKEN",
  maxContentLength: -1,
  maxBodyLength: -1,
  env: {
    FormData: C.classes.FormData,
    Blob: C.classes.Blob
  },
  validateStatus: function(t) {
    return t >= 200 && t < 300;
  },
  headers: {
    common: {
      Accept: "application/json, text/plain, */*",
      "Content-Type": void 0
    }
  }
};
c.forEach(["delete", "get", "head", "post", "put", "patch"], (e) => {
  z.headers[e] = {};
});
const Wn = c.toObjectSet([
  "age",
  "authorization",
  "content-length",
  "content-type",
  "etag",
  "expires",
  "from",
  "host",
  "if-modified-since",
  "if-unmodified-since",
  "last-modified",
  "location",
  "max-forwards",
  "proxy-authorization",
  "referer",
  "retry-after",
  "user-agent"
]), Xn = (e) => {
  const t = {};
  let n, r, o;
  return e && e.split(`
`).forEach(function(i) {
    o = i.indexOf(":"), n = i.substring(0, o).trim().toLowerCase(), r = i.substring(o + 1).trim(), !(!n || t[n] && Wn[n]) && (n === "set-cookie" ? t[n] ? t[n].push(r) : t[n] = [r] : t[n] = t[n] ? t[n] + ", " + r : r);
  }), t;
}, Ae = Symbol("internals");
function q(e) {
  return e && String(e).trim().toLowerCase();
}
function J(e) {
  return e === !1 || e == null ? e : c.isArray(e) ? e.map(J) : String(e);
}
function Kn(e) {
  const t = /* @__PURE__ */ Object.create(null), n = /([^\s,;=]+)\s*(?:=\s*([^,;]+))?/g;
  let r;
  for (; r = n.exec(e); )
    t[r[1]] = r[2];
  return t;
}
const Qn = (e) => /^[-_a-zA-Z0-9^`|~,!#$%&'*+.]+$/.test(e.trim());
function te(e, t, n, r, o) {
  if (c.isFunction(r))
    return r.call(this, t, n);
  if (o && (t = n), !!c.isString(t)) {
    if (c.isString(r))
      return t.indexOf(r) !== -1;
    if (c.isRegExp(r))
      return r.test(t);
  }
}
function Zn(e) {
  return e.trim().toLowerCase().replace(/([a-z\d])(\w*)/g, (t, n, r) => n.toUpperCase() + r);
}
function Yn(e, t) {
  const n = c.toCamelCase(" " + t);
  ["get", "set", "has"].forEach((r) => {
    Object.defineProperty(e, r + n, {
      value: function(o, s, i) {
        return this[r].call(this, t, o, s, i);
      },
      configurable: !0
    });
  });
}
class N {
  constructor(t) {
    t && this.set(t);
  }
  set(t, n, r) {
    const o = this;
    function s(u, d, a) {
      const l = q(d);
      if (!l)
        throw new Error("header name must be a non-empty string");
      const f = c.findKey(o, l);
      (!f || o[f] === void 0 || a === !0 || a === void 0 && o[f] !== !1) && (o[f || d] = J(u));
    }
    const i = (u, d) => c.forEach(u, (a, l) => s(a, l, d));
    if (c.isPlainObject(t) || t instanceof this.constructor)
      i(t, n);
    else if (c.isString(t) && (t = t.trim()) && !Qn(t))
      i(Xn(t), n);
    else if (c.isHeaders(t))
      for (const [u, d] of t.entries())
        s(d, u, r);
    else
      t != null && s(n, t, r);
    return this;
  }
  get(t, n) {
    if (t = q(t), t) {
      const r = c.findKey(this, t);
      if (r) {
        const o = this[r];
        if (!n)
          return o;
        if (n === !0)
          return Kn(o);
        if (c.isFunction(n))
          return n.call(this, o, r);
        if (c.isRegExp(n))
          return n.exec(o);
        throw new TypeError("parser must be boolean|regexp|function");
      }
    }
  }
  has(t, n) {
    if (t = q(t), t) {
      const r = c.findKey(this, t);
      return !!(r && this[r] !== void 0 && (!n || te(this, this[r], r, n)));
    }
    return !1;
  }
  delete(t, n) {
    const r = this;
    let o = !1;
    function s(i) {
      if (i = q(i), i) {
        const u = c.findKey(r, i);
        u && (!n || te(r, r[u], u, n)) && (delete r[u], o = !0);
      }
    }
    return c.isArray(t) ? t.forEach(s) : s(t), o;
  }
  clear(t) {
    const n = Object.keys(this);
    let r = n.length, o = !1;
    for (; r--; ) {
      const s = n[r];
      (!t || te(this, this[s], s, t, !0)) && (delete this[s], o = !0);
    }
    return o;
  }
  normalize(t) {
    const n = this, r = {};
    return c.forEach(this, (o, s) => {
      const i = c.findKey(r, s);
      if (i) {
        n[i] = J(o), delete n[s];
        return;
      }
      const u = t ? Zn(s) : String(s).trim();
      u !== s && delete n[s], n[u] = J(o), r[u] = !0;
    }), this;
  }
  concat(...t) {
    return this.constructor.concat(this, ...t);
  }
  toJSON(t) {
    const n = /* @__PURE__ */ Object.create(null);
    return c.forEach(this, (r, o) => {
      r != null && r !== !1 && (n[o] = t && c.isArray(r) ? r.join(", ") : r);
    }), n;
  }
  [Symbol.iterator]() {
    return Object.entries(this.toJSON())[Symbol.iterator]();
  }
  toString() {
    return Object.entries(this.toJSON()).map(([t, n]) => t + ": " + n).join(`
`);
  }
  get [Symbol.toStringTag]() {
    return "AxiosHeaders";
  }
  static from(t) {
    return t instanceof this ? t : new this(t);
  }
  static concat(t, ...n) {
    const r = new this(t);
    return n.forEach((o) => r.set(o)), r;
  }
  static accessor(t) {
    const r = (this[Ae] = this[Ae] = {
      accessors: {}
    }).accessors, o = this.prototype;
    function s(i) {
      const u = q(i);
      r[u] || (Yn(o, i), r[u] = !0);
    }
    return c.isArray(t) ? t.forEach(s) : s(t), this;
  }
}
N.accessor(["Content-Type", "Content-Length", "Accept", "Accept-Encoding", "User-Agent", "Authorization"]);
c.reduceDescriptors(N.prototype, ({ value: e }, t) => {
  let n = t[0].toUpperCase() + t.slice(1);
  return {
    get: () => e,
    set(r) {
      this[n] = r;
    }
  };
});
c.freezeMethods(N);
function ne(e, t) {
  const n = this || z, r = t || n, o = N.from(r.headers);
  let s = r.data;
  return c.forEach(e, function(u) {
    s = u.call(n, s, o.normalize(), t ? t.status : void 0);
  }), o.normalize(), s;
}
function tt(e) {
  return !!(e && e.__CANCEL__);
}
function v(e, t, n) {
  w.call(this, e ?? "canceled", w.ERR_CANCELED, t, n), this.name = "CanceledError";
}
c.inherits(v, w, {
  __CANCEL__: !0
});
function nt(e, t, n) {
  const r = n.config.validateStatus;
  !n.status || !r || r(n.status) ? e(n) : t(new w(
    "Request failed with status code " + n.status,
    [w.ERR_BAD_REQUEST, w.ERR_BAD_RESPONSE][Math.floor(n.status / 100) - 4],
    n.config,
    n.request,
    n
  ));
}
function er(e) {
  const t = /^([-+\w]{1,25})(:?\/\/|:)/.exec(e);
  return t && t[1] || "";
}
function tr(e, t) {
  e = e || 10;
  const n = new Array(e), r = new Array(e);
  let o = 0, s = 0, i;
  return t = t !== void 0 ? t : 1e3, function(d) {
    const a = Date.now(), l = r[s];
    i || (i = a), n[o] = d, r[o] = a;
    let f = s, m = 0;
    for (; f !== o; )
      m += n[f++], f = f % e;
    if (o = (o + 1) % e, o === s && (s = (s + 1) % e), a - i < t)
      return;
    const y = l && a - l;
    return y ? Math.round(m * 1e3 / y) : void 0;
  };
}
function nr(e, t) {
  let n = 0, r = 1e3 / t, o, s;
  const i = (a, l = Date.now()) => {
    n = l, o = null, s && (clearTimeout(s), s = null), e.apply(null, a);
  };
  return [(...a) => {
    const l = Date.now(), f = l - n;
    f >= r ? i(a, l) : (o = a, s || (s = setTimeout(() => {
      s = null, i(o);
    }, r - f)));
  }, () => o && i(o)];
}
const $ = (e, t, n = 3) => {
  let r = 0;
  const o = tr(50, 250);
  return nr((s) => {
    const i = s.loaded, u = s.lengthComputable ? s.total : void 0, d = i - r, a = o(d), l = i <= u;
    r = i;
    const f = {
      loaded: i,
      total: u,
      progress: u ? i / u : void 0,
      bytes: d,
      rate: a || void 0,
      estimated: a && u && l ? (u - i) / a : void 0,
      event: s,
      lengthComputable: u != null,
      [t ? "download" : "upload"]: !0
    };
    e(f);
  }, n);
}, xe = (e, t) => {
  const n = e != null;
  return [(r) => t[0]({
    lengthComputable: n,
    total: e,
    loaded: r
  }), t[1]];
}, Pe = (e) => (...t) => c.asap(() => e(...t)), rr = C.hasStandardBrowserEnv ? (
  // Standard browser envs have full support of the APIs needed to test
  // whether the request URL is of the same origin as current location.
  function() {
    const t = C.navigator && /(msie|trident)/i.test(C.navigator.userAgent), n = document.createElement("a");
    let r;
    function o(s) {
      let i = s;
      return t && (n.setAttribute("href", i), i = n.href), n.setAttribute("href", i), {
        href: n.href,
        protocol: n.protocol ? n.protocol.replace(/:$/, "") : "",
        host: n.host,
        search: n.search ? n.search.replace(/^\?/, "") : "",
        hash: n.hash ? n.hash.replace(/^#/, "") : "",
        hostname: n.hostname,
        port: n.port,
        pathname: n.pathname.charAt(0) === "/" ? n.pathname : "/" + n.pathname
      };
    }
    return r = o(window.location.href), function(i) {
      const u = c.isString(i) ? o(i) : i;
      return u.protocol === r.protocol && u.host === r.host;
    };
  }()
) : (
  // Non standard browser envs (web workers, react-native) lack needed support.
  /* @__PURE__ */ function() {
    return function() {
      return !0;
    };
  }()
), or = C.hasStandardBrowserEnv ? (
  // Standard browser envs support document.cookie
  {
    write(e, t, n, r, o, s) {
      const i = [e + "=" + encodeURIComponent(t)];
      c.isNumber(n) && i.push("expires=" + new Date(n).toGMTString()), c.isString(r) && i.push("path=" + r), c.isString(o) && i.push("domain=" + o), s === !0 && i.push("secure"), document.cookie = i.join("; ");
    },
    read(e) {
      const t = document.cookie.match(new RegExp("(^|;\\s*)(" + e + ")=([^;]*)"));
      return t ? decodeURIComponent(t[3]) : null;
    },
    remove(e) {
      this.write(e, "", Date.now() - 864e5);
    }
  }
) : (
  // Non-standard browser env (web workers, react-native) lack needed support.
  {
    write() {
    },
    read() {
      return null;
    },
    remove() {
    }
  }
);
function sr(e) {
  return /^([a-z][a-z\d+\-.]*:)?\/\//i.test(e);
}
function ir(e, t) {
  return t ? e.replace(/\/?\/$/, "") + "/" + t.replace(/^\/+/, "") : e;
}
function rt(e, t) {
  return e && !sr(t) ? ir(e, t) : t;
}
const Le = (e) => e instanceof N ? { ...e } : e;
function U(e, t) {
  t = t || {};
  const n = {};
  function r(a, l, f) {
    return c.isPlainObject(a) && c.isPlainObject(l) ? c.merge.call({ caseless: f }, a, l) : c.isPlainObject(l) ? c.merge({}, l) : c.isArray(l) ? l.slice() : l;
  }
  function o(a, l, f) {
    if (c.isUndefined(l)) {
      if (!c.isUndefined(a))
        return r(void 0, a, f);
    } else return r(a, l, f);
  }
  function s(a, l) {
    if (!c.isUndefined(l))
      return r(void 0, l);
  }
  function i(a, l) {
    if (c.isUndefined(l)) {
      if (!c.isUndefined(a))
        return r(void 0, a);
    } else return r(void 0, l);
  }
  function u(a, l, f) {
    if (f in t)
      return r(a, l);
    if (f in e)
      return r(void 0, a);
  }
  const d = {
    url: s,
    method: s,
    data: s,
    baseURL: i,
    transformRequest: i,
    transformResponse: i,
    paramsSerializer: i,
    timeout: i,
    timeoutMessage: i,
    withCredentials: i,
    withXSRFToken: i,
    adapter: i,
    responseType: i,
    xsrfCookieName: i,
    xsrfHeaderName: i,
    onUploadProgress: i,
    onDownloadProgress: i,
    decompress: i,
    maxContentLength: i,
    maxBodyLength: i,
    beforeRedirect: i,
    transport: i,
    httpAgent: i,
    httpsAgent: i,
    cancelToken: i,
    socketPath: i,
    responseEncoding: i,
    validateStatus: u,
    headers: (a, l) => o(Le(a), Le(l), !0)
  };
  return c.forEach(Object.keys(Object.assign({}, e, t)), function(l) {
    const f = d[l] || o, m = f(e[l], t[l], l);
    c.isUndefined(m) && f !== u || (n[l] = m);
  }), n;
}
const ot = (e) => {
  const t = U({}, e);
  let { data: n, withXSRFToken: r, xsrfHeaderName: o, xsrfCookieName: s, headers: i, auth: u } = t;
  t.headers = i = N.from(i), t.url = Ze(rt(t.baseURL, t.url), e.params, e.paramsSerializer), u && i.set(
    "Authorization",
    "Basic " + btoa((u.username || "") + ":" + (u.password ? unescape(encodeURIComponent(u.password)) : ""))
  );
  let d;
  if (c.isFormData(n)) {
    if (C.hasStandardBrowserEnv || C.hasStandardBrowserWebWorkerEnv)
      i.setContentType(void 0);
    else if ((d = i.getContentType()) !== !1) {
      const [a, ...l] = d ? d.split(";").map((f) => f.trim()).filter(Boolean) : [];
      i.setContentType([a || "multipart/form-data", ...l].join("; "));
    }
  }
  if (C.hasStandardBrowserEnv && (r && c.isFunction(r) && (r = r(t)), r || r !== !1 && rr(t.url))) {
    const a = o && s && or.read(s);
    a && i.set(o, a);
  }
  return t;
}, ar = typeof XMLHttpRequest < "u", cr = ar && function(e) {
  return new Promise(function(n, r) {
    const o = ot(e);
    let s = o.data;
    const i = N.from(o.headers).normalize();
    let { responseType: u, onUploadProgress: d, onDownloadProgress: a } = o, l, f, m, y, p;
    function b() {
      y && y(), p && p(), o.cancelToken && o.cancelToken.unsubscribe(l), o.signal && o.signal.removeEventListener("abort", l);
    }
    let h = new XMLHttpRequest();
    h.open(o.method.toUpperCase(), o.url, !0), h.timeout = o.timeout;
    function S() {
      if (!h)
        return;
      const E = N.from(
        "getAllResponseHeaders" in h && h.getAllResponseHeaders()
      ), R = {
        data: !u || u === "text" || u === "json" ? h.responseText : h.response,
        status: h.status,
        statusText: h.statusText,
        headers: E,
        config: e,
        request: h
      };
      nt(function(P) {
        n(P), b();
      }, function(P) {
        r(P), b();
      }, R), h = null;
    }
    "onloadend" in h ? h.onloadend = S : h.onreadystatechange = function() {
      !h || h.readyState !== 4 || h.status === 0 && !(h.responseURL && h.responseURL.indexOf("file:") === 0) || setTimeout(S);
    }, h.onabort = function() {
      h && (r(new w("Request aborted", w.ECONNABORTED, e, h)), h = null);
    }, h.onerror = function() {
      r(new w("Network Error", w.ERR_NETWORK, e, h)), h = null;
    }, h.ontimeout = function() {
      let T = o.timeout ? "timeout of " + o.timeout + "ms exceeded" : "timeout exceeded";
      const R = o.transitional || Ye;
      o.timeoutErrorMessage && (T = o.timeoutErrorMessage), r(new w(
        T,
        R.clarifyTimeoutError ? w.ETIMEDOUT : w.ECONNABORTED,
        e,
        h
      )), h = null;
    }, s === void 0 && i.setContentType(null), "setRequestHeader" in h && c.forEach(i.toJSON(), function(T, R) {
      h.setRequestHeader(R, T);
    }), c.isUndefined(o.withCredentials) || (h.withCredentials = !!o.withCredentials), u && u !== "json" && (h.responseType = o.responseType), a && ([m, p] = $(a, !0), h.addEventListener("progress", m)), d && h.upload && ([f, y] = $(d), h.upload.addEventListener("progress", f), h.upload.addEventListener("loadend", y)), (o.cancelToken || o.signal) && (l = (E) => {
      h && (r(!E || E.type ? new v(null, e, h) : E), h.abort(), h = null);
    }, o.cancelToken && o.cancelToken.subscribe(l), o.signal && (o.signal.aborted ? l() : o.signal.addEventListener("abort", l)));
    const g = er(o.url);
    if (g && C.protocols.indexOf(g) === -1) {
      r(new w("Unsupported protocol " + g + ":", w.ERR_BAD_REQUEST, e));
      return;
    }
    h.send(s || null);
  });
}, ur = (e, t) => {
  const { length: n } = e = e ? e.filter(Boolean) : [];
  if (t || n) {
    let r = new AbortController(), o;
    const s = function(a) {
      if (!o) {
        o = !0, u();
        const l = a instanceof Error ? a : this.reason;
        r.abort(l instanceof w ? l : new v(l instanceof Error ? l.message : l));
      }
    };
    let i = t && setTimeout(() => {
      i = null, s(new w(`timeout ${t} of ms exceeded`, w.ETIMEDOUT));
    }, t);
    const u = () => {
      e && (i && clearTimeout(i), i = null, e.forEach((a) => {
        a.unsubscribe ? a.unsubscribe(s) : a.removeEventListener("abort", s);
      }), e = null);
    };
    e.forEach((a) => a.addEventListener("abort", s));
    const { signal: d } = r;
    return d.unsubscribe = () => c.asap(u), d;
  }
}, lr = function* (e, t) {
  let n = e.byteLength;
  if (n < t) {
    yield e;
    return;
  }
  let r = 0, o;
  for (; r < n; )
    o = r + t, yield e.slice(r, o), r = o;
}, fr = async function* (e, t) {
  for await (const n of dr(e))
    yield* lr(n, t);
}, dr = async function* (e) {
  if (e[Symbol.asyncIterator]) {
    yield* e;
    return;
  }
  const t = e.getReader();
  try {
    for (; ; ) {
      const { done: n, value: r } = await t.read();
      if (n)
        break;
      yield r;
    }
  } finally {
    await t.cancel();
  }
}, De = (e, t, n, r) => {
  const o = fr(e, t);
  let s = 0, i, u = (d) => {
    i || (i = !0, r && r(d));
  };
  return new ReadableStream({
    async pull(d) {
      try {
        const { done: a, value: l } = await o.next();
        if (a) {
          u(), d.close();
          return;
        }
        let f = l.byteLength;
        if (n) {
          let m = s += f;
          n(m);
        }
        d.enqueue(new Uint8Array(l));
      } catch (a) {
        throw u(a), a;
      }
    },
    cancel(d) {
      return u(d), o.return();
    }
  }, {
    highWaterMark: 2
  });
}, Y = typeof fetch == "function" && typeof Request == "function" && typeof Response == "function", st = Y && typeof ReadableStream == "function", pr = Y && (typeof TextEncoder == "function" ? /* @__PURE__ */ ((e) => (t) => e.encode(t))(new TextEncoder()) : async (e) => new Uint8Array(await new Response(e).arrayBuffer())), it = (e, ...t) => {
  try {
    return !!e(...t);
  } catch {
    return !1;
  }
}, hr = st && it(() => {
  let e = !1;
  const t = new Request(C.origin, {
    body: new ReadableStream(),
    method: "POST",
    get duplex() {
      return e = !0, "half";
    }
  }).headers.has("Content-Type");
  return e && !t;
}), Fe = 64 * 1024, ce = st && it(() => c.isReadableStream(new Response("").body)), W = {
  stream: ce && ((e) => e.body)
};
Y && ((e) => {
  ["text", "arrayBuffer", "blob", "formData", "stream"].forEach((t) => {
    !W[t] && (W[t] = c.isFunction(e[t]) ? (n) => n[t]() : (n, r) => {
      throw new w(`Response type '${t}' is not supported`, w.ERR_NOT_SUPPORT, r);
    });
  });
})(new Response());
const mr = async (e) => {
  if (e == null)
    return 0;
  if (c.isBlob(e))
    return e.size;
  if (c.isSpecCompliantForm(e))
    return (await new Request(C.origin, {
      method: "POST",
      body: e
    }).arrayBuffer()).byteLength;
  if (c.isArrayBufferView(e) || c.isArrayBuffer(e))
    return e.byteLength;
  if (c.isURLSearchParams(e) && (e = e + ""), c.isString(e))
    return (await pr(e)).byteLength;
}, yr = async (e, t) => {
  const n = c.toFiniteNumber(e.getContentLength());
  return n ?? mr(t);
}, gr = Y && (async (e) => {
  let {
    url: t,
    method: n,
    data: r,
    signal: o,
    cancelToken: s,
    timeout: i,
    onDownloadProgress: u,
    onUploadProgress: d,
    responseType: a,
    headers: l,
    withCredentials: f = "same-origin",
    fetchOptions: m
  } = ot(e);
  a = a ? (a + "").toLowerCase() : "text";
  let y = ur([o, s && s.toAbortSignal()], i), p;
  const b = y && y.unsubscribe && (() => {
    y.unsubscribe();
  });
  let h;
  try {
    if (d && hr && n !== "get" && n !== "head" && (h = await yr(l, r)) !== 0) {
      let R = new Request(t, {
        method: "POST",
        body: r,
        duplex: "half"
      }), L;
      if (c.isFormData(r) && (L = R.headers.get("content-type")) && l.setContentType(L), R.body) {
        const [P, F] = xe(
          h,
          $(Pe(d))
        );
        r = De(R.body, Fe, P, F);
      }
    }
    c.isString(f) || (f = f ? "include" : "omit");
    const S = "credentials" in Request.prototype;
    p = new Request(t, {
      ...m,
      signal: y,
      method: n.toUpperCase(),
      headers: l.normalize().toJSON(),
      body: r,
      duplex: "half",
      credentials: S ? f : void 0
    });
    let g = await fetch(p);
    const E = ce && (a === "stream" || a === "response");
    if (ce && (u || E && b)) {
      const R = {};
      ["status", "statusText", "headers"].forEach((be) => {
        R[be] = g[be];
      });
      const L = c.toFiniteNumber(g.headers.get("content-length")), [P, F] = u && xe(
        L,
        $(Pe(u), !0)
      ) || [];
      g = new Response(
        De(g.body, Fe, P, () => {
          F && F(), b && b();
        }),
        R
      );
    }
    a = a || "text";
    let T = await W[c.findKey(W, a) || "text"](g, e);
    return !E && b && b(), await new Promise((R, L) => {
      nt(R, L, {
        data: T,
        headers: N.from(g.headers),
        status: g.status,
        statusText: g.statusText,
        config: e,
        request: p
      });
    });
  } catch (S) {
    throw b && b(), S && S.name === "TypeError" && /fetch/i.test(S.message) ? Object.assign(
      new w("Network Error", w.ERR_NETWORK, e, p),
      {
        cause: S.cause || S
      }
    ) : w.from(S, S && S.code, e, p);
  }
}), ue = {
  http: Fn,
  xhr: cr,
  fetch: gr
};
c.forEach(ue, (e, t) => {
  if (e) {
    try {
      Object.defineProperty(e, "name", { value: t });
    } catch {
    }
    Object.defineProperty(e, "adapterName", { value: t });
  }
});
const _e = (e) => `- ${e}`, br = (e) => c.isFunction(e) || e === null || e === !1, at = {
  getAdapter: (e) => {
    e = c.isArray(e) ? e : [e];
    const { length: t } = e;
    let n, r;
    const o = {};
    for (let s = 0; s < t; s++) {
      n = e[s];
      let i;
      if (r = n, !br(n) && (r = ue[(i = String(n)).toLowerCase()], r === void 0))
        throw new w(`Unknown adapter '${i}'`);
      if (r)
        break;
      o[i || "#" + s] = r;
    }
    if (!r) {
      const s = Object.entries(o).map(
        ([u, d]) => `adapter ${u} ` + (d === !1 ? "is not supported by the environment" : "is not available in the build")
      );
      let i = t ? s.length > 1 ? `since :
` + s.map(_e).join(`
`) : " " + _e(s[0]) : "as no adapter specified";
      throw new w(
        "There is no suitable adapter to dispatch the request " + i,
        "ERR_NOT_SUPPORT"
      );
    }
    return r;
  },
  adapters: ue
};
function re(e) {
  if (e.cancelToken && e.cancelToken.throwIfRequested(), e.signal && e.signal.aborted)
    throw new v(null, e);
}
function Be(e) {
  return re(e), e.headers = N.from(e.headers), e.data = ne.call(
    e,
    e.transformRequest
  ), ["post", "put", "patch"].indexOf(e.method) !== -1 && e.headers.setContentType("application/x-www-form-urlencoded", !1), at.getAdapter(e.adapter || z.adapter)(e).then(function(r) {
    return re(e), r.data = ne.call(
      e,
      e.transformResponse,
      r
    ), r.headers = N.from(r.headers), r;
  }, function(r) {
    return tt(r) || (re(e), r && r.response && (r.response.data = ne.call(
      e,
      e.transformResponse,
      r.response
    ), r.response.headers = N.from(r.response.headers))), Promise.reject(r);
  });
}
const ct = "1.7.7", ye = {};
["object", "boolean", "number", "function", "string", "symbol"].forEach((e, t) => {
  ye[e] = function(r) {
    return typeof r === e || "a" + (t < 1 ? "n " : " ") + e;
  };
});
const ke = {};
ye.transitional = function(t, n, r) {
  function o(s, i) {
    return "[Axios v" + ct + "] Transitional option '" + s + "'" + i + (r ? ". " + r : "");
  }
  return (s, i, u) => {
    if (t === !1)
      throw new w(
        o(i, " has been removed" + (n ? " in " + n : "")),
        w.ERR_DEPRECATED
      );
    return n && !ke[i] && (ke[i] = !0, console.warn(
      o(
        i,
        " has been deprecated since v" + n + " and will be removed in the near future"
      )
    )), t ? t(s, i, u) : !0;
  };
};
function wr(e, t, n) {
  if (typeof e != "object")
    throw new w("options must be an object", w.ERR_BAD_OPTION_VALUE);
  const r = Object.keys(e);
  let o = r.length;
  for (; o-- > 0; ) {
    const s = r[o], i = t[s];
    if (i) {
      const u = e[s], d = u === void 0 || i(u, s, e);
      if (d !== !0)
        throw new w("option " + s + " must be " + d, w.ERR_BAD_OPTION_VALUE);
      continue;
    }
    if (n !== !0)
      throw new w("Unknown option " + s, w.ERR_BAD_OPTION);
  }
}
const le = {
  assertOptions: wr,
  validators: ye
}, _ = le.validators;
class j {
  constructor(t) {
    this.defaults = t, this.interceptors = {
      request: new Ne(),
      response: new Ne()
    };
  }
  /**
   * Dispatch a request
   *
   * @param {String|Object} configOrUrl The config specific for this request (merged with this.defaults)
   * @param {?Object} config
   *
   * @returns {Promise} The Promise to be fulfilled
   */
  async request(t, n) {
    try {
      return await this._request(t, n);
    } catch (r) {
      if (r instanceof Error) {
        let o;
        Error.captureStackTrace ? Error.captureStackTrace(o = {}) : o = new Error();
        const s = o.stack ? o.stack.replace(/^.+\n/, "") : "";
        try {
          r.stack ? s && !String(r.stack).endsWith(s.replace(/^.+\n.+\n/, "")) && (r.stack += `
` + s) : r.stack = s;
        } catch {
        }
      }
      throw r;
    }
  }
  _request(t, n) {
    typeof t == "string" ? (n = n || {}, n.url = t) : n = t || {}, n = U(this.defaults, n);
    const { transitional: r, paramsSerializer: o, headers: s } = n;
    r !== void 0 && le.assertOptions(r, {
      silentJSONParsing: _.transitional(_.boolean),
      forcedJSONParsing: _.transitional(_.boolean),
      clarifyTimeoutError: _.transitional(_.boolean)
    }, !1), o != null && (c.isFunction(o) ? n.paramsSerializer = {
      serialize: o
    } : le.assertOptions(o, {
      encode: _.function,
      serialize: _.function
    }, !0)), n.method = (n.method || this.defaults.method || "get").toLowerCase();
    let i = s && c.merge(
      s.common,
      s[n.method]
    );
    s && c.forEach(
      ["delete", "get", "head", "post", "put", "patch", "common"],
      (p) => {
        delete s[p];
      }
    ), n.headers = N.concat(i, s);
    const u = [];
    let d = !0;
    this.interceptors.request.forEach(function(b) {
      typeof b.runWhen == "function" && b.runWhen(n) === !1 || (d = d && b.synchronous, u.unshift(b.fulfilled, b.rejected));
    });
    const a = [];
    this.interceptors.response.forEach(function(b) {
      a.push(b.fulfilled, b.rejected);
    });
    let l, f = 0, m;
    if (!d) {
      const p = [Be.bind(this), void 0];
      for (p.unshift.apply(p, u), p.push.apply(p, a), m = p.length, l = Promise.resolve(n); f < m; )
        l = l.then(p[f++], p[f++]);
      return l;
    }
    m = u.length;
    let y = n;
    for (f = 0; f < m; ) {
      const p = u[f++], b = u[f++];
      try {
        y = p(y);
      } catch (h) {
        b.call(this, h);
        break;
      }
    }
    try {
      l = Be.call(this, y);
    } catch (p) {
      return Promise.reject(p);
    }
    for (f = 0, m = a.length; f < m; )
      l = l.then(a[f++], a[f++]);
    return l;
  }
  getUri(t) {
    t = U(this.defaults, t);
    const n = rt(t.baseURL, t.url);
    return Ze(n, t.params, t.paramsSerializer);
  }
}
c.forEach(["delete", "get", "head", "options"], function(t) {
  j.prototype[t] = function(n, r) {
    return this.request(U(r || {}, {
      method: t,
      url: n,
      data: (r || {}).data
    }));
  };
});
c.forEach(["post", "put", "patch"], function(t) {
  function n(r) {
    return function(s, i, u) {
      return this.request(U(u || {}, {
        method: t,
        headers: r ? {
          "Content-Type": "multipart/form-data"
        } : {},
        url: s,
        data: i
      }));
    };
  }
  j.prototype[t] = n(), j.prototype[t + "Form"] = n(!0);
});
class ge {
  constructor(t) {
    if (typeof t != "function")
      throw new TypeError("executor must be a function.");
    let n;
    this.promise = new Promise(function(s) {
      n = s;
    });
    const r = this;
    this.promise.then((o) => {
      if (!r._listeners) return;
      let s = r._listeners.length;
      for (; s-- > 0; )
        r._listeners[s](o);
      r._listeners = null;
    }), this.promise.then = (o) => {
      let s;
      const i = new Promise((u) => {
        r.subscribe(u), s = u;
      }).then(o);
      return i.cancel = function() {
        r.unsubscribe(s);
      }, i;
    }, t(function(s, i, u) {
      r.reason || (r.reason = new v(s, i, u), n(r.reason));
    });
  }
  /**
   * Throws a `CanceledError` if cancellation has been requested.
   */
  throwIfRequested() {
    if (this.reason)
      throw this.reason;
  }
  /**
   * Subscribe to the cancel signal
   */
  subscribe(t) {
    if (this.reason) {
      t(this.reason);
      return;
    }
    this._listeners ? this._listeners.push(t) : this._listeners = [t];
  }
  /**
   * Unsubscribe from the cancel signal
   */
  unsubscribe(t) {
    if (!this._listeners)
      return;
    const n = this._listeners.indexOf(t);
    n !== -1 && this._listeners.splice(n, 1);
  }
  toAbortSignal() {
    const t = new AbortController(), n = (r) => {
      t.abort(r);
    };
    return this.subscribe(n), t.signal.unsubscribe = () => this.unsubscribe(n), t.signal;
  }
  /**
   * Returns an object that contains a new `CancelToken` and a function that, when called,
   * cancels the `CancelToken`.
   */
  static source() {
    let t;
    return {
      token: new ge(function(o) {
        t = o;
      }),
      cancel: t
    };
  }
}
function Er(e) {
  return function(n) {
    return e.apply(null, n);
  };
}
function Sr(e) {
  return c.isObject(e) && e.isAxiosError === !0;
}
const fe = {
  Continue: 100,
  SwitchingProtocols: 101,
  Processing: 102,
  EarlyHints: 103,
  Ok: 200,
  Created: 201,
  Accepted: 202,
  NonAuthoritativeInformation: 203,
  NoContent: 204,
  ResetContent: 205,
  PartialContent: 206,
  MultiStatus: 207,
  AlreadyReported: 208,
  ImUsed: 226,
  MultipleChoices: 300,
  MovedPermanently: 301,
  Found: 302,
  SeeOther: 303,
  NotModified: 304,
  UseProxy: 305,
  Unused: 306,
  TemporaryRedirect: 307,
  PermanentRedirect: 308,
  BadRequest: 400,
  Unauthorized: 401,
  PaymentRequired: 402,
  Forbidden: 403,
  NotFound: 404,
  MethodNotAllowed: 405,
  NotAcceptable: 406,
  ProxyAuthenticationRequired: 407,
  RequestTimeout: 408,
  Conflict: 409,
  Gone: 410,
  LengthRequired: 411,
  PreconditionFailed: 412,
  PayloadTooLarge: 413,
  UriTooLong: 414,
  UnsupportedMediaType: 415,
  RangeNotSatisfiable: 416,
  ExpectationFailed: 417,
  ImATeapot: 418,
  MisdirectedRequest: 421,
  UnprocessableEntity: 422,
  Locked: 423,
  FailedDependency: 424,
  TooEarly: 425,
  UpgradeRequired: 426,
  PreconditionRequired: 428,
  TooManyRequests: 429,
  RequestHeaderFieldsTooLarge: 431,
  UnavailableForLegalReasons: 451,
  InternalServerError: 500,
  NotImplemented: 501,
  BadGateway: 502,
  ServiceUnavailable: 503,
  GatewayTimeout: 504,
  HttpVersionNotSupported: 505,
  VariantAlsoNegotiates: 506,
  InsufficientStorage: 507,
  LoopDetected: 508,
  NotExtended: 510,
  NetworkAuthenticationRequired: 511
};
Object.entries(fe).forEach(([e, t]) => {
  fe[t] = e;
});
function ut(e) {
  const t = new j(e), n = qe(j.prototype.request, t);
  return c.extend(n, j.prototype, t, { allOwnKeys: !0 }), c.extend(n, t, null, { allOwnKeys: !0 }), n.create = function(o) {
    return ut(U(e, o));
  }, n;
}
const O = ut(z);
O.Axios = j;
O.CanceledError = v;
O.CancelToken = ge;
O.isCancel = tt;
O.VERSION = ct;
O.toFormData = Z;
O.AxiosError = w;
O.Cancel = O.CanceledError;
O.all = function(t) {
  return Promise.all(t);
};
O.spread = Er;
O.isAxiosError = Sr;
O.mergeConfig = U;
O.AxiosHeaders = N;
O.formToJSON = (e) => et(c.isHTMLForm(e) ? new FormData(e) : e);
O.getAdapter = at.getAdapter;
O.HttpStatusCode = fe;
O.default = O;
var lt = /* @__PURE__ */ ((e) => (e.KeyApp = "1", e.Module = "2", e.MenuGroup = "3", e.Menu = "4", e))(lt || {});
function Rr(e) {
  const t = V(() => {
    const d = /* @__PURE__ */ new Map();
    return e.value.forEach((a) => {
      d.set(a.id, a);
    }), d;
  }), n = V(() => {
    const d = /* @__PURE__ */ new Map();
    return e.value.forEach((a) => {
      const { parentId: l } = a;
      l && (d.has(l) || d.set(l, []), d.get(l).push(a));
    }), d;
  }), r = V(() => e.value.filter((d) => {
    const { parentId: a } = d;
    return !a || !t.value.get(a);
  })), o = B([]);
  function s() {
    const d = [], a = [];
    for ([...r.value].reverse().forEach((l) => a.push(l.id)); a.length > 0; ) {
      const l = a.pop(), f = t.value.get(l);
      d.push(f), [...n.value.get(l) || []].reverse().forEach((y) => {
        a.push(y.id);
      });
    }
    return d;
  }
  oe(
    e,
    () => {
      o.value = s();
    }
  );
  function i(d, a) {
    const l = [], f = [d];
    for (; f.length > 0; ) {
      const m = f.shift();
      if (!m)
        continue;
      const y = n.value.get(m.id) || [];
      for (const p of y)
        a(p) && l.push(p), f.push(p);
    }
    return l;
  }
  function u(d) {
    return n.value.get(d == null ? void 0 : d.id) || [];
  }
  return {
    orderedTreeNodes: o,
    getLeafDescendants: i,
    getChildNodes: u
  };
}
function Tr(e, t) {
  const n = B([]), r = /* @__PURE__ */ new Set(), o = Rr(n), {
    orderedTreeNodes: s
  } = o, i = V(() => s.value.filter(a));
  function u(g) {
    return r.has(g);
  }
  function d(g) {
    const E = g;
    return (E == null ? void 0 : E.funcType) === lt.Menu;
  }
  function a(g) {
    return !d(g);
  }
  function l(g) {
    g && (g.layer = Number(g.layer) - 1, g.collapse = typeof g.collapse == "boolean" ? g.collapse : !0);
  }
  function f(g) {
    return typeof e.fetchNodeApi == "function" ? e.fetchNodeApi(g) : !g && typeof e.fetchNodeApi == "string" ? e.fetchNodeApi : "";
  }
  async function m(g) {
    const E = f(g);
    if (!E)
      return Promise.resolve([]);
    const T = {
      headers: {
        "Content-Type": "application/json"
      }
    }, R = St.show({ target: t.value }), P = (await O.get(E, T).then((F) => (R.value.close(), F)).catch((F) => (console.error(F), R.value.close(), { data: [] }))).data || [];
    return P.forEach(l), P;
  }
  function y() {
    n.value.forEach((g) => {
      const R = !!o.getChildNodes(g).find(a);
      g.hasChildren = R;
    }), n.value = [...n.value];
  }
  function p(g) {
    !g || !g.length || (n.value.push(...g), y());
  }
  function b(g) {
    const E = (g == null ? void 0 : g.id) || "";
    u(E) || m(g).then((T) => {
      u(E) || (r.add(E), p(T));
    });
  }
  function h(g) {
    return o.getLeafDescendants(g, d);
  }
  function S() {
    n.value = [], r.clear();
  }
  return {
    treeData: i,
    loadNodesByLevel: b,
    getLeafDescendants: h,
    clearCache: S
  };
}
function Or(e, t) {
  const n = B([]);
  function r(i) {
  }
  function o(i) {
    return [];
  }
  function s() {
  }
  return {
    treeData: n,
    loadNodesByLevel: r,
    getLeafDescendants: o,
    clearCache: s
  };
}
function Cr(e, t) {
  return ft(Tr(e, t));
}
function Nr(e, t) {
  return ft(Or());
}
function ft(e) {
  const {
    treeData: t,
    loadNodesByLevel: n,
    getLeafDescendants: r
  } = e, o = B([]), s = B();
  function i(y) {
    const p = y == null ? void 0 : y[0];
    if (!p)
      return;
    const b = r(p);
    o.value = [...b];
  }
  function u(y) {
    const p = y == null ? void 0 : y[0];
    s.value = p;
  }
  function d() {
    s.value = void 0;
  }
  function a(y) {
    var p;
    return (p = y == null ? void 0 : y.row) == null ? void 0 : p.raw;
  }
  function l(y) {
    const p = a(y);
    n(p);
  }
  function f() {
    s.value = void 0, o.value = [], e.clearCache();
  }
  function m() {
    f(), n();
  }
  return {
    treeData: t,
    gridData: o,
    selectedData: s,
    onNavTreeSelectionChange: i,
    onNavTreeExpandNode: l,
    onDataGridSelectionChange: u,
    onDataGridUnSelectItem: d,
    initialize: m,
    clearCache: f
  };
}
function Ar(e, t, n) {
  const r = ht(Rt, null), o = e.targetType === "app" ? "选择应用" : "选择功能菜单", {
    selectedData: s,
    clearCache: i
  } = n;
  function u(f, m) {
    t.emit("change", f, f, m), t.emit("update:modelValue", f);
  }
  function d() {
    if (!s.value)
      return r == null || r.warning({ message: "请选择数据！", position: "top-center" }), !1;
    const f = s.value.id, m = s.value;
    return u(f, m), !0;
  }
  function a() {
    u("");
  }
  return {
    modalConfigs: mt({
      title: o,
      width: 800,
      height: 550,
      fitContent: !1,
      showHeader: !0,
      showCloseButton: !0,
      showMaxButton: !1,
      resizeable: !1,
      draggable: !0,
      closedCallback: () => {
        i();
      },
      buttons: [
        {
          class: "btn btn-secondary",
          text: "取消",
          handle: () => !0
        },
        {
          class: "btn btn-primary",
          text: "确定",
          handle: () => d()
        }
      ]
    }),
    changeValue: u,
    onClear: a
  };
}
const de = /* @__PURE__ */ je({
  name: "FMenuLookup",
  props: ve,
  emits: ["change", "update:modelValue"],
  setup(e, t) {
    const n = B(), r = e.targetType === "app" ? Nr() : Cr(e, n), {
      modalConfigs: o,
      changeValue: s,
      onClear: i
    } = Ar(e, t, r);
    return () => D(gt, {
      modelValue: e.modelValue,
      enableClear: !0,
      buttonBehavior: "Modal",
      modalOptions: o,
      onClear: i,
      "onUpdate:modelValue": s
    }, {
      default: () => [D("div", {
        ref: n,
        class: "fv-menu-lookup-container"
      }, [D(Gt, {
        targetType: e.targetType,
        useTreeGridCoordinatorComposition: r
      }, null)])]
    });
  }
});
de.register = (e, t, n, r) => {
  e["menu-lookup"] = de, t["menu-lookup"] = zt;
};
const Ur = Tt(de);
export {
  de as FMenuLookup,
  Ur as default,
  ve as menuLookupProps,
  zt as propsResolver
};
