import { computed as h, defineComponent as F, ref as d, watch as q, createVNode as y, Fragment as H, inject as x, onMounted as K } from "vue";
import { isPlainObject as A, cloneDeep as z } from "lodash-es";
import { withInstall as I } from "../common/index.esm.js";
const V = {}, _ = {};
function R(e) {
  const { properties: r, title: c, ignore: t } = e, n = t && Array.isArray(t), o = Object.keys(r).reduce((a, i) => ((!n || !t.find((v) => v === i)) && (a[i] = r[i].type === "object" && r[i].properties ? R(r[i]) : z(r[i].default)), a), {});
  if (c && (!n || !t.find((a) => a === "id"))) {
    const a = c.toLowerCase().replace(/-/g, "_");
    o.id = `${a}_${Math.random().toString().slice(2, 6)}`;
  }
  return o;
}
function ee(e) {
  const { properties: r, title: c, required: t } = e;
  if (t && Array.isArray(t)) {
    const n = t.reduce((o, a) => (o[a] = r[a].type === "object" && r[a].properties ? R(r[a]) : z(r[a].default), o), {});
    if (c && t.find((o) => o === "id")) {
      const o = c.toLowerCase().replace(/-/g, "_");
      n.id = `${o}_${Math.random().toString().slice(2, 6)}`;
    }
    return n;
  }
  return {
    type: c
  };
}
function C(e, r = {}, c) {
  const t = V[e];
  if (t) {
    let n = ee(t);
    const o = _[e];
    return n = o ? o({ getSchemaByType: C }, n, r, c) : n, n;
  }
  return null;
}
function re(e, r) {
  const c = R(r);
  return Object.keys(c).reduce((t, n) => (Object.prototype.hasOwnProperty.call(e, n) && (t[n] && A(t[n]) && A(e[n] || !e[n]) ? Object.assign(t[n], e[n] || {}) : t[n] = e[n]), t), c), c;
}
function X(e, r) {
  return Object.keys(e).filter((t) => e[t] != null).reduce((t, n) => {
    if (r.has(n)) {
      const o = r.get(n);
      if (typeof o == "string")
        t[o] = e[n];
      else {
        const a = o(n, e[n], e);
        Object.assign(t, a);
      }
    } else
      t[n] = e[n];
    return t;
  }, {});
}
function te(e, r, c = /* @__PURE__ */ new Map()) {
  const t = re(e, r);
  return X(t, c);
}
function se(e = {}) {
  function r(s, l, u, f) {
    if (typeof u == "number")
      return f[s].length === u;
    if (typeof u == "object") {
      const k = Object.keys(u)[0], S = u[k];
      if (k === "not")
        return Number(f[s].length) !== Number(S);
      if (k === "moreThan")
        return Number(f[s].length) >= Number(S);
      if (k === "lessThan")
        return Number(f[s].length) <= Number(S);
    }
    return !1;
  }
  function c(s, l, u, f) {
    return f[s] && f[s].propertyValue && String(f[s].propertyValue.value) === String(u);
  }
  const t = /* @__PURE__ */ new Map([
    ["length", r],
    ["getProperty", c]
  ]);
  Object.keys(e).reduce((s, l) => (s.set(l, e[l]), s), t);
  function n(s, l) {
    const u = s;
    return typeof l == "number" ? [{ target: u, operator: "length", param: null, value: Number(l) }] : typeof l == "boolean" ? [{ target: u, operator: "getProperty", param: s, value: !!l }] : typeof l == "object" ? Object.keys(l).map((f) => {
      if (f === "length")
        return { target: u, operator: "length", param: null, value: l[f] };
      const k = f, S = l[f];
      return { target: u, operator: "getProperty", param: k, value: S };
    }) : [];
  }
  function o(s) {
    return Object.keys(s).reduce((u, f) => {
      const k = n(f, s[f]);
      return u.push(...k), u;
    }, []);
  }
  function a(s, l) {
    if (t.has(s.operator)) {
      const u = t.get(s.operator);
      return u && u(s.target, s.param, s.value, l) || !1;
    }
    return !1;
  }
  function i(s, l) {
    return o(s).reduce((k, S) => k && a(S, l), !0);
  }
  function v(s, l) {
    const u = Object.keys(s), f = u.includes("allOf"), k = u.includes("anyOf"), S = f || k, p = (S ? s[S ? f ? "allOf" : "anyOf" : "allOf"] : [s]).map(($) => i($, l));
    return f ? !p.includes(!1) : p.includes(!0);
  }
  return { parseValueSchema: v };
}
const ne = {}, oe = {};
se();
function ae(e, r, c = /* @__PURE__ */ new Map(), t = (a, i, v, s) => i, n = {}, o = (a) => a) {
  return V[r.title] = r, _[r.title] = t, ne[r.title] = n, oe[r.title] = o, (a = {}, i = !0) => {
    if (!i)
      return X(a, c);
    const v = te(a, r, c), s = Object.keys(e).reduce((l, u) => (l[u] = e[u].default, l), {});
    return Object.assign(s, v);
  };
}
function ce(e, r) {
  return { customClass: r.class, customStyle: r.style };
}
const le = /* @__PURE__ */ new Map([
  ["appearance", ce]
]);
function ue(e, r, c) {
  return r;
}
const ie = "https://json-schema.org/draft/2020-12/schema", fe = "https://farris-design.gitee.io/progress.schema.json", ge = "progress", pe = "A Farris Component", de = "object", ye = {
  id: {
    description: "The unique identifier for progress",
    type: "string"
  },
  type: {
    description: "The type string of progress",
    type: "string",
    default: "progress"
  },
  appearance: {
    description: "",
    type: "object",
    properties: {
      class: {
        type: "string"
      },
      style: {
        type: "string"
      }
    },
    default: {}
  },
  binding: {
    description: "",
    type: "object",
    default: {}
  },
  disable: {
    type: "string",
    default: !1
  },
  editable: {
    description: "",
    type: "boolean",
    default: !0
  },
  placeholder: {
    description: "",
    type: "string",
    default: ""
  },
  readonly: {
    description: "",
    type: "boolean",
    default: !1
  },
  require: {
    description: "",
    type: "boolean",
    default: !1
  },
  tabindex: {
    description: "",
    type: "number",
    default: -1
  },
  visible: {
    description: "",
    type: "boolean",
    default: !0
  }
}, he = [
  "id",
  "type"
], ve = {
  $schema: ie,
  $id: fe,
  title: ge,
  description: pe,
  type: de,
  properties: ye,
  required: he
}, me = "progress", ke = "A Farris Component", be = "object", Pe = {
  basic: {
    description: "Basic Infomation",
    title: "基本信息",
    properties: {
      id: {
        description: "组件标识",
        title: "标识",
        type: "string",
        readonly: !0
      },
      type: {
        description: "组件类型",
        title: "控件类型",
        type: "select",
        editor: {
          type: "waiting for modification",
          enum: []
        }
      }
    }
  }
}, Se = {
  title: me,
  description: ke,
  type: be,
  categories: Pe
}, W = {
  progressType: { type: String, default: "line" },
  strokeWidth: { type: Number, default: 0 },
  size: { type: String, default: "default" },
  showInfo: { type: Boolean, default: !0 },
  progressStatus: { type: String, default: "default" },
  successPercent: { type: Number, default: 0 },
  strokeColor: { type: String, default: "" },
  strokeLinecap: { type: String, default: "round" },
  width: { type: Number, default: 100 },
  percent: { type: Number, default: 20 },
  /**
   * 启用成功分段背景图片
   */
  enableBackgroundImg: { type: Boolean, default: !1 },
  /**
   * 成功分段背景图片
   */
  backgroundImg: { type: String, default: "" },
  /**
   * 仪表盘缺口位置
   */
  gapPosition: { type: String },
  /**
   * 仪表盘缺口角度，默认0°
   */
  gapDegree: { type: Number, default: 0 },
  /**
   * 格式化进度信息
   */
  format: { type: Function, default: (e, r) => `${e}%` }
}, Y = ae(W, ve, le, ue, Se);
function $e(e) {
  function r(a) {
    return +a.replace("%", "");
  }
  function c(a) {
    let i = [];
    return Object.keys(a).forEach((v) => {
      const s = a[v], l = r(v);
      isNaN(l) || i.push({
        key: l,
        value: s
      });
    }), i = i.sort((v, s) => v.key - s.key), i;
  }
  const t = h(() => !!e.strokeColor && typeof e.strokeColor != "string"), n = h(() => {
    const { from: a = "#59a1ff", to: i = "#59a1ff", direction: v = "to right", ...s } = e.strokeColor;
    if (Object.keys(s).length !== 0) {
      const l = c(s).map(({ key: u, value: f }) => `${f} ${u}%`).join(", ");
      return `linear-gradient(${v}, ${l})`;
    }
    return `linear-gradient(${v}, ${a}, ${i})`;
  }), o = h(() => c(e.strokeColor).map(({ key: a, value: i }) => ({ offset: `${a}%`, color: i })));
  return {
    isGradient: t,
    linearGradient: n,
    circleGradient: o
  };
}
function we(e) {
  return { strokeWidth: h(() => e.strokeWidth || (e.progressType === "line" && e.size !== "small" ? 8 : 6)) };
}
function je(e) {
  return { formatPercentageText: h(() => e.format(e.percent, e.successPercent)) };
}
function Be(e, r, c, t) {
  const { isCircleStyle: n } = r, { isGradient: o, linearGradient: a } = c, { strokeWidth: i } = t, v = h(() => {
    const p = {
      "f-progress": !0,
      "f-progress-line": e.progressType === "line",
      "ant-progress-small": e.size === "small",
      "f-progress-show-info": e.showInfo,
      "f-progress-circle": n.value
    }, w = `f-progress-status-${e.progressStatus}`;
    return p[w] = !0, p;
  }), s = h(() => ({
    width: `${e.width}px`,
    height: `${e.width}px`,
    "font-size": `${e.width * 0.15 + 6}px`,
    "f-progress-circle-gradient": o.value
  })), l = h(() => ({
    "f-progress-inner": !0,
    "f-progress-circle-gradient": o.value
  })), u = 0, f = h(() => u + 1), k = h(() => {
    const p = 50 - i.value / 2, w = e.gapPosition || (e.progressType === "circle" ? "top" : "bottom");
    let $ = 0, j = -p, D = 0, O = p * -2;
    switch (w) {
      case "left":
        $ = -p, j = 0, D = p * 2, O = 0;
        break;
      case "right":
        $ = p, j = 0, D = p * -2, O = 0;
        break;
      case "bottom":
        j = p, O = p * 2;
        break;
    }
    return `M 50,50 m ${$},${j}
                a ${p},${p} 0 1 1 ${D},${-O}
                a ${p},${p} 0 1 1 ${-D},${O}`;
  }), S = h(() => {
    const p = 50 - i.value / 2, w = Math.PI * 2 * p, $ = e.gapDegree || (e.progressType === "circle" ? 0 : 75);
    return {
      strokeDasharray: `${w - $}px ${w}px`,
      strokeDashoffset: `-${$ / 2}px`,
      transition: "stroke-dashoffset .3s ease 0s, stroke-dasharray .3s ease 0s, stroke .3s"
    };
  }), G = h(() => {
    const p = 50 - i.value / 2, w = Math.PI * 2 * p, $ = e.gapDegree || (e.progressType === "circle" ? 0 : 75), j = e.successPercent !== void 0 && e.successPercent !== null ? [e.successPercent, e.percent] : [e.percent];
    return j.map((D, O) => {
      const M = j.length === 2 && O === 0;
      return {
        stroke: o.value && !M ? `url(#gradient-${f.value})` : null,
        strokePathStyle: {
          stroke: o.value ? null : M ? "default" : e.strokeColor,
          transition: "stroke-dashoffset .3s ease 0s, stroke-dasharray .3s ease 0s, stroke .3s, stroke-width .06s ease .3s",
          strokeDasharray: `${(D || 0) / 100 * (w - $)}px ${w}px`,
          strokeDashoffset: `-${$ / 2}px`
        }
      };
    }).reverse();
  }), E = h(() => ({
    width: `${e.percent}%`,
    "border-radius": e.strokeLinecap === "round" ? "100px" : "0",
    background: o.value ? null : e.strokeColor,
    "background-image": o.value ? a.value : null,
    height: `${i.value}px`
  }));
  return {
    progressClass: v,
    inCircleProgressBarStyle: s,
    inCircleProgressBarClass: l,
    pathString: k,
    trailPathStyle: S,
    progressCirclePaths: G,
    gradientId: f,
    inlineProgressBackgroundStyle: E
  };
}
function Oe(e) {
  return { isCircleStyle: h(() => e.progressType === "circle" || e.progressType === "dashboard") };
}
function Te(e) {
  const r = h(() => {
    const n = {
      "f-progress-text-icon": !0,
      "f-icon": !0
    }, o = `f-icon-${e.progressStatus}`;
    return n[o] = !0, n;
  }), c = h(() => {
    const n = {
      "f-progress-text-icon": !0,
      "f-icon": !0
    }, o = e.progressStatus === "success" ? "f-icon-checkmark" : "f-icon-x";
    return n[o] = !0, n;
  }), t = h(() => e.progressStatus === "error" || e.progressStatus === "success");
  return {
    inlineProgrssStatusClass: r,
    circleProgrssStatusClass: c,
    shouldShowStatus: t
  };
}
function De(e) {
  const r = h(() => ({
    width: `${e.successPercent}%`,
    "border-radius": e.strokeLinecap === "round" ? "100px" : "0",
    height: `${e.strokeWidth}px`,
    "background-image": e.enableBackgroundImg ? `url(${e.backgroundImg})` : null
  })), c = h(() => e.successPercent || e.successPercent === 0);
  return { inlineProgressSuccessBackgroundStyle: r, shouldShowSuccessInlineProgressBackground: c };
}
const L = /* @__PURE__ */ F({
  name: "FProgress",
  props: W,
  emits: [],
  setup(e) {
    const r = d(e.progressType), c = d(e.showInfo), t = d(e.percent), n = d(e.strokeLinecap), o = $e(e), {
      isGradient: a,
      circleGradient: i
    } = o, v = we(e), {
      strokeWidth: s
    } = v, {
      formatPercentageText: l
    } = je(e), u = Oe(e), {
      isCircleStyle: f
    } = u, {
      progressClass: k,
      inCircleProgressBarStyle: S,
      inCircleProgressBarClass: G,
      pathString: E,
      trailPathStyle: p,
      progressCirclePaths: w,
      gradientId: $,
      inlineProgressBackgroundStyle: j
    } = Be(e, u, o, v), {
      inlineProgrssStatusClass: D,
      circleProgrssStatusClass: O,
      shouldShowStatus: M
    } = Te(e), {
      inlineProgressSuccessBackgroundStyle: g,
      shouldShowSuccessInlineProgressBackground: b
    } = De(e);
    q(() => e.percent, (N) => {
      t.value = N || 0;
    });
    function m() {
      return c.value && y("span", {
        class: "f-progress-text"
      }, [M.value ? y("span", {
        class: f.value ? O.value : D.value
      }, null) : l.value]);
    }
    function P() {
      return y(H, null, [y("div", {
        class: "f-progress-outer"
      }, [y("div", {
        class: "f-progress-inner"
      }, [y("div", {
        class: "f-progress-bg",
        style: j.value
      }, null), b.value && y("div", {
        class: "f-progress-success-bg",
        style: g.value
      }, null)])]), m()]);
    }
    function B() {
      return y("div", {
        class: G.value,
        style: S.value
      }, [y("svg", {
        class: "f-progress-circle",
        viewBox: "0 0 100 100"
      }, [a.value && y("defs", null, [y("linearGradient", {
        id: "gradient-" + $.value,
        x1: "100%",
        y1: "0%",
        x2: "0%",
        y2: "0%"
      }, [i.value.map((N) => y("stop", {
        offset: N.offset,
        "stop-color": N.color
      }, null))])]), y("path", {
        class: "f-progress-circle-trail",
        stroke: "#efefef",
        "fill-opacity": "0",
        "stroke-width": s.value,
        d: E.value,
        style: p.value
      }, null), w.value.map((N) => y("path", {
        class: "f-progress-circle-path",
        "fill-opacity": "0",
        d: E.value,
        "stroke-linecap": n.value,
        stroke: N.stroke,
        "stroke-width": t.value ? s.value : 0,
        style: N.strokePathStyle
      }, null))]), m()]);
    }
    return () => y("div", {
      class: k.value
    }, [r.value === "line" && P(), f.value && B()]);
  }
});
function Me(e, r, c) {
  var M;
  const t = "", n = "", o = d();
  function a() {
    return (r == null ? void 0 : r.schema.componentType) !== "frame";
  }
  function i() {
    return !1;
  }
  function v() {
    return (r == null ? void 0 : r.schema.componentType) !== "frame";
  }
  function s() {
    return (r == null ? void 0 : r.schema.componentType) === "frame";
  }
  function l(g) {
    if (!g || !g.value)
      return null;
    if (g.value.schema && g.value.schema.type === "component")
      return g.value;
    const b = d(g == null ? void 0 : g.value.parent), m = l(b);
    return m || null;
  }
  function u(g = r) {
    var B;
    const { componentInstance: b, designerItemElementRef: m } = g;
    if (!b || !b.value)
      return null;
    const { getCustomButtons: P } = b.value;
    return b.value.canMove || P && ((B = P()) != null && B.length) ? m : u(g.parent);
  }
  function f(g) {
    return !!c;
  }
  function k() {
    return (r == null ? void 0 : r.schema.label) || (r == null ? void 0 : r.schema.title) || (r == null ? void 0 : r.schema.name);
  }
  function S() {
  }
  function G(g, b) {
    var m;
    !g || !b || (m = r == null ? void 0 : r.setupContext) == null || m.emit("dragEnd");
  }
  function E(g, b) {
    const { componentType: m } = g;
    let P = C(m, g, b);
    const B = m.toLowerCase().replace(/-/g, "_");
    return P && !P.id && P.type === m && (P.id = `${B}_${Math.random().toString().slice(2, 6)}`), P;
  }
  function p(g) {
  }
  function w(...g) {
  }
  function $(g) {
    if (!g)
      return;
    const b = r == null ? void 0 : r.schema, { formSchemaUtils: m } = g;
    if (b && m.getExpressions().length) {
      const P = m.getExpressions().findIndex((B) => B.target === b.id);
      P > -1 && m.getExpressions().splice(P, 1);
    }
  }
  function j(g) {
    $(g), r != null && r.schema.contents && r.schema.contents.map((b) => {
      let m = b.id;
      b.type === "component-ref" && (m = b.component);
      const P = e.value.querySelectorAll(`#${m}-design-item`);
      P != null && P.length && Array.from(P).map((B) => {
        var N;
        (N = B == null ? void 0 : B.componentInstance) != null && N.value.onRemoveComponent && B.componentInstance.value.onRemoveComponent(g);
      });
    });
  }
  function D() {
  }
  function O(g) {
  }
  return o.value = {
    canMove: a(),
    canSelectParent: i(),
    canDelete: v(),
    canNested: !s(),
    contents: r == null ? void 0 : r.schema.contents,
    elementRef: e,
    parent: (M = r == null ? void 0 : r.parent) == null ? void 0 : M.componentInstance,
    schema: r == null ? void 0 : r.schema,
    styles: t,
    designerClass: n,
    canAccepts: f,
    getBelongedComponentInstance: l,
    getDraggableDesignItemElement: u,
    getDraggingDisplayText: k,
    getPropConfig: w,
    getDragScopeElement: S,
    onAcceptMovedChildElement: G,
    onChildElementMovedOut: p,
    addNewChildComponentSchema: E,
    triggerBelongedComponentToMoveWhenMoved: d(!1),
    triggerBelongedComponentToDeleteWhenDeleted: d(!1),
    onRemoveComponent: j,
    getCustomButtons: D,
    onPropertyChanged: O
  }, o;
}
const Ne = /* @__PURE__ */ F({
  name: "FProgressDesign",
  props: W,
  emits: [],
  setup(e, r) {
    const c = d(e.progressStatus), t = d(e.progressType), n = d(e.size), o = d(e.showInfo), a = d(e.strokeWidth), i = d(e.percent), v = d(e.strokeLinecap), s = d(!1), l = d(e.strokeColor), u = d(null), f = d(0), k = d(e.width), S = d(""), G = d([]), E = d(""), p = d([]), w = d(e.enableBackgroundImg), $ = d(e.backgroundImg), j = d(), D = x("design-item-context"), O = Me(j, D);
    K(() => {
      j.value.componentInstance = O;
    }), r.expose(O.value), q(() => e.percent, (T) => {
      i.value = T || 0;
    });
    const M = h(() => a.value || (t.value === "line" && n.value !== "small" ? 8 : 6)), g = h(() => t.value === "circle" || t.value === "dashboard"), b = h(() => {
      const T = {
        "f-progress": !0,
        "f-progress-line": t.value === "line",
        "ant-progress-small": n.value === "small",
        "f-progress-show-info": o.value,
        ".f-progress-circle": g.value
      }, Z = `f-progress-status-${c.value}`;
      return T[Z] = !0, T;
    }), m = h(() => ({
      width: `${i.value}%`,
      "border-radius": v.value === "round" ? "100px" : "0",
      backgroud: s.value ? null : l.value,
      "background-image": s.value ? u.value : null,
      height: `${M.value}px`
    })), P = h(() => ({
      width: `${i.value}%`,
      "border-radius": v.value === "round" ? "100px" : "0",
      height: `${M.value}px`,
      "background-image": w.value ? $.value : null
    })), B = h(() => f.value || f.value === 0);
    function N() {
      return y("div", {
        class: "f-progress-outer"
      }, [y("div", {
        class: "f-progress-inner"
      }, [y("div", {
        class: "f-progress-bg",
        style: m.value
      }, null), B.value && y("div", {
        class: "f-progress-success-bg",
        style: P.value
      }, null)])]);
    }
    const U = h(() => ({
      width: `${k.value}px`,
      height: `${k.value}px`,
      "font-size": `${k.value * 0.15 + 6}px`,
      "f-progress-circle-gradient": s.value
    })), J = h(() => ({}));
    function Q() {
      return y("div", {
        class: "f-progress-inner",
        style: U.value
      }, [y("svg", {
        class: "f-progress-circle",
        viewBox: "0 0 100 100"
      }, [s.value && y("defs", null, [y("linearGradient", {
        id: "gradient-" + S.value,
        x1: "100%",
        y1: "0%",
        x2: "0%",
        y2: "0%"
      }, [G.value.map((T) => y("stop", {
        offset: T.offset,
        "stop-color": T.color
      }, null))])]), y("path", {
        class: "f-progress-circle-trail",
        stroke: "#efefef",
        "fill-opacity": "0",
        "stroke-width": M.value,
        d: E.value,
        style: J.value
      }, null), p.value.map((T) => y("path", {
        class: "f-progress-circle-path",
        "fill-opacity": "0",
        d: E.value,
        "stroke-linecap": v.value,
        stroke: T.stroke,
        "stroke-width": i.value ? M.value : 0,
        style: T.strokePathStyle
      }, null))])]);
    }
    return () => y("div", {
      ref: j,
      class: b.value
    }, [t.value === "line" && N(), g.value && Q()]);
  }
});
L.register = (e, r, c) => {
  e.progress = L, r.progress = Y;
};
L.registerDesigner = (e, r, c) => {
  e.progress = Ne, r.progress = Y;
};
const Re = I(L);
export {
  L as Progress,
  Re as default,
  W as progressProps,
  Y as propsResolver
};
