var qt = Object.defineProperty;
var Ut = (o, e, t) => e in o ? qt(o, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : o[e] = t;
var q = (o, e, t) => Ut(o, typeof e != "symbol" ? e + "" : e, t);
import { computed as le, getCurrentInstance as at, createVNode as V, reactive as we, withDirectives as Ce, resolveDirective as xe, ref as X, defineComponent as Se, onMounted as Ie, onUnmounted as ct, watch as Te, nextTick as he, inject as ce, provide as ut, onBeforeUnmount as Ht, withModifiers as Wt, createTextVNode as zt } from "vue";
import { isPlainObject as ot, cloneDeep as ge } from "lodash-es";
import "bignumber.js";
import { getCustomClass as pe, withInstall as Xt } from "../common/index.esm.js";
import { useDesignerInnerComponent as Yt, useDesignerComponent as Gt } from "../designer-canvas/index.esm.js";
class dt {
  constructor(e) {
    /** 工具栏项标识 */
    q(this, "id", "");
    /** 工具栏项自定义样式 */
    q(this, "class", "btn-secondary");
    /** 图标 */
    q(this, "icon", "");
    /** 所属分组 */
    q(this, "groupId", "");
    /** 收藏顺序 */
    q(this, "order", -1);
    /** 是否作为下拉菜单的顶层按钮 */
    q(this, "asDropDownTop", !1);
    /** 文本 */
    q(this, "text", "");
    /** 是否可见原值 */
    q(this, "visible", !0);
    /** 控制界面是否显示 */
    q(this, "shown", !0);
    q(this, "responsed", !1);
    /** 是否启用提示消息 */
    q(this, "tipsEnable", !1);
    /** 提示消息内容 */
    q(this, "tipsText", "");
    /** 记录宽度 */
    q(this, "width", 0);
    /** 下拉时的样式名 */
    q(this, "dropdownClass", "");
    q(this, "onClick", () => {
    });
    q(this, "options");
    var n, r;
    this.options = e;
    const t = [
      "id",
      "class",
      "icon",
      "groupId",
      "order",
      "asDropDownTop",
      "text",
      "isDP",
      "visible",
      "responsed",
      "width",
      "tipsEnable",
      "tipsText",
      "dropdownClass",
      "onClick"
    ];
    Object.keys(e).filter((i) => t.indexOf(i) > -1).forEach((i) => {
      i === "visible" ? this[i] = e[i] === void 0 ? !0 : e[i] : this[i] = e[i];
    }), this.shown = this.visible, (n = e.appearance) != null && n.class && (this.class = (r = e.appearance) == null ? void 0 : r.class);
  }
  /** 是否可用 */
  get enable() {
    return Object.keys(this.options).indexOf("disabled") > -1 ? !this.options.disabled : le(() => !0);
  }
  /** 设置宽度 */
  setWidth(e) {
    this.width = parseInt(e, 10);
  }
  /** 获取宽度 */
  getWidth() {
    return this.visible ? this.width : !1;
  }
}
class Qt extends dt {
  constructor(e) {
    super(e);
  }
}
function ft() {
  function o(e) {
    const t = [];
    return e.reduce((n, r) => (r.children && r.children.length > 0 ? n.push(new ye(r)) : n.push(new Qt(r)), n), t), t;
  }
  return { buildResponseToolbarItems: o };
}
const { buildResponseToolbarItems: Jt } = ft();
class ye extends dt {
  constructor(t) {
    super(t);
    q(this, "placement", "");
    // 下拉位置
    /** 是否可见 */
    q(this, "visible", !0);
    /** 下拉class */
    q(this, "dropdownClass", "");
    /** 下拉菜单class */
    q(this, "menuClass", "");
    /** 是否用分开的下拉按钮 */
    q(this, "split", !1);
    q(this, "children", []);
    q(this, "expanded", !1);
    q(this, "shown", !0);
    const n = ["visible", "icon", "isDP", "class", "dropdownClass", "menuClass", "placement", "split", "expanded"];
    Object.keys(t).filter((r) => n.indexOf(r) > -1).forEach((r) => {
      r === "visible" ? this[r] = t[r] === void 0 ? !0 : t[r] : this[r] = t[r];
    }), this.shown = this.visible, t.children && t.children.length && (this.children = Jt(t.children));
  }
}
class co {
  constructor(e, t) {
    q(this, "id");
    q(this, "name");
    /** 记录元素的Id */
    q(this, "presetId", []);
    /** 记录转变为下拉时元素的位置 */
    q(this, "responsedIndex", []);
    /** 记录宽度 */
    q(this, "width");
    this.id = e, this.name = t, this.width = 0;
  }
  // 设置宽度
  setWidth(e) {
    this.width = parseInt(e + "", 10);
  }
  // 获取宽度
  getWidth() {
    return this.width;
  }
  // 更新presetIndex
  setPreset(e) {
    Array.isArray(e) ? this.presetId = this.presetId.concat(e) : this.presetId.push(e);
  }
  // 清除preset
  delPreset() {
    this.presetId = [];
  }
  // 删除
  removeResponsed(e) {
    this.responsedIndex.splice(e, 1);
  }
  // 更新responsedIndex
  setResponsed(e) {
    Array.isArray(e) ? this.responsedIndex = this.responsedIndex.concat(e) : this.responsedIndex.push(e);
  }
  // 是否已经开始处理响应式
  isResponsing() {
    return this.responsedIndex.length > 0;
  }
  // 是否已经处理完响应式
  isResponsed() {
    return this.presetId.length === this.responsedIndex.length;
  }
}
const pt = {}, gt = {};
function Fe(o) {
  const { properties: e, title: t, ignore: n } = o, r = n && Array.isArray(n), i = Object.keys(e).reduce((s, p) => ((!r || !n.find((c) => c === p)) && (s[p] = e[p].type === "object" && e[p].properties ? Fe(e[p]) : ge(e[p].default)), s), {});
  if (t && (!r || !n.find((s) => s === "id"))) {
    const s = t.toLowerCase().replace(/-/g, "_");
    i.id = `${s}_${Math.random().toString().slice(2, 6)}`;
  }
  return i;
}
function Zt(o) {
  const { properties: e, title: t, required: n } = o;
  if (n && Array.isArray(n)) {
    const r = n.reduce((i, s) => (i[s] = e[s].type === "object" && e[s].properties ? Fe(e[s]) : ge(e[s].default), i), {});
    if (t && n.find((i) => i === "id")) {
      const i = t.toLowerCase().replace(/-/g, "_");
      r.id = `${i}_${Math.random().toString().slice(2, 6)}`;
    }
    return r;
  }
  return {
    type: t
  };
}
function ve(o, e = {}, t) {
  const n = pt[o];
  if (n) {
    let r = Zt(n);
    const i = gt[o];
    return r = i ? i({ getSchemaByType: ve }, r, e, t) : r, r;
  }
  return null;
}
function Kt(o, e) {
  const t = Fe(e);
  return Object.keys(t).reduce((n, r) => (Object.prototype.hasOwnProperty.call(o, r) && (n[r] && ot(n[r]) && ot(o[r] || !o[r]) ? Object.assign(n[r], o[r] || {}) : n[r] = o[r]), n), t), t;
}
function ht(o, e) {
  return Object.keys(o).filter((n) => o[n] != null).reduce((n, r) => {
    if (e.has(r)) {
      const i = e.get(r);
      if (typeof i == "string")
        n[i] = o[r];
      else {
        const s = i(r, o[r], o);
        Object.assign(n, s);
      }
    } else
      n[r] = o[r];
    return n;
  }, {});
}
function en(o, e, t = /* @__PURE__ */ new Map()) {
  const n = Kt(o, e);
  return ht(n, t);
}
function tn(o = {}) {
  function e(f, h, l, g) {
    if (typeof l == "number")
      return g[f].length === l;
    if (typeof l == "object") {
      const d = Object.keys(l)[0], m = l[d];
      if (d === "not")
        return Number(g[f].length) !== Number(m);
      if (d === "moreThan")
        return Number(g[f].length) >= Number(m);
      if (d === "lessThan")
        return Number(g[f].length) <= Number(m);
    }
    return !1;
  }
  function t(f, h, l, g) {
    return g[f] && g[f].propertyValue && String(g[f].propertyValue.value) === String(l);
  }
  const n = /* @__PURE__ */ new Map([
    ["length", e],
    ["getProperty", t]
  ]);
  Object.keys(o).reduce((f, h) => (f.set(h, o[h]), f), n);
  function r(f, h) {
    const l = f;
    return typeof h == "number" ? [{ target: l, operator: "length", param: null, value: Number(h) }] : typeof h == "boolean" ? [{ target: l, operator: "getProperty", param: f, value: !!h }] : typeof h == "object" ? Object.keys(h).map((g) => {
      if (g === "length")
        return { target: l, operator: "length", param: null, value: h[g] };
      const d = g, m = h[g];
      return { target: l, operator: "getProperty", param: d, value: m };
    }) : [];
  }
  function i(f) {
    return Object.keys(f).reduce((l, g) => {
      const d = r(g, f[g]);
      return l.push(...d), l;
    }, []);
  }
  function s(f, h) {
    if (n.has(f.operator)) {
      const l = n.get(f.operator);
      return l && l(f.target, f.param, f.value, h) || !1;
    }
    return !1;
  }
  function p(f, h) {
    return i(f).reduce((d, m) => d && s(m, h), !0);
  }
  function c(f, h) {
    const l = Object.keys(f), g = l.includes("allOf"), d = l.includes("anyOf"), m = g || d, b = (m ? f[m ? g ? "allOf" : "anyOf" : "allOf"] : [f]).map((E) => p(E, h));
    return g ? !b.includes(!1) : b.includes(!0);
  }
  return { parseValueSchema: c };
}
const nn = {
  button: { type: "button", name: "按钮" },
  "response-toolbar": { type: "response-toolbar", name: "工具栏" },
  "response-toolbar-item": { type: "response-toolbar-item", name: "按钮" },
  "content-container": { type: "content-container", name: "容器" },
  "input-group": { type: "input-group", name: "文本" },
  textarea: { type: "textarea", name: "多行文本" },
  lookup: { type: "lookup", name: "帮助" },
  "number-spinner": { type: "number-spinner", name: "数值" },
  "date-picker": { type: "date-picker", name: "日期" },
  switch: { type: "switch", name: "开关" },
  "radio-group": { type: "radio-group", name: "单选组" },
  "check-box": { type: "check-box", name: "复选框" },
  "check-group": { type: "check-group", name: "复选框组" },
  "combo-list": { type: "combo-list", name: "下拉列表" },
  "response-form": { type: "response-form", name: "卡片面板" },
  "response-layout": { type: "response-layout", name: "布局容器", icon: "response-layout-3" },
  "response-layout-item": { type: "response-layout-item", name: "布局", icon: "response-layout-1" },
  "tree-grid": { type: "tree-grid", name: "树表格" },
  "tree-grid-column": { type: "tree-grid-column", name: "树表格列" },
  "data-grid": { type: "data-grid", name: "表格" },
  "data-grid-column": { type: "data-grid-column", name: "表格列" },
  module: { type: "Module", name: "模块" },
  component: { type: "component", name: "组件" },
  tabs: { type: "tabs", name: "标签页" },
  "tab-page": { type: "tab-page", name: "标签页项", dependentParentControl: "Tab" },
  "tab-toolbar-item": { type: "tab-toolbar-item", name: "标签页工具栏按钮" },
  "html-template": { type: "html-template", name: "模板容器" },
  "time-picker": { type: "time-picker", name: "时间选择" },
  section: { type: "section", name: "分组面板" },
  "section-toolbar": { type: "section-toolbar", name: "分组面板工具栏" },
  "section-toolbar-item": { type: "section-toolbar-item", name: "分组面板按钮" },
  splitter: { type: "splitter", name: "分栏面板" },
  "splitter-pane": { type: "splitter-pane", name: "分栏面板项", dependentParentControl: "Splitter" },
  "component-ref": { type: "component-ref", name: "组件引用节点" },
  uploader: { type: "uploader", name: "附件上传" },
  "page-header": { type: "page-header", name: "页头" },
  "page-footer": { type: "page-footer", name: "页脚" },
  "tab-toolbar": { type: "tab-toolbar", name: "标签页工具栏" },
  fieldset: { type: "fieldset", name: "分组" },
  "query-solution": { type: "query-solution", name: "筛选方案" },
  drawer: { type: "drawer", name: "抽屉" },
  "external-container": { type: "external-container", name: "外部容器", icon: "content-container" },
  "list-nav": { type: "list-nav", name: "列表导航" },
  "filter-bar": { type: "filter-bar", name: "筛选条" }
}, on = {}, rn = {};
tn();
function mt(o, e, t = /* @__PURE__ */ new Map(), n = (s, p, c, f) => p, r = {}, i = (s) => s) {
  return pt[e.title] = e, gt[e.title] = n, on[e.title] = r, rn[e.title] = i, (s = {}, p = !0) => {
    if (!p)
      return ht(s, t);
    const c = en(s, e, t), f = Object.keys(o).reduce((h, l) => (h[l] = o[l].default, h), {});
    return Object.assign(f, c);
  };
}
function sn(o, e) {
  return { customClass: e.class, customStyle: e.style };
}
function ln(o, e) {
  if (!o || o.length < 1)
    return null;
  for (const t of o) {
    if (t.id === e)
      return t;
    if (t.children) {
      const n = t.children.find((r) => r.id === e);
      if (n)
        return n;
    }
  }
  return null;
}
function an() {
  function o(e, t) {
    const n = e.buttons;
    if (!n || n.length < 1)
      return null;
    const [r, i] = t.payloads, s = ln(n, i);
    return s ? s.onClick || s.click : null;
  }
  return {
    resolve: o
  };
}
const cn = /* @__PURE__ */ new Map([
  ["buttons", "items"],
  ["appearance", sn]
]);
function vt(o, e, t) {
  return e;
}
const un = "https://json-schema.org/draft/2020-12/schema", dn = "https://farris-design.gitee.io/response-toolbar.schema.json", fn = "response-toolbar", pn = "A Farris Toolbar Component", gn = "object", hn = {
  id: {
    description: "The unique identifier for a Response Toolbar",
    type: "string"
  },
  type: {
    description: "The type string of Response Toolbar",
    type: "string",
    default: "response-toolbar"
  },
  appearance: {
    description: "",
    type: "object",
    properties: {
      class: {
        type: "string",
        default: ""
      }
    }
  },
  alignment: {
    description: "The alignment of Response Toolbar Button.",
    type: "string",
    default: "right"
  },
  buttons: {
    description: "The items of Response Toolbar.",
    type: "array",
    default: []
  },
  buttonSize: {
    type: "string",
    default: ""
  },
  visible: {
    description: "",
    type: "boolean",
    default: !0
  }
}, mn = [
  "id",
  "type",
  "buttons"
], vn = {
  onClick: "点击事件"
}, bn = {
  $schema: un,
  $id: dn,
  title: fn,
  description: pn,
  type: gn,
  properties: hn,
  required: mn,
  events: vn
}, yn = "https://json-schema.org/draft/2020-12/schema", wn = "https://farris-design.gitee.io/response-toolbar-item.schema.json", Cn = "response-toolbar-item", xn = "A Farris Toolbar Item Component", Tn = "object", En = {
  id: {
    description: "The unique identifier for a Response Toolbar",
    type: "string"
  },
  type: {
    description: "The type string of Response Toolbar",
    type: "string",
    default: "response-toolbar-item"
  },
  appearance: {
    description: "",
    type: "object",
    properties: {
      class: {
        type: "string",
        default: ""
      }
    }
  },
  alignment: {
    description: "对齐",
    type: "string",
    default: "right"
  },
  text: {
    description: "文本",
    type: "string",
    default: "按钮"
  },
  icon: {
    description: "图标",
    type: "string",
    default: ""
  },
  disabled: {
    description: "禁用",
    type: "boolean",
    default: !1
  },
  visible: {
    description: "是否可见",
    type: "boolean",
    default: !0
  },
  onClick: {
    description: "点击事件",
    type: "string",
    default: ""
  },
  tipsEnable: {
    description: "",
    type: "boolean",
    default: !1
  },
  tipsText: {
    description: "",
    type: "string",
    default: ""
  },
  dropdownClass: {
    description: "处于下拉菜单时的样式",
    type: "string",
    default: ""
  },
  split: {
    description: "",
    type: "boolean",
    default: !1
  }
}, Sn = [
  "id",
  "type",
  "text"
], In = {
  $schema: yn,
  $id: wn,
  title: Cn,
  description: xn,
  type: Tn,
  properties: En,
  required: Sn
}, Le = {
  id: { type: String, default: "" },
  /**  组件自定义样式 */
  customClass: { type: String, default: "" },
  alignment: { Type: String, default: "right" },
  items: {
    Type: Array,
    default: []
  },
  /** 控制是否可见 */
  visible: { type: Boolean, default: !0 }
}, Pn = Object.assign({}, Le, {
  componentId: { type: String, default: "" }
}), qe = mt(
  Le,
  bn,
  cn,
  vt
), bt = {
  id: { type: String, default: "" },
  item: { type: Object, default: {} },
  items: { type: Object, default: {} },
  class: { type: String, default: "btn-secondary" },
  text: { type: String, default: "" },
  disabled: { type: Boolean, default: !1 },
  icon: { type: String, default: "" },
  componentId: { type: String, default: "" },
  // 是否展开子级
  expanded: { type: Boolean, default: !1 },
  alignment: { Type: String, default: "right" },
  split: { type: Boolean, default: !1 },
  // 是否下拉
  isDP: { type: Boolean, default: !1 },
  // 是否下拉项
  isDPItem: { type: Boolean, default: !1 }
}, Mn = mt(
  bt,
  In,
  void 0,
  vt
), kn = an();
function Ue() {
  function o(t) {
    const n = {
      "f-icon": !0
    };
    if (t.icon) {
      const r = t.icon.trim().split(" ");
      r && r.length && r.reduce((i, s) => (i[s] = !0, i), n);
    }
    return n;
  }
  function e(t) {
    return !!(t.icon && t.icon.trim());
  }
  return { iconClass: o, shouldShowIcon: e };
}
const Dn = ["moz", "ms", "webkit"];
function Rn() {
  let o = 0;
  return (e) => {
    const t = (/* @__PURE__ */ new Date()).getTime(), n = Math.max(0, 16 - (t - o)), r = setTimeout(() => {
      e(t + n);
    }, n);
    return o = t + n, r;
  };
}
function Bn() {
  if (typeof window > "u")
    return () => 0;
  if (window.requestAnimationFrame)
    return window.requestAnimationFrame.bind(window);
  const o = Dn.filter((e) => `${e}RequestAnimationFrame` in window)[0];
  return o ? window[`${o}RequestAnimationFrame`] : Rn();
}
Bn();
function _e(o, e) {
  return ((e == null ? void 0 : e.split(" ")) || []).reduce((n, r) => (r && (n[r] = !0), n), o), o;
}
function An(o, e) {
  function t(b) {
    const u = {
      "dropdown-menu": !0
    };
    if (b.class) {
      const E = b.menuClass.split(" ");
      E && E.length && E.reduce((D, M) => (D[M] = !0, D), u);
    }
    return u;
  }
  function n(b) {
    const u = {
      disabled: !b.enable,
      "dropdown-submenu": !0,
      "f-rt-dropdown": !0,
      "text-truncate": !0
    };
    return _e(u, b.dropdownClass);
  }
  function r(b) {
    const u = {
      disabled: !b.enable,
      "dropdown-item": !0,
      "f-rt-btn": !0,
      "text-truncate": !0
    };
    return _e(u, b.dropdownClass);
  }
  function i(b) {
    const u = {
      disabled: !b.enable,
      "dropdown-item": !0,
      "f-rt-btn": !0,
      "text-truncate": !0,
      "f-rt-toggle": !0
    };
    return _e(u, b.dropdownClass);
  }
  let s;
  const p = /* @__PURE__ */ new Map();
  function c(b, u, E) {
    b.stopPropagation();
    const D = E ? E.id : "__top_item__";
    if (u.children && u.children.length && (u.expanded = !u.expanded, u.expanded)) {
      if (p.has(D) && p.get(D) !== u) {
        const M = p.get(D);
        M && (M.expanded = !1, p.delete(D));
      }
      p.set(D, u);
    }
  }
  function f(b, u) {
    document.body.click(), u.enable && (b.stopPropagation(), typeof u.onClick == "function" && u.onClick(b, u.id), o.emit("click", b, u.id));
  }
  function h(b, u) {
    const E = b.target;
    E.className.indexOf("dropdown-item") < 0 || (E.title = E.scrollWidth > E.clientWidth ? u : "");
  }
  function l(b, u) {
    if (u.tipsEnable && u.tipsText) {
      const E = we({
        content: u.tipsText,
        enable: u.tipsEnable
      });
      return Ce(V("li", {
        class: r(u),
        id: u.id,
        onClick: (D) => f(D, u)
      }, [V("span", {
        class: "f-rt-btn text-truncate"
      }, [e.shouldShowIcon(u) && V("i", {
        class: e.iconClass(u)
      }, null), u.text])]), [[xe("tooltip"), E]]);
    }
    return V("li", {
      class: r(u),
      id: u.id,
      onClick: (E) => f(E, u)
    }, [V("span", {
      class: "f-rt-btn text-truncate",
      onMouseenter: (E) => h(E, u.text)
    }, [e.shouldShowIcon(u) && V("i", {
      class: e.iconClass(u)
    }, null), u.text])]);
  }
  function g(b, u, E) {
    u.enable && (typeof u.onClick == "function" && E.onClick(b, u.id), o.emit("click", b, u.id), c(b, u, E));
  }
  function d(b, u) {
    if (u.tipsEnable && u.tipsText) {
      const E = we({
        content: u.tipsText,
        enable: u.tipsEnable
      });
      return V("li", {
        class: n(u),
        id: u.id,
        onClick: (D) => g(D, u, b)
      }, [Ce(V("span", {
        class: i(u)
      }, [e.shouldShowIcon(u) && V("i", {
        class: e.iconClass(u)
      }, null), u.text]), [[xe("tooltip"), E]]), s(u, u)]);
    }
    return V("li", {
      class: n(u),
      id: u.id,
      onClick: (E) => g(E, u, b),
      onMouseenter: (E) => h(E, u.text)
    }, [V("span", {
      class: i(u)
    }, [e.shouldShowIcon(u) && V("i", {
      class: e.iconClass(u)
    }, null), u.text]), s(u, u)]);
  }
  function m(b) {
    return b.children.filter((u) => u.visible).map((u) => u.children && u.children.length ? d(b, u) : l(b, u));
  }
  function w(b, u, E) {
    var j;
    const D = {
      display: b.expanded ? "block" : "none",
      position: "fixed",
      maxWidth: "300px",
      minWidth: "120px",
      zIndex: 1040
    }, M = (j = document.getElementsByTagName("body")[0].getClientRects()[0]) == null ? void 0 : j.width, O = u, N = O == null ? void 0 : O.getClientRects();
    if (O && N && N.length) {
      const {
        top: U,
        width: x,
        left: a,
        right: S,
        height: k
      } = N[0], y = Math.ceil(k + U);
      D.top = `${y}px`, D.left = `${a}px`;
      const I = b.id + "_menu", B = u ? u.querySelector("#" + I) : null;
      if (B) {
        B.style.visibility = "hidden", B.style.display = "block";
        const C = B.offsetHeight;
        D.display === "block" && (B.style.display = "block");
        const T = B.getBoundingClientRect();
        if (E) {
          D.top = `${U - 6}px`;
          const _ = Math.ceil(x + a);
          D.left = `${_}px`;
        }
        M - a - x < T.width && (D.left = `${(E ? a : S) - T.width}px`), window.innerHeight - U - k < C && (U > C ? D.top = `${U - C - 6}px` : (D.maxHeight = `${U - 16}px`, D.overflowY = "auto", U - k > window.innerHeight - U && (D.top = "10px"))), B.style.visibility = "visible";
      }
    }
    return D;
  }
  s = function(b, u) {
    var O, N;
    const E = at(), D = u ? u.id : b.id, M = (N = (O = E == null ? void 0 : E.exposed) == null ? void 0 : O.elementRef.value) == null ? void 0 : N.querySelector("#" + D);
    return V("ul", {
      class: t(b),
      style: w(b, M, u),
      id: b.id + "_menu"
    }, [m(b)]);
  };
  function P() {
    p.forEach((b) => {
      b.expanded = !1;
    }), p.clear();
  }
  return {
    renderDropdownMenu: s,
    clearAllDropDownMenu: P
  };
}
function On(o, e, t) {
  const n = X(o.alignment), {
    renderDropdownMenu: r,
    clearAllDropDownMenu: i
  } = An(e, t);
  function s(l) {
    const g = {
      "btn-group": !0,
      "f-rt-dropdown": !0,
      "f-btn-ml": n.value === "right" || n.value === "center",
      "f-btn-mr": n.value === "left"
    }, d = l.dropdownClass.split(" ");
    return d && d.length && d.reduce((m, w) => (m[w] = !0, m), g), g;
  }
  function p(l) {
    const g = {
      btn: !0,
      disabled: !l.enable,
      "f-rt-btn": !0,
      "btn-icontext": !!(l.icon && l.icon.trim())
    };
    if (l.class) {
      const d = l.class.split(" ");
      d && d.length && d.reduce((m, w) => (m[w] = !0, m), g);
    }
    return g;
  }
  function c(l, g) {
    l.stopPropagation();
    const d = g.expanded;
    document.body.click(), typeof g.onClick == "function" && g.onClick(l, g.id), e.emit("click", l, g.id), g.expanded = !d;
  }
  function f(l, g = !0) {
    if (l.tipsEnable && l.tipsText) {
      const d = we({
        content: l.tipsText,
        enable: l.tipsEnable
      });
      return V("div", {
        id: l.id,
        class: s(l)
      }, [Ce(V("div", {
        class: p(l),
        style: "display: flex;padding-right: 0.1rem;border-top-right-radius: 6px;border-bottom-right-radius: 6px",
        onClick: (m) => l.enable && c(m, l)
      }, [t.shouldShowIcon(l) && V("i", {
        class: t.iconClass(l)
      }, null), V("span", null, [l.text]), V("i", {
        class: "f-icon f-icon-arrow-chevron-down",
        style: "display: inline-block;float: right;line-height: 1.25rem;margin-left: .25rem;margin-right: .25rem;"
      }, null)]), [[xe("tooltip"), d]]), g && r(l)]);
    }
    return V("div", {
      id: l.id,
      class: s(l)
    }, [V("div", {
      class: p(l),
      style: "display: flex;padding-right: 0.1rem;border-top-right-radius: 6px;border-bottom-right-radius: 6px",
      onClick: (d) => l.enable && c(d, l)
    }, [t.shouldShowIcon(l) && V("i", {
      class: t.iconClass(l)
    }, null), V("span", null, [l.text]), V("i", {
      class: "f-icon f-icon-arrow-chevron-down",
      style: "display: inline-block;float: right;line-height: 1.25rem;margin-left: .25rem;margin-right: .25rem;"
    }, null)]), g && r(l)]);
  }
  function h() {
    i();
  }
  return {
    renderToolbarDropdown: f,
    clearAllDropDown: h
  };
}
const {
  buildResponseToolbarItems: rt
} = ft(), Ee = /* @__PURE__ */ Se({
  name: "FResponseToolbar",
  props: Le,
  emits: ["click"],
  setup(o, e) {
    const t = X(rt(o.items)), n = X(), r = X(), i = X(), s = {
      id: "__more_buttons__",
      text: "更多"
    }, p = X(new ye(s)), c = {
      id: s.id + "width",
      text: s.text
    }, f = X(-1), h = Ue();
    let l = !1;
    const g = le(() => p.value.children.length > 0), d = le(() => {
      const C = {
        "f-toolbar": !0,
        "f-response-toolbar": !0,
        "position-relative": !0,
        "f-response-toolbar-sm": o.buttonSize === "sm",
        "f-response-toolbar-lg": o.buttonSize === "lg",
        "d-none": !o.visible
      };
      return pe(C, o.customClass);
    }), m = le(() => ({
      "w-100": !0,
      "d-flex": !0,
      "flex-nowrap": !0,
      "justify-content-end": o.alignment === "right",
      "justify-content-start": o.alignment === "left",
      "justify-content-center": o.alignment === "center"
    })), {
      renderToolbarDropdown: w,
      clearAllDropDown: P
    } = On(o, e, h);
    function b(C) {
      C && C.target.closest("ul.dropdown-menu") && C.type === "wheel" || (t.value.filter((T) => T.children && T.children.length > 0).forEach((T) => {
        T.expanded = !1;
      }), p.value.expanded = !1, P());
    }
    function u(C, T) {
      var L;
      const _ = {
        btn: !0,
        "f-rt-btn": !0,
        "f-btn-ml": o.alignment === "right" || T > 0 && o.alignment === "center",
        "f-btn-mr": o.alignment === "left",
        "btn-icontext": !!(C.icon && C.icon.trim())
      }, H = ((L = C == null ? void 0 : C.appearance) == null ? void 0 : L.class) || C.class || "btn-secondary";
      if (H) {
        const z = H.split(" ");
        z && z.length && z.reduce((Y, J) => (Y[J] = !0, Y), _);
      }
      return _;
    }
    function E(C, T) {
      document.body.click(), typeof T.onClick == "function" && T.onClick(C, T.id), e.emit("click", C, T.id);
    }
    function D(C, T) {
      if (C.tipsEnable && C.tipsText) {
        const _ = we({
          content: C.tipsText,
          enable: C.tipsEnable
        });
        return Ce(V("button", {
          type: "button",
          class: u(C, T),
          id: C.id,
          disabled: !C.enable,
          onClick: (H) => E(H, C)
        }, [h.shouldShowIcon(C) && V("i", {
          class: h.iconClass(C)
        }, null), C.text]), [[xe("tooltip"), _]]);
      }
      return V("button", {
        type: "button",
        class: u(C, T),
        id: C.id,
        disabled: !C.enable,
        onClick: (_) => E(_, C)
      }, [h.shouldShowIcon(C) && V("i", {
        class: h.iconClass(C)
      }, null), C.text]);
    }
    let M = /* @__PURE__ */ new Map(), O = [];
    function N(C) {
      const T = C.computedStyleMap().get("margin-left"), _ = C.computedStyleMap().get("margin-right");
      return (T ? T.value : 0) + C.getBoundingClientRect().width + (_ ? _.value : 0);
    }
    function j(C, T, _) {
      if (T < f.value) {
        let H = _ - 1;
        for (; H >= 0; H--) {
          const L = C[H], z = N(L);
          if (T += z, T >= f.value)
            break;
        }
        _ = H;
      }
      return T -= f.value, {
        start: _,
        space: T
      };
    }
    function U(C) {
      const T = i.value;
      let _ = C;
      const L = Array.from(T.children).filter((ee) => ee.id !== "__more_buttons__"), z = L.length;
      let Y = !1, J = 0;
      for (; J < z; J++) {
        const ee = L[J], re = N(ee);
        if (re <= _)
          _ -= re;
        else {
          const Z = j(L, _, J);
          J = Z.start, _ = Z.space, Y = !0;
          break;
        }
      }
      if (!Y && O.length > 0) {
        const ee = j(L, _, J);
        J = ee.start, _ = ee.space;
      }
      const W = O.length > 0;
      for (; J < z; J++) {
        const ee = L[J], re = N(ee);
        M.set(ee.id, !0), O[W ? "unshift" : "push"]({
          id: ee.id,
          width: re
        });
      }
      return _;
    }
    function x(C) {
      let T = U(C);
      if (O.length) {
        let z = 0;
        for (; z < O.length; z++) {
          const Y = o.items.find((J) => J.id === O[z].id);
          if (Y && Y.visible !== !1) {
            const J = O[z].width;
            if (T >= J || z === O.length - 1 && T + f.value >= J)
              T -= J;
            else
              break;
          }
        }
        for (let Y = 0; Y < z; Y++)
          M.delete(O[Y].id);
        O.splice(0, z - 1);
      }
      const _ = Object.assign({}, p.value);
      _.children = [];
      const H = new ye(_), L = t.value.reduce((z, Y) => {
        const J = o.items.find((W) => W.id === Y.id);
        return M.has(Y.id) ? (H.children.push(Y), Y.shown = !1) : Y.shown = J.visible !== !1, z.push(Y), z;
      }, []);
      p.value = H, t.value = L;
    }
    function a(C = -1) {
      if (C === 0 || !i.value || !r.value)
        return;
      C < 0 && (C = r.value.getBoundingClientRect().width);
      const T = i.value.getBoundingClientRect().width;
      (C >= 0 && C < T || O.length) && (x(C), b());
    }
    function S() {
      return f.value < 0 && V("div", {
        style: "position:absolute;top:-30px;visibility:hidden;"
      }, [w(new ye(c))]);
    }
    const k = new ResizeObserver((C) => {
      if (C.length) {
        const _ = C[0].contentRect.width;
        a(_);
      }
    });
    function y() {
      M = /* @__PURE__ */ new Map(), O = [];
    }
    function I() {
      r.value && !l && (k.observe(r.value), l = !0);
    }
    function B() {
      if (n.value && f.value < 0) {
        const C = n.value.querySelector("#" + c.id);
        C && (f.value = N(C));
      }
    }
    return Ie(() => {
      B(), a(), I(), document.body.addEventListener("click", b), document.body.addEventListener("wheel", b);
    }), ct(() => {
      k.disconnect(), document.body.removeEventListener("click", b), document.body.removeEventListener("wheel", b);
    }), Te(() => o.items, () => {
      t.value = rt(o.items), p.value.children = [], he(() => {
        y(), a();
      });
    }, {
      deep: !0
    }), Te(() => o.visible, (C) => {
      C && he(() => {
        B(), a(), I();
      });
    }), e.expose({
      elementRef: n
    }), () => V("div", {
      class: d.value,
      id: o.id,
      ref: n,
      style: {
        "overflow-y": f.value < 0 ? "hidden" : "initial"
      }
    }, [o.visible && S(), o.visible && V("div", {
      ref: r,
      class: m.value
    }, [V("div", {
      ref: i,
      class: "d-inline-block f-response-content",
      style: "white-space: nowrap;"
    }, [t.value.filter((C) => C.shown).map((C, T) => C.children && C.children.length > 0 ? w(C) : D(C, T)), g.value && w(p.value)])])]);
  }
}), Vn = X(0);
function Nn() {
  Vn.value++;
}
const me = X(0);
function _n(o, e) {
  const t = e.getBoundingClientRect(), n = o.getBoundingClientRect(), r = n.top >= t.top, i = n.top <= t.bottom;
  return r && i;
}
function yt(o) {
  const e = o.querySelector(".component-btn-group");
  if (!e)
    return;
  e.style.display = "";
  const t = e.getBoundingClientRect();
  if (!(t.top === 0 && t.left === 0)) {
    const n = e.querySelector("div");
    if (n) {
      const r = n.getBoundingClientRect();
      n.style.top = t.top + "px";
      let i = t.left - r.width;
      const s = document.querySelector(".editorDiv");
      if (s) {
        const p = s.getBoundingClientRect();
        i < p.left && ({ left: i } = o.getBoundingClientRect());
      }
      n.style.left = i + "px";
    }
  }
}
function jn(o) {
  if (!window.scrollContainerList)
    return;
  const e = Array.from(window.scrollContainerList);
  if (e.length && e.length === 1) {
    const t = e[0], n = document.querySelector(`[id=${t}]`);
    if (n && n.contains(o))
      return n;
  }
}
function wt(o) {
  if (!o)
    return;
  const e = o.getBoundingClientRect();
  if (e.width === 0 && e.height === 0)
    return;
  const t = o.querySelector(".component-btn-group");
  if (t) {
    let n = !0;
    const r = jn(o);
    if (r && (n = _n(o, r)), !n) {
      t.style.display = "none";
      return;
    }
    yt(o);
  }
}
function $n(o) {
  if (!o)
    return;
  let e;
  o.className.includes("dgComponentSelected") ? e = o : e = o.querySelector(".dgComponentSelected"), e && wt(e);
}
function Fn(o) {
  const { formSchemaUtils: e, formStateMachineUtils: t } = o;
  function n(c, f = "") {
    return {
      path: f + c.code,
      field: c.id,
      fullPath: c.code
    };
  }
  function r(c, f = "") {
    return e.getViewModelById(c).states.map((l) => n(l, f));
  }
  function i(c) {
    const f = e.getRootViewModelId(), h = r(c);
    if (c === f)
      return h;
    const l = r(f, "root-component.");
    return [...h, ...l];
  }
  function s(c) {
    return c.binding && c.binding.path || c.id || "";
  }
  function p() {
    return t && t.getRenderStates() || [];
  }
  return { getVariables: i, getControlName: s, getStateMachines: p };
}
class Ln {
  constructor(e) {
    q(this, "sessionVariables", [
      {
        key: "CurrentSysOrgName",
        name: "当前组织Name",
        description: "当前组织Name"
      },
      //   {
      //     key: "CurrentSysOrgCode",
      //     name: "当前组织Code",
      //     description: "当前组织Code"
      //   },
      {
        key: "CurrentSysOrgId",
        name: "当前组织Id",
        description: "当前组织Id"
      },
      {
        key: "CurrentUserName",
        name: "当前用户Name",
        description: "当前用户Name"
      },
      {
        key: "CurrentUserCode",
        name: "当前用户Code",
        description: "当前用户Code"
      },
      {
        key: "CurrentUserId",
        name: "当前用户Id",
        description: "当前用户Id"
      },
      {
        key: "CurrentLanguage",
        name: "当前语言编号",
        description: "当前登录的语言编号，例如简体中文返回'zh-CHS'，英文返回'en'，繁体中文'zh-CHT'"
      }
    ]);
    q(this, "expressionNames", {
      compute: "计算表达式",
      dependency: "依赖表达式",
      validate: "验证表达式",
      dataPicking: "帮助前表达式",
      visible: "可见表达式",
      readonly: "只读表达式",
      required: "必填表达式"
    });
    q(this, "getExpressionConverter", (e, t) => ({
      convertFrom: (n, r, i, s) => {
        const p = i.getExpressionRuleValue(e, t || r);
        return p && p.value || "";
      },
      convertTo: (n, r, i, s, p) => {
        var c;
        if (r === "dataPicking" && (i != null && i.target)) {
          const f = `${i.target}_dataPicking`;
          ((c = i.rules) == null ? void 0 : c.some(
            (l) => l.id === f && l.value
          )) ? n.dictPickingExpressionId = f : delete n.dictPickingExpressionId;
        }
        s.updateExpression(i);
      }
    }));
    this.formSchemaService = e;
  }
  getExpressionRule(e, t) {
    const n = this.formSchemaService.getExpressions();
    if (!n)
      return "";
    const r = n.find((s) => s.target === e);
    if (!r)
      return "";
    const i = r.rules.find((s) => s.type === t);
    return i || "";
  }
  // 获取上下文表单变量
  getContextFormVariables() {
    const { module: e } = this.formSchemaService.getFormSchema();
    if (!e.viewmodels || e.viewmodels.length === 0)
      return [];
    const t = this.formSchemaService.getRootViewModelId(), n = this.formSchemaService.getViewModelById(t);
    if (!n || !n.states || n.states.length === 0)
      return [];
    const r = [];
    return n.states.forEach((i) => {
      r.push({
        key: i.code,
        name: i.name,
        description: i.name,
        category: i.category
      });
    }), r;
  }
  createTreeNode(e, t, n = "label") {
    return {
      id: e.id,
      name: e.name,
      bindingPath: e[n],
      parents: t
    };
  }
  buildEntityFieldsTreeData(e = null, t) {
    const n = [];
    return e == null || e.forEach((r) => {
      var p;
      const i = this.createTreeNode(r, t);
      let s = [];
      (p = r.type) != null && p.fields && (s = this.buildEntityFieldsTreeData(r.type.fields, [...t, r.label])), n.push({
        data: i,
        children: s,
        expanded: !0
      });
    }), n;
  }
  buildChildEntityTreeData(e = null, t) {
    const n = [];
    return e == null || e.forEach((r) => {
      var c, f;
      const i = this.createTreeNode(r, t), s = this.buildEntityFieldsTreeData((c = r.type) == null ? void 0 : c.fields, [...t, r.label]), p = this.buildChildEntityTreeData((f = r.type) == null ? void 0 : f.entities, [...t, r.label]);
      p != null && p.length && (s == null || s.push(...p)), n.push({
        data: i,
        children: s || [],
        // 空值回退
        expanded: !0
      });
    }), n;
  }
  getEntitiesTreeData() {
    const e = this.formSchemaService.getSchemaEntities();
    if (!(e != null && e.length))
      return [];
    const t = e[0];
    if (!(t != null && t.type))
      return [];
    const n = this.buildEntityFieldsTreeData(t.type.fields, [t.code]), r = this.buildChildEntityTreeData(t.type.entities, [t.code]);
    return r != null && r.length && (n == null || n.push(...r)), {
      entityCode: t.code,
      fields: [{
        data: this.createTreeNode(t, [], "code"),
        children: n || []
      }]
    };
  }
  getEntitiesAndVariables() {
    return {
      entities: this.getEntitiesTreeData(),
      variables: {
        session: {
          name: "系统变量",
          items: this.sessionVariables,
          visible: !1
        },
        forms: {
          name: "表单变量",
          items: this.getContextFormVariables(),
          visible: !0
        }
      }
    };
  }
  onBeforeOpenExpression(e, t, n) {
    const r = n === "Field" ? e.binding.field : e.id, i = this.getExpressionRule(r, t), s = this.getEntitiesAndVariables(), p = {
      message: ["validate", "required", "dataPicking"].includes(t) && i ? i.message : "",
      ...s
    };
    return i.messageType != null && (p.messageType = i.messageType), p;
  }
  buildRule(e, t, n, r) {
    const { expression: i, message: s, messageType: p } = t, c = {
      id: `${e}_${n}`,
      type: n,
      value: i
    };
    return (n === "validate" || n === "dataPicking" || n === "required") && (c.message = s), n === "dataPicking" && (c.messageType = p), n === "validate" && r && (c.elementId = r), c;
  }
  getExpressionData() {
    const { expressions: e } = this.formSchemaService.getFormSchema().module;
    return e || [];
  }
  updateExpression(e, t, n, r) {
    const i = t === "Field" ? e.binding.field : e.id, s = this.buildRule(i, n, r, e.type === "form-group" ? e.id : "");
    let c = this.getExpressionData().find((h) => h.targetType === t && h.target === i);
    const f = (h) => h.value.trim() === "";
    if (c) {
      const h = c.rules.find((l) => l.id === s.id);
      if (h)
        f(s) ? c.rules = c.rules.filter((l) => l.id !== s.id) : (Object.assign(h, s), r === "validate" && e.type === "form-group" && (h.elementId = e.id));
      else {
        if (f(s))
          return null;
        c.rules = c.rules || [], c.rules.push(s);
      }
    } else {
      if (f(s))
        return null;
      c = {
        target: `${i}`,
        rules: [s],
        targetType: t
      };
    }
    return c;
  }
  getExpressionEditorOptions(e, t, n, r) {
    return n.reduce((i, s) => {
      var c, f;
      const p = t === "Field" ? (c = e == null ? void 0 : e.binding) == null ? void 0 : c.field : e.id;
      return i[s] = {
        hide: t === "Field" ? !!((f = e == null ? void 0 : e.binding) != null && f.field) : !1,
        description: "",
        title: this.expressionNames[s],
        type: "string",
        $converter: this.getExpressionConverter(p),
        editor: {
          type: "expression-editor",
          singleExpand: !1,
          dialogTitle: `${this.expressionNames[s]}编辑器`,
          showMessage: s === "validate" || s === "dataPicking" || s === "required",
          showMessageType: s === "dataPicking",
          beforeOpen: () => this.onBeforeOpenExpression(e, s, t),
          onSubmitModal: (h) => {
            const l = this.updateExpression(e, t, h, s);
            if (r) {
              const g = this.buildRule(p, h, s);
              r(g);
            }
            return l;
          }
        }
      }, i;
    }, {});
  }
  getExpressionInfo(e, t, n) {
    const r = t === "Field" ? e.binding.field : e.id, i = this.getExpressionRule(r, n), s = {
      value: i && i.value,
      targetId: r,
      targetType: t,
      expressionType: n
    };
    return i && i.message && (s.message = i.message), s;
  }
  getExpressionConfig(e, t, n = ["compute", "dependency", "validate"], r) {
    return {
      description: "表达式",
      title: "表达式",
      properties: {
        ...this.getExpressionEditorOptions(e, t, n, r)
      }
    };
  }
  getExpressionOptions(e, t, n) {
    const r = this.getExpressionInfo(e, t, n);
    return {
      dialogTitle: `${this.expressionNames[n]}编辑器`,
      singleExpand: !1,
      showMessage: n === "required",
      beforeOpen: () => this.onBeforeOpenExpression(e, n, t),
      expressionInfo: r
    };
  }
}
class He {
  constructor(e, t) {
    q(this, "componentId");
    q(this, "viewModelId");
    q(this, "eventsEditorUtils");
    q(this, "formSchemaUtils");
    q(this, "formMetadataConverter");
    q(this, "designViewModelUtils");
    q(this, "designViewModelField");
    q(this, "controlCreatorUtils");
    q(this, "designerHostService");
    q(this, "schemaService", null);
    q(this, "metadataService", null);
    q(this, "propertyConfig", {
      type: "object",
      categories: {}
    });
    var n;
    this.componentId = e, this.designerHostService = t, this.eventsEditorUtils = t.eventsEditorUtils, this.formSchemaUtils = t.formSchemaUtils, this.formMetadataConverter = t.formMetadataConverter, this.viewModelId = ((n = this.formSchemaUtils) == null ? void 0 : n.getViewModelIdByComponentId(e)) || "", this.designViewModelUtils = t.designViewModelUtils, this.controlCreatorUtils = t.controlCreatorUtils, this.metadataService = t.metadataService, this.schemaService = t.schemaService;
  }
  getTableInfo() {
    var e;
    return (e = this.schemaService) == null ? void 0 : e.getTableInfoByViewModelId(this.viewModelId);
  }
  setDesignViewModelField(e) {
    var n;
    const t = e.binding && e.binding.type === "Form" && e.binding.field;
    if (t) {
      if (!this.designViewModelField) {
        const r = this.designViewModelUtils.getDgViewModel(this.viewModelId);
        this.designViewModelField = r.fields.find((i) => i.id === t);
      }
      e.updateOn = (n = this.designViewModelField) == null ? void 0 : n.updateOn;
    }
  }
  getBasicPropConfig(e) {
    return {
      description: "Basic Information",
      title: "基本信息",
      properties: {
        id: {
          description: "组件标识",
          title: "标识",
          type: "string",
          readonly: !0
        },
        type: {
          description: "组件类型",
          title: "控件类型",
          type: "select",
          editor: {
            type: "combo-list",
            textField: "name",
            valueField: "value",
            idField: "value",
            editable: !1,
            data: [{ value: e.type, name: nn[e.type].name }]
          }
        }
      }
    };
  }
  getAppearanceConfig(e = null, t = {}, n) {
    const r = {
      title: "外观",
      description: "Appearance"
    }, i = {
      class: {
        title: "class样式",
        type: "string",
        description: "组件的CSS样式",
        $converter: "/converter/appearance.converter"
      },
      style: {
        title: "style样式",
        type: "string",
        description: "组件的样式",
        $converter: "/converter/appearance.converter"
      }
    };
    for (const s in t)
      i[s] = Object.assign(i[s] || {}, t[s]);
    return {
      ...r,
      properties: { ...i },
      setPropertyRelates(s, p) {
        if (s) {
          switch (s && s.propertyID) {
            case "class":
            case "style": {
              me.value++;
              break;
            }
          }
          n && n(s, e, p);
        }
      }
    };
  }
  getPropertyEditorParams(e, t = [], n = "visible", r = {}, i = {}) {
    const { getVariables: s, getControlName: p, getStateMachines: c } = Fn(this.designerHostService), f = this.getRealTargetType(e), h = t && t.length > 0 ? t : ["Const", "Variable", "StateMachine", "Expression"], l = {
      type: "property-editor",
      propertyTypes: h
    };
    return h.map((g) => {
      switch (g) {
        case "Const":
          Object.assign(l, {
            constType: "enum",
            constEnums: [{ id: !0, name: "是" }, { id: !1, name: "否" }]
          }, r);
          break;
        case "Expression":
          l.expressionConfig = this.getExpressionOptions(e, f, n);
          break;
        case "StateMachine":
          l.stateMachines = c();
          break;
        case "Variable":
          Object.assign(l, {
            controlName: p(e),
            newVariablePrefix: "is",
            newVariableType: "Boolean",
            variables: s(this.viewModelId),
            onBeforeOpenVariables: (d) => {
              d.value = s(this.viewModelId);
            }
          }, i);
          break;
      }
    }), l;
  }
  getVisibleProperty(e, t = "") {
    return {
      visible: {
        title: "是否可见",
        type: "boolean",
        description: "运行时组件是否可见",
        editor: this.getPropertyEditorParams(e, t === "gridFieldEditor" ? ["Const", "Expression"] : ["Const", "Variable", "StateMachine", "Expression"], "visible")
      }
    };
  }
  /**
   * 获取行为
   * @param propertyData 
   * @param viewModelId 
   * @returns 
   */
  getBehaviorConfig(e, t = "", n = {}, r) {
    const i = {
      title: "行为",
      description: ""
    }, s = this.getVisibleProperty(e, t);
    for (const c in n)
      s[c] = Object.assign(s[c] || {}, n[c]);
    const p = this;
    return {
      ...i,
      properties: { ...s },
      setPropertyRelates(c, f) {
        if (c) {
          switch (c.propertyID) {
            case "disabled":
            case "readonly":
            case "visible":
              p.afterMutilEditorChanged(e, c);
              break;
          }
          r && r(c, f);
        }
      }
    };
  }
  /**
   * 当多值编辑器变更时
   * @param propertyData 
   * @param changeObject 
   */
  afterMutilEditorChanged(e, t) {
    this.addNewVariableToViewModel(t, this.viewModelId), this.updateExpressionValue(t), this.clearExpression(t, e);
  }
  /**
   * 
   * @param propertyId 
   * @param componentInstance 
   * @returns 
   */
  updateElementByParentContainer(e, t) {
    const n = t && t.parent && t.parent.schema;
    if (!n)
      return;
    const r = n.contents.findIndex((s) => s.id === e), i = ge(n.contents[r]);
    n.contents.splice(r, 1), n.contents.splice(r, 0, i), Nn();
  }
  /**
   * 属性编辑器，在编辑过程中会新增变量，此处需要将新增的变量追加到ViewModel中
   * @param changeObject 
   * @param viewModelId 
   * @returns 
   */
  addNewVariableToViewModel(e, t) {
    const n = e.propertyValue;
    if (!(n && typeof n == "object") || !(n.type === "Variable" && n.isNewVariable))
      return;
    const s = {
      id: n.field,
      category: "locale",
      code: n.fullPath,
      name: n.fullPath,
      type: n.newVariableType || "String"
    };
    delete n.newVariableType, delete n.isNewVariable, this.formSchemaUtils.getVariableByCode(s.code) || this.formSchemaUtils.getViewModelById(t).states.push(s);
  }
  /**
   * 更新表达式到expressions节点
   * @param changeObject 
   */
  updateExpressionValue(e) {
    const t = e.propertyValue;
    if (!((t && t.type) === "Expression" && t.expressionInfo))
      return;
    const { expressionId: i, expressionInfo: s } = t, { targetId: p, targetType: c, expressionType: f, value: h, message: l } = s, g = this.formSchemaUtils.getModule();
    g.expressions ?? (g.expressions = []);
    const { expressions: d } = g;
    let m = d.find((P) => P.target === p);
    m || (m = { target: p, rules: [], targetType: c }, d.push(m));
    const w = m.rules.find((P) => P.type === f);
    if (w)
      w.value = h, w.message = l;
    else {
      const P = { id: i, type: f, value: h, message: l };
      m.rules.push(P);
    }
    delete t.expressionInfo;
  }
  /**
   * 属性类型切换为非表达式后，清除原表达式
   * @param changeObject 
   * @param propertyData 
   * @returns 
   */
  clearExpression(e, t) {
    const n = e.propertyValue;
    if (n && n.type === "Expression")
      return;
    const i = e.propertyID, s = this.formSchemaUtils.getExpressions(), p = t.binding ? t.binding.field : t.id, c = s.find((f) => f.target === p);
    !c || !c.rules || (c.rules = c.rules.filter((f) => f.type !== i));
  }
  getExpressionOptions(e, t, n) {
    return new Ln(this.formSchemaUtils).getExpressionOptions(e, t, n);
  }
  getRealTargetType(e) {
    return ["response-toolbar-item", "tab-toolbar-item", "section-toolbar-item"].indexOf(e.type) > -1 ? "Button" : e.binding && e.binding.field ? "Field" : "Container";
  }
}
class qn extends He {
  constructor(e, t) {
    super(e, t);
  }
  getPropertyConfig(e) {
    return this.propertyConfig.categories.basic = this.getBasicPropConfig(e), this.getAppearancePropConfig(e), this.propertyConfig.categories.behavior = this.getBehaviorConfig(e), this.propertyConfig;
  }
  getAppearancePropConfig(e) {
    this.propertyConfig.categories.appearance = {
      title: "外观",
      description: "Appearance",
      properties: {
        class: {
          title: "class样式",
          type: "string",
          description: "组件的CSS样式",
          $converter: "/converter/appearance.converter"
        }
      }
    };
  }
  getBehaviorProperties(e) {
    this.propertyConfig.categories.behavior = {
      title: "行为",
      description: "",
      properties: {
        alignment: {
          title: "对齐方式",
          description: "在工具栏区域内按钮组的位置",
          type: "enum",
          editor: {
            type: "combo-list",
            textField: "name",
            valueField: "value",
            data: [
              {
                value: "left",
                name: "左对齐"
              },
              {
                value: "center",
                name: "居中"
              },
              {
                value: "right",
                name: "右对齐"
              }
            ]
          }
        }
      }
    };
  }
}
function Un(o, e, t) {
  const n = o.schema;
  function r(d) {
    return !1;
  }
  function i(d, m) {
    return m.text = d.label, m;
  }
  function s() {
    return !1;
  }
  function p() {
    return !1;
  }
  function c() {
    return !1;
  }
  function f() {
    return !0;
  }
  function h(d) {
    return new qn(d, e).getPropertyConfig(n);
  }
  function l(d) {
    var b;
    d && (d.stopPropagation(), d.preventDefault());
    const { schema: m } = o;
    m.buttons || (m.buttons = []);
    let w = "";
    if (m.type)
      w = m.type + "-item";
    else {
      const u = (b = o.parent) == null ? void 0 : b.schema.type;
      w = u === "tabs" ? "tab-toolbar-item" : u === "section" ? "section-toolbar-item" : "response-toolbar-item";
    }
    const P = ve(w);
    P.id = `toolbar_item_${Math.random().toString().slice(2, 6)}`, m.buttons.push(P), t.updateToolbarItems(), t.changeSelectedId("");
  }
  function g() {
    return [
      {
        id: "appendItem",
        title: "新增按钮",
        text: "",
        icon: "f-icon f-icon-plus-circle text-white",
        onClick: (d) => l(d)
      }
    ];
  }
  return {
    canAccepts: r,
    checkCanAddComponent: c,
    checkCanDeleteComponent: p,
    checkCanMoveComponent: s,
    hideNestedPaddingInDesginerView: f,
    onResolveNewComponentSchema: i,
    getPropsConfig: h,
    getCustomButtons: g
  };
}
var fe = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function Hn(o) {
  return o && o.__esModule && Object.prototype.hasOwnProperty.call(o, "default") ? o.default : o;
}
function be(o) {
  throw new Error('Could not dynamically require "' + o + '". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.');
}
var Ct = { exports: {} };
(function(o, e) {
  (function(t) {
    o.exports = t();
  })(function() {
    return (/* @__PURE__ */ function() {
      function t(n, r, i) {
        function s(f, h) {
          if (!r[f]) {
            if (!n[f]) {
              var l = typeof be == "function" && be;
              if (!h && l) return l(f, !0);
              if (p) return p(f, !0);
              var g = new Error("Cannot find module '" + f + "'");
              throw g.code = "MODULE_NOT_FOUND", g;
            }
            var d = r[f] = { exports: {} };
            n[f][0].call(d.exports, function(m) {
              var w = n[f][1][m];
              return s(w || m);
            }, d, d.exports, t, n, r, i);
          }
          return r[f].exports;
        }
        for (var p = typeof be == "function" && be, c = 0; c < i.length; c++) s(i[c]);
        return s;
      }
      return t;
    }())({
      1: [function(t, n, r) {
        var i = {}, s = "(?:^|\\s)", p = "(?:\\s|$)";
        function c(l) {
          var g = i[l];
          return g ? g.lastIndex = 0 : i[l] = g = new RegExp(s + l + p, "g"), g;
        }
        function f(l, g) {
          var d = l.className;
          d.length ? c(g).test(d) || (l.className += " " + g) : l.className = g;
        }
        function h(l, g) {
          l.className = l.className.replace(c(g), " ").trim();
        }
        n.exports = {
          add: f,
          rm: h
        };
      }, {}],
      2: [function(t, n, r) {
        (function(i) {
          var s = t("contra/emitter"), p = t("crossvent"), c = t("./classes"), f = document, h = f.documentElement;
          function l(a, S) {
            var k = arguments.length;
            k === 1 && Array.isArray(a) === !1 && (S = a, a = []);
            var y, I, B, C, T, _, H, L, z, Y = null, J, W, ee = !1, re = 0, Z, $ = S || {};
            $.moves === void 0 && ($.moves = u), $.accepts === void 0 && ($.accepts = u), $.invalid === void 0 && ($.invalid = Mt), $.containers === void 0 && ($.containers = a || []), $.isContainer === void 0 && ($.isContainer = b), $.copy === void 0 && ($.copy = !1), $.copySortSource === void 0 && ($.copySortSource = !1), $.revertOnSpill === void 0 && ($.revertOnSpill = !1), $.removeOnSpill === void 0 && ($.removeOnSpill = !1), $.direction === void 0 && ($.direction = "vertical"), $.ignoreInputTextSelection === void 0 && ($.ignoreInputTextSelection = !0), $.mirrorContainer === void 0 && ($.mirrorContainer = f.body);
            var K = s({
              containers: $.containers,
              start: Pt,
              end: Ge,
              cancel: Ke,
              remove: Ze,
              destroy: Tt,
              canMove: It,
              dragging: !1
            });
            return $.removeOnSpill === !0 && K.on("over", Dt).on("out", Rt), We(), K;
            function Pe(v) {
              return K.containers.indexOf(v) !== -1 || $.isContainer(v);
            }
            function We(v) {
              var R = v ? "remove" : "add";
              m(h, R, "mousedown", Et), m(h, R, "mouseup", De);
            }
            function Me(v) {
              var R = v ? "remove" : "add";
              m(h, R, "mousemove", St);
            }
            function ze(v) {
              var R = v ? "remove" : "add";
              p[R](h, "selectstart", Xe), p[R](h, "click", Xe);
            }
            function Tt() {
              We(!0), De({});
            }
            function Xe(v) {
              J && v.preventDefault();
            }
            function Et(v) {
              C = v.clientX, T = v.clientY;
              var R = w(v) !== 1 || v.metaKey || v.ctrlKey;
              if (!R) {
                var A = v.target, F = ke(A);
                F && (J = F, Me(), v.type === "mousedown" && (O(A) ? A.focus() : v.preventDefault()));
              }
            }
            function St(v) {
              if (J) {
                if (w(v) === 0) {
                  De({});
                  return;
                }
                if (!(v.clientX !== void 0 && Math.abs(v.clientX - C) <= ($.slideFactorX || 0) && v.clientY !== void 0 && Math.abs(v.clientY - T) <= ($.slideFactorY || 0))) {
                  if ($.ignoreInputTextSelection) {
                    var R = x("clientX", v) || 0, A = x("clientY", v) || 0, F = f.elementFromPoint(R, A);
                    if (O(F))
                      return;
                  }
                  var G = J;
                  Me(!0), ze(), Ge(), Ye(G), c.add(L || B, "gu-transit"), At(), Bt(), re = 0, Ae(v);
                }
              }
            }
            function ke(v) {
              if (!(K.dragging && y) && !Pe(v)) {
                for (var R = v; M(v) && Pe(M(v)) === !1; )
                  if ($.invalid(v, R) || (v = M(v), !v))
                    return;
                var A = M(v);
                if (A && !$.invalid(v, R)) {
                  var F = $.moves(v, A, R, j(v));
                  if (F)
                    return {
                      item: v,
                      source: A
                    };
                }
              }
            }
            function It(v) {
              return !!ke(v);
            }
            function Pt(v) {
              var R = ke(v);
              R && Ye(R);
            }
            function Ye(v) {
              Lt(v.item, v.source) && (L = v.item.cloneNode(!0), K.emit("cloned", L, v.item, "copy")), I = v.source, B = v.item, _ = H = j(v.item), K.dragging = !0, K.emit("drag", B, I);
            }
            function Mt() {
              return !1;
            }
            function Ge() {
              if (K.dragging) {
                var v = L || B;
                Je(v, M(v));
              }
            }
            function Qe() {
              J = !1, Me(!0), ze(!0);
            }
            function De(v) {
              if (Qe(), !!K.dragging) {
                var R = L || B, A = x("clientX", v) || 0, F = x("clientY", v) || 0, G = P(y, A, F), Q = et(G, A, F);
                Q && (L && $.copySortSource || !L || Q !== I) ? Je(R, Q) : $.removeOnSpill ? Ze() : Ke();
              }
            }
            function Je(v, R) {
              var A = M(v);
              L && $.copySortSource && R === I && A.removeChild(B), Be(R) ? K.emit("cancel", v, I) : K.emit("drop", v, R, I, H), Re();
            }
            function Ze() {
              if (K.dragging) {
                var v = L || B, R = M(v);
                R && R.removeChild(v), K.emit(L ? "cancel" : "remove", v, R, I), Re();
              }
            }
            function Ke(v) {
              if (K.dragging) {
                var R = arguments.length > 0 ? v : $.revertOnSpill, A = L || B, F = M(A), G = Be(F);
                G === !1 && R && (L ? F && F.removeChild(L) : I.insertBefore(A, _)), G || R ? K.emit("cancel", A, I, I) : K.emit("drop", A, F, I, H), Re();
              }
            }
            function Re() {
              var v = L || B;
              Qe(), Ot(), Vt(), v && c.rm(v, "gu-transit"), z && clearTimeout(z), K.dragging = !1, Y && K.emit("out", v, Y, I), K.emit("dragend", v, re), I = B = L = _ = H = z = Y = null;
            }
            function Be(v, R) {
              var A;
              return R !== void 0 ? A = R : y ? A = H : A = j(L || B), v === I && A === _;
            }
            function et(v, R, A) {
              for (var F = v; F && !G(); )
                F = M(F);
              return F;
              function G() {
                var Q = Pe(F);
                if (Q === !1)
                  return !1;
                var ae = tt(F, v), oe = nt(F, ae, R, A), se = Be(F, oe);
                return se ? !0 : $.accepts(B, F, I, oe);
              }
            }
            function Ae(v) {
              if (!y)
                return;
              v.preventDefault();
              var R = x("clientX", v) || 0, A = x("clientY", v) || 0;
              y.style.left = R - 2 + "px", y.style.top = A - 2 + "px";
              var F = L || B, G = P(y, R, A), Q = et(G, R, A), ae = Q !== null && Q !== Y;
              (ae || Q === null) && (ie(), Y = Q, de()), Ft(G, A);
              var oe = M(F);
              if (Q === I && L && !$.copySortSource) {
                oe && oe.removeChild(F);
                return;
              }
              var se, ue = tt(Q, G);
              if (ee = Nt(ue, Q), ue !== null)
                se = nt(Q, ue, R, A);
              else if ($.revertOnSpill === !0 && !L)
                se = _, Q = I;
              else {
                L && oe && oe.removeChild(F), L && W && (W.style.display = "none");
                return;
              }
              W.style.display = "block", kt(se, F, ae), se ? jt(ue, se) : $t(Q);
              function te(ne) {
                K.emit(ne, F, Y, I);
              }
              function de() {
                ae && te("over");
              }
              function ie() {
                Y && te("out");
              }
            }
            function kt(v, R, A) {
              (v === R || v === j(R)) && (H = j(R)), (v === null && A || v !== R && v !== j(R)) && (H = v);
            }
            function Dt(v) {
              c.rm(v, "gu-hide");
            }
            function Rt(v) {
              K.dragging && c.add(v, "gu-hide");
            }
            function Bt() {
              y || (y = document.createElement("div"), y.style = "background: grey; color: white; height: 24px; text-align: center; padding: 3px 10px; min-width: 100px;border-radius: 4px; box-shadow: 0 0 6px grey;", y.innerHTML = $.getMirrorText && $.getMirrorText(B) || "控件", c.add(y, "gu-mirror"), $.mirrorContainer.appendChild(y), m(h, "add", "mousemove", Ae), c.add($.mirrorContainer, "gu-unselectable"), K.emit("cloned", y, B, "mirror"));
            }
            function At() {
              if (W = document.createElement("div"), c.add(W, "gu-insertion"), B) {
                var v = B.getBoundingClientRect();
                W.style.left = v.left + "px", W.style.top = v.top + "px";
              }
              ee = !1, $.mirrorContainer.appendChild(W);
            }
            function Ot() {
              y && (c.rm($.mirrorContainer, "gu-unselectable"), m(h, "remove", "mousemove", Ae), M(y).removeChild(y), y = null);
            }
            function Vt() {
              W && (M(W).removeChild(W), W = null);
            }
            function tt(v, R) {
              for (var A = R; A !== v && M(A) !== v; )
                A = M(A);
              return A === h ? null : A;
            }
            function Nt(v, R) {
              if (!R)
                return ee;
              var A = v || R && R.lastElementChild;
              if (!A)
                return !0;
              var F = getComputedStyle(v), G = /^inline/.test(F.getPropertyValue("display")) || /^(left|right)$/.test(F.getPropertyValue("float"));
              if (G)
                return !0;
              if (R) {
                var Q = getComputedStyle(R), ae = Q.getPropertyValue("display");
                if (/flex$/.test(ae)) {
                  var oe = Q.getPropertyValue("flex-direction") || "row";
                  if (oe === "row" || oe === "row-reverse")
                    return !_t(R);
                }
                return !1;
              }
              return !0;
            }
            function _t(v) {
              if (!v.children || !v.children.length)
                return !1;
              for (const R of Array.from(v.children)) {
                const F = (R.className && R.className.split(" ") || []).filter((G) => /^col(-md|-xl|-el){0,1}-([1-9]|10|11|12)$/.test(G));
                if (!F.length)
                  return !1;
                for (const G of F) {
                  const Q = G.slice(G.lastIndexOf("-") + 1);
                  if (parseInt(Q, 10) !== 12)
                    return !1;
                }
              }
              return !0;
            }
            function jt(v, R) {
              const A = R.getBoundingClientRect();
              if (W.style.left = A.left + "px", W.style.top = A.top + "px", ee) {
                if (W.style.height = A.height + "px", W.style.width = "4px", v) {
                  const F = v.getBoundingClientRect();
                  F.top !== A.top && (W.style.left = F.right + "px", W.style.top = F.top + "px", W.style.height = F.height + "px");
                }
              } else if (W.style.height = "4px", W.style.width = A.width + "px", Z) {
                const F = Z.getBoundingClientRect();
                A.top < F.top && (W.style.display = "none");
              }
              R === B && B && (W.style.display = "none");
            }
            function $t(v) {
              H = null;
              var R = v.lastElementChild;
              if (R) {
                var A = R.getBoundingClientRect();
                ee ? (W.style.left = A.right + "px", W.style.top = A.top + "px", W.style.height = A.height + "px", W.style.width = "4px") : (W.style.left = A.left + "px", W.style.top = A.bottom + "px", W.style.height = "4px", W.style.width = A.width + "px"), R === B && B && (W.style.display = "none");
              } else
                W.style.display = "none";
            }
            function Ft(v, R) {
              if (!$.mirrorContainer.contains(v) || !window.scrollContainerList || !Array.from(window.scrollContainerList).length || (Z = g(v), !Z || !Z.contains(v)))
                return;
              const A = document.querySelector(".dgComponentSelected"), F = Z.getBoundingClientRect();
              if (R - 30 < F.top && Z.scrollTop > 0) {
                let G = Z.scrollTop < 10 ? Z.scrollTop : 10;
                Z.scrollBy(0, -1 * G), A && Z.contains(A) && (re = re + -1 * G);
              }
              if (R + 30 > F.bottom && Z.scrollTop < Z.scrollHeight - Z.clientHeight) {
                const G = Z.scrollHeight - Z.clientHeight - Z.scrollTop;
                let Q = G < 10 ? G : 10;
                Z.scrollBy(0, Q), A && Z.contains(A) && (re = re + Q);
              }
            }
            function nt(v, R, A, F) {
              var G = $.direction === "horizontal", Q = $.direction === "mixed", ae = R !== v ? se() : oe();
              return ae;
              function oe() {
                var te = v.children.length, de, ie, ne;
                for (de = 0; de < te; de++)
                  if (ie = v.children[de], ne = ie.getBoundingClientRect(), G && ne.left + ne.width / 2 > A || !Q && !G && ne.top + ne.height / 2 > F || Q && ne.left + ne.width > A && ne.top + ne.height > F)
                    return ie;
                return null;
              }
              function se() {
                var te = R.getBoundingClientRect();
                if (Q) {
                  var de = F - te.top, ie = A - te.left, ne = te.bottom - F, Oe = te.right - A, Ve = Math.min(ie, Oe, de, ne), Ne;
                  return ee ? Ne = Oe < ie : Ne = ne === Ve || Oe === Ve || ie === Ve, ue(Ne);
                }
                return ue(G ? A > te.left + E(te) / 2 : F > te.top + D(te) / 2);
              }
              function ue(te) {
                return te ? j(R) : R;
              }
            }
            function Lt(v, R) {
              return typeof $.copy == "boolean" ? $.copy : $.copy(v, R);
            }
          }
          function g(a) {
            const S = Array.from(window.scrollContainerList);
            if (S.length === 1) {
              const y = Array.from(window.scrollContainerList)[0];
              return document.getElementById(y);
            }
            const k = d(S);
            for (const y of k)
              if (y.contains(a))
                return y;
            return null;
          }
          function d(a) {
            const S = [];
            return a.forEach((k) => {
              const y = document.getElementById(k);
              y && S.push(y);
            }), S.sort((k, y) => k.contains(y) ? 1 : y.contains(k) ? -1 : 0), S;
          }
          function m(a, S, k, y) {
            var I = {
              mouseup: "touchend",
              mousedown: "touchstart",
              mousemove: "touchmove"
            }, B = {
              mouseup: "pointerup",
              mousedown: "pointerdown",
              mousemove: "pointermove"
            }, C = {
              mouseup: "MSPointerUp",
              mousedown: "MSPointerDown",
              mousemove: "MSPointerMove"
            };
            i.navigator.pointerEnabled ? p[S](a, B[k], y) : i.navigator.msPointerEnabled ? p[S](a, C[k], y) : (p[S](a, I[k], y), p[S](a, k, y));
          }
          function w(a) {
            if (a.touches !== void 0)
              return a.touches.length;
            if (a.which !== void 0 && a.which !== 0)
              return a.which;
            if (a.buttons !== void 0)
              return a.buttons;
            var S = a.button;
            if (S !== void 0)
              return S & 1 ? 1 : S & 2 ? 3 : S & 4 ? 2 : 0;
          }
          function P(a, S, k) {
            a = a || {};
            var y = a.className || "", I;
            return a.className += " gu-hide", I = f.elementFromPoint(S, k), a.className = y, I;
          }
          function b() {
            return !1;
          }
          function u() {
            return !0;
          }
          function E(a) {
            return a.width || a.right - a.left;
          }
          function D(a) {
            return a.height || a.bottom - a.top;
          }
          function M(a) {
            return a.parentNode === f ? null : a.parentNode;
          }
          function O(a) {
            return a.tagName === "INPUT" || a.tagName === "TEXTAREA" || a.tagName === "SELECT" || N(a);
          }
          function N(a) {
            return !a || a.contentEditable === "false" ? !1 : a.contentEditable === "true" ? !0 : N(M(a));
          }
          function j(a) {
            return a.nextElementSibling || S();
            function S() {
              var k = a;
              do
                k = k.nextSibling;
              while (k && k.nodeType !== 1);
              return k;
            }
          }
          function U(a) {
            return a.targetTouches && a.targetTouches.length ? a.targetTouches[0] : a.changedTouches && a.changedTouches.length ? a.changedTouches[0] : a;
          }
          function x(a, S) {
            var k = U(S), y = {
              pageX: "clientX",
              // IE8
              pageY: "clientY"
              // IE8
            };
            return a in y && !(a in k) && y[a] in k && (a = y[a]), k[a];
          }
          n.exports = l;
        }).call(this, typeof fe < "u" ? fe : typeof self < "u" ? self : typeof window < "u" ? window : {});
      }, { "./classes": 1, "contra/emitter": 5, crossvent: 6 }],
      3: [function(t, n, r) {
        n.exports = function(s, p) {
          return Array.prototype.slice.call(s, p);
        };
      }, {}],
      4: [function(t, n, r) {
        var i = t("ticky");
        n.exports = function(p, c, f) {
          p && i(function() {
            p.apply(f || null, c || []);
          });
        };
      }, { ticky: 10 }],
      5: [function(t, n, r) {
        var i = t("atoa"), s = t("./debounce");
        n.exports = function(c, f) {
          var h = f || {}, l = {};
          return c === void 0 && (c = {}), c.on = function(g, d) {
            return l[g] ? l[g].push(d) : l[g] = [d], c;
          }, c.once = function(g, d) {
            return d._once = !0, c.on(g, d), c;
          }, c.off = function(g, d) {
            var m = arguments.length;
            if (m === 1)
              delete l[g];
            else if (m === 0)
              l = {};
            else {
              var w = l[g];
              if (!w)
                return c;
              w.splice(w.indexOf(d), 1);
            }
            return c;
          }, c.emit = function() {
            var g = i(arguments);
            return c.emitterSnapshot(g.shift()).apply(this, g);
          }, c.emitterSnapshot = function(g) {
            var d = (l[g] || []).slice(0);
            return function() {
              var m = i(arguments), w = this || c;
              if (g === "error" && h.throws !== !1 && !d.length)
                throw m.length === 1 ? m[0] : m;
              return d.forEach(function(b) {
                h.async ? s(b, m, w) : b.apply(w, m), b._once && c.off(g, b);
              }), c;
            };
          }, c;
        };
      }, { "./debounce": 4, atoa: 3 }],
      6: [function(t, n, r) {
        (function(i) {
          var s = t("custom-event"), p = t("./eventmap"), c = i.document, f = g, h = m, l = [];
          i.addEventListener || (f = d, h = w), n.exports = {
            add: f,
            remove: h,
            fabricate: P
          };
          function g(M, O, N, j) {
            return M.addEventListener(O, N, j);
          }
          function d(M, O, N) {
            return M.attachEvent("on" + O, u(M, O, N));
          }
          function m(M, O, N, j) {
            return M.removeEventListener(O, N, j);
          }
          function w(M, O, N) {
            var j = E(M, O, N);
            if (j)
              return M.detachEvent("on" + O, j);
          }
          function P(M, O, N) {
            var j = p.indexOf(O) === -1 ? x() : U();
            M.dispatchEvent ? M.dispatchEvent(j) : M.fireEvent("on" + O, j);
            function U() {
              var a;
              return c.createEvent ? (a = c.createEvent("Event"), a.initEvent(O, !0, !0)) : c.createEventObject && (a = c.createEventObject()), a;
            }
            function x() {
              return new s(O, { detail: N });
            }
          }
          function b(M, O, N) {
            return function(U) {
              var x = U || i.event;
              x.target = x.target || x.srcElement, x.preventDefault = x.preventDefault || function() {
                x.returnValue = !1;
              }, x.stopPropagation = x.stopPropagation || function() {
                x.cancelBubble = !0;
              }, x.which = x.which || x.keyCode, N.call(M, x);
            };
          }
          function u(M, O, N) {
            var j = E(M, O, N) || b(M, O, N);
            return l.push({
              wrapper: j,
              element: M,
              type: O,
              fn: N
            }), j;
          }
          function E(M, O, N) {
            var j = D(M, O, N);
            if (j) {
              var U = l[j].wrapper;
              return l.splice(j, 1), U;
            }
          }
          function D(M, O, N) {
            var j, U;
            for (j = 0; j < l.length; j++)
              if (U = l[j], U.element === M && U.type === O && U.fn === N)
                return j;
          }
        }).call(this, typeof fe < "u" ? fe : typeof self < "u" ? self : typeof window < "u" ? window : {});
      }, { "./eventmap": 7, "custom-event": 8 }],
      7: [function(t, n, r) {
        (function(i) {
          var s = [], p = "", c = /^on/;
          for (p in i)
            c.test(p) && s.push(p.slice(2));
          n.exports = s;
        }).call(this, typeof fe < "u" ? fe : typeof self < "u" ? self : typeof window < "u" ? window : {});
      }, {}],
      8: [function(t, n, r) {
        (function(i) {
          var s = i.CustomEvent;
          function p() {
            try {
              var c = new s("cat", { detail: { foo: "bar" } });
              return c.type === "cat" && c.detail.foo === "bar";
            } catch {
            }
            return !1;
          }
          n.exports = p() ? s : (
            // IE >= 9
            typeof document < "u" && typeof document.createEvent == "function" ? function(f, h) {
              var l = document.createEvent("CustomEvent");
              return h ? l.initCustomEvent(f, h.bubbles, h.cancelable, h.detail) : l.initCustomEvent(f, !1, !1, void 0), l;
            } : (
              // IE <= 8
              function(f, h) {
                var l = document.createEventObject();
                return l.type = f, h ? (l.bubbles = !!h.bubbles, l.cancelable = !!h.cancelable, l.detail = h.detail) : (l.bubbles = !1, l.cancelable = !1, l.detail = void 0), l;
              }
            )
          );
        }).call(this, typeof fe < "u" ? fe : typeof self < "u" ? self : typeof window < "u" ? window : {});
      }, {}],
      9: [function(t, n, r) {
        var i = n.exports = {}, s, p;
        function c() {
          throw new Error("setTimeout has not been defined");
        }
        function f() {
          throw new Error("clearTimeout has not been defined");
        }
        (function() {
          try {
            typeof setTimeout == "function" ? s = setTimeout : s = c;
          } catch {
            s = c;
          }
          try {
            typeof clearTimeout == "function" ? p = clearTimeout : p = f;
          } catch {
            p = f;
          }
        })();
        function h(D) {
          if (s === setTimeout)
            return setTimeout(D, 0);
          if ((s === c || !s) && setTimeout)
            return s = setTimeout, setTimeout(D, 0);
          try {
            return s(D, 0);
          } catch {
            try {
              return s.call(null, D, 0);
            } catch {
              return s.call(this, D, 0);
            }
          }
        }
        function l(D) {
          if (p === clearTimeout)
            return clearTimeout(D);
          if ((p === f || !p) && clearTimeout)
            return p = clearTimeout, clearTimeout(D);
          try {
            return p(D);
          } catch {
            try {
              return p.call(null, D);
            } catch {
              return p.call(this, D);
            }
          }
        }
        var g = [], d = !1, m, w = -1;
        function P() {
          !d || !m || (d = !1, m.length ? g = m.concat(g) : w = -1, g.length && b());
        }
        function b() {
          if (!d) {
            var D = h(P);
            d = !0;
            for (var M = g.length; M; ) {
              for (m = g, g = []; ++w < M; )
                m && m[w].run();
              w = -1, M = g.length;
            }
            m = null, d = !1, l(D);
          }
        }
        i.nextTick = function(D) {
          var M = new Array(arguments.length - 1);
          if (arguments.length > 1)
            for (var O = 1; O < arguments.length; O++)
              M[O - 1] = arguments[O];
          g.push(new u(D, M)), g.length === 1 && !d && h(b);
        };
        function u(D, M) {
          this.fun = D, this.array = M;
        }
        u.prototype.run = function() {
          this.fun.apply(null, this.array);
        }, i.title = "browser", i.browser = !0, i.env = {}, i.argv = [], i.version = "", i.versions = {};
        function E() {
        }
        i.on = E, i.addListener = E, i.once = E, i.off = E, i.removeListener = E, i.removeAllListeners = E, i.emit = E, i.prependListener = E, i.prependOnceListener = E, i.listeners = function(D) {
          return [];
        }, i.binding = function(D) {
          throw new Error("process.binding is not supported");
        }, i.cwd = function() {
          return "/";
        }, i.chdir = function(D) {
          throw new Error("process.chdir is not supported");
        }, i.umask = function() {
          return 0;
        };
      }, {}],
      10: [function(t, n, r) {
        (function(i) {
          var s = typeof i == "function", p;
          s ? p = function(c) {
            i(c);
          } : p = function(c) {
            setTimeout(c, 0);
          }, n.exports = p;
        }).call(this, t("timers").setImmediate);
      }, { timers: 11 }],
      11: [function(t, n, r) {
        (function(i, s) {
          var p = t("process/browser.js").nextTick, c = Function.prototype.apply, f = Array.prototype.slice, h = {}, l = 0;
          r.setTimeout = function() {
            return new g(c.call(setTimeout, window, arguments), clearTimeout);
          }, r.setInterval = function() {
            return new g(c.call(setInterval, window, arguments), clearInterval);
          }, r.clearTimeout = r.clearInterval = function(d) {
            d.close();
          };
          function g(d, m) {
            this._id = d, this._clearFn = m;
          }
          g.prototype.unref = g.prototype.ref = function() {
          }, g.prototype.close = function() {
            this._clearFn.call(window, this._id);
          }, r.enroll = function(d, m) {
            clearTimeout(d._idleTimeoutId), d._idleTimeout = m;
          }, r.unenroll = function(d) {
            clearTimeout(d._idleTimeoutId), d._idleTimeout = -1;
          }, r._unrefActive = r.active = function(d) {
            clearTimeout(d._idleTimeoutId);
            var m = d._idleTimeout;
            m >= 0 && (d._idleTimeoutId = setTimeout(function() {
              d._onTimeout && d._onTimeout();
            }, m));
          }, r.setImmediate = typeof i == "function" ? i : function(d) {
            var m = l++, w = arguments.length < 2 ? !1 : f.call(arguments, 1);
            return h[m] = !0, p(function() {
              h[m] && (w ? d.apply(null, w) : d.call(null), r.clearImmediate(m));
            }), m;
          }, r.clearImmediate = typeof s == "function" ? s : function(d) {
            delete h[d];
          };
        }).call(this, t("timers").setImmediate, t("timers").clearImmediate);
      }, { "process/browser.js": 9, timers: 11 }]
    }, {}, [2])(2);
  });
})(Ct);
var Wn = Ct.exports;
const it = /* @__PURE__ */ Hn(Wn);
function zn(o) {
  let e;
  function t(r, i, s, p) {
    const c = o.schema;
    if (!(c != null && c.buttons))
      return;
    let f;
    if (s) {
      const d = s.getAttribute("id");
      f = Array.from(i.children).findIndex((m) => m.getAttribute("id") === d);
    } else
      f = Array.from(i.children).length;
    const h = r.getAttribute("id"), l = Array.from(i.children).findIndex((d) => d.getAttribute("id") === h), g = c.buttons[l];
    l !== f && l > -1 && f > -1 && (l < f && (f = f - 1), c.buttons.splice(l, 1), c.buttons.splice(f, 0, g), p(), he(() => {
      const d = i.querySelector(".dgComponentSelected");
      d != null && d.className.includes("dgComponentSelected") && (d.classList.remove("dgComponentSelected"), d.classList.remove("dgComponentFocused"), d.click()), me.value++;
    }));
  }
  function n(r, i, s) {
    e && e.destroy(), !(!it || !r || !i) && (e = it([r], {
      mirrorContainer: i,
      direction: "horizontal",
      getMirrorText(p) {
        return p.innerText;
      },
      // 判断是否可移动
      moves(p, c, f) {
        let h = !0;
        return f.classList.contains("dropdown-item") ? (h = !1, h) : (p.classList.contains("no-drag") && (h = !1), h);
      }
    }).on("drop", (p, c, f, h) => t(p, c, h, s)));
  }
  return {
    dragulaInstance: e,
    initDragula: n
  };
}
function Xn(o, e, t) {
  const {
    renderToolbarItemDesigner: n,
    actionHandlers: r
  } = t;
  function i(w, P = null) {
    const b = e.value.find((u) => u.id === w.id);
    if (b.isDP)
      if (document.body.click(), typeof P == "boolean")
        b.expanded = P;
      else {
        const u = w.expanded;
        b.expanded = !u;
      }
  }
  r.toggleDropdownMenu = i;
  function s(w) {
    var b;
    const P = {
      "dropdown-menu": !0
    };
    if (w.class) {
      const u = (b = w.menuClass) == null ? void 0 : b.split(" ");
      u && u.length && u.reduce((E, D) => (E[D] = !0, E), P);
    }
    return P;
  }
  function p(w) {
    var u;
    const P = {
      disabled: w.disabled === !1,
      "dropdown-submenu": !0,
      "f-rt-dropdown": !0,
      "text-truncate": !0
    }, b = (u = w.dropdownClass) == null ? void 0 : u.split(" ");
    return b && b.length && b.reduce((E, D) => (E[D] = !0, E), P), P;
  }
  function c(w) {
    const P = {
      disabled: !1,
      "dropdown-item": !0,
      "f-rt-btn": !0,
      "position-relative": !0,
      "farris-component": !0,
      "text-truncate": !0
    }, b = (w.class || "").split(" ");
    return b && b.length && b.reduce((u, E) => (u[E] = !0, u), P), P;
  }
  let f;
  const h = /* @__PURE__ */ new Map();
  function l(w, P, b) {
    var E;
    ((E = w.target) == null ? void 0 : E.id) === P.id && w.stopPropagation();
    const u = b ? b.id : "__top_item__";
    if (P.children && P.children.length && (P.expanded = !P.expanded, P.expanded ? h.set(u, P) : h.delete(u)), h.has(u) && h.get(u) !== P) {
      const D = h.get(u);
      D && (D.expanded = !1);
    }
  }
  function g(w) {
    var P;
    return (P = w.children) == null ? void 0 : P.map((b, u) => b.children && b.children.length ? V("li", {
      class: p(b),
      id: b.id,
      onClick: (E) => !b.disabled && l(E, b, w)
    }, [V("span", {
      id: b.id,
      class: c(b),
      onMouseover: (E) => !b.disabled && l(E, b, w)
    }, [b.text, V("i", {
      class: "f-icon f-icon-arrow-chevron-right",
      style: "display: inline-block;float: right;line-height: 1.25rem;"
    }, null)]), f(b, b)]) : n(b, u, !0));
  }
  function d(w, P, b) {
    var j, U;
    const u = {
      display: w.expanded === !0 ? "block" : "none",
      position: "fixed",
      maxWidth: "300px",
      width: "auto",
      minWidth: "120px"
    }, E = (P == null ? void 0 : P.closest(".f-page")) || document.getElementsByTagName("body")[0], D = (j = E.getClientRects()[0]) == null ? void 0 : j.width, M = (U = E.getClientRects()[0]) == null ? void 0 : U.height, O = P, N = O == null ? void 0 : O.getClientRects();
    if (O && N && N.length) {
      const {
        top: x,
        width: a,
        left: S,
        right: k,
        height: y
      } = N[0], I = Math.ceil(y + x);
      u.top = `${I}px`, u.left = `${S}px`;
      const B = w.id + "_menu", C = P ? P.querySelector("#" + B) : null;
      if (C) {
        C.style.visibility = "hidden", C.style.display = "block";
        const T = C.offsetHeight;
        u.display === "block" && (C.style.display = "block");
        const _ = C.getBoundingClientRect();
        if (b) {
          u.top = `${x - 6}px`;
          const H = Math.ceil(a + S);
          u.left = `${H}px`;
        }
        D - S - a < _.width && (u.left = `${(b ? S : k) - _.width}px`), M - x - y < T && (x > T ? u.top = `${x - T - 8}px` : (u.maxHeight = `${x - 16}px`, u.overflowY = "auto", x - y > M - x && (u.top = "10px"))), C.style.visibility = "visible";
      }
    }
    return u;
  }
  r.changeMenuPosition = d, f = function(w, P) {
    var D, M;
    const b = at(), u = P ? P.id : w.id, E = (M = (D = b == null ? void 0 : b.exposed) == null ? void 0 : D.elementRef) == null ? void 0 : M.querySelector("#" + u);
    return V("ul", {
      class: s(w),
      style: d(w, E),
      id: w.id + "_menu"
    }, [g(w)]);
  };
  function m() {
    h.forEach((w) => {
      w.expanded = !1;
    }), h.clear();
  }
  return {
    renderDropdownMenu: f,
    clearAllDropDownMenu: m
  };
}
const Yn = {
  id: { type: String, default: "" },
  componentId: { type: String, default: "" },
  canAdd: { type: Boolean, default: !1 },
  canDelete: { type: Boolean, default: !1 },
  canMove: { type: Boolean, default: !1 },
  contentKey: { type: String, default: "contents" },
  childLabel: { type: String, default: "" },
  childType: { type: String, default: "" },
  /**
   * 组件值
   */
  modelValue: { type: Object }
};
function Gn(o, e, t) {
  var O;
  const n = "", r = X();
  function i() {
    return !0;
  }
  function s() {
    return !1;
  }
  function p() {
    return !0;
  }
  function c() {
    return !0;
  }
  function f() {
    return !0;
  }
  function h(N) {
    if (!N || !N.value)
      return null;
    const j = X(N == null ? void 0 : N.value.parent), U = h(j);
    return U || null;
  }
  function l(N = e) {
    var a;
    const { componentInstance: j, designerItemElementRef: U } = N;
    if (!j || !j.value)
      return null;
    const { getCustomButtons: x } = j.value;
    return j.value.canMove || j.value.canAdd || j.value.canDelete || x && ((a = x()) != null && a.length) ? U : l(N.parent);
  }
  function g() {
  }
  function d(N) {
    return !!t;
  }
  function m() {
    return (e == null ? void 0 : e.schema.label) || (e == null ? void 0 : e.schema.title) || (e == null ? void 0 : e.schema.name);
  }
  function w() {
  }
  function P(N, j) {
  }
  function b(N) {
    const { componentType: j } = N, U = ce("designer-host-service");
    let x = ve(j, N, U);
    const a = j.toLowerCase().replace(/-/g, "_");
    return x && !x.id && x.type === j && (x.id = `${a}_${Math.random().toString().slice(2, 6)}`), x;
  }
  function u(N) {
  }
  function E(...N) {
    return [];
  }
  function D() {
  }
  function M(N) {
  }
  return r.value = {
    canMove: i(),
    canSelectParent: s(),
    canAdd: c(),
    canDelete: p(),
    canNested: !f(),
    contents: [],
    elementRef: o,
    parent: (O = e.parent) == null ? void 0 : O.componentInstance,
    schema: e.schema,
    styles: n,
    canAccepts: d,
    getBelongedComponentInstance: h,
    getDraggableDesignItemElement: l,
    getDraggingDisplayText: m,
    getPropConfig: E,
    getDragScopeElement: w,
    onAcceptMovedChildElement: P,
    onChildElementMovedOut: u,
    addNewChildComponentSchema: b,
    onRemoveComponent: D,
    triggerBelongedComponentToMoveWhenMoved: X(!1),
    triggerBelongedComponentToDeleteWhenDeleted: X(!1),
    onPropertyChanged: M,
    getCustomButtons: g
  }, r;
}
const Qn = /* @__PURE__ */ Se({
  name: "FDesignerInnerItem",
  props: Yn,
  emits: ["selectionChange", "addComponent", "removeComponent", "clickButton"],
  setup(o, e) {
    const t = X(o.canMove), n = X(o.canAdd), r = X(o.canDelete), i = X(!1), s = X(o.contentKey), p = X(o.childType), c = X(o.childLabel), f = X(o.modelValue), h = X(""), l = X(), g = ce("canvas-dragula"), d = X(), m = ce("design-item-context"), w = {
      designerItemElementRef: l,
      componentInstance: d,
      schema: f.value,
      parent: m,
      setupContext: e
    };
    ut("design-item-context", w);
    const P = le(() => {
      var B;
      const y = ((B = d.value) == null ? void 0 : B.getCustomButtons) && d.value.getCustomButtons();
      return {
        "farris-component": !0,
        // 受position-relative影响，整个容器的高度不能被撑起
        "flex-fill": o.id === "root-component",
        "position-relative": t.value || r.value || (y == null ? void 0 : y.length),
        "farris-nested": i.value,
        "can-move": t.value,
        "d-none": l.value && l.value.classList.contains("d-none")
      };
    }), b = le(() => {
      const y = {};
      return h.value && h.value.split(";").reduce((I, B) => {
        const [C, T] = B.split(":");
        return C && (I[C] = T), I;
      }, y), y;
    });
    function u(y, I) {
      if (m && m.schema[s.value]) {
        const B = m.schema[s.value].findIndex((C) => C.id === I.id);
        if (B > -1) {
          const C = m.schema[s.value].length, T = m.schema[s.value][B % C];
          m.designerItemElementRef.value.querySelector(`#${T.id}-design-item`), m.schema[s.value].splice(B, 1), me.value++, e.emit("removeComponent"), e.emit("selectionChange");
        }
      }
    }
    function E(y) {
      if (d.value.addNewChildComponentSchema) {
        const I = {
          componentType: p.value,
          label: c.value,
          parentComponentInstance: d.value,
          targetPosition: -1
        }, B = d.value.addNewChildComponentSchema(I);
        f.value[s.value].push(B), e.emit("addComponent");
      }
    }
    function D() {
      return n.value && V("div", {
        role: "button",
        class: "btn component-settings-button",
        title: "新增",
        ref: "removeComponent",
        onClick: (y) => {
          E();
        }
      }, [V("i", {
        class: "f-icon f-icon-plus-circle"
      }, null)]);
    }
    function M(y) {
      return r.value && V("div", {
        role: "button",
        class: "btn component-settings-button",
        title: "删除",
        ref: "removeComponent",
        onClick: Wt((I) => u(I, y), ["stop"])
      }, [V("i", {
        class: "f-icon f-icon-yxs_delete"
      }, null)]);
    }
    function O() {
      return t.value && V("div", {
        role: "button",
        class: "btn component-settings-button",
        title: "移动",
        ref: "moveComponent"
      }, [V("i", {
        "data-dragging-icon": "true",
        class: "cmp_move f-icon f-icon-yxs_move"
      }, null)]);
    }
    function N() {
      var I;
      const y = ((I = d.value) == null ? void 0 : I.getCustomButtons) && d.value.getCustomButtons();
      return y && !!y.length && y.map((B) => V("div", {
        role: "button",
        class: `btn component-settings-button ${B.class || ""} ${B.text ? "settings-button-extend" : ""}`,
        title: B.title,
        ref: B.id,
        onClick: (C) => B.onClick && B.onClick(C)
      }, [V("i", {
        class: "f-icon " + B.icon
      }, null), B.text && V("span", {
        class: "icon-text"
      }, [B.text])]));
    }
    function j(y) {
      return V("div", {
        class: "component-btn-group",
        "data-noattach": "true"
      }, [V("div", null, [D(), O(), M(y), N()])]);
    }
    Te(() => o.modelValue, (y) => {
      f.value = y, w.schema = y;
    });
    function U(y) {
      window.scrollContainerList || (window.scrollContainerList = /* @__PURE__ */ new Set());
      const I = y.getAttribute("id");
      I && window.scrollContainerList.add(I);
    }
    function x(y) {
      const I = y.target;
      U(I), $n(I);
    }
    function a() {
      var y, I;
      (I = (y = f.value) == null ? void 0 : y.contents) != null && I.length && l.value && l.value.addEventListener("scroll", x);
    }
    function S() {
      const y = l.value, I = X(y.children[1]);
      return Gn(I, w).value;
    }
    Ie(() => {
      if (l.value) {
        const y = l.value.querySelector(`[data-dragref='${f.value.id}-container']`);
        d.value = y && y.componentInstance ? y.componentInstance.value : S(), g && y && g.attachComponents(y, f.value), i.value = d.value.canNested !== void 0 ? d.value.canNested : i.value, n.value = d.value.canAdd !== void 0 ? d.value.canAdd : n.value, r.value = d.value.canDelete !== void 0 ? d.value.canDelete : r.value, t.value = d.value.canMove !== void 0 ? d.value.canMove : t.value, h.value = d.value.styles || "", l.value && (l.value.componentInstance = d, l.value.designItemContext = w);
      }
      a(), me.value++;
    }), Ht(() => {
      l.value && l.value.removeEventListener("scroll", x);
    });
    function k(y) {
      y && (y.preventDefault(), y.stopPropagation());
      let I = w.designerItemElementRef;
      const B = l.value;
      if (B) {
        const C = document.getElementsByClassName("dgComponentFocused");
        C && C.length === 1 && C[0] === l.value && l.value.classList.contains("dgComponentSelected") || (Array.from(C).forEach((_) => _.classList.remove("dgComponentFocused")), Array.from(document.getElementsByClassName("dgComponentSelected")).forEach((_) => _.classList.remove("dgComponentSelected")), B.classList.add("dgComponentFocused"), e.emit("selectionChange", f.value.type, f.value, o.componentId, d.value), d.value.getDraggableDesignItemElement && (I = d.value.getDraggableDesignItemElement(w), I && I.value && I.value.classList.add("dgComponentSelected")));
      }
      wt(I == null ? void 0 : I.value);
    }
    return () => V("div", {
      id: `${o.id}-design-item`,
      ref: l,
      class: P.value,
      style: b.value,
      onClick: k
    }, [j(f.value), e.slots.default && e.slots.default()]);
  }
});
class Jn extends He {
  constructor(e, t) {
    super(e, t);
  }
  getPropertyConfig(e, t = !1) {
    return this.propertyConfig.categories.basic = this.getBasicPropConfig(e), this.propertyConfig.categories.basic.properties.text = {
      title: "文本",
      type: "string",
      description: "",
      refreshPanelAfterChanged: !0
    }, this.getAppearanceProperties(e, t), this.getbBehaviorConfig(e), this.getEventPropConfig(e), this.propertyConfig;
  }
  getAppearanceProperties(e, t = !1) {
    this.propertyConfig.categories.appearance = {
      title: "外观",
      properties: {
        class: {
          description: "组件的CSS样式",
          title: "class样式",
          visible: !t
        },
        icon: {
          title: "图标",
          type: "string",
          description: ""
        }
      }
    };
  }
  getbBehaviorConfig(e) {
    const t = this.getPropertyEditorParams(e, ["Const", "Variable", "StateMachine", "Expression"], "disabled");
    this.propertyConfig.categories.behavior = this.getBehaviorConfig(e, "", {
      disabled: {
        title: "禁用",
        type: "boolean",
        description: "按钮禁用状态",
        refreshPanelAfterChanged: !0,
        editor: t
      }
    });
  }
  getEventPropConfig(e) {
    const t = [
      {
        label: "onClick",
        name: "点击事件"
      }
    ], n = this, r = n.eventsEditorUtils.formProperties(e, n.viewModelId, t), i = {};
    i[n.viewModelId] = {
      type: "events-editor",
      editor: {
        initialData: r
      }
    }, this.propertyConfig.categories.eventsEditor = {
      title: "事件",
      hideTitle: !0,
      properties: i,
      // 这个属性，标记当属性变更得时候触发重新更新属性
      refreshPanelAfterChanged: !0,
      tabId: "commands",
      tabName: "交互",
      setPropertyRelates(s, p) {
        const c = s.propertyValue;
        delete e[n.viewModelId], c && (c.setPropertyRelates = this.setPropertyRelates, n.eventsEditorUtils.saveRelatedParameters(e, n.viewModelId, c.events, c));
      }
    };
  }
}
class Zn extends He {
  constructor(t, n, r = "response-toolbar-item") {
    super(t, n);
    q(this, "toolbarType", "response-toolbar-item");
    this.toolbarType = r;
  }
  /**
   * 
   * @param propertyData 
   * @param isDropdownItem 是否是下拉子项，有些属性在下拉子项上不应该显示 
   * @returns 
   */
  getPropertyConfig(t, n = !1) {
    this.propertyConfig.categories.basic = this.getBasicPropConfig(t), this.propertyConfig.categories.basic.properties.text = {
      title: "文本",
      type: "string",
      description: "",
      refreshPanelAfterChanged: !0
    }, this.propertyConfig.categories.basic.setPropertyRelates = (i) => {
      if (i)
        switch (i && i.propertyID) {
          case "text": {
            i.needRefreshControlTree = !0;
            break;
          }
        }
    }, this.getAppearanceProperties(t, n);
    const r = this.getPropertyEditorParams(t, ["Const", "Variable", "StateMachine", "Expression"], "disabled");
    return this.propertyConfig.categories.behavior = this.getBehaviorConfig(t, "", {
      disabled: {
        title: "禁用",
        type: "boolean",
        description: "按钮禁用状态",
        refreshPanelAfterChanged: !0,
        editor: r
      }
    }), this.getEventPropConfig(t), this.propertyConfig;
  }
  getAppearanceProperties(t, n = !1) {
    this.propertyConfig.categories.appearance = {
      title: "外观",
      description: "Appearance",
      properties: {
        class: {
          title: "class样式",
          type: "string",
          description: "",
          $converter: "/converter/appearance.converter",
          visible: !n
        },
        // "dropdownClass": {
        //     "title": "在下拉菜单中的样式",
        //     "type": "string",
        //     "description": ""
        // },
        icon: {
          title: "图标",
          type: "string",
          description: ""
        },
        tipsEnable: {
          title: "启用提示",
          type: "boolean",
          description: "当启用提示时，鼠标滑过按钮会有消息提示框",
          refreshPanelAfterChanged: !0,
          visible: this.toolbarType === "response-toolbar-item"
        },
        tipsText: {
          title: "提示消息内容",
          type: "string",
          description: "消息提示框内的展示内容",
          visible: t.tipsEnable === !0
        }
      }
    };
  }
  getEventPropConfig(t) {
    const n = [
      {
        label: "onClick",
        name: "点击事件"
      }
    ], r = this, i = r.eventsEditorUtils.formProperties(t, r.viewModelId, n), s = {};
    s[r.viewModelId] = {
      type: "events-editor",
      editor: {
        initialData: i
      }
    }, this.propertyConfig.categories.eventsEditor = {
      title: "事件",
      hideTitle: !0,
      properties: s,
      // 这个属性，标记当属性变更得时候触发重新更新属性
      refreshPanelAfterChanged: !0,
      tabId: "commands",
      tabName: "交互",
      setPropertyRelates(p, c) {
        const f = p.propertyValue;
        delete t[r.viewModelId], f && (f.setPropertyRelates = this.setPropertyRelates, r.eventsEditorUtils.saveRelatedParameters(t, r.viewModelId, f.events, f));
      }
    };
  }
}
function je(o, e) {
  if (!o)
    return !1;
  const t = e || [];
  return (t == null ? void 0 : t.findIndex((r) => r.id === o)) === -1;
}
function st(o, e) {
  const t = e || [];
  let n = { parentIndex: -1, itemIndex: -1 };
  return t.some((r, i) => {
    if (r.children && r.children.length > 0) {
      const s = r.children.findIndex((p) => p.id === o);
      return s > -1 ? (n = { parentIndex: i, itemIndex: s }, !0) : !1;
    }
  }), n;
}
function lt(o, e) {
  const t = e || [];
  let n = { parentIndex: -1, itemIndex: -1 };
  const r = t == null ? void 0 : t.findIndex((i) => i.id === o);
  return r > -1 ? { parent: null, item: t[r] } : (t.some((i, s) => {
    if (i.children && i.children.length > 0) {
      const p = i.children.findIndex((c) => c.id === o);
      return p > -1 ? (n = { parentIndex: s, itemIndex: p }, !0) : !1;
    }
  }), n.parentIndex < 0 ? { parent: null, item: null } : { parent: t[n.parentIndex], item: t[n.parentIndex].children[n.itemIndex] });
}
function Kn(o, e) {
  const t = e || [], n = t == null ? void 0 : t.findIndex((r) => r.id === o);
  return n > -1 && t[n].children && t[n].children.length > 0 ? t[n].expanded === !0 : !1;
}
function eo(o, e, t) {
  function n(x) {
    return !1;
  }
  function r() {
    return !1;
  }
  function i() {
    return !1;
  }
  function s() {
    return !1;
  }
  function p() {
    return t.toolbarContext.schema.buttons || [];
  }
  function c(x, a = "") {
    setTimeout(() => {
      var I, B;
      const S = (I = o.parent) == null ? void 0 : I.designerItemElementRef.value;
      let k;
      a && (k = S == null ? void 0 : S.querySelector("#" + a));
      const y = (B = k || S) == null ? void 0 : B.querySelector("#" + x);
      y == null || y.click();
    }, 0);
  }
  function f(x, a) {
    a.disabled && a.disabled.expressionId && (a.disabled.expressionId = `${a.id}_disabled`), a.visible && a.visible.expressionId && (a.visible.expressionId = `${a.id}_visible`);
    const S = e.formSchemaUtils.getExpressions(), k = S.find((I) => I.target === x.id);
    if (!k || !k.rules || !k.rules.length)
      return;
    const y = {
      target: a.id,
      rules: [],
      targetType: "Button"
    };
    k.rules.forEach((I) => {
      const B = Object.assign(ge(I), {
        id: `${a.id}_${I.type}`
      });
      y.rules.push(B);
    }), S.push(y);
  }
  function h() {
    const x = o.schema, a = Object.assign(
      ge(x),
      {
        id: `${o.schema.type}-cloned-${Math.random().toString(36).slice(2, 6)}`,
        onClick: null
      }
    );
    let S = [];
    return a.children && a.children.length && (S = a.children.map((k) => {
      const y = ge(k);
      return Object.assign(
        y,
        {
          id: `${o.schema.type}-cloned-${Math.random().toString(36).slice(2, 6)}`,
          onClick: null
        }
      ), f(k, y), y;
    }), a.children = S), f(x, a), a;
  }
  function l() {
    const x = o.schema.type || "response-toolbar-item", a = ve(x), S = x.toLowerCase().replace("-", "_");
    return a && !a.id && a.type === x && (a.id = `${S}_${Math.random().toString().slice(2, 6)}`, a.text = "按钮"), a;
  }
  function g(x) {
    const a = p(), S = a == null ? void 0 : a.findIndex((y) => y.id === x), k = S === -1 ? null : a[S];
    return { index: S, toolbarItem: k };
  }
  function d() {
    const x = o.schema.id, a = p();
    return je(x, a);
  }
  function m(x) {
    const a = e.formSchemaUtils.getExpressions();
    if (!a || !a.length)
      return;
    const S = (k) => {
      const y = a && a.findIndex((I) => I.target === k.id);
      y > -1 && a.splice(y, 1);
    };
    S(x), x.children && x.children.length && x.children.forEach((k) => {
      S(k);
    });
  }
  function w(x) {
    t.changeSelectedId(x);
  }
  function P() {
    var k, y;
    const x = p(), { parentIndex: a, itemIndex: S } = st(o.schema.id, x);
    a === -1 || S === -1 || (m(o.schema), x[a].children.splice(S, 1), t.updateToolbarItems(), (k = o.setupContext) == null || k.emit("removeComponent"), (y = o.setupContext) == null || y.emit("selectionChange"));
  }
  function b() {
    var k, y;
    const x = o.schema.id, a = p(), S = a == null ? void 0 : a.findIndex((I) => I.id === x);
    S !== -1 && (m(a[S]), a == null || a.splice(S, 1), t.updateToolbarItems(), (k = o.setupContext) == null || k.emit("removeComponent"), (y = o.setupContext) == null || y.emit("selectionChange"), me.value++);
  }
  function u(x = "Append") {
    var B;
    const a = p(), { parentIndex: S, itemIndex: k } = st(o.schema.id, a);
    if (S === -1 || k === -1)
      return;
    const y = l(), I = x === "Copy" ? h() : Object.assign({}, y);
    a[S].children.splice(k + 1, 0, I), t.updateToolbarItems(), w(I.id), (B = o.setupContext) == null || B.emit("addComponent");
  }
  function E(x, a) {
    const { index: S } = g(a);
    if (S === -1)
      return { index: S, schema: null };
    const k = l(), y = x === "Copy" ? h() : Object.assign({}, k);
    return { index: S, schema: y };
  }
  function D() {
    var k;
    const x = o.schema.id, { index: a, schema: S } = E("Copy", x);
    S && (p().splice(a + 1, 0, S), t.updateToolbarItems(), c(S.id), (k = o.setupContext) == null || k.emit("addComponent"));
  }
  function M() {
    var k;
    const x = o.schema.id, { index: a, schema: S } = E("Append", x);
    if (S && o.parent) {
      const I = p()[a].children || [];
      I.push(S);
      const B = p();
      B[a].children = I, t.updateToolbarItems(), w(S.id), (k = o.setupContext) == null || k.emit("addComponent");
    }
  }
  function O(x) {
    let a;
    switch (o.schema.type) {
      case "tab-toolbar-item":
        a = new Jn(x, e);
        break;
      default:
        a = new Zn(x, e, o.schema.type);
    }
    return a.getPropertyConfig(o.schema, d());
  }
  function N(x) {
    x.stopPropagation(), x.stopImmediatePropagation();
  }
  function j() {
    const x = [{
      id: "delete",
      title: "删除",
      text: "",
      icon: "f-icon-yxs_delete",
      onClick: (a) => {
        N(a), d() ? P() : b();
      }
    }, {
      id: "copy",
      title: "复制",
      icon: "f-icon-yxs_copy",
      onClick: (a) => {
        N(a);
        const { activeElement: S } = document, k = S ? S.tagName.toLowerCase() : "";
        k && k === "input" || k === "textarea" ? (S == null || S.blur(), he(() => {
          d() ? u("Copy") : D();
        })) : d() ? u("Copy") : D();
      }
    }];
    return x.push(d() ? {
      id: "appendSiblingButton",
      title: "",
      text: "新增同级",
      icon: "f-icon-plus-circle",
      onClick: (a) => {
        N(a), u();
      }
    } : {
      id: "appendChildButton",
      title: "",
      text: "新增子级",
      icon: "f-icon-plus-circle",
      onClick: (a) => {
        N(a), M();
      }
    }), x;
  }
  function U() {
    const { schema: x } = o;
    m(x);
  }
  return {
    canAccepts: n,
    checkCanMoveComponent: r,
    checkCanDeleteComponent: i,
    checkCanAddComponent: s,
    getPropsConfig: O,
    getCustomButtons: j,
    onRemoveComponent: U
  };
}
const xt = /* @__PURE__ */ Se({
  name: "FResponseToolbarItemDesign",
  props: bt,
  emits: ["Click", "dropdown", "clearAll"],
  setup(o, e) {
    const t = X(o.alignment), n = Ue(), r = X(), i = ce("designer-host-service"), s = ce("design-item-context"), p = ce("toolbar-item-action"), c = eo(s, i, p), f = Yt(r, s, c);
    Ie(() => {
      r.value.componentInstance = f;
    }), e.expose(f.value);
    function h() {
      const u = {
        "f-icon": !0
      }, E = o.icon ? o.icon.trim() : "";
      return pe(u, E);
    }
    function l() {
      return !!(o.icon && o.icon.trim());
    }
    const g = le(() => {
      const u = {
        btn: !0,
        "f-rt-btn": !0,
        "f-btn-ml": t.value === "right" || t.value === "center",
        "f-btn-mr": t.value === "left",
        "btn-icontext": !!(o.icon && o.icon.trim()),
        disabled: o.disabled === !0,
        "no-drag": !0
      };
      return pe(u, o.class);
    }), d = le(() => {
      let u = {
        btn: !o.isDPItem,
        // 不是下拉按钮，不是下拉项
        disabled: o.disabled === !0,
        "dropdown-item": o.isDPItem,
        "f-rt-btn": !0,
        "text-truncate": !0,
        "btn-icontext": !o.isDPItem && !!(o.icon && o.icon.trim()),
        "dropdown-item-icontext": o.isDPItem && !!(o.icon && o.icon.trim()),
        // 保证内部层级不被拖拽
        "no-drag": !0
      };
      return o.isDPItem || (u = pe(u, o.class || "")), o.isDP && (u = pe(u, o.dropdownClass || "")), u;
    });
    function m(u, E) {
      E && E.stopPropagation(), e.emit(u, {
        id: o.id
      });
    }
    function w() {
      return {
        "btn-group": !0,
        "no-drag": !0,
        "f-rt-dropdown": !0
      };
    }
    function P() {
      return V("div", {
        ref: r,
        "data-dragref": `${s.schema.id}-container`,
        class: "farris-component position-relative",
        style: "display:inline-block!important;"
      }, [V("div", {
        class: w(),
        id: o.id
      }, [V("div", {
        class: g.value,
        style: "display: flex;padding-right: 0.1rem;border-radius:6px;"
      }, [n.shouldShowIcon(o) && V("i", {
        class: n.iconClass(o)
      }, null), V("span", null, [o.text]), V("span", {
        onClick: (u) => m("dropdown", u)
      }, [V("i", {
        class: "f-icon f-icon-arrow-chevron-down",
        style: "display: inline-block;float: right;line-height: 1.25rem;margin-left: .25rem;margin-right: .25rem;"
      }, null)])]), p.renderDropdownMenu(o.item, o.item)])]);
    }
    function b() {
      return V("li", {
        ref: r,
        "data-dragref": `${s.schema.id}-container`,
        id: o.id,
        class: d.value
      }, [n.shouldShowIcon(o) && V("i", {
        class: n.iconClass(o)
      }, null), o.text]);
    }
    return () => o.isDP ? P() : o.isDPItem ? b() : V("div", {
      ref: r,
      "data-dragref": `${s.schema.id}-container`,
      class: "farris-component position-relative",
      style: "display:inline-block!important;"
    }, [V("button", {
      type: "button",
      class: g.value,
      id: o.id,
      onClick: () => m("clearAll")
    }, [l() && V("i", {
      class: h()
    }, null), o.text])]);
  }
});
function to(o, e, t, n) {
  function r(g, d, m, w) {
    n.changeSelectedId((d == null ? void 0 : d.id) || ""), t && t.setupContext && t.setupContext.emit("selectionChange", g, d, m, w);
  }
  function i() {
  }
  function s(g) {
    const d = g.expanded;
    n.clearAllDropdown(), n.toggleDropdownMenu(g, !d);
  }
  function p() {
    n.clearAllDropdown();
  }
  function c(g, d = "") {
    const m = o.items || [], w = d || g, P = m.find((b) => b.id === w);
    return d ? P.children.find((b) => b.id === g) : P;
  }
  function f(g, d = !1) {
    if (!d)
      return;
    const m = g.target;
    m != null && m.classList.contains("dgComponentFocused") && (m == null || m.classList.add("dgComponentSelected"));
  }
  function h(g, d = !1) {
    if (!d)
      return;
    const m = g.target;
    m != null && m.classList.contains("dgComponentFocused") && (m == null || m.classList.remove("dgComponentSelected"));
  }
  function l(g, d, m = !1) {
    const w = c(g.id, g.parent);
    return V(Qn, {
      key: w.id,
      class: ["p-0", m ? "d-block no-drag" : "d-inline-block"],
      modelValue: w,
      "onUpdate:modelValue": (P) => w = P,
      canMove: !1,
      childType: "response-toolbar-item",
      childLabel: "按钮",
      contentKey: "buttons",
      componentId: o.componentId,
      id: w.id,
      onSelectionChange: r,
      onRemoveComponent: i,
      onMouseenter: (P) => f(P, m),
      onMouseleave: (P) => h(P, m)
    }, {
      default: () => {
        var P;
        return [V(xt, {
          id: w.id,
          disabled: w.disabled,
          text: w.text,
          icon: w.icon,
          isDP: g.isDP,
          item: g,
          isDPItem: g.isDPItem,
          class: ((P = g.appearance) == null ? void 0 : P.class) || "btn-secondary",
          alignment: o.alignment || "right",
          onDropdown: () => s(g),
          onClearAll: () => p(),
          componentId: o.componentId
        }, null)];
      }
    });
  }
  return {
    renderToolbarItemDesigner: l,
    actionHandlers: n
  };
}
function $e(o, e = !1, t = "") {
  const n = [];
  return o.reduce((r, i) => {
    if (i.children && i.children.length > 0) {
      const s = $e(i.children, !0, i.id);
      r.push(Object.assign({}, i, {
        children: s,
        isDPItem: !1,
        isDP: !0,
        parent: "",
        expanded: !1
      }));
    } else
      r.push(Object.assign({}, i, {
        isDPItem: e,
        isDP: !1,
        parent: t
      }));
    return r;
  }, n), n;
}
const no = /* @__PURE__ */ Se({
  name: "FResponseToolbarDesign",
  props: Pn,
  emits: ["Click"],
  setup(o, e) {
    const t = X($e(o.items)), n = X(), r = X(), i = X(), s = X("");
    let p = 0;
    const c = 15, f = ce("designer-host-service"), h = ce("design-item-context"), l = {
      clearAllDropdown: (T) => {
      },
      toggleDropdownMenu: (T) => {
      },
      updateToolbarItems: () => {
      },
      changeSelectedId: (T) => {
        s.value = T;
      },
      renderDropdownMenu: (T, _) => {
      },
      toolbarContext: h,
      changeMenuPosition: (T, _, H) => ({})
    }, g = Un(h, f, l), d = Gt(i, h, g), m = ce("toolbar-item-handler"), {
      initDragula: w,
      dragulaInstance: P
    } = zn(h), b = Ue(), u = to(o, r, h, l), E = Xn(b, t, u), {
      renderToolbarItemDesigner: D
    } = u, {
      clearAllDropDownMenu: M,
      renderDropdownMenu: O
    } = E;
    ut("toolbar-item-action", l), l.renderDropdownMenu = O, m && (m.changeSelectedId = function(T) {
      s.value = T;
    });
    function N() {
      const T = r.value.querySelector(".dgComponentSelected");
      T && yt(T);
    }
    function j() {
      if (s.value)
        if (je(s.value, t.value)) {
          const {
            parent: T,
            item: _
          } = lt(s.value, t.value);
          T && (l.toggleDropdownMenu(T, !0), setTimeout(() => {
            var z;
            const H = i.value.querySelector("#" + T.id), L = H == null ? void 0 : H.querySelector("#" + _.id);
            (((z = L == null ? void 0 : L.parentElement) == null ? void 0 : z.className) || "").indexOf("dgComponentFocused") < 0 && (L == null || L.click());
          }, 0));
        } else
          N();
    }
    function U(T) {
      T && T.target.closest("ul.dropdown-menu") && T.type === "wheel" || (t.value.filter((_) => _.children && _.children.length > 0).forEach((_) => {
        _.expanded = !1;
      }), M());
    }
    l.clearAllDropdown = U;
    function x() {
      m && m.updateToolbarItems && m.updateToolbarItems();
    }
    l.updateToolbarItems = x;
    function a(T) {
      if (T) {
        const _ = i.value.querySelector("#" + T.id), H = _.querySelector("#" + T.id + "_menu"), L = l.changeMenuPosition(T, _);
        Object.keys(L).forEach((z) => {
          H.style[z] = L[z];
        });
      }
    }
    const S = new ResizeObserver((T) => {
      var _;
      if (T.length) {
        const L = T[0].contentRect.width;
        if (L === 0) {
          p = 0;
          return;
        }
        if (Math.abs(L - p) > c)
          if (p = L, je(s.value, t.value)) {
            const {
              parent: z,
              item: Y
            } = lt(s.value, t.value);
            a(z);
          } else if (Kn(s.value, t.value)) {
            const z = (_ = t.value) == null ? void 0 : _.find((Y) => Y.id === s.value);
            a(z);
          } else
            U();
      }
    });
    Ie(() => {
      S.observe(i.value), p = i.value.clientWidth, i.value.componentInstance = d, w(r.value, n.value, x), document.body.addEventListener("wheel", U);
    }), ct(() => {
      S.disconnect(), document.body.removeEventListener("wheel", U), P && P.destroy && P.destroy();
    }), e.expose(d.value);
    const k = le(() => {
      const T = {
        "f-toolbar": !0,
        "f-response-toolbar": !0,
        "position-relative": !0,
        "f-response-toolbar-sm": o.buttonSize === "sm",
        "f-response-toolbar-lg": o.buttonSize === "lg",
        "px-2": !0
      };
      return pe(T, o.customClass);
    }), y = le(() => ({
      "text-left": o.alignment === "left",
      "text-right": o.alignment === "right",
      "justify-content-end": o.alignment === "right",
      "justify-content-start": o.alignment === "left",
      "justify-content-center": o.alignment === "center",
      "no-drag": !0,
      "w-100": !0,
      "f-utils-overflow-hidden": !0
    }));
    Te(() => o.items, () => {
      t.value = $e(o.items), he(() => {
        j();
      });
    }, {
      deep: !0
    });
    function I(T) {
      T && (T.stopPropagation(), T.preventDefault());
      const {
        schema: _
      } = h;
      _.buttons || (_.buttons = []);
      const H = ve("response-toolbar-item");
      H.id = `toolbar_item_${Math.random().toString().slice(2, 6)}`, H.appearance = {
        class: "btn btn-secondary"
      }, _.buttons.push(H);
    }
    function B() {
      return V("li", {
        style: "border-width: 1px;border-style: dashed;display: inline-block;padding: 0 8px;line-height: 24px; border-radius: 3px; cursor: default;color: #B4BCCC;",
        onClick: I
      }, [V("span", {
        class: "f-icon f-icon-amplification mr-1",
        style: "font-size: 12px;"
      }, null), V("span", {
        class: "farris-tag-add-text"
      }, [zt("添加按钮")])]);
    }
    function C() {
      return t.value.map((T, _) => D(T, _));
    }
    return () => {
      var T;
      return V("div", {
        ref: i,
        "data-dragref": `${h.schema.id}-container`,
        class: k.value,
        id: o.id
      }, [V("div", {
        ref: n,
        class: y.value,
        onClick: (_) => U(_)
      }, [V("div", {
        ref: r,
        class: "d-block f-response-content"
      }, [(T = t.value) != null && T.length ? C() : B()])])]);
    };
  }
}), uo = qe;
Ee.register = (o, e, t, n) => {
  o["response-toolbar"] = Ee, e["response-toolbar"] = qe, n["response-toolbar"] = { eventHandlerResolver: kn };
};
Ee.registerDesigner = (o, e, t) => {
  o["response-toolbar"] = no, e["response-toolbar"] = qe, o["response-toolbar-item"] = xt, e["response-toolbar-item"] = Mn;
};
const fo = Xt(Ee);
export {
  Ee as FResponseToolbar,
  ye as ResponseToolbarDropDownItem,
  co as ResponseToolbarGroup,
  Qt as ResponseToolbarItem,
  fo as default,
  uo as responseToolbarResolver
};
