import { InputBaseProperty } from "../../../property-panel/src/composition/entity/input-base-property";
export declare class AvatarProperty extends InputBaseProperty {
    constructor(componentId: string, designerHostService: any);
    getEditorProperties(propertyData: any): {
        description: string;
        title: string;
        type: string;
        $converter: string;
        properties: {
            readonly: {
                description: string;
                title: string;
                type: string;
            };
            avatarWidth: {
                description: string;
                title: string;
                type: string;
            };
            avatarHeight: {
                description: string;
                title: string;
                type: string;
            };
            cover: {
                description: string;
                title: string;
                type: string;
            };
        };
    };
}
