import { BindingSelectorProps } from "../binding-selector.props";
export declare function useFieldSelection(props: BindingSelectorProps): {
    initTreeData: () => void;
    getTreeDataSource: (bindingType: string) => never[];
    updateViewModel: (bindingData: Record<string, any>, bindingType: string) => void;
    updateComponentSchema: (bindingData: Record<string, any>, bindingType: string) => any;
    resolveOccupiedFields: (currentBinding: any) => Set<string>;
    resolveFieldTypesByEditorType: (editorType: string) => string[];
    checkFieldValiation: (bindingData: any, bindingType: string) => boolean;
    clearExpresssionConfig: (bindingData: Record<string, any>) => void;
};
