import type { Plugin } from 'vue';
import FCalendar from './src/calendar.component';
import FCalendarHeader from './src/components/header/header.component';
import FCalendarDayView from './src/components/day/day-view.component';
import FCalendarMonthView from './src/components/month/month-view.component';
import FCalendarWeekView from './src/components/week/week-view.component';
export * from './src/calendar.props';
export * from './src/components/day/day-view.props';
export * from './src/components/header/header.props';
export * from './src/components/month/month-view.props';
export * from './src/components/week/week-view.props';
export * from './src/types/calendar';
export * from './src/types/common';
export * from './src/types/month';
export * from './src/types/month-view';
export * from './src/types/schedule';
export { FCalendar, FCalendarDayView, FCalendarHeader, FCalendarMonthView, FCalendarWeekView };
declare const _default: {
    new (...args: any[]): import("vue").CreateComponentPublicInstanceWithMixins<Readonly<{
        [x: string]: any;
    }> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, never[], import("vue").PublicProps, {
        [x: string]: any;
    }, true, {}, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, {}, any, import("vue").ComponentProvideOptions, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<{
        [x: string]: any;
    }> & Readonly<{}>, () => any, {}, {}, {}, {
        [x: string]: any;
    }>;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & import("vue").ComponentOptionsBase<Readonly<{
    [x: string]: any;
}> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, never[], never, {
    [x: string]: any;
}, {}, string, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, import("vue").ComponentProvideOptions> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & Plugin;
export default _default;
