import { ExtractPropTypes } from 'vue';
import { WeekInCalendar } from '../../types/calendar';
import { ScheduleEvent } from '../../types/schedule';
export declare const monthViewProps: {
    dates: {
        Type: {
            (arrayLength: number): WeekInCalendar[];
            (...items: WeekInCalendar[]): WeekInCalendar[];
            new (arrayLength: number): WeekInCalendar[];
            new (...items: WeekInCalendar[]): WeekInCalendar[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: never[];
    };
    daysInWeek: {
        Type: {
            (arrayLength: number): string[];
            (...items: string[]): string[];
            new (arrayLength: number): string[];
            new (...items: string[]): string[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: string[];
    };
    enableKeyboadNavigate: {
        Type: BooleanConstructor;
        default: boolean;
    };
    enableMarkCurrent: {
        Type: BooleanConstructor;
        default: boolean;
    };
    events: {
        Type: {
            (arrayLength: number): ScheduleEvent[];
            (...items: ScheduleEvent[]): ScheduleEvent[];
            new (arrayLength: number): ScheduleEvent[];
            new (...items: ScheduleEvent[]): ScheduleEvent[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: never[];
    };
    activeDay: {
        Type: ObjectConstructor;
        default: null;
    };
};
export type MonthViewProps = ExtractPropTypes<typeof monthViewProps>;
