import { UseEvent } from './types';
/**
 * Event key codes
 */
export declare enum KeyCode {
    enter = 13,
    esc = 27,
    space = 32,
    leftArrow = 37,
    upArrow = 38,
    rightArrow = 39,
    downArrow = 40,
    tab = 9,
    shift = 16
}
/**
 * Event key names
 */
export declare enum KeyName {
    enter = "Enter",
    esc = "Escape",
    space = " ",
    leftArrow = "ArrowLeft",
    upArrow = "ArrowUp",
    rightArrow = "ArrowRight",
    downArrow = "ArrowDown",
    tab = "Tab",
    shift = "Shift"
}
export declare function useEvent(): UseEvent;
