import { DateObject } from './common';
export interface MonthViewItem {
    date: DateObject;
    disable: boolean;
    displayText: string;
    isCurrent: boolean;
    month: number;
    range?: boolean;
    selected?: boolean;
}
export interface ActiveMonth {
    month: number;
    year: number;
    displayTextOfMonth: string;
    displayTextOfYear: string;
}
export interface NameOfMonths {
    [month: number]: string;
}
export declare const defaultNameOfMonths: Record<number, string>;
