import { ExtractPropTypes } from "vue";
import { Option } from '../combo-tree.props';
export declare const treeContainerProps: {
    data: {
        type: {
            (arrayLength: number): Option[];
            (...items: Option[]): Option[];
            new (arrayLength: number): Option[];
            new (...items: Option[]): Option[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: never[];
    };
    enableSearch: {
        type: BooleanConstructor;
        default: boolean;
    };
    idField: {
        type: StringConstructor;
        default: string;
    };
    multiSelect: {
        default: boolean;
        type: BooleanConstructor;
    };
    selectedValues: {
        type: StringConstructor;
        default: string;
    };
    separator: {
        type: StringConstructor;
        default: string;
    };
    textField: {
        type: StringConstructor;
        default: string;
    };
    titleField: {
        type: StringConstructor;
        default: string;
    };
    width: {
        type: NumberConstructor;
    };
    height: {
        type: NumberConstructor;
    };
    valueField: {
        type: StringConstructor;
        default: string;
    };
    formatter: {
        type: FunctionConstructor;
    };
    maxHeight: {
        type: NumberConstructor;
        default: number;
    };
    repositoryToken: {
        type: SymbolConstructor;
        default: null;
    };
    editorParams: {
        type: ObjectConstructor;
    };
    customRowStatus: {
        type: ObjectConstructor;
        default: null;
    };
};
export type TreeContainerProps = ExtractPropTypes<typeof treeContainerProps>;
