/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import type { Plugin } from 'vue';
import FConditionFields from './src/condition-fields.component';
import FConditionList from './src/condition-list.component';
export * from './src/condition.props';
export * from './src/types';
export * from './src/composition/types';
export * from './src/composition/condition-value/types';
export * from './src/composition/use-compare';
export * from './src/composition/use-condition';
export * from './src/composition/use-condition-value';
export * from './src/condition-fields.design.component';
export { FConditionFields, FConditionList };
declare const _default: {
    new (...args: any[]): import("vue").CreateComponentPublicInstanceWithMixins<Readonly<{
        key: string;
        conditions: import("./src/types").Condition[];
        fields: import("./src/types").FieldConfig[];
        isControlInline: boolean;
    }> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, import("vue").PublicProps, {
        key: string;
        conditions: import("./src/types").Condition[];
        fields: import("./src/types").FieldConfig[];
        isControlInline: boolean;
    }, true, {}, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, {}, any, import("vue").ComponentProvideOptions, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<{
        key: string;
        conditions: import("./src/types").Condition[];
        fields: import("./src/types").FieldConfig[];
        isControlInline: boolean;
    }> & Readonly<{}>, () => any, {}, {}, {}, {
        key: string;
        conditions: import("./src/types").Condition[];
        fields: import("./src/types").FieldConfig[];
        isControlInline: boolean;
    }>;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & import("vue").ComponentOptionsBase<Readonly<{
    key: string;
    conditions: import("./src/types").Condition[];
    fields: import("./src/types").FieldConfig[];
    isControlInline: boolean;
}> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {
    key: string;
    conditions: import("./src/types").Condition[];
    fields: import("./src/types").FieldConfig[];
    isControlInline: boolean;
}, {}, string, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, import("vue").ComponentProvideOptions> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & Plugin;
export default _default;
