import { ConditionValue } from "./types";
import { EditorType } from '../../../../dynamic-form';
export declare class ComboLookupValue implements ConditionValue {
    editorType: EditorType;
    textValue: string;
    value: string;
    valueField: string;
    valueType: string;
    constructor(initialData?: {
        textValue: string;
        value: string;
        valueField: string;
    });
    clear(): void;
    getPropValue(helpItem: any, args: Array<string>): any;
    getTextValue(textField: string): string;
    getValue(): string;
    getDisplayText(): string;
    setValue(value: any): void;
    isEmpty(): boolean;
}
