import { EditorType } from '../../../../dynamic-form';
import { ConditionValue } from "./types";
export declare class DateTimePickerValue implements ConditionValue {
    editorType: EditorType;
    value: string | undefined;
    valueType: string;
    displayFormat: string;
    valueFormat: string;
    constructor(initialData?: {
        value: string;
        displayFormat: string;
        valueFormat: string;
    });
    clear(): void;
    getValue(): string | undefined;
    getDisplayText(): string | undefined;
    setValue(value: any): void;
    isEmpty(): boolean;
}
