import { EditorType } from '../../../../dynamic-form';
import { ConditionValue } from "./types";
export declare class MonthRangeValue implements ConditionValue {
    editorType: EditorType;
    begin: string;
    end: string;
    valueType: string;
    clear(): void;
    constructor(initialData?: {
        begin: string;
        end: string;
    });
    getValue(): string;
    getDisplayText(): string;
    setValue(value: {
        dataRange: string;
        delimiter: string;
    }): void;
    isEmpty(): boolean;
}
