import { EditorType } from '../../../../dynamic-form';
import { ConditionValue } from "./types";
export declare class RadioGroupValue implements ConditionValue {
    editorType: EditorType;
    value: any;
    valueType: string;
    valueList: Array<{
        value: string | number | boolean;
        name: string;
    }>;
    constructor(initialData?: {
        value: any;
        valueList: any[];
    });
    clear(): void;
    getValue(): any;
    getDisplayText(): string;
    setValue(value: any): void;
    isEmpty(): boolean;
}
