import { EditorType } from '../../../../dynamic-form';
import { ConditionValue } from "./types";
export declare class TextValue implements ConditionValue {
    editorType: EditorType;
    value: string | undefined;
    valueType: string;
    constructor(initialData?: {
        value: string;
    });
    clear(): void;
    getValue(): string | undefined;
    getDisplayText(): string | undefined;
    setValue(value: any): void;
    isEmpty(): boolean;
}
