import { App, Ref } from 'vue';
import { DataViewOptions, UseColumn, UseDataView, UseFilter, UseFitColumn, UseSort, UseVirtualScroll } from '../../composition/types';
export default function (props: DataViewOptions, gridContentRef: Ref<any>, viewPortWidth: Ref<number>, useColumnComposition: UseColumn, useDataViewComposition: UseDataView, useFilterComposition: UseFilter, useFitColumnComposition: UseFitColumn, useSorterComposition: UseSort, useVirtualScrollComposition: UseVirtualScroll, modalService: any): {
    acceptCallback: () => void;
    rejectCallback: () => void;
    renderSettingsPanel: (app: App) => any;
    openSettingPanel: () => void;
};
