import { Ref, SetupContext } from "vue";
import { ColumnContext, DataViewOptions, UseDataView, UseEdit, UseHierarchy, UseRow, UseSelectHierarchyItem, UseSelection, UseVirtualScroll, UseVisualData, UseVisualDataBound, VisualData } from "../../composition/types";
export default function (props: DataViewOptions, context: SetupContext, columnContext: Ref<ColumnContext>, visibleDatas: Ref<VisualData[]>, useDataViewComposition: UseDataView, useEditComposition: UseEdit, useHierarchyComposition: UseHierarchy, useRowComposition: UseRow, useSelectionCompostion: UseSelection, useSelectHierarchyItemComposition: UseSelectHierarchyItem, useVirtualScrollComposition: UseVirtualScroll, useVisualDataComposition: UseVisualData, useVisualDataBoundComposition: UseVisualDataBound): {
    renderDataRow: (visualData: VisualData, cellPositionMap: Record<string, {
        left: number;
        width?: number;
    }>, area: "primary" | "left" | "right" | undefined, rowIndex: number) => any;
};
