import { Ref } from "vue";
import { DataViewOptions, DictTreeItem, UseHierarchy, VisualData } from "../types";
export declare function useHierarchyStyle(props: DataViewOptions, visibleDatas: Ref<VisualData[]>, useHierarchyComposition: UseHierarchy): {
    hierarchyCellContentStyle: (visualTreeNode: VisualData) => Record<string, any>;
    handleCollapsedPaddingBottom: (index: number, visibleDatasValue: VisualData[], dictTree: DictTreeItem[]) => VisualData[];
};
