import { InputBaseProperty } from "../../../property-panel/src/composition/entity/input-base-property";
export declare class DatePickerProperty extends InputBaseProperty {
    constructor(componentId: string, designerHostService: any);
    getEditorProperties(propertyData: any): {
        properties: {
            readonly: {
                description: string;
                title: string;
                editor: {
                    type: string;
                    propertyTypes: any;
                };
            };
            required: {
                description: string;
                title: string;
                type: string;
                editor: {
                    type: string;
                    propertyTypes: any;
                };
            };
            placeholder: {
                description: string;
                title: string;
                type: string;
            };
        };
        setPropertyRelates(changeObject: any, parameters: any): void;
        description: string;
        title: string;
        type: string;
        $converter: string;
    };
    private setEditorPropertyRelates;
    private getDateFormatOptions;
    private getValueFormatOptions;
}
