import { DesignerItemContext } from "../../types";
import { DesignerHostService } from "../types";
export interface DragDropRule {
    canAccept: boolean;
    canMove: boolean;
    canDelete: boolean;
    [index: string]: boolean;
}
/**
 * 解析模板拖拽控制规则
 */
export declare class UseTemplateDragAndDropRules {
    getTemplateRule(designItemContext: DesignerItemContext, designerHostService?: DesignerHostService): DragDropRule;
    private resolveRuleValue;
    private parseRuleValueSchema;
    getComponentContext(designItemContext: DesignerItemContext): {
        componentClass: any;
        componentClassList: any;
        childContents: import("../../types").ComponentSchema[];
        firstLevelChildSchema: import("../../types").ComponentSchema | null;
        firstLevelChildClass: any;
        firstLevelChildClassList: any;
        secondLevelChildSchema: import("../../types").ComponentSchema | null;
        secondLevelChildClass: any;
        secondLevelChildClassList: any;
        parentSchema: import("../../types").ComponentSchema | undefined;
        parentClass: any;
        parentClassList: any;
    };
}
