import { EffectFunction, PropertyConverter, SchemaService } from './types';
import { ComponentSchema } from "../../designer-canvas/src/types";
import { ElementPropertyConfig } from "../../property-panel/src/composition/entity/property-entity";
declare const propertyConfigSchemaMap: Record<string, any>;
declare const propertyConverterMap: Map<string, PropertyConverter>;
declare const propertyEffectMap: Record<string, EffectFunction>;
declare function getPropertyConfigByType(schemaType: string, schemaService: SchemaService, schema?: ComponentSchema): ElementPropertyConfig[];
declare function getPropertyConfigBySchema(rawSchema: ComponentSchema, schemaService: SchemaService, designerItem: any, componentId: string, propertyConfig?: Record<string, any>): ElementPropertyConfig[];
export { getPropertyConfigBySchema, getPropertyConfigByType, propertyConfigSchemaMap, propertyConverterMap, propertyEffectMap };
