import { DesignerHostService } from "../../designer-canvas/src/composition/types";
import { MapperFunction, SchemaResolverFunction } from "./types";
declare const schemaMap: Record<string, any>;
declare const schemaResolverMap: Record<string, SchemaResolverFunction>;
declare function getSchemaByType(componentType: string, resolveContext?: Record<string, any>, designerHostService?: DesignerHostService): Record<string, any> | null;
declare function mappingSchemaToProps(resolvedSchema: Record<string, any>, schemaMapper: Map<string, string | MapperFunction>): Record<string, any>;
declare function resolveSchemaToProps(schemaValue: Record<string, any>, defaultSchema: Record<string, any>, schemaMapper?: Map<string, string | MapperFunction>): Record<string, any>;
declare function resolveSchemaWithDefaultValue(schemaValue: Record<string, any>): Record<string, any>;
export { getSchemaByType, resolveSchemaWithDefaultValue, resolveSchemaToProps, schemaMap, schemaResolverMap, mappingSchemaToProps };
