import { FormSchemaEntity } from '../../common';
import { EntityBindingSelectorProps } from "../entity-binding-selector.props";
import { RowOptions } from "../../data-view";
export declare function useFieldTree(props: EntityBindingSelectorProps): {
    fieldTreeGridRef: import("vue").Ref<any, any>;
    resolveFieldDataSource: (bindingEntity: FormSchemaEntity) => void;
    occupiedFieldMap: Map<string, boolean>;
    fieldDataSource: import("vue").Ref<any, any>;
    fieldTreeRowOption: Partial<RowOptions>;
    fieldColumns: import("vue").Ref<{
        field: string;
        title: string;
    }[], {
        field: string;
        title: string;
    }[] | {
        field: string;
        title: string;
    }[]>;
    fieldSelectionOption: {
        enableSelectRow: boolean;
        multiSelect: boolean;
        multiSelectMode: string;
        showCheckbox: boolean;
        showSelectAll: boolean;
    };
    checkAndGetSelectedFields: () => any;
    hasSelectableField: import("vue").Ref<boolean, boolean>;
    currentComponentType: import("vue").Ref<any, any>;
};
