export interface VariableModel {
    /** 标识，不可重复 */
    key: string;
    /** 名称 */
    name: string;
    /** 描述 */
    description: string;
}
export interface VariableModels {
    [key: string]: {
        name: string;
        items: VariableModel[];
        visible: boolean;
    };
}
export interface EntityVariableDataSource {
    entities?: {
        entityCode: string;
        fields: any[];
    };
    variables?: VariableModels;
}
