import { Ref } from "vue";
import { Condition, FieldConfig, FilterItem } from "../types";
import { QueryItem } from '../../../query-solution';
export interface UseFilterItems {
    clearAll: () => void;
    clearFilterItem: (itemToBeRemoved: FilterItem) => void;
    currentFilterId: Ref<string>;
    filterFields: Ref<FieldConfig[]>;
    filterItems: Ref<FilterItem[]>;
    loadFilterItems: (fields: FieldConfig[], conditions: Condition[]) => void;
    removeFilterItem: (itemToBeRemoved: FilterItem) => void;
    reset: () => void;
    shouldShowClearButtonInFilterItem: (filterItem: FilterItem) => boolean;
    handleQuery: () => QueryItem[];
}
