import { InputBaseProperty } from '../../../property-panel';
import { DesignerComponentInstance } from '../../../designer-canvas';
export declare class InputGroupProperty extends InputBaseProperty {
    constructor(componentId: string, designerHostService: any);
    getPropertyConfig(propertyData: any, componentInstance: DesignerComponentInstance): {
        type: string;
        categories: {};
    };
    getEditorProperties(propertyData: any): {
        properties: {
            readonly: {
                description: string;
                title: string;
                editor: {
                    type: string;
                    propertyTypes: any;
                };
            };
            required: {
                description: string;
                title: string;
                type: string;
                editor: {
                    type: string;
                    propertyTypes: any;
                };
            };
            placeholder: {
                description: string;
                title: string;
                type: string;
            };
        };
        setPropertyRelates(changeObject: any, parameters: any): void;
        description: string;
        title: string;
        type: string;
        $converter: string;
    };
    getFormatValidation(propertyData: any): any;
}
