import { ExtractPropTypes } from 'vue';
export declare const popupContainerProps: {
    /** 下拉选项的数据源 */
    options: {
        type: ArrayConstructor;
        default: never[];
    };
    /** 下拉选项的ID字段 */
    idField: {
        type: StringConstructor;
        default: string;
    };
    /** 下拉选项的值字段 */
    valueField: {
        type: StringConstructor;
        default: string;
    };
    /** 下拉选项的名称字段 */
    textField: {
        type: StringConstructor;
        default: string;
    };
    /** 下拉选项的标题字段 */
    titleField: {
        type: StringConstructor;
        default: string;
    };
};
export type PopupContainerProps = ExtractPropTypes<typeof popupContainerProps>;
