import { ExtractPropTypes, PropType } from 'vue';
import { UseParameters, FormContextData } from '../composition/types';
import { JsonEditorProps } from '../json-editor.props';
export declare const modalContainerProps: {
    useParametersComposition: {
        type: PropType<UseParameters>;
        require: boolean;
    };
    jsonEditorProps: {
        type: PropType<JsonEditorProps>;
        default: {};
    };
    formContextData: {
        type: PropType<FormContextData>;
        default: {};
    };
};
export type ModalContainerProps = ExtractPropTypes<typeof modalContainerProps>;
