import { Ref } from 'vue';
import FLoading from './loading.component';
import { LoadingProps } from './loading.props';
export default class LoadingService {
    static show(config?: LoadingProps): Ref<InstanceType<typeof FLoading>>;
    static close(loadingId: number, callback?: () => void): void;
    static clearAll(): void;
}
