import { LookupProps } from "../lookup.props";
import { LookupPagination, TreeInfo } from "./types";
import { LookupStates } from "./use-state";
export declare function useCheckProps(props: LookupProps, lookupStates: LookupStates): {
    checkPaination: (paginationOptions?: Partial<LookupPagination>) => {
        enable?: boolean | undefined;
        sizeLimits?: number[] | undefined;
        size?: number | undefined;
        index?: number | undefined;
        showLimits?: boolean | undefined;
        total?: number | undefined;
        showGoto?: boolean | undefined;
        mode?: "server" | "client" | undefined;
    };
    checkMultiSelect: () => {
        enableSelectRow: boolean;
        multiSelect: any;
        showCheckbox: any;
        multiSelectMode: string;
    };
    checkColumnOptions: () => {
        fitColumns: any;
        fitMode: string;
        resizeColumn: boolean;
    };
    isDoubleList: () => any;
    getNavigationSize: () => {
        width: any;
        minWidth: number;
    };
    isTreeList: () => boolean;
    navIsTreeList: () => boolean;
    navIsList: () => any;
    isLoadAll: (treeInfo?: TreeInfo) => boolean;
    isPathCodeTree: (treeInfo?: TreeInfo) => boolean;
};
