import { Ref } from "vue";
import { UseHttpComposition } from "./use-http";
import { BeforeOpenDialogFunction } from "./types";
import { LookupProps } from "../lookup.props";
export type LookupInputChangeOptions = {
    updateModelValue: () => void;
    selectedItems: Ref<any[]>;
    openDialog: () => void;
    beforeOpenDialog: BeforeOpenDialogFunction;
    modelValue: Ref<string>;
    useHttpComposition: UseHttpComposition;
    lookupOptions: any;
};
export declare function useInputChange(props: LookupProps, context: any, options: LookupInputChangeOptions): {
    changeOnBlur: import("vue").ComputedRef<boolean>;
    changeOnEnter: import("vue").ComputedRef<boolean>;
    onInputBlur: (event: MouseEvent) => void;
    onEnterKeyDown: (event: KeyboardEvent) => void;
    isClear: Ref<boolean, boolean>;
};
