import { VisualData } from '../../../data-view';
import { LookupStates } from "./use-state";
import { LookupProps } from "../lookup.props";
export interface LookupSelectionsManager {
    updateSelections: (data: any, checked?: boolean) => void;
    clearSelections: () => void;
    getSelectionIds: () => Array<any>;
    getSelections: () => any[];
    unSelectionsByIds: (itemIds: any) => void;
    selectTreeNodes: (treeNodes: any[]) => void;
    unSelectTreeNode: (treeNode: VisualData) => void;
}
export declare const LOOKUP_SELECTIONS_MANAGER: unique symbol;
export declare function useSelections(props: LookupProps, lookupStates: LookupStates): LookupSelectionsManager;
