import { InputBaseProperty } from '../../../property-panel';
import { DesignerComponentInstance } from '../../../designer-canvas';
export declare const LookupSchemaRepositoryToken: unique symbol;
export declare class LookupPropertyConfig extends InputBaseProperty {
    private comboListEditor;
    private numberEditor;
    private readonlyEditor;
    private visibleEditor;
    private requiredEditor;
    private freeInputEditor;
    getExpressionConfig(propertyData: any, type: 'Field' | 'Button' | 'Container'): {
        description: string;
        title: string;
        properties: {
            [x: string]: any;
        };
    };
    getPropertyConfig(propertyData: any, componentInstance: DesignerComponentInstance | null): {
        type: string;
        categories: any;
    };
    getGridFieldEdtiorPropConfig(propertyData: any): any;
    private flattenTreeNodes;
    private isSimpleStringField;
    getBehaviorConfig(propertyData: any): {
        description: string;
        title: string;
        properties: {
            visible: {
                description: string;
                title: string;
                type: string;
                editor: any;
            };
        };
        setPropertyRelates: (changeObject: any, newPropertyData: any) => void;
    };
    changeBindingField(propertyData: any, changeObject: any): void;
    private getDisplayType;
    private getLookupConfig;
    showNavigatiorWidth(editorOptions: any): boolean;
    private getDialogPropertyConfig;
    private showPagerProperty;
    private getPageConfig;
    private showLoadType;
    private showOnlySelectLeaf;
    private getTreePropConfig;
    private getEventPropConfig;
}
