/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { Plugin } from 'vue';
import FNotify from './src/notify.component';
import FToast from './src/components/toast.component';
import FNotifyService from './src/notify.service';
export * from './src/notify.props';
export * from './src/components/toast.props';
export { FNotify, FNotifyService, FToast };
export declare const F_NOTIFY_SERVICE_TOKEN: unique symbol;
declare const _default: {
    new (...args: any[]): import("vue").CreateComponentPublicInstanceWithMixins<Readonly<{
        showCloseButton: boolean;
        position: import("./src/notify.props").NotifyPosition;
        timeout: number;
        theme: import("./src/notify.props").NotifyTheme;
        animate: import("./src/notify.props").ToastyAnimate;
        safeHtml: boolean;
        id?: string | undefined;
        left?: number | undefined;
        right?: number | undefined;
        top?: number | undefined;
        bottom?: number | undefined;
        options?: import("./src/notify.props").NotifyData | undefined;
    }> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, import("vue").PublicProps, {
        showCloseButton: boolean;
        position: import("./src/notify.props").NotifyPosition;
        timeout: number;
        theme: import("./src/notify.props").NotifyTheme;
        animate: import("./src/notify.props").ToastyAnimate;
        safeHtml: boolean;
    }, true, {}, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, {}, any, import("vue").ComponentProvideOptions, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<{
        showCloseButton: boolean;
        position: import("./src/notify.props").NotifyPosition;
        timeout: number;
        theme: import("./src/notify.props").NotifyTheme;
        animate: import("./src/notify.props").ToastyAnimate;
        safeHtml: boolean;
        id?: string | undefined;
        left?: number | undefined;
        right?: number | undefined;
        top?: number | undefined;
        bottom?: number | undefined;
        options?: import("./src/notify.props").NotifyData | undefined;
    }> & Readonly<{}>, () => any, {}, {}, {}, {
        showCloseButton: boolean;
        position: import("./src/notify.props").NotifyPosition;
        timeout: number;
        theme: import("./src/notify.props").NotifyTheme;
        animate: import("./src/notify.props").ToastyAnimate;
        safeHtml: boolean;
    }>;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & import("vue").ComponentOptionsBase<Readonly<{
    showCloseButton: boolean;
    position: import("./src/notify.props").NotifyPosition;
    timeout: number;
    theme: import("./src/notify.props").NotifyTheme;
    animate: import("./src/notify.props").ToastyAnimate;
    safeHtml: boolean;
    id?: string | undefined;
    left?: number | undefined;
    right?: number | undefined;
    top?: number | undefined;
    bottom?: number | undefined;
    options?: import("./src/notify.props").NotifyData | undefined;
}> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {
    showCloseButton: boolean;
    position: import("./src/notify.props").NotifyPosition;
    timeout: number;
    theme: import("./src/notify.props").NotifyTheme;
    animate: import("./src/notify.props").ToastyAnimate;
    safeHtml: boolean;
}, {}, string, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, import("vue").ComponentProvideOptions> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & Plugin;
export default _default;
