/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import type { Plugin } from 'vue';
import Popover from './src/popover.component';
import PopoverDirective from './src/popover.directive';
export * from './src/popover.props';
export { Popover, PopoverDirective };
declare const _default: {
    new (...args: any[]): import("vue").CreateComponentPublicInstanceWithMixins<Readonly<{
        fitContent: boolean;
        minWidth: number;
        arrowOffsetX: number;
        customStyles: Record<string, any>;
        keepWidthWithReference: boolean;
        offsetX: any;
        placement: import("./src/popover.props").PopoverPlacement;
        showArrow: boolean;
        visible: boolean;
        zIndex: number;
        class?: string | undefined;
        id?: string | undefined;
        title?: string | undefined;
        host?: any;
        leftBoundary?: any;
        reference?: any;
        rightBoundary?: any;
    }> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, import("vue").PublicProps, {
        fitContent: boolean;
        minWidth: number;
        arrowOffsetX: number;
        customStyles: Record<string, any>;
        keepWidthWithReference: boolean;
        offsetX: any;
        placement: import("./src/popover.props").PopoverPlacement;
        showArrow: boolean;
        visible: boolean;
        zIndex: number;
    }, true, {}, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, {}, any, import("vue").ComponentProvideOptions, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<{
        fitContent: boolean;
        minWidth: number;
        arrowOffsetX: number;
        customStyles: Record<string, any>;
        keepWidthWithReference: boolean;
        offsetX: any;
        placement: import("./src/popover.props").PopoverPlacement;
        showArrow: boolean;
        visible: boolean;
        zIndex: number;
        class?: string | undefined;
        id?: string | undefined;
        title?: string | undefined;
        host?: any;
        leftBoundary?: any;
        reference?: any;
        rightBoundary?: any;
    }> & Readonly<{}>, () => any, {}, {}, {}, {
        fitContent: boolean;
        minWidth: number;
        arrowOffsetX: number;
        customStyles: Record<string, any>;
        keepWidthWithReference: boolean;
        offsetX: any;
        placement: import("./src/popover.props").PopoverPlacement;
        showArrow: boolean;
        visible: boolean;
        zIndex: number;
    }>;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & import("vue").ComponentOptionsBase<Readonly<{
    fitContent: boolean;
    minWidth: number;
    arrowOffsetX: number;
    customStyles: Record<string, any>;
    keepWidthWithReference: boolean;
    offsetX: any;
    placement: import("./src/popover.props").PopoverPlacement;
    showArrow: boolean;
    visible: boolean;
    zIndex: number;
    class?: string | undefined;
    id?: string | undefined;
    title?: string | undefined;
    host?: any;
    leftBoundary?: any;
    reference?: any;
    rightBoundary?: any;
}> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {
    fitContent: boolean;
    minWidth: number;
    arrowOffsetX: number;
    customStyles: Record<string, any>;
    keepWidthWithReference: boolean;
    offsetX: any;
    placement: import("./src/popover.props").PopoverPlacement;
    showArrow: boolean;
    visible: boolean;
    zIndex: number;
}, {}, string, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, import("vue").ComponentProvideOptions> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & Plugin;
export default _default;
