import { ExtractPropTypes } from 'vue';
export type ProgressType = 'line' | 'circle' | 'dashboard';
export type ProgressSize = 'default' | 'small';
export type ProgressStatus = 'default' | 'success' | 'error' | 'active';
export type ProgressStrokeColorType = '';
export type ProgressStrokeLinecapType = 'round' | 'square';
export type GapPosition = 'top' | 'bottom' | 'left' | 'right';
export interface FProgressGradientProgress {
    [percent: string]: string;
}
export declare const progressProps: Record<string, any>;
export type ProgressProps = ExtractPropTypes<typeof progressProps>;
export declare const propsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
