/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ControlType } from './types';
export declare function useUtil(sourceType: 'query-solution' | 'filter-bar'): {
    getQuerySolutionExtendSchemaProerty: (controlType: ControlType, options?: any) => {
        required: boolean;
        multiLineLabel: boolean;
    };
    getFilterBarionExtendSchemaProerty: (controlType: ControlType, options?: any) => {
        required: boolean;
        isExtend: boolean;
    };
    getExtendSchemaProerty: (controlType: ControlType, options?: any) => {
        required: boolean;
        multiLineLabel: boolean;
    } | {
        required: boolean;
        isExtend: boolean;
    };
    getEditorByType: (type: any, options?: any) => {
        required: boolean;
        multiLineLabel: boolean;
    } | {
        required: boolean;
        isExtend: boolean;
    };
    getSolutionField: (schemaField: any) => any;
    getControlTypeListByFieldType: (fieldType: any) => {
        key: any;
        value: any;
    }[];
    formatUsingFieldToField: (usingField: any) => {
        id: any;
        code: any;
        labelCode: any;
        name: any;
        controlType: any;
        $type: any;
        $typeInfo: any;
        editor: any;
    } | null;
};
