import { Ref, SetupContext } from "vue";
import { ResponseLayoutSplitterProps } from "../response-layout-splitter.props";
export declare function useResponseLayoutSplitter(props: ResponseLayoutSplitterProps, context: SetupContext): {
    standardLayouts: string[];
    standardLayoutClass: Ref<any[], any[]>;
    selectedLayout: Ref<string, string>;
    currentLayoutItems: Ref<any, any>;
    isStandardLayout: Ref<boolean, boolean>;
    onSelectColumnLayout: (column: string) => void;
};
