import { ExtractPropTypes } from 'vue';
export type ButtonAlignment = 'right' | 'left' | 'center';
export declare const responseToolbarProps: Record<string, any>;
export type ResponseToolbarProps = ExtractPropTypes<typeof responseToolbarProps>;
export declare const responseToolbarDesignProps: Record<string, any> & {
    componentId: {
        type: StringConstructor;
        default: string;
    };
};
export type ResponseToolbarDesignProps = ExtractPropTypes<typeof responseToolbarDesignProps>;
export declare const propsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
export declare const responseToolbarItemDesignProps: Record<string, any>;
export type ResponseToolbarItemDesignProps = ExtractPropTypes<typeof responseToolbarItemDesignProps>;
export declare const itemPropsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
export declare const eventHandlerResolver: import("../../dynamic-resolver").EventHandlerResolver;
