import { FormNumberOptions } from "./types";
/**
 * 处理年，Y=>y, D=>d
 * @param format
 * @returns
 */
export declare function dateToUpperCase(format: string): string;
/**
* 枚举类型处理
*/
export declare function getFormatEnumValue(value: string | undefined | null, data: Array<any>, delimiter: string, textField: string, valueField: string): string;
export declare function dateformat(value: any, format: string): string;
/**
     * C货币
     * D十进制
     * F浮点数
     * N数字，带千分位
     * P百分比
     */
export declare function getNumberFormat(format: string, options: FormNumberOptions | null | undefined): string;
/**
 *
 * @param value 待格式化的数值
 * @param format 指定的格式化
 * @param options 类型
 * @param thousand 千分位符号
 * @param decimal 小数点处符号
 * @param expression 货币符号及值展现形式
 * @returns
 */
export declare function getFormatNumberValue(value: any, format: string, options: FormNumberOptions | null | undefined, thousand: string, decimal: string, expression: string, decimalFilledSymbol: string): any;
export declare function getFormatCheckBoxValue(value: boolean): "是" | "否";
