import { InputBaseProperty } from "../../../property-panel/src/composition/entity/input-base-property";
export declare class TextareaProperty extends InputBaseProperty {
    constructor(componentId: string, designerHostService: any);
    /**
     * 多行文本应用在卡片
     * @param propertyData
     * @returns
     */
    getEditorProperties(propertyData: any): {
        properties: {
            readonly: {
                description: string;
                title: string;
                editor: {
                    type: string;
                    propertyTypes: any;
                };
            };
            required: {
                description: string;
                title: string;
                type: string;
                editor: {
                    type: string;
                    propertyTypes: any;
                };
            };
            placeholder: {
                description: string;
                title: string;
                type: string;
            };
        };
        setPropertyRelates(changeObject: any, parameters: any): void;
        description: string;
        title: string;
        type: string;
        $converter: string;
    };
    /**
     * 多行文本应用在表格
     * @param propertyData
     * @returns
     */
    getGridFieldEdtiorProperties(propertyData: any): {
        properties: {
            readonly: {
                description: string;
                title: string;
                editor: {
                    type: string;
                    propertyTypes: any;
                };
            };
            required: {
                description: string;
                title: string;
                type: string;
                editor: {
                    type: string;
                    propertyTypes: any;
                };
            };
            placeholder: {
                description: string;
                title: string;
                type: string;
            };
        };
        setPropertyRelates(changeObject: any, parameters: any): void;
        description: string;
        title: string;
        type: string;
        $converter: string;
    };
}
