var Ke = Object.defineProperty;
var Ye = (e, a, t) => a in e ? Ke(e, a, { enumerable: !0, configurable: !0, writable: !0, value: t }) : e[a] = t;
var se = (e, a, t) => Ye(e, typeof a != "symbol" ? a + "" : a, t);
import { defineComponent as ie, ref as P, inject as j, onMounted as ue, createVNode as F, watch as U, reactive as ne, toRaw as Ze, computed as H, onUnmounted as Ie, isVNode as et, Fragment as tt, withDirectives as Me, createTextVNode as oe, resolveDirective as at, vModelCheckbox as nt, provide as ce, mergeProps as it } from "vue";
import ot from "../../designer/button-edit/index.esm.js";
import { useDesignerComponent as lt } from "../designer-canvas/index.esm.js";
import { resolveAppearance as st, createPropsResolver as rt } from "../dynamic-resolver/index.esm.js";
import { InputBaseProperty as ut, ExpressionProperty as De } from "../property-panel/index.esm.js";
import { FieldSelectorRepositoryToken as he } from "../field-selector/index.esm.js";
import { F_MODAL_SERVICE_TOKEN as dt } from "../modal/index.esm.js";
import { FButtonEdit as Be } from "../button-edit/index.esm.js";
import { FLayout as ct, FLayoutPane as Oe } from "../layout/index.esm.js";
import { FDataGrid as be } from "../data-grid/index.esm.js";
import { flatten as ft, isNaN as pt, cloneDeep as Ve, throttle as ht, isEmpty as Ce } from "lodash-es";
import { resolveField as ge, encrypt as gt } from "../common/index.esm.js";
import { F_NOTIFY_SERVICE_TOKEN as ze } from "../notify/index.esm.js";
import { FTreeGrid as we } from "../tree-grid/index.esm.js";
import { FComboList as Ae } from "../combo-list/index.esm.js";
import vt from "../popover/index.esm.js";
function Ne(e) {
  return typeof e == "string" && e.startsWith("{") && e.endsWith("}") ? (e = e.replace(/'/g, '"'), { mappingFields: JSON.parse(e) }) : { mappingFields: e };
}
const mt = /* @__PURE__ */ new Map([
  ["appearance", st],
  ["mappingFields", (e, a, t) => {
    if (a)
      return Ne(a);
    const { mappingFields: n } = t;
    return Ne(n);
  }],
  ["uri", (e, a, t) => {
    var n;
    return a ? { uri: a } : { uri: (n = t == null ? void 0 : t.dataSource) == null ? void 0 : n.uri };
  }],
  ["idField", (e, a, t) => {
    var n;
    return a ? { idField: a } : { idField: (n = t == null ? void 0 : t.dataSource) == null ? void 0 : n.idField };
  }]
]), bt = "https://json-schema.org/draft/2020-12/schema", yt = "https://farris-design.gitee.io/lookup.schema.json", St = "lookup", Ct = "A Farris Input Component", Ft = "object", Tt = {
  id: {
    description: "The unique identifier for a combo list",
    type: "string"
  },
  type: {
    description: "The type string of number combo list component",
    type: "string",
    default: "lookup"
  },
  appearance: {
    description: "",
    type: "object",
    properties: {
      class: {
        type: "string"
      },
      style: {
        type: "string"
      }
    },
    default: {}
  },
  binding: {
    description: "",
    type: "object",
    default: {}
  },
  editable: {
    description: "",
    type: "boolean",
    default: !1
  },
  enableLinkLabel: {
    description: "",
    type: "boolean",
    default: !1
  },
  label: {
    description: "",
    type: "string",
    default: "帮助"
  },
  lableWidth: {
    description: "",
    type: "number"
  },
  placeholder: {
    description: "",
    type: "string",
    default: ""
  },
  readonly: {
    description: "",
    type: "boolean",
    default: !1
  },
  required: {
    description: "",
    type: "boolean",
    default: !1
  },
  tabindex: {
    description: "",
    type: "number",
    default: -1
  },
  textAlign: {
    description: "",
    type: "string",
    enum: [
      "left",
      "middle",
      "right"
    ],
    default: "left"
  },
  visible: {
    description: "",
    type: "boolean",
    default: !0
  },
  textField: {
    description: "帮助显示文本字段",
    type: "string",
    default: ""
  },
  mappingFields: {
    description: "帮助字段映射",
    type: "object",
    default: {}
  },
  uri: {
    type: "string",
    default: ""
  },
  dataSource: {
    type: "object",
    default: null
  },
  displayType: {
    type: "string",
    default: "list"
  },
  "onUpdate:dataMapping": {
    type: "object",
    default: null
  },
  onClear: {
    type: "object",
    default: null
  },
  context: {
    type: "object",
    default: null
  },
  enableToSelect: {
    type: "boolean",
    default: !0
  },
  idValue: {
    type: "string",
    default: ""
  },
  multiSelect: {
    type: "boolean",
    default: !1
  },
  separator: {
    type: "string",
    default: ","
  },
  fitColumns: {
    type: "boolean",
    default: !0
  },
  enableFavorite: {
    type: "boolean",
    default: !1
  },
  enableUserData: {
    type: "boolean",
    default: !1
  },
  showSelections: {
    type: "boolean",
    default: !0
  },
  treeToList: {
    type: "boolean",
    default: !1
  },
  navTreeToList: {
    type: "boolean",
    default: !1
  },
  showNavigation: {
    type: "boolean",
    default: !0
  },
  dictPicking: {
    type: "object",
    default: null
  },
  dictPicked: {
    type: "object",
    default: null
  },
  enableSearchBar: {
    type: "boolean",
    default: !0
  },
  searchAnyField: {
    type: "boolean",
    default: !0
  },
  dialog: {
    type: "object",
    default: null
  },
  idField: {
    type: "string",
    default: "id"
  },
  pagination: {
    type: "object",
    default: null
  },
  allowFreeInput: {
    type: "boolean",
    default: !1
  },
  loadTreeDataType: {
    type: "string",
    default: "all"
  },
  onlySelectLeaf: {
    type: "boolean",
    default: !1
  },
  enableFullTree: {
    type: "boolean",
    default: !0
  },
  beforeLoadData: {
    type: "object",
    default: null
  },
  beforeSelectData: {
    type: "object",
    default: null
  },
  enableCascade: {
    type: "boolean",
    default: !1
  },
  showCascadeControl: {
    type: "boolean",
    default: !1
  },
  cascadeItems: {
    type: "object",
    default: {
      both: !0,
      up: !0,
      down: !0,
      disable: !0
    }
  },
  cascadeStatus: {
    type: "string",
    default: "both"
  },
  expandLevel: {
    type: "number",
    default: 0
  },
  enableClear: {
    type: "boolean",
    default: !0
  },
  enableTitle: {
    type: "boolean",
    default: !1
  }
}, Lt = [
  "type"
], It = [
  "id",
  "appearance",
  "binding",
  "visible"
], wt = {
  dictPicking: "帮助前事件",
  dictPicked: "帮助后事件",
  beforeSelectData: "数据选择确认前事件",
  beforeLoadData: "数据加载前事件",
  clear: "清空事件"
}, kt = {
  $schema: bt,
  $id: yt,
  title: St,
  description: Ct,
  type: Ft,
  properties: Tt,
  required: Lt,
  ignore: It,
  events: wt
};
function Pt(e, a, t) {
  return a;
}
const Re = [
  { value: "both", text: "同步选择" },
  { value: "up", text: "包含上级" },
  { value: "down", text: "包含下级" },
  { value: "disable", text: "仅选择自身" }
], Ue = "";
var ee = /* @__PURE__ */ ((e) => (e.List = "LIST", e.Tree = "TREELIST", e.ListList = "NAVLIST", e.TreeList = "NAVTREELIST", e.ListTree = "NAVLISTTREE", e))(ee || {}), ke = /* @__PURE__ */ ((e) => (e.all = "all", e.async = "async", e))(ke || {});
const fe = "__lookup_active_tab__", Da = "__lookup_user_data_id__";
var Q = /* @__PURE__ */ ((e) => (e.dataList = "datalist", e.favorite = "favorite", e))(Q || {});
const xt = Symbol("f_lookup-http-service_token");
var _e = /* @__PURE__ */ ((e) => (e[e.Equal = 0] = "Equal", e[e.NotEqual = 1] = "NotEqual", e[e.Greater = 2] = "Greater", e[e.GreaterOrEqual = 3] = "GreaterOrEqual", e[e.Less = 4] = "Less", e[e.LessOrEqual = 5] = "LessOrEqual", e[e.Like = 6] = "Like", e[e.LikeStartWith = 7] = "LikeStartWith", e[e.LikeEndWith = 8] = "LikeEndWith", e[e.NotLike = 9] = "NotLike", e[e.NotLikeStartWith = 10] = "NotLikeStartWith", e[e.NotLikeEndWith = 11] = "NotLikeEndWith", e[e.Is = 12] = "Is", e[e.IsNot = 13] = "IsNot", e[e.In = 14] = "In", e[e.NotIn = 15] = "NotIn", e))(_e || {}), Te = /* @__PURE__ */ ((e) => (e[e.Empty = 0] = "Empty", e[e.And = 1] = "And", e[e.Or = 2] = "Or", e))(Te || {}), Et = /* @__PURE__ */ ((e) => (e[e.Value = 0] = "Value", e[e.Expression = 1] = "Expression", e.FrontExpress = "frontExpress", e))(Et || {});
const Dt = {
  showCloseButton: !0,
  showMaxButton: !0,
  draggable: !0,
  resizeable: !0,
  enableEsc: !0,
  rememberSize: !0
};
function Ot() {
  function e(a, t) {
    const n = {};
    return n.dictPicking = (o) => t.call("dictPicking", [o, a]), n.beforeLoadData = (o) => t.call("beforeLoadData", [o, a]), n.beforeSelectData = (o) => t.call("beforeSelectData", [o, a]), n.dictPicked = (o) => t.call("dictPicked", [o, a]), n;
  }
  return {
    resolve: e
  };
}
const ye = {
  id: { type: String, require: !0 },
  uri: { type: String, default: "" },
  readonly: { type: Boolean, default: !1 },
  disabled: { type: Boolean, default: !1 },
  editable: { type: Boolean, default: !1 },
  enableFavorite: { type: Boolean, default: !1 },
  mappingFields: { type: Object, default: null },
  fitColumns: { type: Boolean, default: !0 },
  columns: { type: Array, default: [] },
  idField: { type: String, default: "id" },
  textField: { type: String, defalut: "name" },
  data: { type: Array, default: [] },
  displayType: { type: String, default: ee.List },
  dialog: {
    type: Object,
    default: {
      title: ""
    }
  },
  multiSelect: { type: Boolean, default: !1 },
  showSelections: { type: Boolean, default: !0 },
  separator: { type: String, default: "," },
  pagination: { type: Object, default: {
    enable: !1,
    showLimits: !0,
    sizeLimits: [10, 20, 30, 50, 100],
    size: 20,
    index: 1,
    total: 0,
    mode: "server",
    showGoto: !1
  } },
  enableClear: { type: Boolean, default: !0 },
  inputType: { type: String, default: "text" },
  idValue: { type: String, default: "" },
  dictPicking: { type: Function, default: null },
  dictPicked: { type: Function, default: null },
  beforeSelectData: { type: Function, default: null },
  beforeLoadData: { type: Function, default: null },
  enableSearchBar: { type: Boolean, default: !0 },
  searchFields: { type: Array, default: [] },
  searchAnyField: { type: Boolean, default: !0 },
  navigation: { type: Object, default: null },
  textChangeType: { type: String, default: "any" },
  showNavigation: { type: Boolean, default: !0 },
  showIncludeChildNodes: { type: Boolean, default: !0 },
  includeChildNodesValue: { type: Boolean, default: !0 },
  enableMultiFieldSearch: { type: Boolean, default: !1 },
  treeToList: { type: Boolean, default: !1 },
  navTreeToList: { type: Boolean, default: !1 },
  loadTreeDataType: { type: String, default: ke.all },
  enableToSelect: { type: Boolean, default: !0 },
  customData: { type: Object, default: null },
  modelValue: { type: String, default: "" },
  enableUserData: { type: Boolean, default: !1 },
  userDataKey: { type: String, default: "" },
  onReady: { type: Function, default: null },
  context: { type: Object, default: {} },
  placeholder: { type: String, default: "" },
  loader: { type: Function, default: null },
  allowFreeInput: { type: Boolean, default: !1 },
  onlySelectLeaf: { type: Boolean, default: !1 },
  enableFullTree: { type: Boolean, default: !0 },
  enableCascade: { type: Boolean, default: !1 },
  showCascadeControl: { type: Boolean, default: !1 },
  cascadeItems: { type: Object, default: {
    both: !0,
    up: !0,
    down: !0,
    disable: !0
  } },
  cascadeStatus: { type: String, default: "both" },
  /** 0: 不展开； -1: 全部展开；>0: 展开到指定级数 */
  expandLevel: { type: Number, default: 0 },
  enableTitle: { type: Boolean, default: !1 }
}, $e = rt(ye, kt, mt, Pt), Nt = Ot();
function ve(e) {
  let a = [10, 20, 30, 50, 100];
  return e && (typeof e == "string" && (a = e.replaceAll("[", "").replaceAll("]", "").replaceAll(" ", "").split(",")), Array.isArray(e) && (a = e)), a.map((t) => ({ value: parseInt(t, 10) })).sort((t, n) => t.value - n.value);
}
const J = {
  convertFrom: (e, a) => a === "multiSelect" || a === "enableTitle" ? !!e.editor[a] : a === "separator" ? e.editor[a] || "," : a === "onlySelectLeaf" ? e.editor[a] == null ? !1 : e.editor[a] : a === "loadTreeDataType" ? e.editor[a] || "all" : e.editor[a],
  convertTo: (e, a, t) => {
    e.editor[a] = t;
  }
};
function Mt(e) {
  let a = "form_group_" + Date.now();
  return e && (a = e.replaceAll("-", "_").replaceAll(".", "_")), "lookup." + a;
}
function Bt(e, a) {
  const { enablePager: t, pageSize: n, pageList: o } = a;
  e.pagination = e.pagination || {}, Object.assign(e.pagination, {
    enable: t,
    sizeLimits: ve(o).map((s) => s.value),
    size: n,
    showLimits: !0,
    showGoto: !1,
    mode: "server"
  });
}
const Vt = {
  convertFrom: (e, a) => {
    var t;
    return (t = e.editor[a]) == null ? void 0 : t.displayName;
  },
  convertTo: (e, a, t) => {
    if (t && t.length > 0) {
      const n = t[0], { name: o, id: s, metadataContent: i, code: d } = n;
      e.editor.dataSource || (e.editor.dataSource = {}), e.editor.dataSource.displayName = `${o}(${d})`, e.editor.helpId = s;
      const { displayType: l, idField: m, textField: v } = i;
      e.editor.displayType = l, e.editor.dataSource.idField = m, e.editor.textField = v, e.editor.dataSource.type = "ViewObject";
      const { pageInfo: g, treeInfo: x } = i.dataSource;
      if (Bt(e.editor, g), x) {
        const { onlySelectLeaf: T, loadDataType: r } = x;
        e.editor.loadTreeDataType = r || "all", e.editor.onlySelectLeaf = T ?? !1;
      }
      e.editor.dataSource.uri || (e.editor.dataSource.uri = Mt(e.id));
    }
  }
}, zt = {
  convertFrom: (e, a) => {
    var t;
    return (t = e.editor.dataSource) == null ? void 0 : t.idField;
  },
  convertTo: (e, a, t) => {
    if (t && t.length > 0) {
      const n = t[0];
      e.editor.dataSource.idField = n == null ? void 0 : n.bindingPath;
    }
  }
}, At = {
  convertFrom: (e, a) => {
    var t;
    return (t = e.editor) == null ? void 0 : t.textField;
  },
  convertTo: (e, a, t) => {
    if (t && t.length > 0) {
      const n = t[0];
      e.editor.textField = n == null ? void 0 : n.bindingPath;
    }
  }
}, Rt = {
  convertFrom: (e, a) => e.editor.displayType ? e.editor.displayType.toUpperCase() : "LIST",
  convertTo: (e, a, t) => {
    e.editor.displayType = t;
  }
}, ae = {
  convertFrom: (e, a) => {
    var o;
    const t = e.editor.dialog || {};
    if (a === "title")
      return t[a] || Ue;
    if (a === "width")
      return (o = e.editor.displayType) != null && o.toUpperCase().startsWith("NAV") ? t[a] || 960 : t[a] || 590;
    if (a === "height")
      return t[a] || 620;
    if (a === "navigatorWidth")
      return t[a] || 320;
    if (a === "draggable")
      return !0;
    if (["showMaxButton", "showCloseButton", "resizeable", "enableEsc", "rememberSize"].includes(a))
      return t[a] == null ? !0 : t[a];
  },
  convertTo: (e, a, t) => {
    e.editor.dialog = e.editor.dialog || {}, e.editor.dialog[a] = t;
  }
}, Fe = {
  convertFrom: (e, a) => {
    const t = e.editor.pagination || {};
    if (a === "enable" || a === "showLimits")
      return t[a] == null ? !1 : t[a];
    if (a === "sizeLimits") {
      const n = t[a];
      return ve(n);
    }
    if (a === "size")
      return t[a] || 20;
  },
  convertTo: (e, a, t) => {
    var n, o;
    if (e.editor.pagination = e.editor.pagination || {}, a === "sizeLimits") {
      const s = t.map((d) => d.value);
      e.editor.pagination[a] = s;
      const i = ((o = (n = e.editor) == null ? void 0 : n.pagination) == null ? void 0 : o.size) ?? 20;
      s.includes(i) || (e.editor.pagination.size = s[0]);
      return;
    }
    e.editor.pagination[a] = t;
  }
}, Ut = [
  {
    label: "clear",
    name: "清空事件"
  },
  {
    label: "dictPicking",
    name: "帮助前事件"
  },
  {
    label: "beforeLoadData",
    name: "数据加载前事件"
  },
  {
    label: "beforeSelectData",
    name: "选择数据确认前事件"
  },
  {
    label: "dictPicked",
    name: "帮助后事件"
  }
], _t = Symbol("schema_repository_token");
class $t extends ut {
  constructor() {
    super(...arguments);
    se(this, "comboListEditor", {
      type: "combo-list",
      enableClear: !1,
      editable: !1
    });
    se(this, "numberEditor", {
      type: "number-spinner",
      useThousands: !1
    });
    se(this, "readonlyEditor", { ...this.comboListEditor, editable: !0 });
    se(this, "visibleEditor", { ...this.comboListEditor, editable: !1 });
    se(this, "requiredEditor", { ...this.comboListEditor, editable: !1 });
    se(this, "freeInputEditor", { ...this.comboListEditor, editable: !1 });
  }
  getExpressionConfig(t, n) {
    const o = ["validate"];
    return t.type === "form-group" && o.push("dataPicking"), new De(this.formSchemaUtils).getExpressionConfig(t, "Field", o);
  }
  getPropertyConfig(t, n) {
    this.readonlyEditor = this.getPropertyEditorParams(t, [], "readonly"), this.visibleEditor = this.getPropertyEditorParams(t, [], "visible"), this.requiredEditor = this.getPropertyEditorParams(t, ["Const", "Variable", "StateMachine", "Expression"], "required"), this.freeInputEditor = this.getPropertyEditorParams(t, ["Const", "Variable"], "allowFreeInput");
    const o = this.getBasicProperties(t, n), s = this.getBehaviorConfig(t), i = this.getAppearanceProperties(t, n), d = this.getLookupConfig(t), l = this.getEventPropConfig(t), m = this.getDialogPropertyConfig(t), v = this.getPageConfig(t.editor), g = this.getTreePropConfig(t.editor), x = this.getExpressionConfig(t, "Field"), T = {
      basic: o,
      appearance: i,
      behavior: s,
      lookup: d,
      treeConfig: g,
      dialog: m,
      pager: v,
      expressons: x
    };
    return t.type === "form-group" && (T.eventsEditor = l), {
      type: "object",
      categories: T
    };
  }
  getGridFieldEdtiorPropConfig(t) {
    return this.getPropertyConfig(t, null).categories;
  }
  flattenTreeNodes(t) {
    return t.reduce((n, o) => {
      var s;
      return n.push(o), (s = o.children) != null && s.length && n.push(...this.flattenTreeNodes(o.children)), n;
    }, []);
  }
  isSimpleStringField() {
    var d;
    const t = ((d = this.designViewModelField) == null ? void 0 : d.path) || "";
    if (!t || !t.includes("."))
      return !0;
    const n = t.split("."), o = this.designViewModelUtils.getAllFields2TreeByVMId(this.viewModelId);
    if (!(o != null && o.length))
      return !1;
    const s = o.find((l) => l.data.code === n[0]);
    if (!s)
      return !1;
    const i = [s, ...this.flattenTreeNodes(s.children)];
    return !n.reduce(
      (l, m, v) => [...l, v ? `${l[v - 1]}.${m}` : m],
      []
    ).some(
      (l) => {
        var m, v, g;
        return ((g = (v = (m = i.find((x) => x.data.path === l)) == null ? void 0 : m.data) == null ? void 0 : v.type) == null ? void 0 : g.$type) === "EntityType";
      }
    );
  }
  getBehaviorConfig(t) {
    return {
      description: "Basic Infomation",
      title: "行为",
      properties: {
        visible: {
          description: "运行时组件是否可见",
          title: "是否可见",
          type: "boolean",
          editor: this.visibleEditor
        }
      },
      setPropertyRelates: (n, o) => {
        this.afterMutilEditorChanged(o, n);
      }
    };
  }
  // 绑定字段更新后，处理lookup 的相关属性
  changeBindingField(t, n) {
    super.changeBindingField(t, n), t.editor.multiSelect = !1;
  }
  getDisplayType(t) {
    return t.displayType ? t.displayType.toUpperCase() : "";
  }
  getLookupConfig(t) {
    const n = t.editor, o = () => {
      const s = this.formSchemaUtils.getFormSchema().module.entity[0].id, i = this.formSchemaUtils.getFormMetadataBasicInfo();
      return { propertyData: n, formBasicInfo: i, viewModelId: s, dataSourceId: n.helpId };
    };
    return {
      description: "Basic Infomation",
      title: "编辑器",
      setPropertyRelates: (s, i) => {
        if (s)
          switch (s.propertyID) {
            case "readonly":
            case "required":
              this.afterMutilEditorChanged(i, s);
              break;
          }
      },
      properties: {
        readonly: {
          description: "",
          title: "只读",
          type: "boolean",
          $converter: "/converter/property-editor.converter",
          editor: this.readonlyEditor
        },
        required: {
          description: "",
          title: "必填",
          type: "boolean",
          $converter: "/converter/property-editor.converter",
          editor: this.requiredEditor
        },
        placeholder: {
          description: "当控件没有值时在输入框中显示的文本",
          title: "提示文本",
          type: "string",
          $converter: J
        },
        enableTitle: {
          description: "鼠标悬停显示文本内容",
          title: "悬停提示",
          type: "boolean",
          $converter: J,
          editor: this.comboListEditor
        },
        editable: {
          description: "",
          title: "允许编辑",
          type: "boolean",
          $converter: J,
          refreshPanelAfterChanged: !0,
          editor: this.comboListEditor
        },
        allowFreeInput: {
          description: "",
          title: "任意输入",
          type: "boolean",
          $converter: J,
          editor: this.freeInputEditor,
          visible: !1
          // !!editorOptions.editable
        },
        enableClear: {
          title: "启用清除按钮",
          type: "boolean",
          $converter: J
        },
        dataSource: {
          description: "数据源",
          title: "数据源",
          type: "string",
          refreshPanelAfterChanged: !0,
          editor: {
            type: "schema-selector",
            title: "选择数据源",
            editorParams: {
              propertyData: n,
              formBasicInfo: this.formSchemaUtils.getFormMetadataBasicInfo()
            },
            displayFormatter: (s) => s && s.length ? s.map((i) => `${i.name}(${i.code})`).join(",") : "",
            viewOptions: [
              {
                id: "recommend",
                title: "推荐",
                type: "List",
                dataSource: "Recommand",
                enableGroup: !0,
                groupField: "category",
                groupFormatter: (s, i) => `${s === "local" ? "本地元数据" : "最近使用"}`
              },
              { id: "total", title: "全部", type: "List", dataSource: "Total" }
            ],
            repositoryToken: _t,
            onSubmitModal: (s) => {
              if (s) {
                delete n.mappingFields;
                const i = this.formSchemaUtils.getFormMetadataBasicInfo();
                return this.metadataService.getPickMetadata(i.relativePath, s[0].data).then((d) => JSON.parse(d == null ? void 0 : d.metadata.content));
              }
            }
          },
          $converter: Vt
        },
        filterConditions: {
          descriptions: "帮助过滤条件",
          title: "过滤条件",
          type: "string",
          $converter: J,
          editor: {
            type: "filter-condition-editor",
            editable: !1,
            displayText: "点击配置",
            enableClear: !1,
            enableExpression: !0,
            editorParams: {
              propertyData: n,
              formBasicInfo: this.formSchemaUtils.getFormMetadataBasicInfo(),
              viewModelId: this.formSchemaUtils.getFormSchema().module.entity[0].id
            },
            idField: "path",
            repositoryToken: he,
            beforeOpen: async ({ repository: s, notifyService: i }) => {
              var x;
              if (!(n == null ? void 0 : n.helpId))
                return i == null || i.warning({ message: "请先配置数据源！" }), !1;
              const l = o(), v = new De(this.formSchemaUtils).getEntitiesAndVariables();
              let g = {};
              if (s) {
                const T = await s.getData(l), r = await s.getLookupConditions(l);
                g = { fieldList: T, conditionList: r };
              }
              return (x = v.variables) != null && x.forms && (v.variables.forms.items = v.variables.forms.items.filter((T) => T.category === "remote")), { ...g, ...v };
            },
            onSubmitModal: async ({ loadingService: s, repository: i, conditions: d, originalConditions: l, FMessageBoxService: m }) => {
              if (i)
                try {
                  const v = o(), g = await i.getLookupConditions(v) || [];
                  return JSON.stringify(g) !== JSON.stringify(l.value) ? (s == null || s.clearAll(), m.question("视图对象中的帮助过滤条件已更改，请点击确定同步过滤数据", "", () => {
                    d.value = g, l.value = JSON.parse(JSON.stringify(d.value));
                  }, () => {
                  }), !1) : (JSON.stringify(d.value) === JSON.stringify(l.value) || await i.saveFilterCondition(d.value, v), !0);
                } catch {
                  return m == null || m.error("保存失败", ""), !1;
                } finally {
                  s == null || s.clearAll();
                }
            }
          },
          visible: !!n.helpId
        },
        displayType: {
          description: "类型： 树列表、列表、双列表、左树右列表",
          title: "展示类型",
          type: "string",
          $converter: Rt,
          editor: {
            type: "combo-list",
            editable: !1,
            disabled: !0,
            data: [
              { text: "列表", value: "LIST" },
              { text: "树列表", value: "TREELIST" },
              { text: "双列表", value: "NAVLIST" },
              { text: "左树右列表", value: "NAVTREELIST" }
            ],
            textField: "text",
            idField: "value",
            valueField: "value"
          }
        },
        idField: {
          description: "数据源标识字段",
          title: "标识字段",
          type: "string",
          editor: {
            type: "field-selector",
            textField: "bindingPath",
            idField: "bindingPath",
            editorParams: {
              propertyData: n,
              formBasicInfo: this.formSchemaUtils.getFormMetadataBasicInfo()
            },
            columns: [
              { field: "name", title: "名称" },
              { field: "code", title: "编号" },
              { field: "bindingPath", title: "绑定字段" }
            ],
            repositoryToken: he
          },
          $converter: zt,
          visible: !1
        },
        textField: {
          description: "显示文本字段",
          title: "文本字段",
          type: "string",
          $converter: At,
          editor: {
            type: "field-selector",
            textField: "bindingPath",
            idField: "bindingPath",
            editorParams: {
              propertyData: n,
              formBasicInfo: this.formSchemaUtils.getFormMetadataBasicInfo()
            },
            columns: [
              { field: "name", title: "名称" },
              { field: "code", title: "编号" },
              { field: "bindingPath", title: "绑定字段" }
            ],
            repositoryToken: he
          }
        },
        mappingFields: {
          description: "字段映射",
          title: "字段映射",
          type: "string",
          $converter: J,
          editor: {
            type: "mapping-editor",
            modalWidth: 800,
            modalHeight: 600,
            editable: !1,
            editorParams: {
              propertyData: n,
              formBasicInfo: this.formSchemaUtils.getFormMetadataBasicInfo()
            },
            fromData: {
              editable: !1,
              formatter: (s, i) => `${i.raw.name} [${i.raw.bindingPath}]`,
              idField: "bindingPath",
              textField: "bindingPath",
              valueField: "bindingPath",
              repositoryToken: he
            },
            toData: {
              idField: "bindingPath",
              textField: "bindingPath",
              valueField: "bindingPath",
              dataSource: () => this.designViewModelUtils.getAllFields2TreeByVMId(this.viewModelId),
              formatter: (s, i) => `${i.raw.name} [${i.raw.bindingPath}]`
            }
          }
        },
        enableToSelect: {
          description: "数据加载后是否选中现有值",
          $converter: J,
          title: "选中已选值",
          type: "boolean",
          editor: this.comboListEditor
        },
        multiSelect: {
          description: "启用多选",
          $converter: J,
          title: "启用多选",
          type: "boolean",
          editor: this.comboListEditor,
          refreshPanelAfterChanged: !0,
          visible: this.isSimpleStringField()
        },
        showSelections: {
          description: "显示已选记录",
          $converter: J,
          title: "显示已选记录",
          type: "boolean",
          visible: !!n.multiSelect
        },
        separator: {
          description: "多选分隔符",
          $converter: J,
          title: "多选分隔符",
          type: "string",
          editor: {
            type: "combo-list",
            editable: !1,
            disabled: !1,
            data: [
              { text: ",", value: "," },
              { text: "|", value: "|" },
              { text: "#", value: "#" }
            ],
            textField: "text",
            idField: "value",
            valueField: "value",
            separator: "@"
          },
          visible: !!n.multiSelect
        },
        enableSearchBar: {
          description: "显示搜索工具条",
          $converter: J,
          refreshPanelAfterChanged: !0,
          title: "启用搜索框",
          type: "boolean",
          visible: !1
        },
        searchAnyField: {
          description: "显示所有列",
          $converter: J,
          title: "允许查询所有列",
          type: "boolean",
          visible: n.enableSearchBar == null ? !0 : !!n.enableSearchBar
        },
        enableFavorite: {
          description: "启用收藏夹",
          $converter: J,
          title: "启用收藏夹",
          type: "boolean"
        },
        enableUserData: {
          description: "保存界面状态",
          $converter: J,
          refreshPanelAfterChanged: !0,
          title: "保存界面状态",
          type: "boolean",
          visible: !0
        }
      }
    };
  }
  showNavigatiorWidth(t) {
    return this.getDisplayType(t).startsWith("NAV") ? t.showNavigation === void 0 ? !0 : !!t.showNavigation : !1;
  }
  getDialogPropertyConfig(t) {
    var n, o, s, i;
    return {
      description: "帮助窗口尺寸配置",
      title: "帮助窗口",
      properties: {
        title: {
          description: "帮助标题",
          title: "帮助标题",
          type: "string",
          $converter: ae
        },
        width: {
          description: "窗口宽度，最小值：300px",
          title: "宽度",
          type: "number",
          refreshPanelAfterChanged: !0,
          $converter: ae,
          editor: {
            ...this.numberEditor,
            min: this.showNavigatiorWidth(t.editor) ? 520 : 300
          }
        },
        height: {
          description: "窗口高度，最小值：200px",
          title: "高度",
          type: "number",
          $converter: ae,
          editor: {
            ...this.numberEditor,
            min: 200
          }
        },
        showNavigation: {
          description: "显示导航栏",
          $converter: J,
          refreshPanelAfterChanged: !0,
          title: "显示导航栏",
          type: "boolean",
          visible: this.getDisplayType(t.editor).includes("NAV")
        },
        navigatorWidth: {
          description: "导航栏宽度，最小200px, 最大为窗口宽度减去200px",
          title: "导航栏宽度",
          type: "number",
          $converter: ae,
          visible: this.showNavigatiorWidth(t.editor),
          editor: {
            ...this.numberEditor,
            min: 200,
            max: (((o = (n = t.editor) == null ? void 0 : n.dialog) == null ? void 0 : o.width) ?? 960) - 200
          }
        },
        resizeable: {
          description: "允许鼠标拖拽窗口边缘调整尺寸",
          title: "允许调整窗口尺寸",
          type: "boolean",
          $converter: ae,
          refreshPanelAfterChanged: !0
        },
        rememberSize: {
          description: "记录窗口尺寸",
          title: "记录窗口尺寸",
          type: "boolean",
          $converter: ae,
          visible: !!t.editor.enableUserData && (((i = (s = t.editor) == null ? void 0 : s.dialog) == null ? void 0 : i.resizeable) ?? !0)
        },
        enableEsc: {
          description: "允许ESC关闭",
          title: "允许ESC关闭",
          type: "boolean",
          $converter: ae
        },
        showMaxButton: {
          description: "显示最大化按钮",
          title: "显示最大化按钮",
          type: "boolean",
          $converter: ae
        },
        showCloseButton: {
          description: "显示关闭按钮",
          title: "显示关闭按钮",
          type: "boolean",
          $converter: ae
        }
      }
    };
  }
  showPagerProperty(t, n) {
    const o = this.getDisplayType(t) !== "TREELIST" || t.treeToList;
    return n && o ? t.pagination && t.pagination[n] : o;
  }
  getPageConfig(t) {
    var o, s, i, d;
    const n = !((o = t.pagination) != null && o.enable);
    return {
      hide: this.getDisplayType(t) === "TREELIST" || !t.helpId || n,
      description: "分页配置",
      title: "分页",
      properties: {
        // enable: {
        //     description: "启用分页",
        //     title: "启用分页",
        //     type: "boolean",
        //     refreshPanelAfterChanged: true,
        //     $converter: lookupPaginationConverter
        // },
        showLimits: {
          description: "显示每页条数选择器",
          title: "显示条数选择器",
          type: "boolean",
          refreshPanelAfterChanged: !0,
          $converter: Fe,
          visible: this.showPagerProperty(t)
        },
        sizeLimits: {
          description: "每页可显示条数",
          title: "每页显示条数",
          type: "array",
          $converter: Fe,
          refreshPanelAfterChanged: !0,
          visible: this.showPagerProperty(t, "showLimits"),
          editor: {
            columns: [
              {
                field: "value",
                title: "显示条数",
                dataType: "number",
                editor: {
                  ...this.numberEditor,
                  min: 10,
                  max: 1e4
                }
              }
            ],
            title: "每页显示条数编辑器",
            modalWidth: 400,
            modalHeight: 500,
            type: "item-collection-editor",
            valueField: "value",
            nameField: "value",
            requiredFields: ["value"],
            uniqueFields: ["value"],
            modelValue: ve((s = t.pagination) == null ? void 0 : s.sizeLimits),
            beforeSubmit: ({ notifyService: l, data: m }) => !m || !m.length ? (l == null || l.warning({ message: "每页显示条数不能为空！" }), !1) : new Set(m.map((g) => parseInt(g.value, 10))).size === m.length ? !0 : (l == null || l.warning({ message: "每页显示条数不能重复！" }), !1)
          }
        },
        size: {
          description: "默认显示条数",
          title: "默认显示条数",
          type: "number",
          visible: this.showPagerProperty(t),
          $converter: Fe,
          editor: {
            ...this.comboListEditor,
            data: ve((i = t.pagination) == null ? void 0 : i.sizeLimits),
            textField: "value",
            idField: "value",
            valueField: "value",
            modelValue: (d = t.pagination) == null ? void 0 : d.size
          }
        }
      }
    };
  }
  showLoadType(t) {
    const n = this.getDisplayType(t);
    return (n === "TREELIST" || n === "NAVTREELIST") && !t.treeToList && !t.navTreeToList;
  }
  showOnlySelectLeaf(t) {
    return this.getDisplayType(t) === "TREELIST" && !t.treeToList;
  }
  getTreePropConfig(t) {
    return {
      hide: this.getDisplayType(t) !== "TREELIST" && this.getDisplayType(t) !== "NAVTREELIST",
      description: "树形数据配置",
      title: "树形数据配置",
      properties: {
        treeToList: {
          description: "以列表的形式展示树结构数据",
          $converter: J,
          refreshPanelAfterChanged: !0,
          title: "以列表形式展示",
          type: "boolean",
          visible: this.getDisplayType(t) === "TREELIST"
        },
        navTreeToList: {
          description: "以列表的形式展示树结构数据",
          $converter: J,
          refreshPanelAfterChanged: !0,
          title: "以列表形式展示",
          type: "boolean",
          visible: this.getDisplayType(t) === "NAVTREELIST"
        },
        loadTreeDataType: {
          description: "树形数据加载方式",
          $converter: J,
          title: "数据加载方式",
          type: "string",
          editor: {
            ...this.comboListEditor,
            data: [
              { value: "all", text: "全部加载" },
              { value: "async", text: "分层加载" }
            ],
            textField: "text",
            valueField: "value"
          },
          visible: !1
          // this.showLoadType(editorOptions)
        },
        enableFullTree: {
          description: "启用构造完整树",
          $converter: J,
          title: "构造完整树",
          type: "boolean",
          visible: this.showLoadType(t)
        },
        onlySelectLeaf: {
          description: "仅选择叶子节点",
          $converter: J,
          title: "仅选择叶子节点",
          type: "boolean",
          visible: this.showOnlySelectLeaf(t)
        },
        enableCascade: {
          description: "启用级联选择",
          $converter: J,
          refreshPanelAfterChanged: !0,
          title: "启用级联选择",
          type: "boolean",
          visible: !1
          // this.showOnlySelectLeaf(editorOptions) && !!editorOptions.multiSelect
        },
        showCascadeControl: {
          description: "显示级联选择控件",
          $converter: J,
          title: "显示级联选择控件",
          type: "boolean",
          visible: !1
          // !!editorOptions.enableCascade && this.showOnlySelectLeaf(editorOptions) 
        },
        cascadeStatus: {
          description: "级联选择默认状态",
          $converter: J,
          title: "级联状态",
          type: "string",
          visible: !1,
          // !!editorOptions.enableCascade && this.showOnlySelectLeaf(editorOptions),
          editor: {
            ...this.comboListEditor,
            data: Re,
            textField: "text",
            valueField: "value"
          }
        },
        expandLevel: {
          description: "默认展开层级:  0: 不展开； -1: 全部展开；>0: 展开到指定级数 ",
          $converter: J,
          title: "默认展开层级",
          type: "number",
          visible: this.showLoadType(t),
          editor: {
            ...this.numberEditor,
            min: -1,
            max: 99
          }
        }
      }
    };
  }
  getEventPropConfig(t) {
    const n = this, o = Ut, s = n.eventsEditorUtils.formProperties(t, n.viewModelId, o), i = {};
    return i[n.viewModelId] = {
      type: "events-editor",
      editor: {
        initialData: s
      }
    }, {
      title: "事件",
      hideTitle: !0,
      properties: i,
      // 这个属性，标记当属性变更得时候触发重新更新属性
      refreshPanelAfterChanged: !0,
      tabId: "commands",
      tabName: "交互",
      setPropertyRelates(d, l) {
        const m = d.propertyValue;
        delete l[n.viewModelId], m && n.eventsEditorUtils.saveRelatedParameters(l, n.viewModelId, m.events, m);
        const v = n.designViewModelUtils.getDgViewModel(n.viewModelId);
        v && n.designViewModelField && v.changeField(n.designViewModelField.id, { valueChanging: l.fieldValueChanging, valueChanged: l.fieldValueChanged });
      }
    };
  }
}
function jt(e, a) {
  function t(n, o) {
    const s = e.schema;
    return new $t(n, a).getPropertyConfig(s, o);
  }
  return { getPropsConfig: t };
}
const qt = /* @__PURE__ */ ie({
  name: "FLookupDesign",
  props: ye,
  emits: [],
  setup(e, a) {
    const t = P(), n = j("design-item-context"), o = j("designer-host-service"), s = jt(n, o), i = lt(t, n, s);
    return ue(() => {
      t.value.componentInstance = i;
    }), a.expose(i.value), () => F("div", {
      class: "f-lookup-design",
      ref: t
    }, [F(ot, {
      ref: t,
      readonly: !0,
      editable: !1,
      placeholder: e.placeholder
    }, null)]);
  }
});
function de(e, a) {
  const { lookupOptions: t } = a, n = {
    enable: !0,
    sizeLimits: [10, 20, 30, 50, 100],
    size: 20,
    index: 1,
    total: 0,
    mode: "server"
  };
  function o(r) {
    return { ...n, ...r };
  }
  function s() {
    return {
      enableSelectRow: !0,
      multiSelect: t.multiSelect,
      showCheckbox: t.multiSelect,
      multiSelectMode: "OnCheckAndClick"
    };
  }
  function i() {
    return {
      fitColumns: e.fitColumns,
      fitMode: "percentage",
      resizeColumn: !0
    };
  }
  function d() {
    const { displayType: r } = a.lookupOptions;
    return typeof r == "string" && r in ee ? !1 : r.toLowerCase().startsWith("nav");
  }
  function l() {
    const { displayType: r, treeToList: h } = a.lookupOptions;
    return (r.toLowerCase() === ee.Tree.toLowerCase() || r.toLowerCase() === ee.ListTree.toLowerCase()) && !h;
  }
  function m() {
    const { displayType: r, navTreeToList: h } = a.lookupOptions;
    return r.toLowerCase() === ee.TreeList.toLowerCase() && !h;
  }
  function v() {
    const { displayType: r, navTreeToList: h } = a.lookupOptions, y = r.toLowerCase();
    return y === ee.ListList.toLowerCase() || y === ee.ListTree.toLowerCase() || h;
  }
  function g() {
    var y;
    return t.dialog ? {
      width: ((y = t.dialog) == null ? void 0 : y.navigatorWidth) || 320,
      minWidth: 200
    } : {
      width: 320,
      minWidth: 200
    };
  }
  function x(r) {
    const { loadTreeDataType: h } = t;
    return h === ke.all || h === "default" && (r == null ? void 0 : r.loadDataType) === "all";
  }
  function T(r) {
    return (r == null ? void 0 : r.layerType) === "pathcode";
  }
  return {
    checkPaination: o,
    checkMultiSelect: s,
    checkColumnOptions: i,
    isDoubleList: d,
    getNavigationSize: g,
    isTreeList: l,
    navIsTreeList: m,
    navIsList: v,
    isLoadAll: x,
    isPathCodeTree: T
  };
}
function je(e, a, t) {
  var s;
  const n = P(e.searchFields || []), o = P(((s = e.navigation) == null ? void 0 : s.searchFields) || []);
  return U(() => a == null ? void 0 : a.searchFields, (i) => {
    n.value = i;
  }), U(() => t == null ? void 0 : t.searchFields, (i) => {
    o.value = i;
  }), {
    searchFieldItems: n,
    navSearchFieldItems: o
  };
}
function Wt(e) {
  const a = ne({}), t = ne({}), n = ne({}), o = ne({}), s = ne({}), i = P([]), d = P(), l = ne({}), m = [
    "displayType",
    "treeToList",
    "navTreeToList",
    "showSelections",
    "showNavigation",
    "multiSelect",
    "mappingFields",
    "loader",
    "idField",
    "textField",
    "userDataKey",
    "dialog",
    "expandLevel",
    "treeInfo",
    "navTreeInfo",
    "onlySelectLeaf",
    "loadTreeDataType"
  ];
  function v() {
    m.forEach((g) => {
      l[g] = e[g];
    });
  }
  return v(), {
    pageInfoState: a,
    lookupState: t,
    navigationState: n,
    queryState: o,
    searchState: s,
    selectionState: i,
    unSelectDataId: d,
    lookupOptions: l
  };
}
const Le = P(), le = "F_LOOKUP_HTTP_COMPOSITION_TOKEN";
function Gt(e, a) {
  const t = j("FLoadingService"), n = j(xt), o = Wt(e), { pageInfoState: s, lookupState: i, navigationState: d, lookupOptions: l } = o, { searchFieldItems: m, navSearchFieldItems: v } = je(e, i, d), g = P(e.uri), x = P(e.idValue), T = P(!1), r = () => {
    var C;
    const u = (C = l.displayType) == null ? void 0 : C.toUpperCase();
    return u === ee.Tree || u === ee.TreeList;
  }, h = (u, C = !1) => {
    if (u) {
      const {
        layerType: f,
        dataField: k,
        parentField: N,
        pathField: p,
        layerField: b,
        isDetailField: D,
        loadDataType: S
      } = u, B = {
        layerType: f,
        dataField: k,
        parentField: N,
        pathField: p,
        layerField: b,
        isDetailField: D,
        loadDataType: S
      }, { onlySelectLeaf: _, loadTreeDataType: Y } = l;
      B.onlySelectLeaf = _, B.loadDataType = Y, C ? l.navTreeInfo = Object.assign(l.navTreeInfo || {}, B) : l.treeInfo = Object.assign(l.treeInfo || {}, B);
    }
  };
  function y(u, C) {
    if (C == null || !C.trim())
      return [];
    const f = Array.from(new Set(C.trim().split(" ").filter((p) => p.trim())));
    if (!u || !f.length)
      return [];
    const k = (u || []).map((p, b) => {
      const D = f.map((S, B) => ({
        filterField: p.value,
        value: S,
        lbracket: "",
        rbracket: "",
        relation: Te.And,
        compare: _e.Like
      }));
      return D.length && (D.length > 1 && (D[0].lbracket = "(", D[D.length - 1].rbracket = ")"), D[D.length - 1].relation = Te.Or), D;
    }).filter((p) => p.length);
    let N = [];
    return k && k.length && (N = ft(k), N.length > 1 && (N[0].lbracket += "(", N[N.length - 1].rbracket += ")"), N[N.length - 1].relation = 0), N;
  }
  function V() {
    let { expandLevel: u } = l;
    return u && !pt(u) && (u = u < -1 ? -1 : u), u;
  }
  function M(u, C) {
    const f = {};
    f.category = C;
    let k = null, N = null;
    if (u != null && u.search) {
      const { field: p, value: b, isNavigation: D, type: S } = u.search, B = S || "like";
      if (b && (f.searchValue = b.trim()), f.searchField = p ? p.trim() : "*", f.searchType = B, D && (f.category = "navsearch"), !e.enableMultiFieldSearch && f.searchField === "*") {
        const _ = D ? v.value : m.value, Y = y(_, b);
        Y && Y.length && (D ? k = Y : N = Y), b === "" && f.category === "search" && !N && !k && (f.category = "all");
      }
    }
    return r() && (f.layerNum = V()), {
      searchParam: f,
      navSearchConditions: k,
      searchConditions: N
    };
  }
  function z(u) {
    var f, k;
    if (u === "fav")
      return {
        pageIndex: 1,
        pageSize: 500
      };
    let C = "default";
    return u === "navsearch" && (C = "navigation"), {
      pageIndex: ((f = s[C]) == null ? void 0 : f.index) || 1,
      pageSize: ((k = s[C]) == null ? void 0 : k.size) || 20
    };
  }
  function I(u) {
    const C = {}, f = (u == null ? void 0 : u.action) || "all", { searchParam: k, navSearchConditions: N, searchConditions: p } = M(u, f);
    p && (C.searchConditions = p), N && (C.navSearchConditions = N), C.enableFullTree = e.enableFullTree, C.searchValue = JSON.stringify(k);
    const { pageIndex: b, pageSize: D } = z(f);
    return C.pageIndex = b, C.pageSize = D, C.treeToList = e.treeToList, C.navTreeToList = e.navTreeToList, C.loadTreeDataType = l.loadTreeDataType, u != null && u.relationFilter && (C.relationFilter = [...u.relationFilter]), u != null && u.navNodePathCode && (C.navPathCode = u.navNodePathCode), u.selectedInfo && (C.selectedInfo = u.selectedInfo), C.customData = Ze(Le.value), C;
  }
  function R(u) {
    return u == null ? void 0 : u.map((C) => (C.resizable = !0, C));
  }
  function c(u, C) {
    return u.map((f) => {
      const k = C == null ? void 0 : C.find((N) => N.field.toLowerCase() === f.value.toLowerCase());
      return k && (f.label = k.title), f;
    });
  }
  function L(u) {
    u.columns && (u.columns = R(u.columns), u.searchFields && (u.searchFields = c(u.searchFields, u.columns))), u.navigation && u.navigation.columns && (u.navigation.columns = R(u.navigation.columns), u.navigation.searchFields && (u.navigation.searchFields = c(u.navigation.searchFields, u.navigation.columns)));
  }
  function $() {
    return l.loader || n && n.getData.bind(n);
  }
  function W(u) {
    const C = $();
    return g.value && C ? C(g.value, u).then((f) => (L(f), f)) : new Promise((f, k) => {
      f({
        columns: [...e.columns],
        items: [...e.data],
        searchFields: [...e.searchFields],
        navigation: { ...e.navigation }
      });
    });
  }
  function q(u) {
    const C = V();
    return C === -1 ? !0 : C === 0 ? !1 : u <= C;
  }
  function E(u, C = !1, f = "layer") {
    u.forEach((k) => {
      var N;
      k.collapse = C ? !1 : l.loadTreeDataType === "all" ? !q(ge(k.data, f)) : !(k.expanded ?? !0), (N = k.children) != null && N.length && E(k.children, C, f);
    });
  }
  async function w(u, C) {
    var N;
    const f = I(u), k = t == null ? void 0 : t.show();
    try {
      let p = await W(f);
      if (r()) {
        const { items: b, treeInfo: D } = p.navigation || p;
        if (b != null && b.length && D) {
          const { dataField: S, layerField: B } = D;
          E(b, !1, `${S}.${B}`);
        }
      }
      e.beforeLoadData && (p = await e.beforeLoadData({ data: p })), C(p);
    } finally {
      (N = k == null ? void 0 : k.value) == null || N.close();
    }
  }
  function G(u) {
    T.value = u;
  }
  function A(u, C) {
    const { dataField: f, pathField: k } = C;
    return k ? f ? u[f][k] : ge(u, k) : "";
  }
  function O(u) {
    const C = [];
    return (u.selectable || u.selectable === void 0) && C.push(u), u.children && u.children.length && u.children.forEach((f) => {
      C.push(...O(f));
    }), C;
  }
  function X(u, C = !1) {
    var p;
    if (!(u != null && u.length))
      return u;
    const f = C ? (p = l.navigation) == null ? void 0 : p.treeInfo : l.treeInfo, { dataField: k, layerField: N } = f || {};
    return k && N && E(u, !0, `${k}.${N}`), u;
  }
  function K() {
    try {
      const u = x.value;
      return u !== "" && u != null ? u : "";
    } catch (u) {
      return console.error("Error in getIdValues:", u), "";
    }
  }
  function Z() {
    let u = K() || [];
    return Array.isArray(u) || (u = ("" + u).split(e.separator)), { selectedIds: u, selected: !0 };
  }
  return {
    includeChilds: T,
    updateIncludeChilds: G,
    idValues: x,
    getData: W,
    loadData: w,
    updateSearchFieldTitle: c,
    getPathCode: A,
    getChildNodes: O,
    lookupStates: o,
    httpService: n,
    lookupRequest: $,
    expandAllNodes: X,
    getIdQueryParams: Z,
    setTreeInfo: h,
    getFieldValue: ge
  };
}
function qe(e, a) {
  U(() => e.pagination, (n) => {
    a.default = n;
  }), U(() => {
    var n;
    return (n = e.navigation) == null ? void 0 : n.pagination;
  }, (n) => {
    a.navigation = n;
  });
  function t(n, o = !1) {
    n && (o ? a.navigation = { ...a.navigation, ...n } : a.default = { ...a.default, ...n });
  }
  return {
    updatePageInfo: t
  };
}
const Pe = "F_LOOKUP_USER_DATA_SERVICE";
function Ht(e, a) {
  const t = j("FLoadingService", null), { lookupStates: n, lookupRequest: o, httpService: s } = a, { lookupOptions: i } = n, d = H(() => gt(i.userDataKey || e.id)), l = ne({ key: d.value, data: {} });
  function m() {
    return s ? s.getSettings(l.key).then((r) => (r && r.textValue ? l.data = JSON.parse(r.textValue) : l.data = {}, e.enableUserData || (l.data.tabIndex = Q.dataList), r)) : Promise.resolve();
  }
  function v({ width: r, height: h }) {
    var y;
    l.data.size = ((y = l.data) == null ? void 0 : y.size) || {}, l.data.size = { width: r, height: h };
  }
  function g() {
    if (e.enableUserData && s) {
      const { key: r, data: h } = l, y = {
        configkey1: r,
        configkey2: "",
        configkey3: "",
        textvalue: JSON.stringify(h)
      };
      return s == null ? void 0 : s.updateSettings(r, y);
    }
    return Promise.resolve();
  }
  function x(r) {
    const h = { category: "fav", favoriteIds: r.favoriteIds };
    return {
      searchValue: JSON.stringify(h),
      pageIndex: 1,
      pageSize: 500,
      treeToList: i.treeToList
    };
  }
  function T() {
    var V;
    const r = x({ favoriteIds: (V = l.data) == null ? void 0 : V.favorites }), h = t == null ? void 0 : t.show(), y = o();
    return y ? y(e.uri, r).then((M) => {
      var z;
      return (z = h.value) == null || z.close(), l.favoriteItems = M && M.items || [], M;
    }) : Promise.resolve();
  }
  return {
    userDataState: l,
    setDialogSize: v,
    saveUserData: g,
    getFavoriteData: T,
    getUserData: m
  };
}
function xe(e, a) {
  const t = j(ze), n = j(Pe), {
    userDataState: o
  } = n;
  o.data = o.data || {};
  const s = "_favorite_", i = P(!1);
  function d({
    id: h,
    data: y
  }, V = "add") {
    var z, I;
    if (h == null && h === "")
      return;
    const M = h;
    o.data.favorites = ((z = o.data) == null ? void 0 : z.favorites) || [], o.favoriteItems = o.favoriteItems || [], V === "add" ? (i.value = !1, o.data.favorites = Array.from(/* @__PURE__ */ new Set([...((I = o.data) == null ? void 0 : I.favorites) || [], M])), o.favoriteItems = [...o.favoriteItems, y]) : (i.value = !0, o.data.favorites = o.data.favorites.filter((R) => R !== M), o.favoriteItems = o.favoriteItems.filter((R) => R[a] !== M)), n == null || n.saveUserData().then((R) => {
      const c = V === "add" ? "已添加到收藏" : "已从收藏中移除";
      t == null || t.success({
        message: c,
        position: "top-center"
      });
    });
  }
  function l(h) {
    return h ? h.raw[a] : "";
  }
  const m = H(() => (h) => {
    var V, M;
    const y = l(h);
    return (M = (V = o.data) == null ? void 0 : V.favorites) == null ? void 0 : M.includes(y);
  });
  function v(h, y, V) {
    h.stopPropagation();
    const M = l(y);
    d({
      id: M,
      data: y.raw
    }, m.value(y) ? "remove" : "add");
  }
  const g = (h, y) => F("button", {
    type: "button",
    onClick: (V) => {
      v(V, y);
    },
    class: ["btn btn-link f-icon f-icon-star-outline p-0", {
      "f-icon-star": m.value(y)
    }],
    style: "color: #ffbd8c;",
    title: m.value(y) ? "取消收藏" : "收藏"
  }, null), x = (h, y) => y.disabled ? "" : g(h, y), T = {
    field: s,
    title: "",
    width: 50,
    fixed: "right",
    align: "center",
    formatter: g
  };
  function r(h, y, V = !1) {
    const M = Ve(y);
    e.enableFavorite && (T.formatter = V ? x : g, M.push(T)), h == null || h.updateColumns(M);
  }
  return {
    favorite: T,
    removeFavoriteItem: i,
    setColumns: r
  };
}
function Ee(e, a, t, n) {
  const { selectionState: o, unSelectDataId: s, lookupOptions: i } = t, d = H(() => !(o.value && o.value.length));
  n && U(() => n.value, (l, m) => {
    var v;
    if (l === Q.dataList && l !== m && !d.value) {
      const g = o.value.map((x) => x[i.idField]);
      (v = a.value) == null || v.selectItemByIds(g);
    }
  }), U(d, (l, m) => {
    var v;
    l && ((v = a.value) == null || v.clearSelection());
  }), e.showSelections && i.multiSelect && U(s, (l) => {
    var m;
    l && ((m = a.value) == null || m.unSelectItemByIds(l));
  });
}
const pe = Symbol("LOOKUP_SELECTIONS_MANAGER");
function We(e, a) {
  const { selectionState: t, unSelectDataId: n, lookupOptions: o } = a, s = H(() => o.idField);
  function i() {
    let r = /* @__PURE__ */ new Map();
    return t.value && t.value.length && (r = new Map(t.value.map((h) => [h[s.value], h]))), r;
  }
  function d() {
    t.value = [];
  }
  function l() {
    return t.value || [];
  }
  function m() {
    return t.value.map((r) => r[s.value]);
  }
  function v(r) {
    if (!r)
      return;
    if (!s.value) {
      console.error("idField is required");
      return;
    }
    const h = Array.isArray(r) ? r : [r], y = i();
    h.forEach((V) => {
      y.delete(V);
    }), t.value = Array.from(y.values()), n.value = h;
  }
  function g(r, h = !0) {
    if (!r)
      return;
    if (!s.value) {
      console.error("idField is required");
      return;
    }
    const y = Array.isArray(r) ? r : [r];
    if (!y.length)
      return;
    if (!y.every((z) => s.value in z)) {
      console.error("Some items do not have the specified idField:", s.value);
      return;
    }
    o.multiSelect || d();
    const V = y.map((z) => z[s.value]), M = i();
    if (h) {
      const z = new Map(y.map((I) => [I[s.value], I]));
      V.forEach((I) => {
        M.has(I) || M.set(I, z.get(I));
      });
    } else
      V.forEach((z) => {
        M.delete(z);
      });
    t.value = Array.from(M.values());
  }
  function x(r) {
    if (!r || !r.length)
      return;
    const h = r.map((y) => y.data);
    g(h);
  }
  function T(r) {
    if (r) {
      const h = r.raw[s.value];
      v(h);
    }
  }
  return {
    updateSelections: g,
    clearSelections: d,
    getSelectionIds: m,
    getSelections: l,
    unSelectionsByIds: v,
    selectTreeNodes: x,
    unSelectTreeNode: T
  };
}
function Ge(e, a) {
  const { getSelectionIds: t } = We(e, a);
  function n(i, d) {
    i == null || i.updateDataSource(d || []);
  }
  function o(i) {
    const d = t();
    d && d.length && (i == null || i.selectItemByIds(d));
  }
  function s(i, d) {
    n(i, d), o(i);
  }
  return { loadData: n, selectItemByIds: o, loadAndSelect: s };
}
function Jt(e, a, t) {
  const n = j(fe, P(Q.dataList)), o = j(le), s = j(pe), {
    lookupStates: i,
    loadData: d,
    includeChilds: l,
    getPathCode: m,
    getChildNodes: v
  } = o, {
    lookupState: g,
    navigationState: x,
    pageInfoState: T,
    searchState: r,
    lookupOptions: h
  } = i, {
    checkPaination: y,
    checkMultiSelect: V,
    checkColumnOptions: M,
    navIsTreeList: z,
    isLoadAll: I,
    isPathCodeTree: R
  } = de(e, i), {
    updatePageInfo: c
  } = qe(e, T), {
    updateSelections: L
  } = s, {
    loadAndSelect: $
  } = Ge(e, i), W = y(e.pagination), q = V(), E = M(), w = P(), G = P([]), {
    navSelectedItems: A,
    getNavigationIdField: O,
    getRelationFilter: X
  } = t;
  c(W);
  const K = P(T.default), {
    setColumns: Z
  } = xe(e, h.idField);
  U(() => T.default, (S) => {
    var B;
    K.value = S, (B = w.value) == null || B.updatePagination(S);
  }), Ee(e, w, o.lookupStates, n);
  function u(S, B, _) {
    const Y = {
      total: B
    };
    if (_) {
      const {
        pageIndex: te,
        pageSize: Je,
        enablePager: Xe,
        pageList: Qe
      } = _;
      Object.assign(Y, {
        index: te,
        size: Je,
        enable: Xe,
        sizeLimits: Qe
      });
    }
    c(Y), $(w.value, S || []);
  }
  const C = H(() => {
    if (A.value && A.value.length) {
      let S = A.value;
      if (z() && l.value) {
        const B = x.treeInfo;
        if (I(B))
          return S = v(S[0]), {
            relationFilter: X(S)
          };
        if (R(B))
          return {
            navNodePathCode: m(S[0].data, B)
          };
      }
      return {
        relationFilter: X(S)
      };
    }
    return null;
  });
  U([() => g == null ? void 0 : g.columns, () => g == null ? void 0 : g.items, () => g == null ? void 0 : g.pageInfo, () => g == null ? void 0 : g.total, () => g == null ? void 0 : g.selectedData], ([S, B, _, Y, te]) => {
    S && Z(w.value, S), te && te.length && L(te), u(B, Y || 0, _);
  }), U(() => e.idValue, (S) => {
    G.value = S.split(e.separator);
  });
  function f(S) {
    L(S);
  }
  function k(S) {
    L(S == null ? void 0 : S.raw, !1);
  }
  function N() {
    const S = {
      search: r.default,
      action: "list"
    };
    C.value && Object.assign(S, C.value), d(S, (B) => {
      u(B.items, B.total || 0, B.pageInfo);
    });
  }
  const p = ht(() => {
    c({
      index: 1
    }), N();
  }, 200);
  U(() => A.value, (S) => {
    if (e.uri) {
      p();
      return;
    }
    const B = S.map((_) => _[O()]);
    a.emit("navSelectionsChanged", {
      items: S,
      ids: B
    });
  }), U(() => r.default, (S) => {
    if (e.uri) {
      p();
      return;
    }
    a.emit("search", S);
  }), U(() => l.value, () => {
    if (e.uri && A.value && A.value.length) {
      p();
      return;
    }
  });
  function b({
    pageSize: S,
    pageIndex: B
  }) {
    var te;
    let _ = B;
    ((te = K.value) == null ? void 0 : te.size) !== S && (_ = 1);
    const Y = {
      size: S,
      index: _,
      isNavigation: !1
    };
    if (c(Y), e.uri) {
      N();
      return;
    }
    a.emit("pageSizeChanged", Y);
  }
  function D() {
    return F(be, {
      ref: w,
      pagination: K.value,
      summary: {
        enable: !1
      },
      columnOption: E,
      idField: h.idField,
      rowNumber: {
        enable: !1
      },
      showBorder: !0,
      virtualized: !0,
      fit: !0,
      selection: q,
      selectionValues: G.value,
      onSelectionChange: f,
      onUnSelectItem: k,
      onChanged: b
    }, null);
  }
  return {
    datagridRef: w,
    selectionValues: G,
    renderDataGrid: D
  };
}
const Se = Symbol("LOOKUP_TREEROW_OPTIONS");
function Xt(e, a = !1) {
  function t(n) {
    return (n.raw.addtional || n.raw.selectable === !1) && (n.disabled = !0), (a ? e.navTreeInfo : e.treeInfo).onlySelectLeaf && (n.disabled = !n.raw.leaf), n;
  }
  return { customRowStatus: t };
}
function Qt(e, a) {
  const t = j(fe, P(Q.dataList)), n = j(le), o = j(Se), {
    lookupStates: s
  } = n, {
    lookupState: i,
    searchState: d,
    lookupOptions: l
  } = s, m = j(pe), {
    checkMultiSelect: v,
    checkColumnOptions: g
  } = de(e, s), {
    setColumns: x
  } = xe(e, l.idField), {
    selectTreeNodes: T,
    unSelectTreeNode: r,
    updateSelections: h
  } = m, y = v(), V = g(), M = P(), z = P([]), {
    loadAndSelect: I
  } = Ge(e, s), {
    loadData: R,
    expandAllNodes: c
  } = n;
  function L(A) {
    var O;
    (O = d.default) != null && O.value && (A = c(A)), I(M.value, A || []);
  }
  Ee(e, M, s, t), U([() => i == null ? void 0 : i.columns, () => i == null ? void 0 : i.items, () => i == null ? void 0 : i.pageInfo, () => i == null ? void 0 : i.total, () => i == null ? void 0 : i.selectedData], ([A, O, X, K, Z]) => {
    Z && Z.length && h(Z), A && x(M.value, A, !0), L(O);
  });
  function $(A) {
    T(A);
  }
  function W(A) {
    r(A);
  }
  function q(A = "list") {
    R({
      search: d.default,
      action: A
    }, (O) => {
      L(O.items);
    });
  }
  U(() => d.default, (A) => {
    if (e.uri) {
      q("search");
      return;
    }
    a.emit("search", A);
  });
  const E = {
    cascadeOption: {
      autoCheckChildren: !1,
      autoCheckParent: !1
    },
    collapseField: "collapse"
  };
  function w(A) {
  }
  function G() {
    return F(we, {
      ref: M,
      fit: !0,
      data: e.data,
      idField: l.idField,
      columns: e.columns,
      rowNumber: {
        enable: !1
      },
      columnOption: V,
      selection: y,
      showBorder: !0,
      virtualized: !0,
      displayField: "code",
      rowOption: o,
      hierarchy: E,
      onSelectionChange: $,
      onUnSelectItem: W,
      onExpandNode: w
    }, null);
  }
  return {
    treegridRef: M,
    selectionTreeValues: z,
    renderTreeGrid: G
  };
}
const Kt = {
  fields: { type: Array, default: () => [] },
  showAllColumns: { type: Boolean, default: !0 },
  isNavigation: { type: Boolean, default: !1 }
}, Yt = /* @__PURE__ */ ie({
  name: "FLookupSearchBar",
  props: Kt,
  emits: ["search"],
  setup(e, a) {
    const t = j(le), {
      queryState: n
    } = t.lookupStates, o = P(e.fields || []), s = P(""), i = P(n.value), d = P(e.isNavigation), l = P(), m = H(() => ({
      field: s.value,
      value: i.value,
      isNavigation: d.value
    }));
    function v() {
      if (!o.value.length)
        return;
      let r = "";
      e.showAllColumns && (r = "*"), r = o.value[0].value;
      const h = o.value.find((y) => !!y.isDefault);
      h && (r = h.value), s.value = r;
    }
    U(() => e.fields, (r) => {
      o.value = r, v();
    });
    function g() {
      a.emit("search", m.value);
    }
    function x() {
      i.value = "", g();
    }
    function T(r) {
      r.key === "Enter" && g();
    }
    return ue(() => {
      v(), d.value && (i.value = "");
    }), () => F("div", {
      class: "fv-lookup-search-bar d-flex flex-row"
    }, [F("div", {
      style: "width: 160px;"
    }, [F(Ae, {
      ref: l,
      data: o.value,
      textField: "label",
      valueField: "value",
      idField: "value",
      modelValue: s.value,
      "onUpdate:modelValue": (r) => s.value = r,
      enableClear: !1
    }, null)]), F("div", {
      class: "f-utils-fill ml-2"
    }, [F(Be, {
      buttonContent: '<i class="f-icon f-icon-search"></i>',
      maxLength: 200,
      modelValue: i.value,
      "onUpdate:modelValue": (r) => i.value = r,
      onClickButton: g,
      enableClear: !0,
      onClear: x,
      onKeyup: T,
      popupOnClick: !0
    }, null)])]);
  }
});
function He(e, a, t) {
  const {
    lookupState: n,
    searchState: o,
    navigationState: s
  } = t, {
    searchFieldItems: i,
    navSearchFieldItems: d
  } = je(e, n, s), l = P([]), m = P([]);
  function v(r, h = !1) {
    let y = r;
    e.searchAnyField && (y = [{
      label: "所有列",
      value: "*"
    }].concat(r)), h ? m.value = y : l.value = y;
  }
  v(i.value), v(d.value, !0), U(() => i.value, (r) => {
    v(r);
  }), U(() => d.value, (r) => {
    v(r, !0);
  });
  function g(r) {
    const h = {
      ...r
    };
    if (a) {
      o.navigation = h;
      return;
    }
    o.default = h;
  }
  const x = H(() => a ? m.value || [] : l.value || []);
  function T() {
    if (e.enableSearchBar && x.value.length > 0)
      return F("div", {
        class: "p-2"
      }, [F(Yt, {
        fields: x.value,
        showAllColumns: e.searchAnyField,
        isNavigation: a,
        onSearch: g
      }, null)]);
  }
  return {
    renderSearchBar: T
  };
}
function Zt(e, a) {
  var C;
  const t = j(Se), n = j(le), {
    loadData: o,
    lookupStates: s,
    expandAllNodes: i,
    getFieldValue: d
  } = n, {
    navigationState: l,
    pageInfoState: m,
    searchState: v
  } = s, {
    renderSearchBar: g
  } = He(e, !0, s), {
    checkPaination: x,
    navIsList: T,
    navIsTreeList: r
  } = de(e, s), {
    updatePageInfo: h
  } = qe(e, m), y = P([]);
  if (T()) {
    const f = x((C = e.navigation) == null ? void 0 : C.pagination);
    h(f, !0);
  }
  const V = P(m.navigation), M = {
    enableSelectRow: !0,
    multiSelect: !1,
    showCheckbox: !1,
    keepSelectingOnClick: !1
  }, z = {
    fitColumns: !0,
    fitMode: "percentage",
    resizeColumn: !0
  }, I = P(), R = P(), c = P("id");
  U(() => m.navigation, (f) => {
    var k;
    V.value = f, (k = R.value) == null || k.updatePagination(f);
  });
  function L(f, k, N) {
    var p, b, D;
    if (f = f || [], T()) {
      const S = {
        total: k
      };
      if (N) {
        const {
          pageIndex: B,
          pageSize: _,
          enablePager: Y,
          pageList: te
        } = N;
        Object.assign(S, {
          index: B,
          size: _,
          enable: Y,
          sizeLimits: te
        });
      }
      h(S, !0), (p = R.value) == null || p.updateDataSource(f);
    } else r() && ((b = v.navigation) != null && b.value && (f = i(f, !0)), (D = I.value) == null || D.updateDataSource(f));
  }
  function $(f) {
    var k, N;
    T() ? (k = R.value) == null || k.updateColumns(f) : r() && ((N = I.value) == null || N.updateColumns(f));
  }
  U([() => l == null ? void 0 : l.columns, () => l == null ? void 0 : l.items, () => l == null ? void 0 : l.pageInfo, () => l == null ? void 0 : l.total], ([f, k, N, p]) => {
    f && $(f), L(k, p || 0, N);
  }), U(() => l == null ? void 0 : l.idField, (f) => {
    c.value = f || "id";
  });
  function W(f) {
    y.value = f;
  }
  function q(f) {
    y.value = f;
  }
  function E() {
    o({
      search: v.navigation,
      action: "navsearch"
    }, (f) => {
      L(f.items, f.total || 0, f.pageInfo);
    });
  }
  U(() => v.navigation, (f) => {
    if (e.uri) {
      h({
        index: 1
      }, !0), E();
      return;
    }
    a.emit("search", f);
  });
  function w({
    pageSize: f,
    pageIndex: k
  }) {
    var b;
    let N = k;
    ((b = V.value) == null ? void 0 : b.size) !== f && (N = 1);
    const p = {
      size: f,
      index: N
    };
    if (h(p, !0), e.uri) {
      E();
      return;
    }
    a.emit("pageSizeChanged", p);
  }
  const G = {
    collapseField: "collapse"
  };
  function A() {
    return F(we, {
      ref: I,
      fit: !0,
      idField: c.value,
      rowNumber: {
        enable: !1
      },
      columnOption: z,
      selection: M,
      virtualized: !0,
      showBorder: !0,
      rowOption: t,
      hierarchy: G,
      onSelectionChange: W
    }, null);
  }
  function O() {
    return F(be, {
      ref: R,
      pagination: V.value,
      summary: {
        enable: !1
      },
      columnOption: z,
      idField: c.value,
      rowNumber: {
        enable: !1
      },
      showBorder: !0,
      fit: !0,
      virtualized: !0,
      selection: M,
      onSelectionChange: q,
      onChanged: w
    }, null);
  }
  function X() {
    if (r())
      return A();
    if (T())
      return O();
  }
  function K() {
    return F("div", {
      class: "d-flex h-100 w-100 flex-column"
    }, [g(), F("div", {
      class: "f-utils-fill px-2",
      style: "position: relative;"
    }, [X()])]);
  }
  function Z() {
    return c.value;
  }
  function u(f) {
    return l.relations && l.relations.length ? l.relations.map((N) => {
      const {
        groupField: p,
        helpField: b
      } = N, D = {
        fieldName: b,
        fieldValue: ""
      }, S = f.map((B) => d(B, p));
      return D.fieldValue = S.join(","), D;
    }) : "";
  }
  return {
    renderNavigation: K,
    selectedItems: y,
    getNavigationIdField: Z,
    getRelationFilter: u
  };
}
function ea(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !et(e);
}
const ta = /* @__PURE__ */ ie({
  name: "LookupContainer",
  props: ye,
  emits: ["update:modelValue", "search", "navSelectionsChanged", "pageIndexChanged", "pageSizeChanged", "changeDialogOptions", "clearSearch"],
  setup(e, a) {
    j(fe, P(Q.dataList));
    const t = j(le), {
      lookupStates: n,
      getIdQueryParams: o
    } = t, {
      lookupState: s,
      navigationState: i,
      queryState: d,
      lookupOptions: l
    } = n, {
      renderSearchBar: m
    } = He(e, !1, n), {
      isDoubleList: v,
      getNavigationSize: g,
      isTreeList: x
    } = de(e, n), {
      renderNavigation: T,
      selectedItems: r,
      getNavigationIdField: h,
      getRelationFilter: y
    } = Zt(e, a);
    function V() {
      if (x()) {
        const {
          renderTreeGrid: L
        } = Qt(e, a);
        return L;
      }
      const {
        renderDataGrid: c
      } = Jt(e, a, {
        navSelectedItems: r,
        getNavigationIdField: h,
        getRelationFilter: y
      });
      return c;
    }
    const M = V(), z = g();
    function I(c) {
      var $;
      const L = ($ = l.dialog) == null ? void 0 : $.title;
      L && L !== Ue && (c = L), a.emit("changeDialogOptions", {
        title: c
      });
    }
    function R() {
      const c = {};
      e.enableToSelect && (c.selectedInfo = o(), d.value != null && (c.search = {
        field: "*",
        value: d.value,
        type: "like"
      }, c.action = "search")), t == null || t.loadData(c, (L) => {
        L.navigation && (Object.keys(L.navigation).forEach(($) => {
          var W;
          i[$] = (W = L.navigation) == null ? void 0 : W[$];
        }), L.navigation.treeInfo && (t == null || t.setTreeInfo(L.navigation.treeInfo, !0)), delete L.navigation), L.treeInfo && (t == null || t.setTreeInfo(L.treeInfo)), Object.keys(L).forEach(($) => {
          s[$] = L[$];
        }), I(L.title || "");
      });
    }
    return ue(() => {
      R(), document.body.classList.add("lookup-modal-open");
    }), Ie(() => {
      document.body.classList.remove("lookup-modal-open");
    }), () => {
      let c;
      return F(ct, null, {
        default: () => [v() && e.showNavigation && F(Oe, {
          position: "left",
          width: z == null ? void 0 : z.width,
          minWidth: z == null ? void 0 : z.minWidth
        }, ea(c = T()) ? c : {
          default: () => [c]
        }), F(Oe, {
          position: "center"
        }, {
          default: () => [F("div", {
            class: "d-flex h-100 w-100 flex-column"
          }, [m(), F("div", {
            class: "f-utils-fill px-2",
            style: "position: relative;"
          }, [M()])])]
        })]
      });
    };
  }
}), aa = {
  multiSelect: { type: Boolean, default: !1 },
  idField: { type: String, default: "id" },
  displayType: { type: String, default: "list" },
  selectedIds: { type: Array, default: [] },
  showSelections: { type: Boolean, default: !1 },
  treeToList: { type: Boolean, default: !1 },
  enableFavorite: { type: Boolean, default: !0 }
}, na = /* @__PURE__ */ ie({
  name: "FLookupFavorite",
  props: aa,
  setup(e, a) {
    const t = j(Se), {
      userDataState: n,
      getFavoriteData: o
    } = j(Pe), s = j(fe, P(Q.dataList)), i = j(pe), d = j(le), {
      lookupStates: l,
      expandAllNodes: m
    } = d, v = H(() => l.lookupOptions.idField || "id"), g = P(e.selectedIds), {
      setColumns: x,
      removeFavoriteItem: T
    } = xe(e, v.value), {
      isTreeList: r
    } = de(e, l), {
      updateSelections: h,
      unSelectTreeNode: y,
      selectTreeNodes: V
    } = i, M = P(), z = P(), I = H(() => r() ? z.value : M.value);
    Ee(e, I, l);
    function R() {
      return n.data && n.data.favorites && n.data.favorites.length;
    }
    function c(O) {
      I.value.clearSelection(), O && O.length && I.value.selectItemByIds(O);
    }
    U(() => e.selectedIds, (O, X) => {
      JSON.stringify(O) !== JSON.stringify(X) && (g.value = O, g.value.length ? c(g.value) : I.value.clearSelection());
    });
    function L(O, X) {
      X && X.length && x(I.value, X, r()), O && (r() && (O = m(O)), I.value.updateDataSource(O || [])), c(g.value || []);
    }
    function $() {
      o().then((O) => {
        O ? L(O.items || [], O.columns) : L([], null);
      });
    }
    U(() => s.value, (O, X) => {
      var K;
      O === Q.favorite && (R() ? $() : L([], (K = l.lookupState) == null ? void 0 : K.columns));
    }), U(() => T.value, (O, X) => {
      s.value === Q.favorite && O && (r() ? $() : L(n.favoriteItems || [], null), T.value = !1);
    });
    const W = {
      fitColumns: !0,
      fitMode: "percentage",
      resizeColumn: !0
    }, q = {
      enableSelectRow: !0,
      multiSelect: e.multiSelect,
      showCheckbox: e.multiSelect,
      multiSelectMode: "OnCheckAndClick"
    };
    function E(O) {
      r() ? V(O) : h(O);
    }
    function w(O) {
      r() ? y(O) : h(O == null ? void 0 : O.raw, !1);
    }
    function G() {
      return F(we, {
        ref: z,
        fit: !0,
        idField: v.value,
        rowNumber: {
          enable: !1
        },
        columnOption: W,
        selection: q,
        showBorder: !0,
        virtualized: !0,
        rowOption: t,
        onSelectionChange: E,
        onUnSelectItem: w
      }, null);
    }
    function A() {
      return F(be, {
        ref: M,
        pagination: {
          enable: !1
        },
        summary: {
          enable: !1
        },
        columnOption: W,
        idField: v.value,
        rowNumber: {
          enable: !1
        },
        showBorder: !0,
        virtualized: !0,
        fit: !0,
        selection: q,
        onSelectionChange: E,
        onUnSelectItem: w
      }, null);
    }
    return () => r() ? G() : A();
  }
}), ia = {
  title: { type: String },
  height: { type: Number, default: 50 },
  draggable: { type: Boolean, default: !0 },
  enableFavorite: { type: Boolean, default: !1 },
  useHttpComposition: { type: Object, default: {} },
  userDataService: { type: Object, default: {} },
  useDialog: { type: Object, default: {} },
  selectionsManager: { type: Object, default: {} },
  showSelectedList: { type: Boolean, default: !1 },
  showIncludeChildNodes: { type: Object, default: { show: !0, value: !1 } },
  showCascadeControl: { type: Boolean, default: !1 },
  cascadeValue: { type: String, default: "both" },
  isMaximized: { type: Boolean, default: !1 }
}, oa = {
  idField: { type: String, default: "id" },
  parentRef: { type: HTMLElement, default: null },
  popoverOffsetX: { type: Number, default: 0 }
}, la = /* @__PURE__ */ ie({
  props: oa,
  setup(e, a) {
    const t = j("FMessageBoxService"), n = j(pe), o = j(le), {
      lookupState: s,
      selectionState: i
    } = o.lookupStates, {
      clearSelections: d,
      unSelectionsByIds: l
    } = n, m = P(), v = H(() => m), g = P(), x = P(e.popoverOffsetX || -15);
    U(() => e.popoverOffsetX, (w) => {
      x.value = w;
    });
    const T = H(() => x.value === -15 ? 10 : 100), r = P(e.parentRef), h = "_remove_selected_";
    function y(w, G, A) {
      w.stopPropagation();
      const O = G.raw[e.idField];
      l(O);
    }
    const V = {
      field: h,
      title: "",
      width: 50,
      fixed: "right",
      align: "center",
      formatter: (w, G) => F("button", {
        type: "button",
        onClick: (A) => {
          y(A, G);
        },
        class: "btn btn-link f-icon f-icon-x p-0",
        style: "color: #dd2438;",
        title: "取消选择"
      }, null)
    }, M = H(() => {
      const w = Ve((s == null ? void 0 : s.columns) || []);
      if (w.length)
        return w.push(V), w;
    });
    U(() => e.parentRef, (w) => {
      r.value = w;
    });
    const z = {
      fitColumns: !0,
      fitMode: "percentage",
      resizeColumn: !0
    }, I = {
      enableSelectRow: !0,
      multiSelect: !1,
      showCheckbox: !1,
      showSelectAll: !1,
      multiSelectMode: "OnCheckAndClick"
    }, R = P({
      width: "0px",
      height: "0px"
    });
    let c;
    function L() {
      var X, K;
      const w = ((X = r.value) == null ? void 0 : X.offsetHeight) - 100, G = 200, A = i.value.length * 28 + 60, O = A > w ? w : A < G ? G : A;
      R.value = {
        width: ((K = r.value) == null ? void 0 : K.offsetWidth) - 20 + "px",
        height: O + "px"
      };
    }
    U(() => g.value, (w) => {
      w && (w.updateColumns(M.value), w.updateDataSource(i.value || []), L());
    }), U(() => i.value, (w) => {
      var G;
      (G = g.value) == null || G.updateDataSource(w || [], {
        keepScrollTop: !0
      });
    }), U(() => r.value, (w) => {
      c = new ResizeObserver(() => {
        r.value && L();
      }), c.observe(r.value);
    });
    const $ = H(() => (i.value || []).length > 0), W = H(() => ({
      display: "flex",
      "align-items": "center",
      opacity: $.value ? 1 : 0.4,
      cursor: $.value ? "pointer" : "not-allowed",
      pointerEvents: $.value ? "auto" : "none"
    }));
    function q() {
      t == null || t.question("您确认要取消所有选中记录吗?", "", () => {
        d();
      });
    }
    ue(() => {
      L();
    }), Ie(() => {
      c && r.value && c.unobserve(r.value);
    });
    function E() {
      var w;
      (w = v.value) == null || w.value.hide();
    }
    return a.expose({
      hidePopup: E
    }), () => F(tt, null, [F("div", {
      class: "d-flex flex-row align-items-center",
      style: "line-height:24px"
    }, [Me(F("div", {
      style: W.value
    }, [oe("已选"), F("span", {
      style: "font-size: 18px;padding: 0 3px;"
    }, [i.value.length]), oe("条")]), [[at("popover"), v.value, "toggle"]]), $.value && F("button", {
      class: "btn btn-link btn-sm p-0 pl-2",
      onClick: q
    }, [oe("取消已选")])]), F(vt, {
      id: "lookup-selected-popover",
      customStyles: {
        filter: "drop-shadow(#c5c5c5 0px 0px 6px)"
      },
      offsetX: x.value,
      arrowOffsetX: T.value,
      ref: m,
      placement: "top-left",
      keepWidthWithReference: !1,
      fitContent: !0
    }, {
      default: () => {
        var w;
        return [F("div", {
          style: R.value
        }, [((w = m.value) == null ? void 0 : w.isShow) && F(be, {
          ref: g,
          pagination: {
            enable: !1
          },
          summary: {
            enable: !1
          },
          columnOption: z,
          idField: e.idField,
          rowNumber: {
            enable: !1
          },
          showBorder: !1,
          virtualized: !0,
          fit: !0,
          selection: I
        }, null)])];
      }
    })]);
  }
}), sa = /* @__PURE__ */ ie({
  props: {
    modelValue: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["update:modelValue"],
  setup(e, a) {
    const t = P(e.modelValue);
    function n(o) {
      o.stopPropagation(), t.value = !t.value, a.emit("update:modelValue", t.value);
    }
    return () => F("div", {
      class: "custom-control custom-checkbox mb-0",
      onClick: n
    }, [Me(F("input", {
      id: "lookup-include-childs-input",
      "onUpdate:modelValue": (o) => t.value = o,
      title: "checkbox-input",
      type: "checkbox",
      class: "custom-control-input"
    }, null), [[nt, t.value]]), F("label", {
      class: "custom-control-label",
      style: "padding-left: 1.2rem;"
    }, [oe("包含下级")])]);
  }
}), ra = /* @__PURE__ */ ie({
  name: "FLookupCascadeSelector",
  props: ["modelValue"],
  emits: [],
  setup(e, a) {
    const t = P(), n = P(e.modelValue);
    return () => F("div", {
      style: "width: 130px",
      class: "ml-3"
    }, [F(Ae, {
      ref: t,
      data: Re,
      textField: "text",
      valueField: "value",
      idField: "value",
      modelValue: n.value,
      "onUpdate:modelValue": (o) => n.value = o,
      enableClear: !1,
      minPanelWidth: 130,
      placement: "top-left"
    }, null)]);
  }
}), ua = /* @__PURE__ */ ie({
  name: "FLookupModalContainer",
  props: ia,
  emits: ["closeModal", "maximize"],
  setup(e, a) {
    const t = P(Q.dataList);
    ce(fe, t), ce(le, e.useHttpComposition), ce(Pe, e.userDataService), ce(pe, e.selectionsManager);
    const n = ne(e.showIncludeChildNodes), o = P(n.value), {
      lookupOptions: s
    } = e.useHttpComposition.lookupStates, i = s.dialog, d = s.displayType.toUpperCase() === ee.TreeList, l = Xt(s, d);
    ce(Se, l);
    const m = P(e.isMaximized);
    U(() => e.isMaximized, (E, w) => {
      m.value = E;
    });
    const v = H(() => ({
      "f-icon": !0,
      modal_maximize: !0,
      modalrevert: m.value
    }));
    P();
    const g = H(() => n.show && t.value === Q.dataList && s.displayType && d), x = H(() => g.value ? -99 : -15);
    U(() => o.value, (E, w) => {
      e.useHttpComposition.updateIncludeChilds(E);
    });
    const {
      userDataState: T
    } = e.userDataService, {
      cancelDialog: r,
      submitDialog: h
    } = e.useDialog, y = P(), V = P();
    function M(E) {
      a.emit("maximize", E);
    }
    function z(E) {
      a.emit("closeModal", E);
    }
    async function I(E) {
      await h() && z(E);
    }
    async function R(E) {
      await r() && z(E);
    }
    function c(E) {
      t.value = E, T.data.tabIndex = E;
    }
    const L = H(() => ({
      transform: `translate3d(${t.value === Q.favorite ? 84 : 0}px, 0px, 0px)`
    })), $ = H(() => (E) => ({
      visibility: t.value === E ? "visible" : "hidden",
      position: "absolute",
      top: 0,
      transition: "all 0.3s ease-in",
      opacity: t.value === E ? 1 : 0
    })), W = H(() => {
      const E = e.enableFavorite ? "50%" : "100%", w = e.enableFavorite ? 100 : 80, G = i.showMaxButton || i.showCloseButton ? w : 0;
      return {
        maxWidth: `calc(${E} - ${G}px)`
      };
    });
    function q(E) {
      E.stopPropagation(), document.body.click();
    }
    return ue(() => {
      var E;
      T.data.favorites && T.data.favorites.length && (t.value = ((E = T.data) == null ? void 0 : E.tabIndex) || Q.dataList), g.value && e.useHttpComposition.updateIncludeChilds(o.value);
    }), () => F("div", {
      class: "d-flex flex-column h-100 lookup-modal",
      ref: y
    }, [F("div", {
      class: "d-flex justify-content-between align-items-center px-3 lookup-modal-header"
    }, [F("div", {
      class: "lookup-modal-header-title",
      title: e.title,
      style: W.value
    }, [e.title]), e.enableFavorite && F("div", {
      class: "d-flex justify-content-center w-100"
    }, [F("div", {
      class: "lookup-modal-header-tabs-container d-flex",
      onMousedown: q
    }, [F("div", {
      class: "active-tab",
      style: L.value
    }, null), F("div", {
      class: ["tab-item", "d-flex", {
        active: t.value === Q.dataList
      }],
      onClick: () => c(Q.dataList)
    }, [oe("数据列表")]), F("div", {
      class: ["tab-item", "d-flex", {
        active: t.value === Q.favorite
      }],
      onClick: () => c(Q.favorite)
    }, [oe("收藏夹")])])]), (i.showMaxButton || i.showCloseButton) && F("div", {
      class: "d-flex flex-row h-100 justify-content-end align-items-center lookup-modal-header-buttons",
      onMousedown: (E) => E.stopPropagation()
    }, [i.showMaxButton && F("span", {
      class: v.value,
      onClick: M,
      style: "cursor: pointer"
    }, null), i.showCloseButton && F("span", {
      class: "f-icon modal_close ml-2",
      onClick: z,
      style: "cursor: pointer;position: relative;top: 1px;"
    }, null)])]), F("div", {
      class: "f-utils-fill",
      style: "position: relative;"
    }, [F("div", {
      class: "h-100 d-flex flex-column f-utils-fill w-100",
      style: $.value(Q.dataList)
    }, [a.slots.default && a.slots.default()]), F("div", {
      class: "h-100 d-flex flex-column px-2 f-utils-fill w-100",
      style: $.value(Q.favorite)
    }, [a.slots.fav && a.slots.fav()])]), F("div", {
      class: "modal-footer"
    }, [F("div", {
      class: "f-utils-fill align-items-center d-flex flex-row"
    }, [g.value && F(sa, {
      modelValue: o.value,
      "onUpdate:modelValue": (E) => o.value = E
    }, null), e.showSelectedList && F(la, {
      popoverOffsetX: x.value,
      parentRef: y.value,
      ref: V,
      idField: s.idField
    }, null), e.showCascadeControl && F(ra, {
      modelValue: e.cascadeValue,
      "onUpdate:modelValue": (E) => e.cascadeValue = E
    }, null)]), F("button", {
      name: "cancel",
      type: "button",
      class: "btn btn-secondary",
      onClick: R
    }, [oe("取消")]), F("button", {
      name: "accept",
      type: "button",
      class: "btn btn-primary",
      onClick: I
    }, [oe("确定")])])]);
  }
});
function me(e, a) {
  if (e.context) {
    if (!a) {
      delete e.context.editor;
      return;
    }
    const { editor: t } = e.context;
    t ? Object.assign(t, a) : e.context.editor = a;
  }
}
function da(e, a, t, {
  dictPicked: n,
  modelValue: o,
  buttonEditInstance: s,
  userDataService: i,
  useHttp: d
}) {
  const l = j(ze, null), m = j("FLoadingService"), v = P(), g = P(
    "accept"
    /* accept */
  ), x = P(), { lookupStates: T } = d, { queryState: r, lookupState: h, navigationState: y, pageInfoState: V, searchState: M, selectionState: z, lookupOptions: I } = T, { isDoubleList: R } = de(e, T), c = Object.assign({}, Dt, I.dialog);
  I.dialog = c;
  const L = { position: "top-center" };
  async function $() {
    const b = t.value.map((B) => ge(B, I.textField)).join(e.separator), D = t.value.map((B) => B[I.idField]).join(e.separator);
    o.value = b, d.idValues.value = D, a.emit("update:modelValue", b), a.emit("update:idValue", D);
    const S = { items: t.value, mappingFields: I.mappingFields };
    return a.emit("update:dataMapping", S), me(e, S), await n(S);
  }
  function W() {
    return g.value = "cancel", !0;
  }
  const q = (b) => {
    Object.keys(b).forEach((D) => {
      delete b[D];
    });
  }, E = (b) => {
    b.forEach((D) => {
      q(D);
    });
  };
  function w() {
    m == null || m.clearAll(), E([h, y, V, M, r]), z.value = [], x.value = null;
  }
  async function G() {
    var D;
    if (t.value.length === 0)
      return l == null || l.warning({ message: "请选择数据！", ...L }), { shouldUpdate: !1 };
    const b = await ((D = e.beforeSelectData) == null ? void 0 : D.call(e, { items: t.value }));
    return {
      shouldUpdate: typeof b == "boolean" ? b : (b == null ? void 0 : b.canSelect) ?? !0,
      message: b == null ? void 0 : b.message
    };
  }
  async function A(b) {
    return typeof b == "object" ? {
      shouldClose: b.closeDialog,
      message: b.message
    } : { shouldClose: b, message: "" };
  }
  async function O() {
    const { shouldUpdate: b, message: D } = await G();
    if (!b)
      return D && (l == null || l.warning({ message: D, ...L })), !1;
    const S = await $(), { shouldClose: B, message: _ } = await A(S);
    return B ? (g.value = "accept", !0) : (_ && (l == null || l.warning({ message: _, ...L })), !1);
  }
  function X() {
    const b = (c == null ? void 0 : c.height) || 620, D = (c == null ? void 0 : c.width) || 590, S = (c == null ? void 0 : c.minWidth) || 300, B = (c == null ? void 0 : c.minHeight) || 200, _ = {
      height: b,
      width: D,
      minWidth: S,
      minHeight: B
    };
    return R() && (_.width = (c == null ? void 0 : c.width) || 960), _;
  }
  const { width: K, height: Z, minHeight: u, minWidth: C } = X(), f = !0, k = f && ((c == null ? void 0 : c.resizeable) == null ? !0 : c == null ? void 0 : c.resizeable);
  c.rememberSize = c.rememberSize && k;
  const N = {
    title: c == null ? void 0 : c.title,
    fitContent: !1,
    showHeader: !1,
    dragHandle: ".lookup-modal-header",
    height: Z,
    width: K,
    minWidth: C,
    minHeight: u,
    resizeable: k,
    draggable: f,
    enableEsc: (c == null ? void 0 : c.enableEsc) == null ? !0 : c == null ? void 0 : c.enableEsc,
    closedCallback: (b, D) => {
      const S = { type: g.value, button: b == null ? void 0 : b.target };
      if ((D === "esc" || D === "icon") && (S.type = "esc"), S.type === "accept" && (S.items = t.value), (S.type === "cancel" || S.type === "esc") && (o.value = e.modelValue), i && e.enableUserData) {
        i.saveUserData().then(() => {
          w(), a.emit("dialogClosed", S);
        });
        return;
      }
      w(), a.emit("dialogClosed", S);
    },
    showButtons: !1,
    resizeHandle: (b) => {
      if (c.rememberSize) {
        v.value = b;
        const { width: D, height: S } = b.newSize.size;
        !(b.isMaximized ?? !1) && i.setDialogSize({ width: Math.round(D), height: Math.round(S) });
      }
    },
    enableEnter: !0,
    onEnter: (b) => {
      b.event.preventDefault(), !b.event.target.closest(".fv-lookup-search-bar") && O().then((S) => {
        var B;
        if (S) {
          const _ = (B = s.value) == null ? void 0 : B.getModal();
          _ && _.close(b.event, "enter");
        }
      });
    }
  };
  async function p(b) {
    var B;
    let D = !0;
    if (await i.getUserData(), (B = i == null ? void 0 : i.userDataState) != null && B.data && e.enableUserData && c.rememberSize) {
      const { size: _ } = i.userDataState.data;
      _ && Object.assign(N, _);
    }
    const S = e.dictPicking;
    if (S && typeof S == "function") {
      const _ = await S({ customData: x, options: I });
      typeof _ == "boolean" && !_ && (D = !1), typeof _ == "object" && (_.canOpen ? _.data && (x.value = _.data) : (D = !1, _.message && (l == null || l.error({ message: _.message, position: "top-center" }))));
    }
    return D;
  }
  return {
    modalOptions: N,
    beforeOpenDialog: p,
    dialogSize: v,
    customData: x,
    updateModelValue: $,
    cancelDialog: W,
    submitDialog: O
  };
}
function ca(e) {
  return { dictPicked: async ({ items: t, mappingFields: n }) => e.dictPicked && typeof e.dictPicked == "function" ? await e.dictPicked({ items: t, mappingFields: n }) ?? !0 : !0 };
}
function fa(e, a, t, n) {
  if (!e.editable)
    return;
  a.emit("update:modelValue", t), a.emit("update:idValue", "");
  const o = { mappingFields: n.mappingFields };
  me(e, o);
}
function pa(e, a, t) {
  const n = H(() => e.textChangeType === "blur" || e.textChangeType === "any"), o = H(() => e.textChangeType === "enter" || e.textChangeType === "any"), { beforeOpenDialog: s, updateModelValue: i, selectedItems: d, openDialog: l, lookupOptions: m, useHttpComposition: v } = t, { updateSearchFieldTitle: g } = v, { lookupState: x, queryState: T } = v.lookupStates, r = P(!1);
  function h(I) {
    const R = Ce(e.modelValue) && Ce(I) ? !1 : e.modelValue !== I;
    return Ce(I) && R ? (r.value = !0, !1) : (R ? T.value = I : T.value = "", R);
  }
  async function y(I) {
    const R = {
      search: { field: "*", value: I, type: "equal" },
      action: "search"
    };
    if (s) {
      if (await s(R) === !1)
        return;
      document.body.classList.add("lookup-modal-open"), v.loadData(R, (L) => {
        if (L.items && L.items.length === 1 && (!L.items[0].children || !L.items[0].children.length)) {
          d.value = (L.items || []).map((W) => W.data ? W.data : W), i(), T.value = "", document.body.classList.remove("lookup-modal-open");
          return;
        }
        if (L.searchFields && L.columns) {
          const W = g(L.searchFields, L.columns);
          x.searchFields = W;
        }
        l();
      });
    }
  }
  function V(I, R) {
    var L;
    let c = (L = I.target) == null ? void 0 : L.value;
    if (c !== "" && (c = c.trim()), h(c)) {
      if (e.allowFreeInput) {
        fa(e, a, c, m);
        return;
      }
      e.uri ? y(c) : a.emit("textChanged", { value: c, type: R ? "blur" : "enter" });
    }
  }
  function M(I) {
    n.value && V(I, !0);
  }
  function z(I) {
    I.key === "Enter" && o.value && V(I, !1);
  }
  return {
    changeOnBlur: n,
    changeOnEnter: o,
    onInputBlur: M,
    onEnterKeyDown: z,
    isClear: r
  };
}
const re = /* @__PURE__ */ ie({
  name: "FLookup",
  props: ye,
  emits: ["update:modelValue", "update:idValue", "search", "navSelectionsChanged", "pageIndexChanged", "pageSizeChanged", "resize", "dialogClosed", "textChanged", "clear", "update:dataMapping"],
  setup(e, a) {
    const t = '<i class="f-icon f-icon-lookup"></i>', n = P(), o = P(e.modelValue), s = P("");
    Le.value = e.customData;
    const i = Gt(e), {
      lookupOptions: d,
      selectionState: l
    } = i.lookupStates, m = Ht(e, i), v = H(() => e.showSelections && d.multiSelect), g = H(() => e.showIncludeChildNodes && e.showNavigation && !d.navTreeToList), x = We(e, i.lookupStates);
    function T() {
      n.value && !n.value.getModal() && n.value.openDialog();
    }
    const {
      dictPicked: r
    } = ca(e), {
      modalOptions: h,
      beforeOpenDialog: y,
      dialogSize: V,
      customData: M,
      updateModelValue: z,
      cancelDialog: I,
      submitDialog: R
    } = da(e, a, l, {
      dictPicked: r,
      modelValue: o,
      buttonEditInstance: n,
      userDataService: m,
      useHttp: i
    }), {
      onInputBlur: c,
      onEnterKeyDown: L,
      isClear: $
    } = pa(e, a, {
      beforeOpenDialog: y,
      updateModelValue: z,
      selectedItems: l,
      openDialog: T,
      modelValue: o,
      useHttpComposition: i,
      lookupOptions: d
    }), W = ne(h), q = j(dt);
    U(() => M.value, (p) => {
      Le.value = p;
    }), U(() => e.modelValue, (p) => {
      o.value = p;
    });
    function E(p) {
      i.idValues.value = p, p || (l.value = []), a.emit("update:idValue", p);
    }
    U(() => e.idValue, (p) => {
      E(p);
    }), ue(() => {
    }), Ie(() => {
      me(e);
    }), U(() => V.value, (p) => {
      a.emit("resize", p);
    });
    async function w() {
      a.emit("update:modelValue", ""), E("");
      const p = {
        items: null,
        mappingFields: d.mappingFields
      };
      a.emit("clear", p), me(e, p);
    }
    U(() => $.value, (p) => {
      p && (w(), $.value = !1);
    });
    function G(p) {
      a.emit("search", p);
    }
    function A(p) {
      a.emit("navSelectionsChanged", p);
    }
    function O(p) {
      a.emit("pageIndexChanged", p);
    }
    function X(p) {
      a.emit("pageSizeChanged", p);
    }
    async function K(p) {
      const b = q == null ? void 0 : q.getCurrentModal();
      b && b.updateModalOptions(p), p.title && (s.value = p.title);
    }
    function Z(p) {
      const b = q == null ? void 0 : q.getCurrentModal();
      b && b.close(p);
    }
    function u(p) {
      const b = q == null ? void 0 : q.getCurrentModal();
      b && b.maxDialog(p);
    }
    const C = H(() => {
      const p = q == null ? void 0 : q.getCurrentModal();
      return p == null ? void 0 : p.isMaximized;
    }), f = H(() => d.multiSelect && e.showCascadeControl && e.enableCascade && ee.Tree === d.displayType.toUpperCase() && !d.treeToList), k = H(() => l.value && l.value.length ? l.value.map((p) => p[d.idField]) : []);
    function N(p) {
      for (const b in d)
        p[b] !== void 0 && (d[b] = p[b]);
    }
    return a.expose({
      openDialog: T,
      updateIdValue: E,
      mappingFields: d.mappingFields,
      idField: d.idField,
      setProps: N,
      clear: w
    }), () => F(Be, {
      ref: n,
      id: e.id,
      modelValue: o.value,
      "onUpdate:modelValue": (p) => o.value = p,
      disable: e.disable,
      readonly: e.readonly,
      editable: e.editable,
      inputType: "text",
      enableClear: e.enableClear,
      buttonContent: t,
      buttonBehavior: "Modal",
      modalOptions: W,
      onClear: w,
      beforeOpen: y,
      onBlur: c,
      onKeydown: L,
      placeholder: e.placeholder,
      enableTitle: e.enableTitle
    }, {
      default: () => [F(ua, {
        title: s.value,
        enableFavorite: e.enableFavorite,
        onCloseModal: Z,
        onMaximize: (p) => u(p),
        useHttpComposition: i,
        userDataService: m,
        useDialog: {
          cancelDialog: I,
          submitDialog: R
        },
        showSelectedList: v.value,
        selectionsManager: x,
        showIncludeChildNodes: {
          show: g.value,
          value: e.includeChildNodesValue
        },
        showCascadeControl: f.value,
        isMaximized: C.value
      }, {
        default: () => F(ta, it(e, {
          onSearch: G,
          onNavSelectionsChanged: A,
          onPageIndexChanged: O,
          onPageSizeChanged: X,
          onChangeDialogOptions: K
        }), null),
        fav: () => F(na, {
          idField: d.idField,
          displayType: d.displayType,
          selectedIds: k.value,
          multiSelect: d.multiSelect,
          showSelections: v.value,
          treeToList: d.treeToList
        }, null)
      })]
    });
  }
});
re.install = (e) => {
  e.component(re.name, re);
};
re.register = (e, a, t, n) => {
  e.lookup = re, a.lookup = $e, n.lookup = { callbackResolver: Nt };
};
re.registerDesigner = (e, a, t) => {
  e.lookup = qt, a.lookup = $e;
};
export {
  _e as Compare,
  Dt as DEFAULT_LOOKUP_DIALOG_OPTIONS,
  Ue as DefaultDialogTitle,
  Et as ExpressValueType,
  re as FLookup,
  xt as F_LOOKUP_HTTP_SERVICE_TOKEN,
  Te as FilterRelation,
  fe as LOOKUP_ACTIVE_TAB,
  Da as LOOKUP_USER_DATA_ID,
  ke as LoadTreeDataType,
  ee as LookupDisplayType,
  _t as LookupSchemaRepositoryToken,
  Q as LookupTabs,
  Nt as callbackResolver,
  Re as cascadeItems,
  re as default,
  ye as lookupProps,
  $e as propsResolver
};
