var R = Object.defineProperty;
var E = (s, t, e) => t in s ? R(s, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : s[t] = e;
var N = (s, t, e) => E(s, typeof t != "symbol" ? t + "" : t, e);
import { defineComponent as S, ref as v, computed as r, watch as H, createVNode as n, Fragment as x, reactive as P, createApp as F, onUnmounted as _, onMounted as $, Transition as M, mergeProps as j } from "vue";
const L = {
  showCloseButton: { type: Boolean, default: !0 },
  position: { type: String, default: "top-center" },
  timeout: { type: Number, default: 3e3 },
  theme: { type: String, default: "bootstrap" },
  left: { type: Number },
  right: { type: Number },
  top: { type: Number },
  bottom: { type: Number },
  id: { type: String },
  animate: { type: String, default: "fadeIn" },
  options: { type: Object },
  safeHtml: { type: Boolean, default: !0 }
}, k = {
  showCloseButton: { type: Boolean, default: !0 },
  animate: { type: String, default: "fadeIn" },
  options: { type: Object }
}, w = /* @__PURE__ */ S({
  name: "Toast",
  props: k,
  emits: ["close", "click"],
  setup: (s, t) => {
    const e = v(s.animate), a = "fadeOut", o = r(() => s.options), i = v(!1), u = r(() => {
      const c = {
        animated: i.value,
        toast: !0
      };
      return c[s.animate] = !1, c[a] = i.value, c[o.value.type] = !0, o.value.theme && (c[o.value.theme] = !0), c;
    }), l = r(() => {
      const I = `f-icon-${o.value && o.value.type ? o.value.type.replace("toasty-type-", "") : "default"}`, O = {
        "f-icon": !0
      };
      return O[I] = !0, O;
    }), d = r(() => o.value.title || o.value.message), f = r(() => o.value.title && o.value.message), m = r(() => !o.value.title && o.value.message), h = r(() => s.showCloseButton), p = r(() => !!o.value.buttons || !!t.slots.default);
    function g(c) {
      c.stopPropagation(), c.preventDefault(), i.value = !1, setTimeout(() => {
        t.emit("close", o.value);
      }, 200);
    }
    function y(c, b) {
    }
    function B(c) {
      return `f-preten-link ${c.customClass ? c.customClass : ""}`;
    }
    H(e, () => {
      e.value;
    });
    const T = () => {
      var c;
      return n(x, null, [n("div", {
        class: "after-toast-msg text-right"
      }, [!t.slots.default && ((c = o.value.buttons) == null ? void 0 : c.map((b) => n("span", {
        class: B(b),
        onClick: (I) => void 0
      }, [b.text]))), t.slots.default && t.slots.default()])]);
    };
    return () => n("div", {
      class: u.value,
      style: "min-height:44px"
    }, [h.value && n("button", {
      title: "关闭",
      class: "toast-close f-btn-icon f-bare",
      onClick: g
    }, [n("span", {
      class: "f-icon modal_close"
    }, null)]), d.value && n("section", {
      class: "modal-tips"
    }, [n("div", {
      class: "float-left modal-tips-iconwrap"
    }, [n("span", {
      class: l.value
    }, null)]), n("div", {
      class: "modal-tips-content"
    }, [f.value && n(x, null, [n("h5", {
      class: "toast-title modal-tips-title",
      innerHTML: o.value.title
    }, null), n("p", {
      class: "toast-msg",
      innerHTML: o.value.message
    }, null), p.value && T()]), m.value && (o.value.buttons ? n("div", {
      class: "toast-title-btns-wrapper d-flex"
    }, [n("h5", {
      class: "toast-title modal-tips-title only-toast-msg",
      innerHTML: o.value.message
    }, null), n("div", {
      class: "after-toast-title text-right ml-auto"
    }, [T()])]) : n("h5", {
      class: "toast-title modal-tips-title only-toast-msg",
      innerHTML: o.value.message
    }, null))])])]);
  }
}), C = /* @__PURE__ */ S({
  name: "Notify",
  props: L,
  emits: ["close", "empty"],
  setup(s, t) {
    const e = r(() => ({
      "farris-notify": !0
    })), a = {
      left: 12,
      right: 12,
      top: 20,
      bottom: 12
    }, o = v(), i = v(s.options), u = v(s.showCloseButton), l = r(() => s.position || "bottom-right"), d = r(() => s.timeout != null ? s.timeout : 3e3), f = r(() => {
      const p = s.bottom ? s.bottom : a.bottom, g = s.top ? s.top : a.top, y = {
        transition: "all 0.2s ease",
        left: l.value.indexOf("left") > -1 ? `${s.left ? s.left : a.left}px` : "",
        right: l.value.indexOf("right") > -1 ? `${s.right ? s.right : a.right}px` : "",
        top: l.value.indexOf("top") > -1 ? `${g}px` : "",
        bottom: l.value.indexOf("bottom") > -1 ? `${p}px` : ""
      };
      return l.value.indexOf("center") > -1 && (y.left = "50%", y.marginLeft = "calc(-24rem / 2)", l.value === "center-center" && (y.top = "50%", y.transform = "translate(-50%, -50%)")), y;
    });
    function m(p) {
      t.emit("close");
    }
    d.value && setTimeout(() => {
      m();
    }, d.value), t.expose({
      closeToast: m,
      container: o,
      notifyPosition: l
    });
    function h(p, g) {
      m();
    }
    return () => n("div", {
      class: e.value,
      style: f.value,
      ref: o
    }, [n(w, {
      options: i.value,
      showCloseButton: u.value,
      animate: s.animate,
      onClose: (p) => h(p, i.value)
    }, null)]);
  }
});
class A {
  constructor() {
    N(this, "notifyRefs", []);
    N(this, "globalConfig", P({}));
  }
  escapeAllHtml(t) {
    if (typeof t != "string" || !t)
      return "";
    const e = document.createElement("div");
    return e.textContent = t || "", e.innerHTML.replace(/ /g, "&nbsp;").replace(/\\n/g, "<br>").replace(/\\t/g, "&nbsp;&nbsp;&nbsp;&nbsp;").replace(/\\r/g, "");
  }
  createNotifyInstance(t) {
    const e = this, o = Object.assign({
      timeout: 3e3,
      position: "bottom-right",
      showCloseButton: !0,
      safeHtml: !0
    }, this.globalConfig, {
      ...t
    }), i = document.createElement("div");
    i.style.display = "contents";
    const u = F({
      setup() {
        var f;
        const l = v();
        function d() {
          l.value.container.style.transform = "scale(0)", setTimeout(() => {
            e.updateNotifyPositionForClose(o, l), u.unmount();
          }, 220);
        }
        if (o.position.indexOf("top") > -1) {
          const m = e.getNotifyInstances(o.position), h = m[m.length - 1];
          if (h) {
            const p = h.value.container.getBoundingClientRect();
            o.top = p.bottom;
          }
        }
        return o.safeHtml && ((f = o.options) != null && f.message) && (o.options.message = e.escapeAllHtml(o.options.message)), _(() => {
          document.body.removeChild(i);
        }), $(() => {
          e.updateNotifyPositionForCreate(o, l);
        }), () => n(M, {
          mode: "out-in",
          name: "fade",
          appear: !0
        }, {
          default: () => [n(C, j({
            ref: l
          }, o, {
            onClose: d
          }), null)]
        });
      }
    });
    return u.provide("NotifyService", this), document.body.appendChild(i), u.mount(i), u;
  }
  getNotifyInstances(t) {
    return this.notifyRefs.filter((e) => e.value.notifyPosition === t);
  }
  updateNotifyPositionForCreate(t, e) {
    if (this.notifyRefs && this.notifyRefs.length) {
      const a = window.innerHeight;
      t.position.indexOf("bottom") > -1 && this.getNotifyInstances(t.position).forEach((o) => {
        const i = o.value.container.getBoundingClientRect();
        o.value.container.style.bottom = i.height + a - i.bottom + "px";
      });
    }
    this.notifyRefs = [...this.notifyRefs, e];
  }
  updateNotifyPositionForClose(t, e) {
    const a = this.notifyRefs.indexOf(e);
    if (t.position.indexOf("top") > -1) {
      const o = this.getNotifyInstances(t.position), i = o.indexOf(e);
      o.slice(i + 1).forEach((u) => {
        u.value.container.style.top = u.value.container.offsetTop - u.value.container.offsetHeight + "px";
      });
    }
    a > -1 && this.notifyRefs.splice(a, 1);
  }
  show(t) {
    return this.createNotifyInstance(t);
  }
  buildNotifyProps(t, e) {
    let a = "", o = "", i, u, l;
    typeof e == "string" ? a = e : e && (a = e.message || "", o = e.title || "", u = e.position || null, l = e.showCloseButton != null ? e.showCloseButton : null, i = e.timeout != null ? e.timeout : null);
    const f = {
      options: {
        type: t,
        message: a,
        title: o
      }
    };
    return u != null && (f.position = u), l != null && (f.showCloseButton = l), i != null && (f.timeout = i), f;
  }
  info(t) {
    const e = this.buildNotifyProps("info", t);
    return this.show(e);
  }
  success(t) {
    const e = this.buildNotifyProps("success", t);
    return this.show(e);
  }
  warning(t) {
    const e = this.buildNotifyProps("warning", t);
    return this.show(e);
  }
  error(t) {
    const e = this.buildNotifyProps("error", t);
    return this.show(e);
  }
  close(t) {
    t && t.unmount();
  }
  closeAll() {
    this.notifyRefs.forEach((t) => {
      t == null || t.value.closeToast();
    }), this.notifyRefs.length = 0;
  }
}
const D = Symbol("NOTIFY_SERVICE_TOKEN");
C.install = (s) => {
  s.component(C.name, C), s.component(w.name, w);
  const t = new A();
  s.provide(D, t), s.provide("FNotifyService", t);
};
export {
  C as FNotify,
  A as FNotifyService,
  w as FToast,
  D as F_NOTIFY_SERVICE_TOKEN,
  C as default,
  L as notifyProps,
  k as toastProps
};
