var at = Object.defineProperty;
var nt = (e, t, a) => t in e ? at(e, t, { enumerable: !0, configurable: !0, writable: !0, value: a }) : e[t] = a;
var N = (e, t, a) => nt(e, typeof t != "symbol" ? t + "" : t, a);
import { defineComponent as X, ref as o, watch as z, computed as O, onMounted as Q, createVNode as u, nextTick as ue, toRefs as lt, onBeforeMount as re, createTextVNode as G, Fragment as ce, withModifiers as oe, inject as Be, provide as ot, onUnmounted as Te, Teleport as it, Transition as ut, shallowRef as st, createApp as rt, render as he, h as ct, cloneVNode as dt, mergeProps as Fe, reactive as ee } from "vue";
import { isPlainObject as xe, cloneDeep as J, isUndefined as ft } from "lodash-es";
import vt from "../list-view/index.esm.js";
import mt from "../button-edit/index.esm.js";
const pt = {
  /** 接受传入的原始数据的defaultState */
  initialState: { type: Object, default: {} }
}, ht = {
  /** 记录默认模式及分组状态 */
  defaultStates: { type: Object, default: { mode: "" } },
  /** 当前开关模式 */
  onSwitchInStandardModeChanged: { type: Function, default: () => {
  } },
  /** 用户设置的屏幕分辨率变化-例:MD*/
  onCurrentScreenResolutionChanged: { type: Function, default: () => {
  } },
  /** 用户设置的屏幕分辨率缩写变化-例:中等屏幕 */
  onScreenNameChanged: { type: Function, default: () => {
  } }
}, gt = "https://json-schema.org/draft/2020-12/schema", yt = "https://farris-design.gitee.io/capsule.schema.json", bt = "capsule", wt = "A Farris Component", Ct = "object", St = {
  id: {
    description: "The unique identifier for a capsule",
    type: "string"
  },
  type: {
    description: "The type string of capsule component",
    type: "string",
    default: "capsule"
  },
  appearance: {
    description: "",
    type: "object",
    properties: {
      class: {
        type: "string"
      },
      style: {
        type: "string"
      }
    },
    default: {}
  },
  binding: {
    description: "",
    type: "object",
    default: {}
  },
  disable: {
    type: "string",
    default: !1
  },
  editable: {
    description: "",
    type: "boolean",
    default: !0
  },
  placeholder: {
    description: "",
    type: "string",
    default: ""
  },
  readonly: {
    description: "",
    type: "boolean",
    default: !1
  },
  require: {
    description: "",
    type: "boolean",
    default: !1
  },
  tabindex: {
    description: "",
    type: "number",
    default: -1
  },
  visible: {
    description: "",
    type: "boolean",
    default: !0
  }
}, xt = [
  "id",
  "type"
], Mt = {
  $schema: gt,
  $id: yt,
  title: bt,
  description: wt,
  type: Ct,
  properties: St,
  required: xt
}, ke = {}, Ee = {};
function ye(e) {
  const { properties: t, title: a, ignore: n } = e, l = n && Array.isArray(n), s = Object.keys(t).reduce((c, d) => ((!l || !n.find((m) => m === d)) && (c[d] = t[d].type === "object" && t[d].properties ? ye(t[d]) : J(t[d].default)), c), {});
  if (a && (!l || !n.find((c) => c === "id"))) {
    const c = a.toLowerCase().replace(/-/g, "_");
    s.id = `${c}_${Math.random().toString().slice(2, 6)}`;
  }
  return s;
}
function Bt(e) {
  const { properties: t, title: a, required: n } = e;
  if (n && Array.isArray(n)) {
    const l = n.reduce((s, c) => (s[c] = t[c].type === "object" && t[c].properties ? ye(t[c]) : J(t[c].default), s), {});
    if (a && n.find((s) => s === "id")) {
      const s = a.toLowerCase().replace(/-/g, "_");
      l.id = `${s}_${Math.random().toString().slice(2, 6)}`;
    }
    return l;
  }
  return {
    type: a
  };
}
function Re(e, t = {}, a) {
  const n = ke[e];
  if (n) {
    let l = Bt(n);
    const s = Ee[e];
    return l = s ? s({ getSchemaByType: Re }, l, t, a) : l, l;
  }
  return null;
}
function Tt(e, t) {
  const a = ye(t);
  return Object.keys(a).reduce((n, l) => (Object.prototype.hasOwnProperty.call(e, l) && (n[l] && xe(n[l]) && xe(e[l] || !e[l]) ? Object.assign(n[l], e[l] || {}) : n[l] = e[l]), n), a), a;
}
function De(e, t) {
  return Object.keys(e).filter((n) => e[n] != null).reduce((n, l) => {
    if (t.has(l)) {
      const s = t.get(l);
      if (typeof s == "string")
        n[s] = e[l];
      else {
        const c = s(l, e[l], e);
        Object.assign(n, c);
      }
    } else
      n[l] = e[l];
    return n;
  }, {});
}
function Ft(e, t, a = /* @__PURE__ */ new Map()) {
  const n = Tt(e, t);
  return De(n, a);
}
function kt(e = {}) {
  function t(r, v, i, f) {
    if (typeof i == "number")
      return f[r].length === i;
    if (typeof i == "object") {
      const w = Object.keys(i)[0], x = i[w];
      if (w === "not")
        return Number(f[r].length) !== Number(x);
      if (w === "moreThan")
        return Number(f[r].length) >= Number(x);
      if (w === "lessThan")
        return Number(f[r].length) <= Number(x);
    }
    return !1;
  }
  function a(r, v, i, f) {
    return f[r] && f[r].propertyValue && String(f[r].propertyValue.value) === String(i);
  }
  const n = /* @__PURE__ */ new Map([
    ["length", t],
    ["getProperty", a]
  ]);
  Object.keys(e).reduce((r, v) => (r.set(v, e[v]), r), n);
  function l(r, v) {
    const i = r;
    return typeof v == "number" ? [{ target: i, operator: "length", param: null, value: Number(v) }] : typeof v == "boolean" ? [{ target: i, operator: "getProperty", param: r, value: !!v }] : typeof v == "object" ? Object.keys(v).map((f) => {
      if (f === "length")
        return { target: i, operator: "length", param: null, value: v[f] };
      const w = f, x = v[f];
      return { target: i, operator: "getProperty", param: w, value: x };
    }) : [];
  }
  function s(r) {
    return Object.keys(r).reduce((i, f) => {
      const w = l(f, r[f]);
      return i.push(...w), i;
    }, []);
  }
  function c(r, v) {
    if (n.has(r.operator)) {
      const i = n.get(r.operator);
      return i && i(r.target, r.param, r.value, v) || !1;
    }
    return !1;
  }
  function d(r, v) {
    return s(r).reduce((w, x) => w && c(x, v), !0);
  }
  function m(r, v) {
    const i = Object.keys(r), f = i.includes("allOf"), w = i.includes("anyOf"), x = f || w, F = (x ? r[x ? f ? "allOf" : "anyOf" : "allOf"] : [r]).map((B) => d(B, v));
    return f ? !F.includes(!1) : F.includes(!0);
  }
  return { parseValueSchema: m };
}
const Et = {}, Rt = {};
kt();
function ae(e, t, a = /* @__PURE__ */ new Map(), n = (c, d, m, r) => d, l = {}, s = (c) => c) {
  return ke[t.title] = t, Ee[t.title] = n, Et[t.title] = l, Rt[t.title] = s, (c = {}, d = !0) => {
    if (!d)
      return De(c, a);
    const m = Ft(c, t, a), r = Object.keys(e).reduce((v, i) => (v[i] = e[i].default, v), {});
    return Object.assign(r, m);
  };
}
function ne(e, t) {
  return { customClass: t.class, customStyle: t.style };
}
const Dt = /* @__PURE__ */ new Map([
  ["appearance", ne]
]);
function Ot(e, t, a) {
  return t;
}
const $t = "capsule", At = "A Farris Component", jt = "object", It = {
  basic: {
    description: "Basic Infomation",
    title: "基本信息",
    properties: {
      id: {
        description: "组件标识",
        title: "标识",
        type: "string",
        readonly: !0
      },
      type: {
        description: "组件类型",
        title: "控件类型",
        type: "select",
        editor: {
          type: "waiting for modification",
          enum: []
        }
      }
    }
  }
}, Lt = {
  title: $t,
  description: At,
  type: jt,
  categories: It
}, Oe = {
  items: {
    Type: Array,
    default: [
      { name: "升序", value: "asc", icon: "f-icon f-icon-col-ascendingorder" },
      { name: "降序", value: "desc", icon: "f-icon f-icon-col-descendingorder" }
    ]
  },
  /**
   * 组件值
   */
  modelValue: { type: String, default: "" },
  type: { type: String, default: "primary" }
}, Vt = {
  name: { type: String, default: "" },
  value: { type: String, default: "" },
  isActive: { type: Boolean, default: !1 },
  icon: { type: String, default: "" },
  index: { type: Number, default: 0 },
  show: { type: Boolean, default: !0 },
  disabled: { type: Boolean, default: !1 }
};
ae(Oe, Mt, Dt, Ot, Lt);
const zt = /* @__PURE__ */ X({
  name: "FCapsuleItem",
  props: Vt,
  emits: ["mounted", "active"],
  setup(e, t) {
    const a = o(), n = o(e.isActive);
    z(() => e.isActive, (c) => {
      n.value = c;
    });
    const l = O(() => ({
      "f-capsule-item": !0,
      "f-capsule-active-item": n.value,
      "f-capsule-disabled": e.disabled
    }));
    Q(() => {
      t.emit("mounted", a, e.value);
    });
    function s(c) {
      e.disabled || t.emit("active", c, {
        name: e.name,
        value: e.value
      });
    }
    return () => u("div", {
      ref: a,
      class: l.value,
      onClick: (c) => s(c)
    }, [e.icon && u("i", {
      class: e.icon
    }, null), e.name]);
  }
}), Ht = /* @__PURE__ */ X({
  name: "FCapsule",
  props: Oe,
  emits: ["change", "update:modelValue"],
  setup(e, t) {
    const a = o(e.items), n = o(), l = 2, s = o(e.modelValue), c = o("none"), d = o(e.type), m = O(() => {
      const h = {
        "f-capsule-container": !0
      };
      return d.value && (h[d.value] = !0), h;
    }), r = O(() => ({})), v = O(() => ({
      "f-capsule": !0
    })), i = o(l), f = o(0), w = o(0), x = O(() => ({
      left: `${i.value}px`,
      width: `${f.value}px`,
      transition: c.value
    })), R = O(() => ({
      width: `${w.value}px`
    })), C = /* @__PURE__ */ new Map();
    function F(h) {
      var g;
      if (C.has(h.value)) {
        const y = (g = C.get(h.value)) == null ? void 0 : g.value;
        if (y) {
          const M = y.getBoundingClientRect(), j = n.value.getBoundingClientRect();
          i.value = M.left - j.left + l + n.value.scrollLeft, f.value = M.width - 2 * l;
        }
      }
    }
    function E(h, g) {
      const y = h.value;
      s.value = y, t.emit("update:modelValue", y), F(h), g && t.emit("change", y);
    }
    function B(h) {
      const g = a.value.findIndex((y) => y.value === h);
      g > -1 && E(a.value[g], !1);
    }
    z(() => e.modelValue, (h) => {
      s.value = h, B(s.value);
    }), Q(async () => {
      B(s.value), await ue(), c.value = "0.1s ease-out all", w.value = Array.from(C.values()).reduce((h, g) => (h += g.value.clientWidth, h), 0);
    });
    function V(h, g) {
      E(g, !0);
    }
    function D(h, g) {
      C.set(g, h);
    }
    function L(h) {
      Array.from(C.keys()).forEach((g) => {
        h.find((M) => M.value === g) || C.delete(g);
      });
    }
    function p(h, g) {
      return u(zt, {
        name: h.name,
        value: h.value,
        isActive: h.value === s.value,
        index: g,
        disabled: h.disabled,
        key: h.value,
        onMounted: D,
        onActive: V
      }, null);
    }
    return z(() => e.items, async (h) => {
      const g = h.filter((y) => y.show);
      L(g), a.value = g, await ue(), B(s.value), w.value = Array.from(C.values()).reduce((y, M) => (y += M.value.clientWidth, y), 0);
    }), () => u("span", {
      ref: n,
      class: m.value,
      style: r.value
    }, [u("span", {
      class: "f-capsule-pane"
    }, [a.value.map((h, g) => p(h, g))]), u("small", {
      class: v.value,
      style: x.value
    }, null), u("div", {
      class: "f-capsule-board",
      style: R.value
    }, null)]);
  }
}), Pt = /* @__PURE__ */ new Map([
  ["appearance", ne]
]), Nt = "https://json-schema.org/draft/2020-12/schema", Wt = "https://farris-design.gitee.io/switch.schema.json", qt = "switch", Ut = "A Farris Component", Gt = "object", Xt = {
  id: {
    description: "The unique identifier for a switch",
    type: "string"
  },
  type: {
    description: "The type string of switch component",
    type: "string",
    default: "switch"
  },
  appearance: {
    description: "",
    type: "object",
    properties: {
      class: {
        type: "string"
      },
      style: {
        type: "string"
      }
    },
    default: {}
  },
  binding: {
    description: "",
    type: "object",
    default: {}
  },
  disabled: {
    type: "boolean",
    default: !1
  },
  onBackground: {
    description: "",
    type: "string",
    default: ""
  },
  offBackground: {
    description: "",
    type: "string",
    default: ""
  },
  onColor: {
    description: "",
    type: "string",
    default: ""
  },
  offColor: {
    description: "",
    type: "string",
    default: ""
  },
  onLabel: {
    description: "",
    type: "string",
    default: ""
  },
  offLabel: {
    description: "",
    type: "string",
    default: ""
  },
  readonly: {
    description: "",
    type: "boolean",
    default: !1
  },
  size: {
    description: "",
    type: "enum",
    default: "medium"
  },
  required: {
    description: "",
    type: "boolean",
    default: !1
  }
}, Yt = [
  "type"
], _t = [
  "id",
  "appearance",
  "binding"
], Jt = {
  $schema: Nt,
  $id: Wt,
  title: qt,
  description: Ut,
  type: Gt,
  properties: Xt,
  required: Yt,
  ignore: _t
};
function Qt(e, t, a) {
  return t;
}
const $e = {
  modelValue: { type: Boolean, default: !1 },
  /** 禁用 */
  disabled: { type: Boolean, default: !1 },
  /**
   * 同disabled 
   */
  readonly: { type: Boolean, default: !1 },
  onBackground: { type: String },
  offBackground: { type: String },
  onColor: { type: String },
  offColor: { type: String },
  onLabel: { type: String },
  offLabel: { type: String },
  /** 尺寸大小 */
  size: { type: String, default: "medium" },
  /** 开关值变化事件 */
  onModelValueChanged: { type: Function, default: () => {
  } },
  focusOnCreated: { type: Boolean, default: !1 }
};
ae($e, Jt, Pt, Qt);
const Zt = /* @__PURE__ */ X({
  name: "FSwitch",
  props: $e,
  emits: ["update:modelValue", "modelValueChanged"],
  setup(e, t) {
    const {
      disabled: a,
      size: n,
      onLabel: l,
      offLabel: s,
      onBackground: c,
      offBackground: d,
      onColor: m,
      offColor: r,
      readonly: v
    } = lt(e), i = o(!!e.modelValue), f = o(), w = O(() => ({
      switch: !0,
      "f-cmp-switch": !0,
      checked: i.value,
      disabled: v.value || a.value,
      "switch-large": n.value === "large",
      "switch-medium": n.value === "medium",
      "switch-small": n.value === "small"
    })), x = O(() => i.value ? {
      outline: "none",
      background: c.value
    } : {
      outline: "none",
      backgroundColor: d.value
    }), R = O(() => i.value ? {
      background: m.value
    } : {
      backgroundColor: r.value
    }), C = O(() => (l == null ? void 0 : l.value) || (s == null ? void 0 : s.value));
    function F() {
      v.value || a.value || (i.value = !i.value, t.emit("update:modelValue", i.value));
    }
    return z(i, (E, B) => {
      E !== B && t.emit("modelValueChanged", E);
    }), z(() => e.modelValue, (E, B) => {
      E !== B && (i.value = E);
    }), Q(() => {
      var E;
      e.focusOnCreated && ((E = f.value) == null || E.focus());
    }), () => u("span", {
      ref: f,
      tabindex: "0",
      role: "button",
      class: w.value,
      style: x.value,
      onClick: F
    }, [C.value && u("span", {
      class: "switch-pane"
    }, [u("span", {
      class: "switch-label-checked"
    }, [l == null ? void 0 : l.value]), u("span", {
      class: "switch-label-unchecked"
    }, [s == null ? void 0 : s.value])]), u("small", {
      style: R.value
    }, [t.slots.default && t.slots.default()])]);
  }
}), Kt = /* @__PURE__ */ X({
  name: "FScreenResolutionSelector",
  props: ht,
  emits: ["screenNameChanged", "currentScreenResolutionChanged", "switchInStandardModeChanged"],
  setup(e, t) {
    const a = o([{
      name: "小屏幕",
      code: "SM",
      value: "SM",
      active: !1
    }, {
      name: "中等屏幕",
      code: "MD",
      value: "MD",
      active: !0
    }, {
      name: "大屏幕",
      code: "LG",
      value: "LG",
      active: !1
    }, {
      name: "极大屏幕",
      code: "EL",
      value: "EL",
      active: !1
    }]), n = o(e.defaultStates), l = o("MD"), s = o("中等屏幕"), c = o(!0);
    function d(v) {
      a.value.forEach((i) => {
        i.active = i.code === v, i.active && (l.value = i.code, s.value = i.name, t.emit("screenNameChanged", s.value), t.emit("currentScreenResolutionChanged", l.value));
      });
    }
    function m() {
      t.emit("switchInStandardModeChanged", c.value);
    }
    z(c, () => {
    }), re(() => {
      n.value.model === "standard" ? c.value = !0 : (c.value = !1, m());
    });
    function r() {
      return u(Ht, {
        class: "f-layout-editor-screen-resolution-selector-frame",
        items: a.value,
        modelValue: l.value,
        "onUpdate:modelValue": (v) => l.value = v,
        onChange: d
      }, null);
    }
    return () => u("div", {
      class: "f-layout-editor-screen-resolution-selector"
    }, [u("div", {
      class: "f-layout-editor-screen-resolution-selector-header"
    }, [u("div", {
      class: "f-layout-editor-screen-resolution-selector-form"
    }, [G("表单布局配置")])]), r(), u("div", {
      class: "f-layout-editor-screen-resolution-selector-switch"
    }, [u(Zt, {
      class: "f-layout-editor-show-switch",
      modelValue: c.value,
      "onUpdate:modelValue": (v) => c.value = v,
      onModelValueChanged: m
    }, null), c.value ? u("div", {
      class: "f-layout-editor-show-switch-label"
    }, [G("标准模式")]) : u("div", {
      class: "f-layout-editor-show-switch-label"
    }, [G("自定义模式")])])]);
  }
}), ea = {
  /** 默认屏幕分辨率对应的英文缩写 */
  currentScreenResolution: { type: String, default: "" },
  /** 模式开关 */
  switchInStandardMode: { type: Boolean, default: !1 },
  /** 记录当前展示的区域 */
  currentArea: { type: Object, default: [] },
  /** 接受组件列表区传入的二维数组 */
  twoDimensionalArray: { type: Array, default: [] }
}, ta = {
  /** 单个组件的预览状态 */
  item: { type: Object, default: {} },
  /** 默认屏幕分辨率对应的英文缩写 */
  currentScreenResolution: { type: String, default: "" },
  /** 接受switch状态，若为自定义模式，则需要改变Col-num的num来源；*/
  switchInStandardMode: { type: Boolean, default: !1 }
}, aa = /* @__PURE__ */ X({
  name: "FColumnWidthView",
  props: ta,
  emits: [],
  setup(e, t) {
    const a = o(e.item), n = o(e.currentScreenResolution), l = O(() => `col-${a.value[`columnIn${n.value}`]}`);
    return z([() => e.item, () => e.currentScreenResolution], ([s, c], [d, m]) => {
      s !== d && (a.value = s), c !== m && (n.value = c);
    }), () => u("div", {
      class: l.value
    }, [u("div", {
      class: "f-layout-editor-column-width-view",
      title: a.value.label
    }, [u("div", {
      class: "f-layout-editor-column-width-view-label"
    }, [a.value.label])])]);
  }
}), na = /* @__PURE__ */ X({
  name: "FPreview",
  props: ea,
  emits: ["update:twoDimensionalArray"],
  setup(e, t) {
    const a = o(e.currentScreenResolution), n = o(e.switchInStandardMode), l = o(e.currentArea), s = o(e.twoDimensionalArray), c = o([]);
    z([() => e.currentArea, () => e.switchInStandardMode, () => e.currentScreenResolution], ([i, f, w], [x, R, C]) => {
      i !== x && (l.value = i), f !== R && (n.value = f), w !== C && (a.value = w);
    });
    function d(i, f) {
      const w = [];
      let x = [];
      return i.forEach((R) => {
        f !== R.componentRow && (f += 1, w.push(x), x = []), x.push(R);
      }), w.push(x), w;
    }
    function m() {
      const i = [];
      let f = 1;
      return c.value.forEach((w) => {
        const x = d(w, f);
        f += x.length, i.push(x);
      }), i;
    }
    function r() {
      c.value = J(s.value), c.value = m();
    }
    z(() => e.twoDimensionalArray, () => {
      s.value = e.twoDimensionalArray, r();
    }), Q(() => {
      r();
    });
    function v() {
      if (n.value)
        return "";
      const i = Array.from({
        length: 12
      }, () => u("div", {
        class: "col-1"
      }, [u("div", {
        class: "f-layout-editor-preview-customize-single-background"
      }, [G(" ")])]));
      return u("div", {
        class: "f-layout-editor-preview-customize-whole-background"
      }, [i]);
    }
    return () => u("div", {
      class: "f-layout-editor-preview f-utils-fill-flex-column"
    }, [u("div", {
      class: "f-layout-editor-preview-header"
    }, [G("预览区")]), v(), u("div", {
      class: "f-layout-editor-preview-view f-utils-overflow-xhya"
    }, [u("div", {
      class: "f-layout-editor-preview-row-group"
    }, [c.value.map((i) => {
      var f, w;
      return ((f = i[0][0]) == null ? void 0 : f.group.toString()) === ((w = l.value[0]) == null ? void 0 : w.id) && i.map((x) => u("div", {
        class: "f-layout-editor-row"
      }, [x.map((R) => u(aa, {
        item: R,
        "onUpdate:item": (C) => R = C,
        currentScreenResolution: a.value,
        switchInStandardMode: n.value
      }, null))]));
    })])])]);
  }
}), la = {
  /** 用户切换屏幕分辨率-缩写-例:MD； */
  currentScreenResolution: { type: String, default: "" },
  /** 检测用户是否切换模式 */
  switchInStandardMode: { type: Boolean, default: !1 },
  /** 输入的控件原始数据 */
  originalData: { type: Array, default: [] },
  /** 在用户切换模式时显示原数据，确保两个模式下的数据不互通 */
  originalDataCopy: { type: Array, default: [] },
  /** 默认状态：包括defaultGroupNumber(默认显示组)及mode(当前模式：standard或customize) */
  defaultStates: { type: Object, default: {} },
  /** twoDimensionalArray值变化事件 */
  onTwoDimensionalArrayChanged: { type: Function, default: () => {
  } },
  /** originalData值变化事件 */
  onOriginalDataChanged: { type: Function, default: () => {
  } }
};
function oa(e, t) {
  const a = o(-1), n = o(!1);
  function l(i) {
    if (i.target.offsetParent) {
      const f = i.target.offsetParent, w = f.offsetWidth - i.target.offsetWidth / 2 - 4, x = f.offsetHeight / 2;
      i.dataTransfer && i.dataTransfer.setDragImage(f, w, x);
    }
  }
  function s(i) {
    if (i) {
      const f = e.value.findIndex((w) => w.label === i.label);
      setTimeout(() => {
        a.value = f, n.value = !0, i.moving = !0;
      });
    }
  }
  function c(i, f) {
    i.stopPropagation(), l(i), s(f);
  }
  function d(i) {
    const f = e.value.findIndex((w) => w.label === i.label);
    if (a.value !== f) {
      const w = e.value[a.value], x = e.value;
      x.splice(a.value, 1), x.splice(f, 0, w), a.value = f, t && t();
    }
  }
  function m(i, f) {
    i.preventDefault(), d(f);
  }
  function r(i) {
    i.preventDefault(), i.dataTransfer && (i.dataTransfer.dropEffect = "move");
  }
  function v(i, f) {
    f && (f.moving = !1), n.value = !1;
  }
  return {
    dragstart: c,
    dragenter: m,
    dragover: r,
    dragend: v,
    isDragging: n
  };
}
const ia = /* @__PURE__ */ new Map([
  ["appearance", ne]
]), ua = "https://json-schema.org/draft/2020-12/schema", sa = "https://farris-design.gitee.io/combo-list.schema.json", ra = "combo-list", ca = "A Farris Input Component", da = "object", fa = {
  id: {
    description: "The unique identifier for a combo list",
    type: "string"
  },
  type: {
    description: "The type string of number combo list component",
    type: "string",
    default: "combo-list"
  },
  appearance: {
    description: "",
    type: "object",
    properties: {
      class: {
        type: "string"
      },
      style: {
        type: "string"
      }
    },
    default: {}
  },
  binding: {
    description: "",
    type: "object",
    default: {}
  },
  disabled: {
    description: "",
    type: "boolean",
    default: !1
  },
  enableClear: {
    description: "",
    type: "boolean",
    default: !1
  },
  editable: {
    description: "",
    type: "boolean",
    default: !1
  },
  enableLinkLabel: {
    description: "",
    type: "boolean",
    default: !1
  },
  label: {
    description: "",
    type: "string",
    default: ""
  },
  lableWidth: {
    description: "",
    type: "number"
  },
  placeholder: {
    description: "",
    type: "string",
    default: "请选择"
  },
  idField: {
    description: "",
    type: "string",
    default: "id"
  },
  valueField: {
    description: "",
    type: "string",
    default: "id"
  },
  titleField: {
    description: "",
    type: "string",
    default: "name"
  },
  textField: {
    description: "",
    type: "string",
    default: "name"
  },
  dataSourceType: {
    description: "",
    type: "string",
    default: "static"
  },
  data: {
    description: "",
    type: "array"
  },
  remote: {
    description: "",
    type: "string"
  },
  readonly: {
    description: "",
    type: "boolean",
    default: !1
  },
  required: {
    description: "",
    type: "boolean",
    default: !1
  },
  tabindex: {
    description: "",
    type: "number",
    default: -1
  },
  textAlign: {
    description: "",
    type: "string",
    enum: [
      "left",
      "middle",
      "right"
    ],
    default: "left"
  },
  multiSelect: {
    description: "",
    type: "boolean",
    default: !1
  },
  maxLength: {
    description: "",
    type: "number",
    default: null
  },
  visible: {
    description: "",
    type: "boolean",
    default: !0
  },
  onBlur: {
    description: "",
    type: "string",
    default: ""
  },
  onClickLinkLabel: {
    description: "",
    type: "sting",
    default: ""
  },
  maxHeight: {
    description: "",
    type: "number",
    default: 350
  },
  minPanelWidth: {
    description: "",
    type: "number",
    default: 160
  },
  popupOnClick: {
    description: "",
    type: "boolean",
    default: !0
  },
  separator: {
    description: "",
    type: "string",
    default: ","
  }
}, va = [
  "type"
], ma = [
  "id",
  "appearance",
  "binding",
  "visible"
], pa = {
  $schema: ua,
  $id: sa,
  title: ra,
  description: ca,
  type: da,
  properties: fa,
  required: va,
  ignore: ma
};
function ha(e, t, a) {
  return t;
}
const be = {
  /**
   * 组件标识
   */
  id: { type: String },
  /**
   * 下拉数据源
   */
  data: { type: Array, default: [] },
  /**
   * 可选，展示文本
   * 默认为空字符串 -----内部需要根据value重新生成展示文本，此属性不生效
   * displayText: { type: String, default: '' },
  */
  /**
   * 可选，是否禁用
   * 默认为`false`
   */
  disabled: { default: !1, type: Boolean },
  /**
   * 可选，下拉图标
   * 默认为'<span class="f-icon f-icon-arrow-60-down"></span>'
   */
  dropDownIcon: { type: String, default: '<span class="f-icon f-icon-arrow-60-down"></span>' },
  /**
   * 可选，是否可编辑
   * 默认`false`
   */
  editable: { default: !1, type: Boolean },
  /**
   * 可选，是否启用清空
   * 默认启用
   */
  enableClear: { default: !0, type: Boolean },
  /**
   * 可选，启用搜索
   * 默认为`false`
   */
  enableSearch: { type: Boolean, default: !1 },
  /**
   * 可选，鼠标悬停时是否显示控件值
   * 默认显示
   */
  enableTitle: { default: !0, type: Boolean },
  fitEditor: { default: !1, type: Boolean },
  /**
   * 可选，强制显示占位符
   * 默认`false`
   */
  forcePlaceholder: { default: !1, type: Boolean },
  /**
   * 可选，清空值时隐藏面板
   * 默认`true`
   */
  hidePanelOnClear: { default: !0, type: Boolean },
  /**
   * 可选，数据源id字段
   * 默认为`id`
   */
  idField: { default: "id", type: String },
  /**
   * 可选，字段映射
   */
  mapFields: { type: Object },
  /**
   * 可选，最大高度
   * 默认`350`
   */
  maxHeight: { default: 350, type: Number },
  /**
   * 最大输入长度
   */
  maxLength: { type: Number },
  /**
   * 可选，是否支持多选
   * 默认`false`
   */
  multiSelect: { type: Boolean, default: !1 },
  /**
   * 绑定值
   */
  modelValue: {},
  /**
   * 占位符
   */
  placeholder: { type: String, default: "请选择" },
  /**
   * 可选，下拉面板展示位置
   * 默认为`auto`
   */
  placement: {
    type: String,
    default: "auto"
    /* auto */
  },
  /**
   * 可选，是否只读
   * 默认为`false`
   */
  readonly: { default: !1, type: Boolean },
  /**
   * 远端数据源信息
   */
  remote: { default: null, type: Object },
  /**
   * 可选，是否支持远端过滤
   * 默认`false`
   */
  remoteSearch: { default: !1, type: Boolean },
  /**
   * 可选，分隔符
   * 默认`,`
   */
  separator: { default: ",", type: String },
  /**
   * tabIndex
   */
  tabIndex: { type: Number, default: -1 },
  /**
   * 可选，数据源显示字段
   * 默认为`name`
   */
  textField: { default: "name", type: String },
  /**
   * 可选，数据源的title
   * 默认为`name`
   */
  titleField: { default: "name", type: String },
  /**
   * 可选，数据源值字段
   * 默认为`id`
   */
  valueField: { default: "id", type: String },
  /**
   * 可选，启用多选下，下拉列表值在输入框中的展示方式
   * 支持text | tag
   * 因为ButtonEdit内部处理类型只有在批量的情况下才会有展示类型区分
   */
  viewType: { default: "tag", type: String },
  /**
   * 值变化事件
   */
  change: { type: Function, default: () => {
  } },
  /**
   * 作为内嵌编辑器被创建后默认获得焦点
   */
  focusOnCreated: { type: Boolean, default: !1 },
  /**
   * 作为内嵌编辑器被创建后默认选中文本
   */
  selectOnCreated: { type: Boolean, default: !1 },
  /**
   * 此属性废弃
   */
  autoHeight: { type: Boolean, default: !0 },
  /**
   * 打开前
   */
  beforeOpen: { type: Function, default: null },
  searchOption: {
    type: [Boolean, Function],
    default: !1
  },
  // 搜索启用高亮
  enableHighlightSearch: { type: Boolean, default: !0 },
  minPanelWidth: { type: Number, default: 160 },
  popupOnClick: { type: Boolean, default: !0 }
};
Object.assign({}, be, {
  readonly: {}
});
ae(be, pa, ia, ha);
const ga = {
  dataSource: { type: Array, default: [] },
  enableSearch: { type: Boolean, default: !1 },
  idField: { type: String, default: "id" },
  multiSelect: { type: Boolean, default: !1 },
  selectedValues: { type: String, default: "" },
  separator: { type: String, default: "," },
  textField: { type: String, default: "name" },
  titleField: { type: String, default: "name" },
  width: { type: Number },
  maxHeight: { type: Number },
  valueField: { type: String, default: "id" },
  /** 值变化事件 */
  onSelectionChange: { type: Function, default: () => {
  } },
  searchOption: {
    type: [Boolean, Function],
    default: !1
  },
  // 搜索启用高亮
  enableHighlightSearch: { type: Boolean, default: !0 }
}, ya = /* @__PURE__ */ X({
  name: "FComboListContainer",
  props: ga,
  emits: ["selectionChange"],
  setup(e, t) {
    const a = o(), n = o(e.dataSource), l = o([]), s = o(e.separator), c = o(e.width), d = o(e.maxHeight), m = o(String(e.selectedValues).split(s.value)), r = O(() => e.multiSelect), v = O(() => ({
      enableSelectRow: !0,
      multiSelect: e.multiSelect,
      multiSelectMode: "OnCheckAndClick",
      showCheckbox: r.value,
      showSelectAll: !1,
      showSelection: !0
    }));
    z(e.dataSource, () => {
      n.value = e.dataSource;
    }), O(() => e.enableSearch ? "SearchBar" : "ContentHeader");
    const i = O(() => {
      const C = {};
      return c.value !== void 0 && (C.width = `${c.value}px`), d.value !== void 0 && d.value > 0 && (C.maxHeight = `${d.value}px`), C;
    });
    function f(C) {
      a.value.search(C);
    }
    function w(C) {
      l.value = C.map((F) => Object.assign({}, F)), m.value = C.map((F) => F[e.idField]), t.emit("selectionChange", l.value);
    }
    function x(C) {
      if (e.enableHighlightSearch)
        return;
      let F = [];
      const {
        searchOption: E
      } = e;
      typeof E == "function" ? F = n.value.filter((B) => E(C, B)) : F = n.value.filter((B) => B[e.valueField].indexOf(C) > -1 || B[e.textField].indexOf(C) > -1), a.value.updateDataSource(F);
    }
    z([() => e.selectedValues], ([C]) => {
      e.multiSelect ? m.value = C.split(s.value) : m.value = [C];
    });
    function R(C) {
      a.value.activeRowById(C);
    }
    return Q(() => {
      var C, F;
      if (!e.multiSelect) {
        const E = (C = m.value) == null ? void 0 : C[0];
        let B = E;
        if (!ft(E)) {
          const V = typeof E, D = typeof ((F = n.value[0]) == null ? void 0 : F[e.valueField || e.idField]);
          D === "number" && V !== D && (B = Number(E)), D === "boolean" && V !== D && (B = E === "true" ? !0 : E === "false" ? !1 : E), R(B);
        }
      }
    }), t.expose({
      search: f,
      activeRowById: R
    }), () => u("div", {
      class: "f-combo-list-container",
      style: i.value
    }, [u(vt, {
      ref: a,
      size: "small",
      itemClass: "f-combo-list-item",
      itemContentClass: "text-truncate",
      header: "ContentHeader",
      headerClass: "f-combo-list-search-box",
      data: n.value,
      idField: e.idField,
      textField: e.textField,
      titleField: e.titleField,
      multiSelect: e.multiSelect,
      selection: v.value,
      enableHighlightSearch: e.enableHighlightSearch,
      selectionValues: m.value,
      onSelectionChange: w,
      onAfterSearch: x
    }, null)]);
  }
});
function ba(e) {
  const t = o(""), a = o(e.modelValue), n = o(e.data || []), l = o(e.editable);
  function s(i) {
    const f = e.multiSelect ? String(i).split(e.separator) : [String(i)], w = f.map((C) => [C, !0]), x = new Map(w);
    return n.value.filter((C) => x.has(String(C[e.valueField]))).sort((C, F) => {
      const E = f.indexOf(C[e.valueField]), B = f.indexOf(F[e.valueField]);
      return E - B;
    });
  }
  function c(i) {
    const f = s(i).map((w) => w[e.textField]).join(e.separator);
    t.value = l.value ? f || i : f;
  }
  function d(i) {
    if (e.multiSelect) {
      const f = i.split(e.separator).map((x) => [x, !0]), w = new Map(f);
      return n.value.filter((x) => w.has(x[e.textField]));
    }
    return n.value.filter((f) => "" + f[e.textField] === i);
  }
  function m(i) {
    const f = {};
    return f[e.idField] = i, f[e.textField] = i, [f];
  }
  function r(i) {
    let f = d(i);
    const w = f && f.length > 0;
    return l.value && !w && (f = m(i)), f;
  }
  function v() {
    const { url: i, method: f = "GET", headers: w = {}, body: x = null } = e.remote, R = f.toLowerCase() === "get" ? { method: f, headers: w } : { method: f, headers: w, body: x };
    let C = !1;
    fetch(i, R).then((F) => {
      var B, V;
      if (F.status === 200)
        return C = !!((V = (B = F.headers) == null ? void 0 : B.get("content-type")) != null && V.includes("application/json")), C ? F.text() : F.json();
      throw new Error(F.statusText);
    }).then((F) => {
      n.value = C ? JSON.parse(F) : F;
    }).catch((F) => {
      console.error(F);
    });
  }
  return e.remote && v(), z(() => e.data, () => {
    n.value = e.data;
  }), z([n], ([i]) => {
    if (e.modelValue != null) {
      const f = i.find((w) => w[e.valueField] === e.modelValue);
      f && (t.value = f[e.textField]);
    }
  }), z(() => e.modelValue, (i) => {
    a.value = i, c(i);
  }), c(e.modelValue), { dataSource: n, displayText: t, editable: l, modelValue: a, getItemsByDisplayText: d, getItemsByValue: s, getSelectedItemsByDisplayText: r };
}
const wa = /* @__PURE__ */ X({
  name: "FComboList",
  props: be,
  emits: ["clear", "update:modelValue", "change", "input"],
  setup(e, t) {
    const a = o(), n = o(), l = o(e.disabled || e.readonly), s = o(e.enableClear), c = o(e.enableSearch), d = o(e.readonly), {
      dataSource: m,
      displayText: r,
      editable: v,
      modelValue: i,
      getSelectedItemsByDisplayText: f,
      getItemsByDisplayText: w
    } = ba(e), x = O(() => e.multiSelect), R = O(() => n.value ? n.value.elementRef.getBoundingClientRect().width : 0);
    function C() {
      !x.value && n.value && n.value.hidePopup();
    }
    function F(y) {
      r.value = y.map((j) => j[e.textField]).join(e.separator);
      let M = "";
      y.length === 1 ? M = y[0][e.valueField] : M = y.map((j) => j[e.valueField]).join(e.separator), i.value !== M && (i.value = M, t.emit("update:modelValue", i.value), t.emit("change", y, i.value));
    }
    function E() {
      const y = f(r.value);
      F(y);
    }
    function B() {
      d.value || r.value;
    }
    function V(y) {
      var M;
      i.value = "", (M = a.value) == null || M.activeRowById(""), t.emit("update:modelValue", ""), t.emit("change", [], ""), t.emit("clear");
    }
    function D(y) {
      var M, j;
      e.enableSearch ? ((M = a.value) == null || M.search(y), (j = a.value) == null || j.activeRowById(y)) : (i.value = y, r.value = y, t.emit("update:modelValue", i.value), t.emit("change", [y], y));
    }
    function L(y) {
      if (e.multiSelect) {
        const M = w(y), U = M.map((k) => k[e.idField || e.valueField]).join(e.separator);
        i.value !== U && (i.value = U, t.emit("update:modelValue", i.value), t.emit("change", M, i.value));
      }
    }
    function p() {
      return r.value;
    }
    function h(y) {
      D(y), t.emit("input", y);
    }
    function g() {
      n.value.hidePopup();
    }
    return t.expose({
      getDisplayText: p,
      hidePopup: g
    }), z([() => e.disabled, () => e.editable, () => e.enableClear, () => e.enableSearch, () => e.readonly], ([y, M, j, U, k]) => {
      l.value = y, v.value = M, s.value = j, c.value = U, d.value = k;
    }), () => u(mt, {
      ref: n,
      id: e.id,
      disable: l.value,
      readonly: d.value,
      forcePlaceholder: e.forcePlaceholder,
      editable: v.value,
      buttonContent: e.dropDownIcon,
      placeholder: e.placeholder,
      enableClear: s.value,
      maxLength: e.maxLength,
      tabIndex: e.tabIndex,
      enableTitle: e.enableTitle,
      multiSelect: e.multiSelect,
      inputType: e.multiSelect ? e.viewType : "text",
      modelValue: r.value,
      "onUpdate:modelValue": (y) => r.value = y,
      focusOnCreated: e.focusOnCreated,
      selectOnCreated: e.selectOnCreated,
      onClear: V,
      onClick: B,
      onChange: L,
      onBlur: E,
      onInput: h,
      beforeOpen: e.beforeOpen,
      placement: e.placement,
      popupMinWidth: e.minPanelWidth,
      popupClass: "f-combo-list-wrapper",
      popupOnClick: e.popupOnClick
    }, {
      default: () => [u(ya, {
        ref: a,
        idField: e.idField,
        valueField: e.valueField,
        textField: e.textField,
        titleField: e.titleField,
        dataSource: m.value,
        selectedValues: i.value,
        separator: e.separator,
        multiSelect: e.multiSelect,
        enableSearch: c.value,
        maxHeight: e.maxHeight,
        enableHighlightSearch: e.enableHighlightSearch,
        width: e.fitEditor ? R.value : void 0,
        onSelectionChange: (y) => {
          F(y), C();
        }
      }, null)]
    });
  }
}), Ca = {
  /** 默认屏幕分辨率对应的英文缩写 */
  currentScreenResolution: { type: String, default: "" },
  /** 传入的单个控件的响应式列宽值 */
  field: { type: Object, default: {} },
  /** 模式开关 */
  switchInStandardMode: { type: Boolean, default: !1 },
  /** 列数值变化事件 */
  fieldChanged: { type: Function, default: () => {
  } }
}, Sa = /* @__PURE__ */ new Map([
  ["appearance", ne]
]);
function xa(e, t, a) {
  return t;
}
const Ma = "https://json-schema.org/draft/2020-12/schema", Ba = "https://farris-design.gitee.io/radio-button.schema.json", Ta = "radio-button", Fa = "A Farris Component", ka = "object", Ea = {
  id: {
    description: "The unique identifier for radio-button",
    type: "string"
  },
  type: {
    description: "The type string of radio-button",
    type: "string",
    default: "radio-button"
  },
  appearance: {
    description: "",
    type: "object",
    properties: {
      class: {
        type: "string"
      },
      style: {
        type: "string"
      }
    },
    default: {}
  },
  binding: {
    description: "",
    type: "object",
    default: {}
  },
  disable: {
    type: "string",
    default: !1
  },
  editable: {
    description: "",
    type: "boolean",
    default: !0
  },
  placeholder: {
    description: "",
    type: "string",
    default: ""
  },
  readonly: {
    description: "",
    type: "boolean",
    default: !1
  },
  require: {
    description: "",
    type: "boolean",
    default: !1
  },
  tabindex: {
    description: "",
    type: "number",
    default: -1
  },
  visible: {
    description: "",
    type: "boolean",
    default: !0
  }
}, Ra = [
  "id",
  "type"
], Da = {
  $schema: Ma,
  $id: Ba,
  title: Ta,
  description: Fa,
  type: ka,
  properties: Ea,
  required: Ra
}, Oa = "radio-button", $a = "A Farris Component", Aa = "object", ja = {
  basic: {
    description: "Basic Infomation",
    title: "基本信息",
    properties: {
      id: {
        description: "组件标识",
        title: "标识",
        type: "string",
        readonly: !0
      },
      type: {
        description: "组件类型",
        title: "控件类型",
        type: "select",
        editor: {
          type: "waiting for modification",
          enum: []
        }
      }
    }
  }
}, Ia = {
  title: Oa,
  description: $a,
  type: Aa,
  categories: ja
}, Ae = {
  /**
   * 单选组枚举数组
   */
  enumData: { type: Array, default: [{ text: "1", active: !0 }] },
  /**
   * 后缀
   */
  suffixValue: { type: String, default: "" },
  /**
   * 返回值
   */
  onSelectedValueChanged: { type: Function, default: () => {
  } }
};
ae(Ae, Da, Sa, xa, Ia);
const La = /* @__PURE__ */ X({
  name: "FRadioButton",
  props: Ae,
  emits: ["selectedValueChanged"],
  setup(e, t) {
    const a = o(e.enumData);
    function n(s, c) {
      if (s.currentTarget.classList.value = "btn btn-secondary active", s.currentTarget.tagName.toLowerCase() === "label") {
        const {
          currentTarget: d
        } = s, m = d.parentElement;
        Array.from(m.querySelectorAll("label")).filter((v) => v !== d).forEach((v) => v.classList.remove("active"));
      }
      t.emit("selectedValueChanged", c);
    }
    function l(s) {
      return `${s.text}${e.suffixValue}`;
    }
    return z(() => e.enumData, (s, c) => {
      s !== c && (a.value = e.enumData);
    }), () => u("div", {
      class: "f-radio-button"
    }, [u("div", {
      class: ["farris-input-wrap"]
    }, [a.value.map((s, c) => u(ce, null, [u("label", {
      class: s.active ? "btn btn-secondary active" : "btn btn-secondary",
      onClick: (d) => n(d, s)
    }, [u("span", {
      class: "f-radio-button-text"
    }, [l(s)])])]))])]);
  }
}), Va = /* @__PURE__ */ new Map([
  ["appearance", ne]
]);
function za(e, t, a) {
  return t;
}
const Ha = "https://json-schema.org/draft/2020-12/schema", Pa = "https://farris-design.gitee.io/rate.schema.json", Na = "rate", Wa = "A Farris Component", qa = "object", Ua = {
  id: {
    description: "The unique identifier for rate",
    type: "string"
  },
  type: {
    description: "The type string of rate",
    type: "string",
    default: "rate"
  },
  appearance: {
    description: "",
    type: "object",
    properties: {
      class: {
        type: "string"
      },
      style: {
        type: "string"
      }
    },
    default: {}
  },
  binding: {
    description: "",
    type: "object",
    default: {}
  },
  disable: {
    type: "string",
    default: !1
  },
  editable: {
    description: "",
    type: "boolean",
    default: !0
  },
  placeholder: {
    description: "",
    type: "string",
    default: ""
  },
  readonly: {
    description: "",
    type: "boolean",
    default: !1
  },
  require: {
    description: "",
    type: "boolean",
    default: !1
  },
  tabindex: {
    description: "",
    type: "number",
    default: -1
  },
  visible: {
    description: "",
    type: "boolean",
    default: !0
  }
}, Ga = [
  "id",
  "type"
], Xa = [
  "id",
  "appearance",
  "binding"
], Ya = {
  $schema: Ha,
  $id: Pa,
  title: Na,
  description: Wa,
  type: qa,
  properties: Ua,
  required: Ga,
  ignore: Xa
}, _a = "rate", Ja = "A Farris Component", Qa = "object", Za = {
  basic: {
    description: "Basic Infomation",
    title: "基本信息",
    properties: {
      id: {
        description: "组件标识",
        title: "标识",
        type: "string",
        readonly: !0
      },
      type: {
        description: "组件类型",
        title: "控件类型",
        type: "select",
        editor: {
          type: "waiting for modification",
          enum: []
        }
      }
    }
  }
}, Ka = {
  title: _a,
  description: Ja,
  type: Qa,
  categories: Za
}, en = ["很不满意", "不满意", "一般", "满意", "非常满意"], je = {
  /** 星星大小 */
  size: { type: String, default: "large" },
  /** 启用半颗星模式 */
  enableHalf: { type: Boolean, default: !1 },
  /** 启用再次点击后清除 */
  enableClear: { type: Boolean, default: !1 },
  /** 只读 */
  disabled: { type: Boolean, default: !1 },
  /** 分制 */
  pointSystem: { type: Number, default: 5 },
  /** 星星亮色 */
  lightColor: { type: String, default: "" },
  /** 星星暗色（底色） */
  darkColor: { type: String, default: "" },
  /** 图案样式 */
  iconClass: { type: String, default: "f-icon-star" },
  /** 星星个数 */
  numOfStar: { type: Number, default: 5 },
  /** 禁用单个星星的文字提示 */
  toolTipDisabled: { type: Boolean, default: !0 },
  /** 默认的满意度文案 */
  toolTipContents: { type: Array, default: en },
  /** 启用评分 */
  enableScore: { type: Boolean, default: !0 },
  /** 启用满意度 */
  enableSatisfaction: { type: Boolean, default: !1 },
  /**
   * 绑定值
   */
  value: { type: Number, default: 0 },
  modelValue: { type: Number, default: 0 }
};
ae(je, Ya, Va, za, Ka);
const tn = /* @__PURE__ */ X({
  name: "FRate",
  props: je,
  emits: ["selectedValue", "update:modelValue"],
  setup(e, t) {
    const a = o(e.size), n = o(e.enableHalf), l = o(e.enableClear), s = o(e.disabled), c = o(e.pointSystem), d = o(e.lightColor), m = o(e.darkColor), r = o(e.iconClass), v = o(e.numOfStar), i = o(e.toolTipDisabled), f = o(e.toolTipContents), w = o(e.enableScore), x = o(e.enableSatisfaction);
    let R;
    const C = o(0), F = o(0), E = o(0), B = o(e.modelValue);
    let V = 1, D, L, p;
    const h = 4;
    Q(() => {
    });
    function g() {
      const b = v.value;
      p = [];
      for (let A = 1; A <= b; A++)
        p.push({
          id: A
        });
    }
    function y() {
      let b;
      n.value ? b = Math.ceil(B.value / V) : b = B.value, F.value = (R * B.value + Math.floor(B.value) * h) / V, D = f.value[b - 1];
    }
    function M() {
      switch (a.value) {
        case "small":
          R = 14;
          break;
        case "middle":
          R = 16;
          break;
        case "large":
          R = 18;
          break;
        case "extraLarge":
          R = 24;
          break;
      }
      g(), v.value && (V = c.value / v.value), B.value && y();
    }
    M();
    function j(b) {
      return b.className.indexOf("f-icon") !== -1;
    }
    function U() {
      return C.value === F.value && l.value && F.value !== 0 ? (F.value = 0, B.value = 0, L = null, C.value = 0, E.value = 0, t.emit("selectedValue", B.value), t.emit("update:modelValue", B.value), !0) : !1;
    }
    function k(b, A, I) {
      if (b.movementX || b.movementY) {
        if (s.value)
          return;
        x.value && (D = f.value[A - 1]), b.offsetX < R / 2 && n.value === !0 ? (C.value = R * A - R / 2 + h * (A - 1), E.value = V * A - V / 2) : (C.value = R * A + h * (A - 1), E.value = V * A);
      }
      if (I === !0) {
        if (U())
          return;
        B.value = E.value, F.value = C.value, L = D, t.emit("update:modelValue", B.value), t.emit("selectedValue", B.value);
      }
    }
    function $(b, A) {
      var I;
      if (j(b.target) && b.target) {
        const W = parseInt((I = b.target) == null ? void 0 : I.id);
        k(b, W, A);
      }
    }
    const P = O(() => E.value ? E.value + "分" : B.value + "分"), _ = O(() => ({
      width: (C.value || F.value) + "px"
    }));
    function T() {
      C.value = 0;
    }
    return z(() => e.modelValue, (b) => {
      B.value = b, y();
    }), () => u("div", {
      class: "farris-star-rating",
      onMouseover: oe((b) => $(b, !1), ["prevent"]),
      onMousemove: oe((b) => $(b, !1), ["prevent"]),
      onMouseleave: oe((b) => T(), ["prevent"]),
      onClick: oe((b) => $(b, !0), ["prevent"])
    }, [u("div", {
      class: "star-light-area",
      style: _.value
    }, [p.map((b) => u("span", {
      class: ["f-icon default-light-color ", r.value, {
        "f-star-sm": a.value === "small"
      }, {
        "f-star-md": a.value === "middle"
      }, {
        "f-star-lg": a.value === "large"
      }, {
        "f-star-exlarge": a.value === "extraLarge"
      }, {
        disabled: i.value
      }],
      id: b.id,
      style: {
        color: d.value
      }
    }, null))]), u("div", {
      class: ["star-dark-area", {
        small: a.value === "small"
      }, {
        middle: a.value === "middle"
      }, {
        large: a.value === "large"
      }]
    }, [p.map((b) => u("span", {
      class: ["f-icon default-dark-color", r.value, {
        "f-star-sm": a.value === "small"
      }, {
        "f-star-md": a.value === "middle"
      }, {
        "f-star-lg": a.value === "large"
      }, {
        "f-star-exlarge": a.value === "extraLarge"
      }],
      id: b.id,
      style: {
        color: m.value
      }
    }, null))]), u("div", {
      class: ["f-utils-fill", {
        "font-small": a.value === "small"
      }, {
        "font-middle": a.value === "middle"
      }, {
        "font-large": a.value === "large"
      }, {
        "font-exlarge": a.value === "extraLarge"
      }]
    }, [w.value && u("span", null, [G(" "), P.value, G(" ")]), x.value && (L || D) && u("span", null, [G(" "), D || L])])]);
  }
}), an = /* @__PURE__ */ X({
  name: "FColumnWidthEditor",
  props: Ca,
  emits: ["fieldChanged"],
  setup(e, t) {
    const a = {
      SM: ["1"],
      MD: ["1", "2"],
      LG: ["1", "2", "3", "4"],
      EL: ["1", "2", "3", "4", "5", "6"]
    }, n = o(e.currentScreenResolution), l = o(e.field), s = o(e.switchInStandardMode), c = o(), d = o(""), m = o(), r = o("customize"), v = o(), i = Be("ResponseLayoutEditorDraggableComposition"), {
      dragstart: f,
      dragenter: w,
      dragover: x,
      dragend: R
    } = i;
    function C() {
      c.value = a == null ? void 0 : a[n.value], s.value ? (d.value = `displayWidthIn${n.value}`, r.value = `${l.value[d.value]}`) : (d.value = `columnIn${n.value}`, v.value = l.value[d.value]);
    }
    function F(g) {
      if (s.value === !0) {
        const y = Number(g == null ? void 0 : g.text);
        m.value = y;
        const M = l.value[`columnIn${n.value}`] / l.value[`displayWidthIn${n.value}`];
        l.value[`columnIn${n.value}`] = y * M, l.value[`displayWidthIn${n.value}`] = Number(y), t.emit("fieldChanged", l.value);
      }
    }
    function E(g) {
      v.value = g;
      const y = l.value[`columnIn${n.value}`] / l.value[`displayWidthIn${n.value}`];
      l.value[`columnIn${n.value}`] = v.value, l.value[`displayWidthIn${n.value}`] = v.value / y, t.emit("fieldChanged", l.value);
    }
    function B() {
      return u(tn, {
        enableHalf: !0,
        size: "extraLarge",
        pointSystem: 12,
        numOfStar: 6,
        lightColor: "#5D89FE",
        darkColor: "#e7e9f3",
        iconClass: "f-icon-column-rectangle",
        modelValue: v.value,
        "onUpdate:modelValue": (g) => v.value = g,
        enableScore: !1,
        onSelectedValue: () => E(v.value)
      }, null);
    }
    function V() {
      const g = [];
      c.value = a == null ? void 0 : a[n.value];
      const y = l.value[`displayWidthIn${n.value}`];
      return c.value.forEach((M) => {
        const j = {
          text: M,
          active: y.toString() === M
        };
        g.push(j);
      }), g;
    }
    function D() {
      const g = V();
      return u(La, {
        enumData: g,
        suffixValue: "列",
        onSelectedValueChanged: F
      }, {
        default: () => [G(" ")]
      });
    }
    function L() {
      var g;
      if (((g = l == null ? void 0 : l.value) == null ? void 0 : g.showTopBorder) === 1)
        return u("div", {
          class: "f-layout-editor-column-width-editor-row"
        }, [u("span", {
          class: "f-layout-editor-column-width-editor-row-left"
        }, null), u("span", {
          class: "f-layout-editor-column-width-editor-row-middle"
        }, [G("第"), l.value.componentRow, G("行")]), u("span", {
          class: "f-layout-editor-column-width-editor-row-right"
        }, null)]);
    }
    function p() {
      return s.value ? u("div", {
        class: "f-column-width-editor-switch-standard"
      }, [u("div", {
        class: "f-layout-editor-column-width-editor-click-button"
      }, [D()])]) : u("div", {
        class: "f-column-width-editor-switch-customize",
        onDragenter: (g) => w(g, l.value),
        onDragend: (g) => R(g, l.value),
        onDragover: (g) => x(g)
      }, [u("div", {
        class: "f-layout-editor-column-width-editor-rectangle"
      }, [B(), u("div", {
        class: "f-layout-editor-rate-show-column"
      }, [v.value, G("列")]), u("span", {
        class: "f-layout-editor-drag-handler f-icon f-icon-drag-vertical",
        draggable: "true",
        onDragstart: (g) => f(g, l.value)
      }, null)])]);
    }
    function h() {
      var g, y;
      return u("div", {
        class: "f-layout-editor-column-width-editor-component"
      }, [u("div", {
        class: "f-layout-editor-column-width-editor-label",
        title: (g = l == null ? void 0 : l.value) == null ? void 0 : g.label
      }, [(y = l == null ? void 0 : l.value) == null ? void 0 : y.label]), p()]);
    }
    return z(() => [e.field, e.switchInStandardMode, e.currentScreenResolution], ([g, y, M], [j, U, k]) => {
      M !== k && (n.value = M, c.value = a[n.value], C()), y !== U && (s.value = y), s.value === !1 && C(), g !== j && (l.value = g);
    }), Q(() => {
      C();
    }), () => u("div", {
      class: "f-layout-editor-column-width-editor"
    }, [L(), h()]);
  }
}), nn = /* @__PURE__ */ X({
  name: "FFieldList",
  props: la,
  emits: ["update:currentArea", "twoDimensionalArrayChanged", "originalDataChanged"],
  setup(e, t) {
    const a = o(e.currentScreenResolution), n = o(e.switchInStandardMode), l = o(e.originalData), s = o(e.originalDataCopy), c = o(e.defaultStates), d = o(""), m = o([]), r = o(e.currentArea), v = o(0), i = o(), f = o(0), w = o("1"), x = o([]);
    function R() {
      const k = [];
      return l.value.forEach(($) => {
        k.indexOf($.group) === -1 && k.push($.group);
      }), k;
    }
    function C() {
      w.value = c.value.defaultGroupNumber.toString(), d.value = `区域${w.value}`, r.value = [m.value[Number(w.value) - 1]], t.emit("update:currentArea", r.value);
    }
    function F() {
      var $;
      const k = R();
      for (let P = 0; P < k.length; P++) {
        const _ = {
          id: ($ = k[P]) == null ? void 0 : $.toString(),
          label: "区域" + k[P]
        };
        m.value.push(_);
      }
      C();
    }
    function E() {
      let k = [];
      i.value = [];
      let $ = 1;
      l.value.forEach((P) => {
        P.group === $ || ($ += 1, i.value.push(k), k = []), k.push(P);
      }), i.value.push(k);
    }
    function B(k, $) {
      let _ = 12;
      return v.value = 1 + $, k.forEach((T) => {
        T.showTopBorder = 0;
        const b = T[`columnIn${a.value}`];
        _ >= b ? (T.componentRow = v.value, _ -= b) : (v.value += 1, T.componentRow = v.value, _ = 12 - b, T.showTopBorder = 1);
      }), k[0].showTopBorder = 1, k;
    }
    function V(k) {
      let $ = [];
      for (const P of k)
        $ = $.concat(P);
      l.value = J($), f.value = 0;
    }
    function D() {
      i.value[r.value[0].id - 1] = J(x.value);
      const k = [];
      f.value = 0, i.value.forEach(($) => {
        const P = B($, f.value);
        k.push(P), f.value = P[P.length - 1].componentRow;
      }), V(k);
    }
    function L() {
      E();
      const k = [];
      return f.value = 0, i.value.forEach(($) => {
        const P = B($, f.value);
        k.push(P), f.value = P[P.length - 1].componentRow;
      }), t.emit("twoDimensionalArrayChanged", i.value), V(k), l.value;
    }
    function p() {
      x.value = [], l.value.forEach((k) => {
        k.group === Number(r.value[0].id) && x.value.push(k);
      });
    }
    function h() {
      l.value = J(L()), t.emit("originalDataChanged", l.value);
    }
    function g(k) {
      x.value.forEach(($) => {
        $.id === k.id && Object.assign($, k);
      }), D(), h(), p();
    }
    function y(k) {
      for (let $ = 0; $ < k.length; $++)
        r.value = [{
          id: k[$].id,
          label: k[$].label
        }];
      t.emit("update:currentArea", r.value), p(), D();
    }
    function M() {
      return u("div", {
        class: "f-layout-editor-field-list-top"
      }, [u("div", {
        class: "f-layout-editor-field-list-header"
      }, [G("组件列表")]), u("div", {
        class: "f-layout-editor-choose-group"
      }, [u(wa, {
        modelValue: w.value,
        "onUpdate:modelValue": (k) => w.value = k,
        placeholder: "当前可编辑组",
        enableClear: !1,
        "id-field": "id",
        "text-field": "label",
        data: m.value,
        editable: !1,
        onChange: y
      }, null)])]);
    }
    function j() {
      return u("div", {
        class: "f-layout-editor-field-list-content f-utils-overflow-xhya"
      }, [x.value.map((k) => u(an, {
        key: k.label,
        currentScreenResolution: a.value,
        field: k,
        "onUpdate:field": ($) => k = $,
        switchInStandardMode: n.value,
        "onUpdate:switchInStandardMode": ($) => n.value = $,
        onFieldChanged: g
      }, null))]);
    }
    const U = oa(x, () => {
      D(), h(), p();
    });
    return ot("ResponseLayoutEditorDraggableComposition", U), z(() => e.currentArea, (k, $) => {
      k !== $ && (r.value = e.currentArea, p());
    }), z(r, (k, $) => {
      k !== $ && p();
    }), z(() => e.currentGroup, (k, $) => {
      k !== $ && (d.value = e.currentGroup);
    }), z(() => e.currentScreenResolution, (k, $) => {
      k !== $ && (a.value = e.currentScreenResolution, h(), E(), r.value[0] && (x.value = J(i.value[Number(r.value[0].id) - 1])));
    }), z(() => e.switchInStandardMode, (k, $) => {
      k !== $ && (n.value = e.switchInStandardMode, l.value = J(s.value));
    }), z(c, (k, $) => {
      k !== $ && h();
    }), re(() => {
      F(), L(), p();
    }), () => u("div", {
      class: "f-layout-editor-field-list f-utils-fill-flex-column"
    }, [n.value ? (
      /* 标准模式 */
      u("div", {
        class: "f-layout-editor-field-list-standard f-utils-fill-flex-column"
      }, [M(), j()])
    ) : (
      /* 自定义模式 */
      u("div", {
        class: "f-layout-editor-field-list-customize f-utils-fill-flex-column"
      }, [M(), j()])
    )]);
  }
}), se = /* @__PURE__ */ X({
  name: "FResponseLayoutEditor",
  props: pt,
  emits: ["close", "submit"],
  setup(e, t) {
    const a = o(e.initialState), n = o(), l = o(), s = o(""), c = o(""), d = o(!0), m = o([{
      id: "1",
      label: "区域1"
    }]), r = o([]), v = o();
    o(e.width), o(e.height), z(() => e.initialState, (p) => {
      a.value = p;
    }), z([() => e.currentArea, () => e.switchInStandardMode], ([p, h], [g, y]) => {
      p !== g && (m.value = p), h !== y && (d.value = h);
    });
    function i(p) {
      s.value = p;
    }
    function f(p) {
      c.value = p;
    }
    function w(p) {
      d.value = p;
    }
    function x(p) {
      m.value = [].concat(p);
    }
    function R(p) {
      n.value = J(p);
    }
    function C(p) {
      r.value = p;
    }
    function F() {
      t.emit("close");
    }
    function E() {
      t.emit("submit", n.value);
    }
    function B() {
      return u(nn, {
        class: "f-utils-fill-flex-column",
        defaultStates: l.value,
        originalDataCopy: v.value,
        currentScreenResolution: c.value,
        "onUpdate:currentScreenResolution": (p) => c.value = p,
        originalData: n.value,
        "onUpdate:originalData": (p) => n.value = p,
        switchInStandardMode: d.value,
        "onUpdate:switchInStandardMode": (p) => d.value = p,
        currentArea: m.value,
        "onUpdate:currentArea": (p) => m.value = p,
        onCurrentAreaChanged: x,
        onTwoDimensionalArrayChanged: C,
        onOriginalDataChanged: R
      }, null);
    }
    function V() {
      return u(na, {
        class: "f-utils-fill-flex-column",
        currentArea: m.value,
        "onUpdate:currentArea": (p) => m.value = p,
        currentScreenResolution: c.value,
        "onUpdate:currentScreenResolution": (p) => c.value = p,
        switchInStandardMode: d.value,
        twoDimensionalArray: r.value,
        "onUpdate:twoDimensionalArray": (p) => r.value = p
      }, null);
    }
    const D = O(() => d.value ? "f-layout-editor-left-standard f-utils-fill-flex-column" : "f-layout-editor-left-customize f-utils-fill-flex-column"), L = O(() => d.value ? "f-layout-editor-right-standard f-utils-fill-flex-column" : "f-layout-editor-right-customize f-utils-fill-flex-column");
    return re(() => {
      n.value = J(a.value.importData), v.value = J(a.value.importData), l.value = a.value.defaultState, s.value = "中等屏幕", c.value = "MD";
    }), (p) => u("div", {
      class: "f-layout-editor f-utils-flex-column"
    }, [u("div", {
      class: "f-layout-editor-top"
    }, [u(Kt, {
      defaultStates: l.value,
      onScreenNameChanged: i,
      onCurrentScreenResolutionChanged: f,
      onSwitchInStandardModeChanged: w
    }, null)]), u("div", {
      class: "f-layout-editor-content f-utils-fill"
    }, [u("div", {
      class: "f-layout-editor-left f-utils-fill-flex-column"
    }, [u("div", {
      class: D.value
    }, [B()])]), u("div", {
      class: "f-layout-editor-right f-utils-fill-flex-column"
    }, [u("div", {
      class: L.value
    }, [V()])])]), u("div", {
      class: "f-layout-editor-bottom"
    }, [u("div", {
      class: "f-layout-editor-button"
    }, [u("div", {
      class: "f-layout-editor-cancel-btn",
      onClick: F
    }, [u("span", {
      class: "f-layout-editor-text-cancel"
    }, [G("取消")])]), u("div", {
      class: "f-layout-editor-sure-btn",
      onClick: E
    }, [u("span", {
      class: "f-layout-editor-text-sure"
    }, [G("确认")])])])])]);
  }
}), ln = /* @__PURE__ */ new Map([
  ["appearance", ne]
]);
function on(e, t, a, n) {
  const l = e.getSchemaByType("section");
  return l.id = `${n}-section`, l.appearance = { class: "f-section-form f-section-in-main" }, l.mainTitle = "标题", l.contents = [t], l;
}
function un(e, t, a, n) {
  const l = e.getSchemaByType("component");
  return l.id = `${n}-component`, l.componentType = "form-col-1", l.appearance = {
    class: "f-struct-form f-struct-wrapper"
  }, l.contents = [t], l;
}
function sn(e, t, a) {
  t.appearance = { class: "f-form-layout farris-form farris-form-controls-inline" };
  const n = on(e, t, a, t.id);
  return un(e, n, a, t.id);
}
const rn = "https://json-schema.org/draft/2020-12/schema", cn = "https://farris-design.gitee.io/response-layout-editor-setting.schema.json", dn = "response-layout-editor-setting", fn = "A Farris Data Collection Component", vn = "object", mn = {
  id: {
    description: "The unique identifier for response layout editor",
    type: "string"
  },
  type: {
    description: "The type string of response layout editor component",
    type: "string",
    default: "response-layout-editor-setting"
  },
  initialState: {
    description: "",
    type: "object",
    default: {}
  },
  height: {
    description: "",
    type: "number",
    default: 0
  },
  width: {
    description: "",
    type: "number",
    default: 0
  },
  beforeOpen: {
    description: "",
    type: "function"
  }
}, pn = [
  "id",
  "type"
], hn = {
  $schema: rn,
  $id: cn,
  title: dn,
  description: fn,
  type: vn,
  properties: mn,
  required: pn
}, gn = "response-form", yn = "A Farris Component", bn = "object", wn = {
  basic: {
    description: "Basic Infomation",
    title: "基本信息",
    properties: {
      id: {
        description: "组件标识",
        title: "标识",
        type: "string",
        readonly: !0
      },
      type: {
        description: "组件类型",
        title: "控件类型",
        type: "select",
        editor: {
          type: "waiting for modification",
          enum: []
        }
      }
    }
  }
}, Cn = {
  title: gn,
  description: yn,
  type: bn,
  categories: wn
}, we = {
  /** 接受传入的原始数据的defaultState */
  initialState: { type: Object },
  /** 页面高度 */
  height: { type: Number, default: 0 },
  /** 页面宽度 */
  width: { type: Number, default: 0 },
  modelValue: { type: Object },
  /** 打开弹窗前进行校验 */
  beforeOpen: { type: Object }
}, Me = ae(we, hn, ln, sn, Cn), Sn = {
  /**
   * 允许点击遮罩关闭对话框
   */
  allowClickMaskToClose: { type: Boolean, default: !1 },
  /**
   * 关闭对话框前事件， 是个函数，返回true或者false
   */
  beforeClose: { type: Function, default: () => !0 },
  /**
   * 自定义类
   */
  class: { type: String, default: "" },
  /**
   * 自定义遮罩类
   */
  maskClass: { type: String, default: "" },
  /**
   * 模态框标题
   */
  title: { type: String, default: "" },
  /**
   * 模态框宽度
   */
  width: { type: Number, default: 500 },
  /**
   * 模态框高度
   */
  height: { type: Number, default: 320 },
  /**
   * 自定义按钮列表
    */
  buttons: {
    type: Array,
    default: []
  },
  /**
   * 是否展示模态框
   */
  modelValue: { type: Boolean, default: !1 },
  /**
   * 是否模态
   */
  mask: { type: Boolean, default: !0 },
  /**
   * 是否展示头部
   */
  showHeader: { type: Boolean, default: !0 },
  /**
   * 是否展示默认按钮
   */
  showButtons: { type: Boolean, default: !0 },
  /**
   * 是否启用自适应样式
   */
  fitContent: { type: Boolean, default: !0 },
  /**
   * 是否展示右上角按钮
   */
  showCloseButton: { type: Boolean, default: !0 },
  showMaxButton: { type: Boolean, default: !1 },
  minHeight: { type: Number },
  maxHeight: { type: Number },
  minWidth: { type: Number },
  maxWidth: { type: Number },
  containment: { type: Object, default: null },
  resizeable: { type: Boolean, default: !1 },
  draggable: { type: Boolean, default: !1 },
  dragHandle: { type: Object, default: null },
  closedCallback: { type: Function, default: null },
  resizeHandle: { type: Function, default: null },
  render: { type: Function, default: null },
  acceptCallback: { type: Function, default: null },
  rejectCallback: { type: Function, default: null },
  enableEsc: { type: Boolean, default: !0 },
  enableEnter: { type: Boolean, default: !1 },
  dialogType: { type: String, default: "" },
  src: { type: String, default: "" },
  footerHeight: { type: Number, default: 60 }
};
class q {
  constructor(t, a) {
    this.x = t, this.y = a;
  }
  static getTransformInfo(t) {
    const n = window.getComputedStyle(t).getPropertyValue("transform").replace(/[^-\d,]/g, "").split(",");
    if (n.length >= 6) {
      const l = parseInt(n[4], 10), s = parseInt(n[5], 10);
      return { x: l, y: s };
    }
    return { x: 0, y: 0 };
  }
  static fromEvent(t, a = null) {
    if (this.isMouseEvent(t))
      return new q(t.clientX, t.clientY);
    if (a === null || t.changedTouches.length === 1)
      return new q(t.changedTouches[0].clientX, t.changedTouches[0].clientY);
    for (let n = 0; n < t.changedTouches.length; n++)
      if (t.changedTouches[n].target === a)
        return new q(t.changedTouches[n].clientX, t.changedTouches[n].clientY);
  }
  static isMouseEvent(t) {
    return Object.prototype.toString.apply(t).indexOf("MouseEvent") === 8;
  }
  static isIPosition(t) {
    return !!t && "x" in t && "y" in t;
  }
  static getCurrent(t) {
    const a = new q(0, 0);
    if (window) {
      const n = window.getComputedStyle(t);
      if (n) {
        const l = parseInt(n.getPropertyValue("left"), 10), s = parseInt(n.getPropertyValue("top"), 10);
        a.x = isNaN(l) ? 0 : l, a.y = isNaN(s) ? 0 : s;
      }
      return a;
    }
    return null;
  }
  static copy(t) {
    return new q(0, 0).set(t);
  }
  get value() {
    return { x: this.x, y: this.y };
  }
  add(t) {
    return this.x += t.x, this.y += t.y, this;
  }
  subtract(t) {
    return this.x -= t.x, this.y -= t.y, this;
  }
  multiply(t) {
    this.x *= t, this.y *= t;
  }
  divide(t) {
    this.x /= t, this.y /= t;
  }
  reset() {
    return this.x = 0, this.y = 0, this;
  }
  set(t) {
    return this.x = t.x, this.y = t.y, this;
  }
}
class te {
  constructor(t, a) {
    this.width = t, this.height = a;
  }
  static getCurrent(t) {
    const a = new te(0, 0);
    if (window) {
      const n = window.getComputedStyle(t);
      return n && (a.width = parseInt(n.getPropertyValue("width"), 10), a.height = parseInt(n.getPropertyValue("height"), 10)), a;
    }
    return null;
  }
  static copy(t) {
    return new te(0, 0).set(t);
  }
  set(t) {
    return this.width = t.width, this.height = t.height, this;
  }
}
function xn(e, t) {
  const a = o(), n = o(), l = o(), s = o(), c = o(), d = o(), m = o(), r = o(), v = o(), i = o(), f = o(), w = o(e.resizeable), x = o(), R = o(e.draggable), C = o(!1);
  function F() {
    const T = n.value || document.body, b = window.getComputedStyle(T);
    if (!b || !a.value)
      return;
    const A = q.getTransformInfo(a.value), I = {};
    m.value && (I.deltaL = a.value.offsetLeft - m.value.x, I.deltaT = a.value.offsetTop - m.value.y);
    const W = b.getPropertyValue("position");
    I.width = T.clientWidth, I.height = T.clientHeight, I.pr = parseInt(b.getPropertyValue("padding-right"), 10), I.pb = parseInt(b.getPropertyValue("padding-bottom"), 10), I.position = b.getPropertyValue("position"), W === "static" && (T.style.position = "relative"), I.translateX = A.x, I.translateY = A.y, i.value = I;
  }
  function E(T) {
    if (a.value) {
      s.value = te.getCurrent(a.value), c.value = q.getCurrent(a.value), d.value = s.value ? te.copy(s.value) : null, m.value = c.value ? q.copy(c.value) : null, F();
      const b = T.target.getAttribute("type") || "";
      r.value = {
        n: !!b.match(/n/),
        s: !!b.match(/s/),
        w: !!b.match(/w/),
        e: !!b.match(/e/)
      };
    }
  }
  function B() {
    var T, b, A, I;
    if (a.value) {
      const W = a.value;
      r.value && ((r.value.n || r.value.s) && ((T = d.value) != null && T.height) && (W.style.height = d.value.height + "px"), (r.value.w || r.value.e) && ((b = d.value) != null && b.width) && (W.style.width = d.value.width + "px"), m.value && ((A = m.value) != null && A.x && (W.style.left = m.value.x + "px"), (I = m.value) != null && I.y && (W.style.top = m.value.y + "px")));
    }
  }
  function V() {
    const T = e.minHeight ? e.minHeight : 1, b = e.minWidth ? e.minWidth : 1;
    d.value && m.value && r.value && s.value && (d.value.height < T && (d.value.height = T, r.value.n && c.value && (m.value.y = c.value.y + (s.value.height - T))), d.value.width < b && (d.value.width = b, r.value.w && c.value && (m.value.x = c.value.x + (s.value.width - b))), e.maxHeight && d.value.height > e.maxHeight && (d.value.height = e.maxHeight, c.value && r.value.n && (m.value.y = c.value.y + (s.value.height - e.maxHeight))), e.maxWidth && d.value.width > e.maxWidth && (d.value.width = e.maxWidth, r.value.w && c.value && (m.value.x = c.value.x + (s.value.width - e.maxWidth))));
  }
  function D() {
    if (n.value) {
      const T = i.value;
      if (m.value && d.value && r.value && s.value) {
        const b = T.width - T.pr - T.deltaL - T.translateX - m.value.x, A = T.height - T.pb - T.deltaT - T.translateY - m.value.y;
        r.value.n && m.value.y + T.translateY < 0 && c.value && (m.value.y = -T.translateY, d.value.height = s.value.height + c.value.y + T.translateY), r.value.w && m.value.x + T.translateX < 0 && c.value && (m.value.x = -T.translateX, d.value.width = s.value.width + c.value.x + T.translateX), d.value.width > b && (d.value.width = b), d.value.height > A && (d.value.height = A);
      }
    }
  }
  function L(T) {
    if (!l.value || !s.value || !c.value || !r.value)
      return;
    T.subtract(l.value);
    const b = T.x, A = T.y;
    r.value.n ? (m.value.y = c.value.y + A, d.value.height = s.value.height - A) : r.value.s && (d.value.height = s.value.height + A), r.value.e ? d.value.width = s.value.width + b : r.value.w && (d.value.width = s.value.width - b, m.value.x = c.value.x + b), D(), V(), B();
  }
  function p(T) {
    if (!v.value)
      return;
    const b = q.fromEvent(T);
    b && L(b);
  }
  function h() {
    if (a.value) {
      const {
        width: T,
        height: b,
        x: A,
        y: I
      } = a.value.getBoundingClientRect(), W = q.getTransformInfo(a.value);
      return {
        size: {
          width: T,
          height: b
        },
        position: {
          x: A - W.x,
          y: I - W.y
        }
      };
    }
    return null;
  }
  function g(T) {
    if (a.value) {
      const b = h();
      f.value = b;
    }
    l.value = void 0, s.value = null, c.value = null, d.value = null, m.value = null, r.value = null, v.value = null, document.removeEventListener("mousemove", p), document.removeEventListener("mouseup", g);
  }
  function y() {
    document.addEventListener("mousemove", p), document.addEventListener("mouseup", g);
  }
  function M(T) {
    T instanceof MouseEvent && T.button === 2 || R.value && (document.body.click(), T.stopPropagation(), T.preventDefault(), l.value = q.fromEvent(T), v.value = T.target, E(T), y());
  }
  function j(T) {
    return a.value = T, w.value && u(ce, null, [u("div", {
      class: "fv-resizable-handle fv-resizable-n",
      type: "n",
      onMousedown: (b) => M(b)
    }, null), u("div", {
      class: "fv-resizable-handle fv-resizable-e",
      type: "e",
      onMousedown: (b) => M(b)
    }, null), u("div", {
      class: "fv-resizable-handle fv-resizable-s",
      type: "s",
      onMousedown: (b) => M(b)
    }, null), u("div", {
      class: "fv-resizable-handle fv-resizable-w",
      type: "w",
      onMousedown: (b) => M(b)
    }, null), u("div", {
      class: "fv-resizable-handle fv-resizable-ne",
      type: "ne",
      onMousedown: (b) => M(b)
    }, null), u("div", {
      class: "fv-resizable-handle fv-resizable-se fv-resizable-diagonal",
      type: "se",
      onMousedown: (b) => M(b)
    }, null), u("div", {
      class: "fv-resizable-handle fv-resizable-sw",
      type: "sw",
      onMousedown: (b) => M(b)
    }, null), u("div", {
      class: "fv-resizable-handle fv-resizable-nw",
      type: "nw",
      onMousedown: (b) => M(b)
    }, null)]);
  }
  function U(T = !0) {
    document.body.click();
    const b = n.value || document.body, A = te.getCurrent(b), I = a.value;
    T && I && (x.value = h(), x.value.transform = I.style.transform), A && I && (d.value = A, d.value.height -= 14, d.value.width -= 14, I.style.height = d.value.height + "px", I.style.width = d.value.width + "px", I.style.left = "7px", I.style.top = "7px", I.style.transform = "", f.value = {
      size: d.value,
      position: {
        x: 0,
        y: 0
      }
    }, R.value = !1, C.value = !0);
  }
  function k() {
    var T, b;
    if (document.body.click(), x.value) {
      const A = {
        width: x.value.size.width || 0,
        height: x.value.size.height || 0
      }, I = {
        x: (window.innerWidth - A.width) / 2,
        y: (window.innerHeight - A.height) / 2
      };
      (T = d.value) == null || T.set(A), (b = m.value) == null || b.set(I);
      const W = a.value;
      W.style.height = A.height + "px", W.style.width = A.width + "px", W.style.left = `${I.x}px`, W.style.top = `${I.y}px`, W.style.transform = "", f.value = {
        size: A,
        position: I
      }, R.value = e.draggable, C.value = !1;
    }
  }
  function $() {
    if (a.value) {
      const T = te.getCurrent(a.value);
      if (T) {
        const {
          width: b,
          height: A
        } = T;
        a.value.style.left = `${(window.innerWidth - b) / 2}px`, a.value.style.top = `${(window.innerHeight - A) / 2}px`, a.value.style.transform = "";
      }
    }
  }
  function P() {
    const T = () => {
      C.value ? U(!1) : $(), document.body.click();
    };
    return window.addEventListener("resize", T), () => {
      window.removeEventListener("resize", T);
    };
  }
  const _ = P();
  return {
    renderResizeBar: j,
    boundingElement: n,
    resizedEventParam: f,
    maximize: U,
    restore: k,
    allowDrag: R,
    isMaximized: C,
    unWindowResizeHandle: _
  };
}
function Mn(e, t, a) {
  const n = o(), l = o(e.draggable), s = o(e.lockAxis), c = o(), d = o(), m = o(!1), r = o(new q(0, 0)), v = o(new q(0, 0)), i = o(new q(0, 0)), f = o(new q(0, 0));
  z(() => a.value, (p) => {
    c.value.style.cursor = p ? "move" : "default";
  });
  function w(p, h) {
    if (h.tagName === "BUTTON")
      return !1;
    if (h === p)
      return !0;
    for (const g in h.children)
      if (Object.prototype.hasOwnProperty.call(h.children, g) && w(p, h.children[g]))
        return !0;
    return !1;
  }
  function x() {
    var y, M;
    let p = i.value.x + v.value.x, h = i.value.y + v.value.y;
    s.value === "x" ? (p = ((y = r.value) == null ? void 0 : y.x) || 0, i.value.x = 0) : s.value === "y" && (h = ((M = r.value) == null ? void 0 : M.y) || 0, i.value.y = 0);
    const g = `translate3d(${Math.round(p)}px, ${Math.round(h)}px, 0px)`;
    n.value && (n.value.style.transform = g), f.value.x = p, f.value.y = h;
  }
  function R() {
    if (!d.value || !n.value)
      return null;
    const p = d.value.getBoundingClientRect(), h = n.value.getBoundingClientRect(), g = {
      top: p.top < h.top,
      right: p.right > h.right,
      bottom: p.bottom > h.bottom,
      left: p.left < h.left
    };
    return g.top || (i.value.y -= h.top - p.top), g.bottom || (i.value.y -= h.bottom - p.bottom), g.right || (i.value.x -= h.right - p.right), g.left || (i.value.x -= h.left - p.left), x(), g;
  }
  function C(p) {
    p && (r.value && p.subtract(r.value), i.value.set(p), x(), R());
  }
  function F(p) {
    m.value && l.value && (p.stopPropagation(), p.preventDefault(), C(q.fromEvent(p, c.value)));
  }
  function E() {
    var p;
    m.value && (m.value = !1, v.value.add(i.value), i.value.reset(), (p = n.value) == null || p.classList.remove("ng-dragging"), t.emit("stopMove"), document.removeEventListener("mousemove", F), document.removeEventListener("mouseup", E));
  }
  function B() {
    !m.value && c.value && (m.value = !0, c.value.classList.add("ng-dragging"), document.addEventListener("mousemove", F), document.addEventListener("mouseup", E));
  }
  function V() {
    if (n.value) {
      const p = q.getTransformInfo(n.value);
      v.value.set(p);
      return;
    }
    v.value.reset();
  }
  function D(p) {
    if (!a.value || p instanceof MouseEvent && p.button === 2)
      return;
    const h = p.target || p.srcElement;
    c.value !== void 0 && h && !w(h, c.value) || l.value !== !1 && (document.body.click(), p.stopPropagation(), p.preventDefault(), r.value = q.fromEvent(p, n.value), V(), B());
  }
  function L(p, h, g) {
    if (l.value && h) {
      if (p)
        c.value = p;
      else if (e.dragHandle) {
        if (e.dragHandle instanceof HTMLElement)
          c.value = e.dragHandle;
        else if (typeof e.dragHandle == "string") {
          const y = h.querySelector(e.dragHandle);
          y && (c.value = y);
        }
      }
      n.value = h, d.value = g, c.value ? (c.value.classList.add("ng-draggable"), c.value.addEventListener("mousedown", D)) : l.value = !1;
    }
  }
  return {
    registerDraggle: L,
    resetTranslate: V
  };
}
function Ie(e, t) {
  if (e) {
    const a = (n) => {
      n.key.toLowerCase() === e.toLowerCase() && t({ event: n, key: e });
    };
    return document.addEventListener("keydown", a), () => {
      document.removeEventListener("keydown", a);
    };
  }
}
function Bn(e, t) {
  const a = o(e.enableEsc);
  let n = null;
  return a.value ? (n = Ie("Escape", (l) => {
    t.emit("esc", { event: l.event, type: "esc" });
  }), {
    remove: n
  }) : null;
}
function Tn(e, t) {
  const a = o(e.enableEnter);
  let n = null;
  return a.value ? (n = Ie("Enter", (l) => {
    t.emit("enter", { event: l.event, type: "enter" });
  }), {
    remove: n
  }) : null;
}
const le = /* @__PURE__ */ X({
  name: "FModal",
  props: Sn,
  emits: ["update:modelValue", "accept", "cancel", "closed", "resize", "esc", "enter", "stopMove"],
  setup(e, t) {
    const a = o(e.width || 300), n = o(e.height || 200), l = o(e.modelValue), s = o(""), c = o(e.class), d = o(e.fitContent), m = o(e.showHeader), r = o(""), v = o(e.showCloseButton), i = o(e.showMaxButton), f = o(!1), w = o(e.dialogType), x = o(e.src), R = o(""), C = o(e.showButtons), F = o(e.title), E = o(e.containment || null), B = o(), V = o(!1);
    function D(S, H) {
      Promise.resolve().then(() => {
        var Y;
        return (Y = e.beforeClose) == null ? void 0 : Y.call(e);
      }).then((Y) => {
        Y && (l.value = !1, t.emit("update:modelValue", !1), H != null && t.emit(H ? "accept" : "cancel"), t.emit("closed", S));
      });
    }
    const L = [{
      name: "cancel",
      text: "取消",
      class: "btn btn-secondary",
      handle: (S) => {
        D(S, !1);
      }
    }, {
      name: "accept",
      text: "确定",
      class: "btn btn-primary",
      handle: (S) => {
        D(S, !0);
      }
    }], p = o(e.buttons && e.buttons.length ? e.buttons : L), h = O(() => !!r.value), g = O(() => !!C.value && !!p.value), y = o(), M = o(), j = o(!1), {
      renderResizeBar: U,
      maximize: k,
      restore: $,
      boundingElement: P,
      resizedEventParam: _,
      allowDrag: T,
      unWindowResizeHandle: b
    } = xn(e), {
      registerDraggle: A
    } = Mn(e, t, T);
    function I() {
      return !!document.querySelectorAll(".farris-modal").length && document.body.classList.contains("modal-open");
    }
    function W() {
      const S = document.querySelectorAll(".farris-modal").length;
      (!S || S - 1 <= 0) && document.body.classList.remove("modal-open"), B.value && B.value.classList.remove("show");
    }
    z(() => e.title, (S, H) => {
      S !== H && (F.value = S);
    }), z(() => e.modelValue, (S, H) => {
      S !== H && (l.value = S, l.value && e.draggable && ue(() => {
        M.value && !E.value && (E.value = M.value.parentElement, P.value = E.value, A(y.value, M.value, P.value));
      }), S || (E.value && (E.value = null), W())), l.value && (V.value = I());
    }), z(() => e.showHeader, (S, H) => {
      S !== H && (m.value = S);
    }), z(() => e.showButtons, (S, H) => {
      S !== H && (C.value = S);
    }), z(() => _.value, (S, H) => {
      const Y = S || {}, K = H || {};
      JSON.stringify(Y) !== JSON.stringify(K) && t.emit("resize", {
        newSize: S,
        oldSize: H,
        isMaximized: j.value
      });
    });
    const fe = O(() => (l.value && document.body.classList.add("modal-open"), l.value)), Ve = O(() => {
      var Y;
      const S = {
        modal: !0,
        "farris-modal": !0,
        fade: !0
      };
      S["f-modal-fitContent"] = !!d.value, S.show = !!fe.value;
      const H = (Y = e.maskClass) == null ? void 0 : Y.split(" ");
      return H == null || H.reduce((K, pe) => (K[pe] = !0, K), S), S;
    }), ze = O(() => {
      var Y;
      const S = {
        "modal-dialog": !0
      }, H = (Y = c.value) == null ? void 0 : Y.split(" ");
      return H == null || H.reduce((K, pe) => (K[pe] = !0, K), S), S;
    }), He = O(() => {
      const S = {
        position: "absolute",
        top: `${(window.innerHeight - n.value) / 2}px`,
        left: `${(window.innerWidth - a.value) / 2}px`,
        width: `${a.value}px`,
        height: d.value ? "auto" : `${n.value}px`
      };
      return e.mask || (S.pointerEvents = "auto"), S;
    }), Pe = O(() => {
      const S = {
        display: "block"
      };
      return e.mask || (S.pointerEvents = "none", S.backgroundColor = "transparent"), V.value && (S.backgroundColor = "transparent"), S;
    }), Ne = O(() => ({
      "modal-content": !0,
      "modal-content-has-header": m.value
    })), We = O(() => {
      const S = {
        display: m.value ? "" : "none"
      };
      return S["pointer-events"] = T.value ? "auto" : "none", S;
    }), qe = O(() => ({
      "f-icon": !0,
      modal_maximize: !0,
      modalrevert: j.value
    })), Ue = O(() => ({
      "modal-body": !0,
      "f-utils-flex-column": w.value === "iframe",
      "f-utils-fill": !0
    }));
    function Ge() {
      return {
        height: `${e.footerHeight || 60}px`
      };
    }
    const Xe = O(() => {
      const S = {
        textAlgin: R.value
      }, H = Ge();
      return Object.assign(S, H);
    });
    function Se(S) {
      if (S.stopPropagation(), j.value) {
        j.value = !1, $();
        return;
      }
      k(), j.value = !0;
    }
    async function Ye(S, H) {
      S.handle && await S.handle(H, S) && t.emit("closed", H);
    }
    function _e(S) {
      S.width && (a.value = S.width), S.height && (n.value = S.height), S.buttons && (p.value = S.buttons), S.title && (F.value = S.title);
    }
    let ve = null, me = null;
    re(() => {
      V.value = I();
    }), Q(() => {
      M.value && !E.value && (E.value = M.value.parentElement, P.value = E.value, A(y.value, M.value, P.value)), fe.value && document.body.classList.add("modal-open"), ve = Bn(e, t), me = Tn(e, t);
    }), Te(() => {
      b && b(), ve && ve.remove(), me && me.remove();
    }), t.expose({
      modalElementRef: M,
      updateModalOptions: _e,
      close: D,
      maxDialog: Se,
      isMaximized: j
    });
    function Je() {
      return u("ul", null, [f.value && u("li", {
        class: "f-btn-icon f-bare"
      }, [u("span", {
        class: "f-icon modal_minimize"
      }, null)]), i.value && u("li", {
        onClick: Se,
        class: "f-btn-icon f-bare",
        style: "pointer-events: auto;"
      }, [u("span", {
        class: qe.value
      }, null)]), v.value && u("li", {
        class: "f-btn-icon f-bare",
        onClick: (S) => D(S, !1),
        style: "pointer-events: auto;"
      }, [u("span", {
        class: "f-icon modal_close"
      }, null)])]);
    }
    function Qe() {
      return u("div", {
        class: "modal-footer",
        style: Xe.value
      }, [p.value && p.value.map((S) => {
        const H = o(S.disabled);
        return u("button", {
          name: S.name,
          type: "button",
          disabled: H.value,
          class: S.class + (S.iconClass ? " btn-icontext" : ""),
          onClick: (Y) => {
            Ye(S, Y);
          }
        }, [!!S.iconClass && u("i", {
          class: S.iconClass
        }, null), S.text]);
      })]);
    }
    function Ze() {
      return u("div", {
        ref: y,
        class: "modal-header",
        style: We.value
      }, [t.slots.headerTemplate ? t.slots.headerTemplate() : u("div", {
        class: "modal-title"
      }, [h.value && u("span", {
        class: r.value,
        style: "margin-right: 8px"
      }, null), u("span", {
        class: "modal-title-label"
      }, [F.value])]), u("div", {
        class: "actions"
      }, [Je()])]);
    }
    function Ke() {
      return t.slots.footerTemplate ? t.slots.footerTemplate() : g.value && Qe();
    }
    function et(S) {
      if (S.stopPropagation(), e.allowClickMaskToClose) {
        if (S.target !== B.value)
          return;
        D(S, !1);
      }
    }
    function tt() {
      var S, H;
      return u("div", {
        id: s.value,
        class: ze.value,
        style: He.value,
        ref: M
      }, [u("div", {
        class: Ne.value
      }, [m.value && Ze(), u("div", {
        class: Ue.value
      }, [(H = (S = t.slots).default) == null ? void 0 : H.call(S), w.value === "iframe" && u("iframe", {
        title: s.value,
        class: "f-utils-fill",
        width: "100%",
        frameborder: "0",
        src: x.value
      }, null)]), Ke()]), !d.value && M.value && !j.value && U(M.value)]);
    }
    return () => u(it, {
      to: "body"
    }, {
      default: () => [fe.value && u(ut, {
        name: "fade",
        appear: !0
      }, {
        default: () => [u("div", {
          ref: B,
          class: Ve.value,
          style: Pe.value,
          onClick: et
        }, [tt()])]
      })]
    });
  }
});
function Le(e) {
  if (e.content && e.content.render)
    return e.content.render;
  if (e.render && typeof e.render == "function")
    return e.render;
}
function Fn(e) {
  const t = document.createElement("div");
  t.style.display = "contents";
  const a = rt({
    setup(n, l) {
      Te(() => {
        document.body.removeChild(t);
      });
      const s = o(), c = o(e.class || ""), d = o(!!e.showButtons), m = o(!!e.showHeader), r = o(e.showCloseButton == null ? !0 : e.showCloseButton), v = o(!0), i = o(e.title || ""), f = e.acceptCallback || (() => {
      }), w = e.rejectCallback || (() => {
      }), x = e.closedCallback || ((B) => {
      }), R = e.resizeHandle || ((B) => {
      }), C = e.stopMoveHandle || ((B) => {
      }), F = Le(e), E = (B) => {
        v.value = !1, a.unmount(), x(B);
      };
      return Q(() => {
      }), l.expose({
        modalRef: s
      }), () => u(le, {
        ref: s,
        class: c.value,
        modelValue: v.value,
        "onUpdate:modelValue": (B) => v.value = B,
        title: i.value,
        width: e.width,
        height: e.height,
        buttons: e.buttons,
        "show-header": m.value,
        "show-buttons": d.value,
        "show-close-button": r.value,
        "show-max-button": !1,
        onAccept: f,
        onCancel: w,
        fitContent: e.fitContent == null ? !0 : e.fitContent,
        onClosed: E,
        onResize: R,
        onStopMove: C
      }, {
        default: () => [F && F(a)]
      });
    }
  });
  return document.body.appendChild(t), a.mount(t), a;
}
class de {
  constructor(t) {
    N(this, "appContext", null);
    N(this, "modalRef", o());
    N(this, "activeModalIndex", o(0));
    N(this, "modalRefs", {});
    N(this, "isUseEscCloseModal", o(!1));
    N(this, "activeModalInstance", O(() => this.modalRefs[this.activeModalIndex.value]));
    this.app = t, this.appContext = t ? t._context : null;
  }
  getCurrentModal() {
    return this.activeModalInstance.value;
  }
  adaptToWindow(t, a) {
    const {
      width: n,
      height: l
    } = {
      width: window.innerWidth,
      height: window.innerHeight
    };
    return n < t && (t = n - 14), l < a && (a = l - 14), {
      width: t,
      height: a
    };
  }
  static show(t) {
    const a = Object.assign({
      title: "",
      showButtons: !0,
      showHeader: !0
    }, t);
    return Fn(a);
  }
  close(t) {
    var a, n;
    t ? (n = t.value) == null || n.close() : (a = this.getCurrentModal()) == null || a.close();
  }
  open(t) {
    const a = document.createDocumentFragment();
    t.showMaxButton && t.fitContent && (t.showMaxButton = !1);
    const n = st(Object.assign({
      title: "",
      showButtons: !0,
      showHeader: !0
    }, t)), l = o(!0), s = n.value.acceptCallback || (() => {
    }), c = n.value.rejectCallback || (() => {
    }), d = n.value.closedCallback || ((D, L) => {
    }), m = n.value.resizeHandle || ((D) => {
    }), r = t.stopMoveHandle || ((D) => {
    });
    let v;
    const i = Le(n.value), f = (D) => {
      var p;
      l.value = !1;
      const L = (p = D == null ? void 0 : D.target) == null ? void 0 : p.classList.contains("modal_close");
      d(D, this.isUseEscCloseModal.value ? "esc" : L ? "icon" : "button");
    }, w = (D) => {
      f(D), v && ue(() => {
        if (this.modalRefs[this.activeModalIndex.value] && delete this.modalRefs[this.activeModalIndex.value], he(null, a), v = null, this.modalRef.value = null, this.modalRefs) {
          const L = Object.keys(this.modalRefs).map((p) => Number(p));
          L.length > 0 ? this.activeModalIndex.value = Math.max(...L) : this.activeModalIndex.value = 0;
        }
        this.isUseEscCloseModal.value = !1;
      });
    }, x = (D) => {
      var L;
      this.isUseEscCloseModal.value = !0, this.activeModalInstance && ((L = this.activeModalInstance.value) == null || L.close(D == null ? void 0 : D.event));
    }, {
      width: R,
      height: C
    } = n.value, F = this.adaptToWindow(R || 500, C || 320);
    Object.assign(n.value, F);
    const E = () => u(le, Fe({
      ref: this.modalRef,
      modelValue: l.value,
      "onUpdate:modelValue": (D) => l.value = D
    }, n.value, {
      onAccept: s,
      onCancel: c,
      onClosed: w,
      onResize: m,
      onEsc: x,
      onStopMove: r
    }), {
      default: () => [i && i(this.app)]
    });
    return v = ((D) => {
      const L = ct(E, D);
      return L.appContext = this.appContext, he(L, a), L;
    })({
      ...n.value
      // 'onUpdate:modelValue': onUpdateModelValue,
    }), this.activeModalIndex.value++, this.modalRefs[this.activeModalIndex.value] = this.modalRef.value, {
      update: (D) => {
        n.value = {
          ...n.value,
          ...D
        }, v && he(dt(v, {
          ...n
        }), a);
      },
      destroy: w,
      modalRef: this.activeModalInstance,
      close: this.close
    };
  }
}
const kn = Symbol("FModalService");
le.install = (e) => {
  e.component(le.name, le);
  const t = new de(e);
  e.provide(kn, t), e.provide("FModalService", t);
};
function En(e, t, a) {
  var p;
  const n = "", l = "", s = o();
  function c() {
    return (t == null ? void 0 : t.schema.componentType) !== "frame";
  }
  function d() {
    return !1;
  }
  function m() {
    return (t == null ? void 0 : t.schema.componentType) !== "frame";
  }
  function r() {
    return (t == null ? void 0 : t.schema.componentType) === "frame";
  }
  function v(h) {
    if (!h || !h.value)
      return null;
    if (h.value.schema && h.value.schema.type === "component")
      return h.value;
    const g = o(h == null ? void 0 : h.value.parent), y = v(g);
    return y || null;
  }
  function i(h = t) {
    var j;
    const { componentInstance: g, designerItemElementRef: y } = h;
    if (!g || !g.value)
      return null;
    const { getCustomButtons: M } = g.value;
    return g.value.canMove || M && ((j = M()) != null && j.length) ? y : i(h.parent);
  }
  function f(h) {
    return !!a;
  }
  function w() {
    return (t == null ? void 0 : t.schema.label) || (t == null ? void 0 : t.schema.title) || (t == null ? void 0 : t.schema.name);
  }
  function x() {
  }
  function R(h, g) {
    var y;
    !h || !g || (y = t == null ? void 0 : t.setupContext) == null || y.emit("dragEnd");
  }
  function C(h, g) {
    const { componentType: y } = h;
    let M = Re(y, h, g);
    const j = y.toLowerCase().replace(/-/g, "_");
    return M && !M.id && M.type === y && (M.id = `${j}_${Math.random().toString().slice(2, 6)}`), M;
  }
  function F(h) {
  }
  function E(...h) {
  }
  function B(h) {
    if (!h)
      return;
    const g = t == null ? void 0 : t.schema, { formSchemaUtils: y } = h;
    if (g && y.getExpressions().length) {
      const M = y.getExpressions().findIndex((j) => j.target === g.id);
      M > -1 && y.getExpressions().splice(M, 1);
    }
  }
  function V(h) {
    B(h), t != null && t.schema.contents && t.schema.contents.map((g) => {
      let y = g.id;
      g.type === "component-ref" && (y = g.component);
      const M = e.value.querySelectorAll(`#${y}-design-item`);
      M != null && M.length && Array.from(M).map((j) => {
        var U;
        (U = j == null ? void 0 : j.componentInstance) != null && U.value.onRemoveComponent && j.componentInstance.value.onRemoveComponent(h);
      });
    });
  }
  function D() {
  }
  function L(h) {
  }
  return s.value = {
    canMove: c(),
    canSelectParent: d(),
    canDelete: m(),
    canNested: !r(),
    contents: t == null ? void 0 : t.schema.contents,
    elementRef: e,
    parent: (p = t == null ? void 0 : t.parent) == null ? void 0 : p.componentInstance,
    schema: t == null ? void 0 : t.schema,
    styles: n,
    designerClass: l,
    canAccepts: f,
    getBelongedComponentInstance: v,
    getDraggableDesignItemElement: i,
    getDraggingDisplayText: w,
    getPropConfig: E,
    getDragScopeElement: x,
    onAcceptMovedChildElement: R,
    onChildElementMovedOut: F,
    addNewChildComponentSchema: C,
    triggerBelongedComponentToMoveWhenMoved: o(!1),
    triggerBelongedComponentToDeleteWhenDeleted: o(!1),
    onRemoveComponent: V,
    getCustomButtons: D,
    onPropertyChanged: L
  }, s;
}
const Rn = /* @__PURE__ */ X({
  name: "FResponseLayoutEditorSettingDesign",
  props: we,
  emits: [],
  setup(e, t) {
    const a = o(e.initialState), n = o(e.width), l = o(e.height), s = o(), c = Be("design-item-context"), d = En(s, c);
    Q(() => {
      s.value.componentInstance = d;
    }), t.expose(d.value);
    function m() {
      const r = de.show({
        // title: '响应式列宽编辑器',
        render: () => u(se, {
          initialState: a,
          width: n,
          height: l
        }, null),
        width: 900,
        height: 500,
        buttons: [{
          class: "btn btn-primary",
          text: "确定",
          iconClass: "f-icon f-icon-check",
          handle: () => {
            r.destroy();
          }
        }, {
          class: "btn btn-light",
          text: "取消",
          iconClass: "f-icon f-icon-close",
          handle: () => {
            r.destroy();
          }
        }]
      });
    }
    return () => u("div", {
      ref: s,
      class: "f-column-width-setting-button",
      onClick: m
    }, [u("div", {
      class: "f-icon f-icon-add"
    }, null), u("div", {
      class: "f-column-width-setting-button-name"
    }, [u("span", {
      class: "f-column-width-setting-button-center"
    }, [G("高级设置")])])]);
  }
}), Dn = {
  width: { Type: Number, default: 400 },
  type: { Type: String, default: "info" },
  title: { Type: String, default: "" },
  detail: { Type: String, default: "" },
  okButtonText: { Type: String, default: "确定" },
  cancelButtonText: { Type: String, default: "取消" },
  exceptionInfo: { Type: Object, default: null },
  promptEditorType: { Type: String, default: "text-area" },
  buttons: { type: Object, default: [] }
};
function Ce() {
  return new DOMException("The request is not allowed", "NotAllowedError");
}
async function On(e) {
  if (!navigator.clipboard)
    throw Ce();
  return navigator.clipboard.writeText(e);
}
async function $n(e) {
  const t = document.createElement("span");
  t.textContent = e, t.style.whiteSpace = "pre", t.style.webkitUserSelect = "auto", t.style.userSelect = "all", document.body.appendChild(t);
  const a = window.getSelection(), n = window.document.createRange();
  a == null || a.removeAllRanges(), n.selectNode(t), a == null || a.addRange(n);
  let l = !1;
  try {
    l = window.document.execCommand("copy");
  } finally {
    a == null || a.removeAllRanges(), window.document.body.removeChild(t);
  }
  if (!l)
    throw Ce();
}
async function An(e) {
  try {
    await On(e);
  } catch (t) {
    try {
      await $n(e);
    } catch (a) {
      throw a || t || Ce();
    }
  }
}
function jn() {
  async function e(t) {
    await An(t);
  }
  return { onCopy: e };
}
function In(e, t, a, n) {
  const l = o(14), s = o(140), c = o(""), d = o(n.value.length), m = O(() => n.value), r = O(() => ({
    "font-size": `${l.value}px`,
    height: "100%"
  }));
  function v(i) {
    if (i.currentTarget) {
      const f = i.currentTarget.value || "";
      d.value = f.length;
    }
  }
  return () => u(ce, null, [u("textarea", {
    title: "promptMessage",
    name: "promptMessage",
    class: "form-control",
    style: r.value,
    rows: "4",
    maxlength: s.value,
    onInput: (i) => v(i)
  }, [m.value]), u("span", {
    class: "textarea-wordcount",
    title: c.value,
    style: "position: absolute; bottom: 76px; right: 32px; cursor: pointer; text-align: right;"
  }, [d.value + " / " + s.value])]);
}
function Ln(e, t, a, n) {
  const l = In(e, t, a, n), s = /* @__PURE__ */ new Map([["text-area", l]]);
  function c(d) {
    return s.get(d) || null;
  }
  return { getEditorRender: c };
}
function Vn() {
  const e = o(!1), t = o("复制成功");
  return {
    feedbackStyle: O(() => {
      const n = {
        position: "absolute",
        left: "50%",
        top: "50%",
        width: "100px",
        height: "40px",
        background: "#303C53",
        "line-height": "40px",
        "text-align": "center",
        "margin-left": "-30px",
        "margin-top": "-50px",
        "border-radius": "10px",
        "box-shadow": "0px 2px 8px 0px",
        color: "#fff",
        transition: "all .3s ease"
      };
      return n.opacity = e.value ? "0.8" : "0", n.display = e.value ? "" : "none", n;
    }),
    feedbackMessage: t,
    toShowFeedback: e
  };
}
function zn(e, t) {
  const a = t.getEditorRender(e.promptEditorType);
  return () => a && a();
}
function Hn(e) {
  const t = O(() => !!e.value && !!e.value.date), a = O(() => `发生时间 : ${e.value && e.value.date || ""}`), n = O(() => !!e.value && !!e.value.detail), l = O(() => "详细信息 : " + (e.value && e.value.detail || "")), s = "exp_switch_" + (/* @__PURE__ */ new Date()).getTime();
  return () => u("div", {
    class: "toast-msg-detail"
  }, [t.value && u("div", null, [a.value]), n.value && /* <div id="exception_error_msg" class="exception_error_msg" ref="exceptionMessageRef" style={exceptionMessageStyle.value}>
      <input type="checkbox" id="exp_switch" class="d-none exp_switch" />
      <div>详细信息:
          <label class="swith" for="exp_switch"></label>
          <span v-html={safeExceptionMessage.value}></span>
      </div>
  </div> */
  u("div", {
    class: "exception_wrap"
  }, [u("input", {
    type: "checkbox",
    id: s,
    class: "d-none exp_switch"
  }, null), u("div", {
    class: "exception_error_msg"
  }, [u("label", {
    class: "swith",
    htmlFor: s
  }, null), u("div", {
    innerHTML: l.value
  }, null)])])]);
}
function Pn(e) {
  return () => u("p", {
    class: "toast-msg-detail",
    innerHTML: e.value
  }, null);
}
function Nn(e, t, a, n) {
  const l = o(e.exceptionInfo), s = O(() => {
    const f = {
      "f-icon": !0
    }, w = `f-icon-${t.value}`;
    return f[w] = !0, f;
  }), c = O(() => a.value || l.value && l.value.message), d = O(() => n.value), m = O(() => !!n.value), r = O(() => !!l.value);
  function v() {
    return r.value ? Hn(l) : m.value ? Pn(d) : () => null;
  }
  const i = v();
  return () => u(ce, null, [u("div", {
    class: "float-left modal-tips-iconwrap"
  }, [u("span", {
    class: s.value
  }, null)]), u("div", {
    class: "modal-tips-content"
  }, [u("p", {
    class: "toast-msg-title",
    innerHTML: c.value
  }, null), i()])]);
}
function Wn(e, t, a) {
  const {
    onCopy: n
  } = t, {
    toShowFeedback: l
  } = a, s = o("复制成功"), c = o("复制详细信息"), d = o(e.exceptionInfo || {
    date: "",
    message: "",
    detail: ""
  }), m = O(() => d.value && d.value.detail || "");
  function r(v) {
    n(m.value).catch((i) => {
      s.value = "复制失败";
    }).finally(() => {
      l.value = !0, setTimeout(() => {
        l.value = !1;
      }, 700);
    });
  }
  return () => u("span", {
    style: "width: 100%;color: #2A87FF;padding-left: 37px;"
  }, [u("span", {
    onClick: r,
    style: "cursor: pointer;"
  }, [c.value])]);
}
function qn(e, t, a, n) {
  const l = o(e.type), s = o(e.buttons), c = o(e.exceptionInfo), d = o(e.okButtonText), m = o(e.cancelButtonText), r = o(!0), v = o(!0), i = O(() => !!(s.value && s.value.length)), f = O(() => c.value && c.value.date && c.value.message && c.value.detail), w = O(() => !(s.value && s.value.length) && (d.value || m.value)), x = O(() => v.value && d.value), R = O(() => r.value && m.value), C = Wn(e, a, n);
  function F(B) {
    l.value === "question" && t.emit("reject"), t.emit("close");
  }
  function E(B) {
    l.value === "question" && t.emit("accept"), t.emit("close");
  }
  return () => u("div", {
    class: "modal-footer"
  }, [f.value && C(), w.value && R.value && u("button", {
    type: "button",
    class: "btn btn-secondary btn-lg",
    onClick: F
  }, [m.value]), w.value && x.value && u("button", {
    type: "button",
    class: "btn btn-primary btn-lg",
    onClick: E
  }, [d.value]), i.value && s.value.length && s.value.map((B) => u("button", {
    type: "button",
    onClick: B.handle,
    class: B.class
  }, [B.iconClass && u("span", {
    class: B.iconClass
  }, null), B.text]))]);
}
const ie = /* @__PURE__ */ X({
  name: "FMessageBox",
  props: Dn,
  emits: ["accept", "reject", "close"],
  setup(e, t) {
    const a = o(e.type), n = o(e.title), l = o(e.detail), s = O(() => {
      const C = {
        "modal-tips": !0,
        "d-flex": !0,
        "flex-row": !0
      }, F = `messager-type-${a.value}`;
      return C[F] = !0, C;
    }), c = O(() => {
      const C = {};
      return a.value === "prompt" ? C.padding = "0.5rem 0.5rem 1rem 1.5rem" : a.value === "error" && (C.padding = "0.5rem 1.5rem 1rem 1.5rem"), C;
    }), d = jn(), m = Ln(e, a, n, l), r = Vn(), {
      feedbackStyle: v,
      feedbackMessage: i
    } = r;
    function f() {
      return u("div", {
        style: v.value
      }, [i.value]);
    }
    function w() {
      switch (a.value) {
        case "prompt":
          return zn(e, m);
        default:
          return Nn(e, a, n, l);
      }
    }
    const x = w(), R = qn(e, t, d, r);
    return () => u("div", {
      class: "farris-messager"
    }, [u("section", {
      class: s.value,
      style: c.value
    }, [x()]), R(), f()]);
  }
});
class Z {
  static show(t) {
    const a = ee({
      ...t
    }), n = !1, l = a.type === "error" || a.type === "prompt", s = a.type === "error" ? "错误提示" : a.type === "prompt" && a.title || "", c = a.acceptCallback || (() => {
    }), d = a.rejectCallback || (() => {
    });
    let m = null, r = new de(m);
    const v = () => {
      m && (m == null || m.destroy(), r = null);
    };
    return m = r == null ? void 0 : r.open({
      class: "modal-message modal-message-type-info",
      title: s,
      showButtons: n,
      showHeader: l,
      width: a.width || 400,
      fitContent: !0,
      showMaxButton: !1,
      draggable: !0,
      render: () => u(ie, Fe(a, {
        onAccept: c,
        onReject: d,
        onClose: v
      }), null)
    }), r == null ? void 0 : r.getCurrentModal();
  }
  static info(t, a) {
    const n = ee({
      type: "info",
      title: t,
      detail: a,
      okButtonText: "知道了",
      cancelButtonText: ""
    });
    Z.show(n);
  }
  static warning(t, a) {
    const n = ee({
      type: "warning",
      title: t,
      detail: a,
      okButtonText: "知道了",
      cancelButtonText: ""
    });
    Z.show(n);
  }
  static success(t, a) {
    const n = ee({
      type: "success",
      title: t,
      detail: a,
      okButtonText: "关闭",
      cancelButtonText: ""
    });
    Z.show(n);
  }
  static error(t, a, n) {
    const l = ee({
      width: 500,
      type: "error",
      okButtonText: "关闭",
      cancelButtonText: "",
      exceptionInfo: {
        date: n,
        message: t,
        detail: a
      }
    });
    Z.show(l);
  }
  static prompt(t, a) {
    const n = ee({
      type: "prompt",
      title: t,
      detail: a,
      okButtonText: "确定",
      cancelButtonText: "取消"
    });
    Z.show(n);
  }
  static question(t, a, n, l) {
    const s = ee({
      type: "question",
      title: t,
      detail: a,
      okButtonText: "确定",
      cancelButtonText: "取消",
      acceptCallback: n,
      rejectCallback: l
    });
    Z.show(s);
  }
}
ie.install = (e) => {
  e.component(ie.name, ie), e.provide("FMessageBoxService", Z);
};
const ge = /* @__PURE__ */ X({
  name: "FResponseLayoutEditorSetting",
  props: we,
  emits: ["change"],
  setup(e, t) {
    const a = o(e.initialState), n = o(e.width), l = o(e.height);
    z(() => e.initialState, (r) => {
      a.value = r;
    });
    function s(r, v) {
      a.value.importData = v, t.emit("change", v), r && r.unmount();
    }
    function c(r) {
      r && r.unmount();
    }
    function d() {
      if (e.width > 0 && e.width > 0)
        return;
      const r = document.documentElement.clientWidth, v = document.documentElement.clientHeight;
      l.value = v < 650 ? 500 : v > 1200 ? 840 : 630, n.value = r < 850 ? 900 : r > 1400 ? 1e3 : 890;
    }
    function m() {
      if (e.beforeOpen && typeof e.beforeOpen == "function" && (a.value = e.beforeOpen()), !a.value.defaultState || !a.value.importData) {
        const r = a.value.message || "只可以在响应式表单组件中调整响应式布局配置";
        Z.info(r, "");
        return;
      }
      d(), de.show({
        render: (r) => u(se, {
          initialState: a,
          onClose: () => c(r),
          onSubmit: (v) => s(r, v)
        }, null),
        width: n.value,
        height: l.value,
        fitContent: !1,
        showButtons: !1,
        showHeader: !1,
        showFloatingClose: !0
      });
    }
    return () => u("div", {
      class: "f-column-width-setting-button",
      onClick: m
    }, [u("i", {
      class: "f-icon f-icon-add"
    }, null), u("div", {
      class: "f-column-width-setting-button-name"
    }, [u("span", {
      class: "f-column-width-setting-button-center"
    }, [G("高级设置")])])]);
  }
});
class Jn {
  constructor() {
    /** 控件标题 */
    N(this, "label", "");
    /** 控件id */
    N(this, "id", "");
    /** 每个控件占用的栅格数 */
    N(this, "columnInSM", 12);
    N(this, "columnInMD", 6);
    N(this, "columnInLG", 3);
    N(this, "columnInEL", 2);
    /** 每个控件占用的列数 */
    N(this, "displayWidthInSM", 1);
    N(this, "displayWidthInMD", 1);
    N(this, "displayWidthInLG", 1);
    N(this, "displayWidthInEL", 1);
    /** 编辑器内部默认显示的屏幕大小-----可以去掉 */
    N(this, "displayColumnCountAtBreakPoint", "md");
    /** 控件所在行，传0即可-----编辑器内部使用 */
    N(this, "tagRow", 0);
    /** 控件是否显示上方空白：传0即可-----编辑器内部使用 */
    N(this, "showTopBorder", 0);
    /** 区域，从1开始。卡片内的控件从上往下，从左往右划分区域，遇到分组fieldSet时group+1，分组结束后group+1 */
    N(this, "group", 1);
    /** 控件是否符合标准的class配置(设计器用的) */
    N(this, "isSupportedClass", !0);
    /** 控件所在分组id(设计器用的) */
    N(this, "fieldSetId", "");
  }
}
const Qn = {
  install(e) {
    e.component(se.name, se), e.component(ge.name, ge);
  },
  register(e, t, a, n) {
    e["response-layout-editor-setting"] = ge, t["response-layout-editor-setting"] = Me;
  },
  registerDesigner(e, t, a) {
    e["response-layout-editor-setting"] = Rn, t["response-layout-editor-setting"] = Me;
  }
};
export {
  Jn as ResponseFormLayoutContext,
  se as ResponseLayoutEditor,
  ge as ResponseLayoutEditorSetting,
  Qn as default,
  pt as responseLayoutEditorProps
};
