import { ExtractPropTypes } from 'vue';
import { EventItem } from '../../types/common';
export declare const dayViewProps: {
    day: {
        Type: ObjectConstructor;
        default: {};
    };
    dayInWeek: {
        Type: StringConstructor;
        default: string;
    };
    enableMarkCurrent: {
        Type: BooleanConstructor;
        default: boolean;
    };
    events: {
        Type: {
            (arrayLength: number): EventItem[];
            (...items: EventItem[]): EventItem[];
            new (arrayLength: number): EventItem[];
            new (...items: EventItem[]): EventItem[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: never[];
    };
};
export type DayViewPropsType = ExtractPropTypes<typeof dayViewProps>;
