import { ExtractPropTypes } from 'vue';
export declare const hueProps: {
    color: {
        type: ObjectConstructor;
        default: string;
    };
    hue: {
        type: ObjectConstructor;
        default: string;
    };
    allowColorNull: {
        type: BooleanConstructor;
        default: boolean;
    };
    onChange: {
        type: FunctionConstructor;
    };
};
export type HueProps = ExtractPropTypes<typeof hueProps>;
