import { EditorType } from '../../../../dynamic-form';
import { ConditionValue } from "./types";
export declare class CheckBoxValue implements ConditionValue {
    editorType: EditorType;
    value: boolean[];
    valueType: string;
    constructor(initialData?: {
        value: any;
    });
    clear(): void;
    setValue(value: boolean[]): void;
    getValue(): boolean[];
    getDisplayText(): string;
    isEmpty(): boolean;
}
