import { EditorType } from '../../../../dynamic-form';
import { ConditionValue } from "./types";
type propsDateValue = {
    count: null | number;
    dateType: string;
    isFirstDay: boolean;
    isLastDay: boolean;
    name: string;
    period: string;
    text: string;
};
export declare class DatePickerValue implements ConditionValue {
    editorType: EditorType;
    value: string | propsDateValue | undefined;
    valueType: string;
    displayFormat: string;
    valueFormat: string;
    constructor(initialData?: {
        value: string | propsDateValue;
        displayFormat: string;
        valueFormat: string;
    });
    setValue(target: {
        formatted: string | propsDateValue;
    }): void;
    getValue(): string | propsDateValue | undefined;
    getDisplayText(): string | propsDateValue | undefined;
    isEmpty(): boolean;
    clear(): void;
}
export {};
