import { ConditionValue } from './types';
import { EditorType } from '../../../../dynamic-form';
export declare class InputGroupValue implements ConditionValue {
    editorType: EditorType;
    value: any;
    valueType: string;
    displayText: string;
    valueField: string;
    isInputText: boolean;
    constructor(initialData?: {
        value: string;
        displayText: string;
        displayField: string;
        isInputText: boolean;
    });
    clear(): void;
    getPropValue(item: any, fieldPath: Array<string>): any;
    getTextValue(targetField: string): string;
    getValue(): string;
    getDisplayText(): string;
    setValue(value: any): void;
    isEmpty(): boolean;
}
