import { EditorType } from '../../../../dynamic-form';
import { ConditionValue } from "./types";
export declare class LookupValue implements ConditionValue {
    editorType: EditorType;
    helpId: string;
    mapFields: any[];
    value: string;
    valueField: string;
    valueType: string;
    isInputText: boolean;
    constructor(initialData?: {
        mapFields: any[];
        value: any;
        valueField: string;
        isInputText: boolean;
        helpId: string;
    });
    clear(): void;
    getValue(): string;
    getDisplayText(): string;
    setValue(value: any): void;
    isEmpty(): boolean;
}
