import { EditorType } from '../../../../dynamic-form';
import { ConditionValue } from "./types";
export declare class MonthPickerValue implements ConditionValue {
    editorType: EditorType;
    value: string | undefined;
    valueType: string;
    constructor(initialData?: {
        value: string;
    });
    setValue(target: {
        formatted: string | undefined;
    }): void;
    getValue(): string | undefined;
    getDisplayText(): string | undefined;
    clear(): void;
    isEmpty(): boolean;
}
