import { EditorType } from '../../../../dynamic-form';
import { ConditionValue } from "./types";
export declare class NumberRangeValue implements ConditionValue {
    editorType: EditorType;
    begin: number | null;
    end: number | null;
    valueType: string;
    constructor(initialData?: {
        begin: string | number | null;
        end: string | number | null;
    });
    clear(): void;
    getValue(): {
        begin: number | null;
        end: number | null;
    };
    getDisplayText(): string;
    setValue(value: {
        begin: string | number | null;
        end: string | number | null;
    }): void;
    isEmpty(): boolean;
}
