import { BaseControlProperty } from '../../../property-panel/src/composition/entity/base-property';
export declare class DataGriColumnProperty extends BaseControlProperty {
    constructor(componentId: string, designerHostService: any);
    getPropertyConfig(propertyData: any, gridData: any): {
        type: string;
        categories: {};
    };
    getBasicPropConfig(propertyData: any): void;
    getAppearanceProperties(propertyData: any): void;
    private getFieldEditorProperties;
    /**
     * 列编辑器属性
     * @param propertyData 列属性值
     * @param viewModelId viewModelId
     */
    getFieldEditorProp(propertyData: any, showPosition?: string, isSimpleTable?: boolean): void;
    /**
     * datagrid field:列编辑器类型切换后事件
     * @param newControlType 新控件类型
     * @param viewModelId 视图模型ID
     */
    changeFieldEditorType(propertyData: any, newControlType: string): void;
    /**
     * 校验编辑器是否支持切换类型
     * @param control 控件
     */
    private checkCanChangeControlType;
    /**
     * 获取可选的编辑器类型
     */
    private getAvailableEditorType;
}
