import { ExtractPropTypes } from 'vue';
export declare const designerOutlineProps: {
    /** 树表数据 */
    data: {
        type: ObjectConstructor;
        default: never[];
    };
    /** 树表是否支持可选状态 */
    selectable: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 选中父节点会自动选中子节点 */
    autoCheckChildren: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 返回值展示父节点和子节点 */
    cascade: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否显示图标集 */
    showTreeNodeIcons: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否显示连接线 */
    showLines: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 新增值 */
    newDataItem: {
        type: ObjectConstructor;
        default: {};
    };
    /** 连接线颜色 */
    lineColor: {
        type: StringConstructor;
        default: string;
    };
    /** 单元格高度 */
    cellHeight: {
        type: NumberConstructor;
        default: number;
    };
};
export type DesignerOutlineProps = ExtractPropTypes<typeof designerOutlineProps>;
