import { SetupContext } from 'vue';
import { DiscussionEditorProps } from '../../discussion-editor.props';
export declare function useDiscussionEditor(props: DiscussionEditorProps, context: SetupContext): {
    personSearchUrl: import("vue").Ref<string, string>;
    personnelsDisplayKey: import("vue").Ref<string, string>;
    /** 搜索人事管理弹窗 */
    personModalVisible: import("vue").Ref<boolean, boolean>;
    relativeVisible: import("vue").Ref<boolean, boolean>;
    selectedPersonnels: any;
    stopBubble: (e: any) => void;
    _isInArray: (value: any, fieldInArray: string, array: any[]) => boolean;
    getSearchData: (text: string, pageIndex: number) => Promise<any>;
    getAvatar: (item: any) => any;
    setRelativeValue: () => void;
};
