import { ExtractPropTypes } from "vue";
export declare const dynamicFormLabelProps: {
    id: {
        type: StringConstructor;
    };
    required: {
        type: BooleanConstructor;
        default: boolean;
    };
    text: {
        type: StringConstructor;
        default: string;
    };
    title: {
        type: StringConstructor;
    };
    valid: {
        type: BooleanConstructor;
        default: boolean;
    };
    inValidTip: {
        type: StringConstructor;
        default: string;
    };
};
export type DynamicFormLabelProps = ExtractPropTypes<typeof dynamicFormLabelProps>;
