import { DesignerHostService } from '../../../designer-canvas/src/composition/types';
import { DynamicResolver } from '../../../../components/dynamic-resolver';
import { ComponentBuildInfo } from '../../../component/src/composition/inner-component-build-info';
/**
 * 创建卡片类组件服务类
 */
export declare class ResponseFormComponentCreatorService {
    private resolver;
    private designerHostService;
    private formSchemaUtils;
    private controlCreatorUtils;
    private designViewModelUtils;
    constructor(resolver: DynamicResolver, designerHostService: DesignerHostService);
    createComponent(buildInfo: ComponentBuildInfo): any;
    createComponentRefNode(buildInfo: ComponentBuildInfo): any;
    createComponentNode(buildInfo: ComponentBuildInfo): any;
    /**
     * 获取卡片组件层级的class样式
     */
    private getFormComponentClass;
    private createFormComponentContents;
    private resolveControlClassByFormColumns;
    /**
     * 添加viewModel节点
     */
    createViewModeNode(buildInfo: ComponentBuildInfo): any;
    /**
     * 组装viewModel fields 节点
     */
    private assembleViewModelFields;
}
