import { EntityBindingSelectorProps } from "../entity-binding-selector.props";
import { RowOptions } from "../../data-view";
export declare function useEntityTree(props: EntityBindingSelectorProps): {
    entityTreeGridRef: import("vue").Ref<any, any>;
    entityDataSource: import("vue").Ref<any, any>;
    resolveEntityDataSource: () => void;
    entityBindToMap: Map<string, string>;
    checkAndGetSelectedEntity: () => any;
    entityColumns: import("vue").Ref<{
        field: string;
        title: string;
    }[], {
        field: string;
        title: string;
    }[] | {
        field: string;
        title: string;
    }[]>;
    entityTreeRowOption: Partial<RowOptions>;
    initialSelectedEntity: import("vue").Ref<any, any>;
    isMainEntityInitialSelected: import("vue").Ref<boolean, boolean>;
};
