import { EventParameterProps } from "../event-parameter.props";
export declare function useGeneralEditor(props: EventParameterProps): {
    tabs: import("vue").Reactive<({
        id: string;
        title: string;
        treeConfigs: {
            id: string;
            columns: {
                field: string;
            }[];
            data: any;
            onSelectNode: () => void;
            componentRef: import("vue").Ref<any, any>;
        };
        visible: boolean;
    } | {
        id: string;
        title: string;
        treeConfigs: {
            id: string;
            data: any;
            columns?: undefined;
            onSelectNode?: undefined;
            componentRef?: undefined;
        };
        visible: boolean;
    })[]>;
    cleanTreeData: () => void;
};
