import type { App } from 'vue';
import FilterConditionEditor from './src/filter-condition-editor.component';
import ConditionActions from './src/components/filter-condition-actions.component';
export * from './src/filter-condition-editor.props';
export * from './src/composition/types';
export * from './src/composition/use-fields-tree';
export * from './src/composition/use-condition-data';
export * from './src/composition/use-condition-editor';
export * from './src/composition/use-constant-data';
export { FilterConditionEditor, ConditionActions };
declare const _default: {
    install(app: App): void;
    register(componentMap: Record<string, any>, propsResolverMap: Record<string, any>, configResolverMap: Record<string, any>, resolverMap: Record<string, any>): void;
};
export default _default;
