import { Ref } from "vue";
import { FilterConditionEditorProps } from '../filter-condition-editor.props';
export declare function useConditionData(props: FilterConditionEditorProps, conditions: Ref<any[]>): {
    displayText: import("vue").ComputedRef<any>;
    activeRowIndex: Ref<number, number>;
    canClear: import("vue").ComputedRef<boolean>;
    canMove: import("vue").ComputedRef<(direction?: 'up' | 'down') => boolean>;
    onAddFilter: () => void;
    onRemove: ({ index }: {
        index: any;
    }) => void;
    onInsert: ({ index }: {
        index: any;
    }) => void;
    onClear: () => void;
    onMoveTop: () => void;
    onMovePrev: () => void;
    onMoveNext: () => void;
    onMoveBottom: () => void;
    onSelectRow: ({ index }: {
        index: any;
    }) => void;
    validateCondition: () => true | {
        result: boolean;
        message: string;
    } | undefined;
    resetActiveRow: () => void;
};
