/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import FJsonEditor from './src/json-editor.component';
export * from './src/json-editor.props';
export { FJsonEditor };
declare const _default: {
    new (...args: any[]): import("vue").CreateComponentPublicInstanceWithMixins<Readonly<{
        modelValue: string;
        parameterDescriptors: import("./src/composition/types").ParameterDescriptor[];
        formContextData: import("./src/composition/types").FormContextData;
        beforeOpen: import("./src/json-editor.props").BeforeOpenFunction;
        dialogTitle: string;
        keyColumnTitle: string;
        valueColumnTitle: string;
        operationColumnTitle: string;
        keyColumnPlaceholder: string;
        valueColumnPlaceholder: string;
        addButtonText: string;
    }> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, import("vue").PublicProps, {
        modelValue: string;
        parameterDescriptors: import("./src/composition/types").ParameterDescriptor[];
        formContextData: import("./src/composition/types").FormContextData;
        beforeOpen: import("./src/json-editor.props").BeforeOpenFunction;
        dialogTitle: string;
        keyColumnTitle: string;
        valueColumnTitle: string;
        operationColumnTitle: string;
        keyColumnPlaceholder: string;
        valueColumnPlaceholder: string;
        addButtonText: string;
    }, true, {}, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, {}, any, import("vue").ComponentProvideOptions, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<{
        modelValue: string;
        parameterDescriptors: import("./src/composition/types").ParameterDescriptor[];
        formContextData: import("./src/composition/types").FormContextData;
        beforeOpen: import("./src/json-editor.props").BeforeOpenFunction;
        dialogTitle: string;
        keyColumnTitle: string;
        valueColumnTitle: string;
        operationColumnTitle: string;
        keyColumnPlaceholder: string;
        valueColumnPlaceholder: string;
        addButtonText: string;
    }> & Readonly<{}>, () => any, {}, {}, {}, {
        modelValue: string;
        parameterDescriptors: import("./src/composition/types").ParameterDescriptor[];
        formContextData: import("./src/composition/types").FormContextData;
        beforeOpen: import("./src/json-editor.props").BeforeOpenFunction;
        dialogTitle: string;
        keyColumnTitle: string;
        valueColumnTitle: string;
        operationColumnTitle: string;
        keyColumnPlaceholder: string;
        valueColumnPlaceholder: string;
        addButtonText: string;
    }>;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & import("vue").ComponentOptionsBase<Readonly<{
    modelValue: string;
    parameterDescriptors: import("./src/composition/types").ParameterDescriptor[];
    formContextData: import("./src/composition/types").FormContextData;
    beforeOpen: import("./src/json-editor.props").BeforeOpenFunction;
    dialogTitle: string;
    keyColumnTitle: string;
    valueColumnTitle: string;
    operationColumnTitle: string;
    keyColumnPlaceholder: string;
    valueColumnPlaceholder: string;
    addButtonText: string;
}> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {
    modelValue: string;
    parameterDescriptors: import("./src/composition/types").ParameterDescriptor[];
    formContextData: import("./src/composition/types").FormContextData;
    beforeOpen: import("./src/json-editor.props").BeforeOpenFunction;
    dialogTitle: string;
    keyColumnTitle: string;
    valueColumnTitle: string;
    operationColumnTitle: string;
    keyColumnPlaceholder: string;
    valueColumnPlaceholder: string;
    addButtonText: string;
}, {}, string, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, import("vue").ComponentProvideOptions> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & import("vue").Plugin;
export default _default;
