import { ExtractPropTypes } from 'vue';
export declare const editableComboProps: {
    /** 绑定值 */
    modelValue: {
        type: StringConstructor;
        default: string;
    };
    /** 下拉选项的数据源 */
    options: {
        type: ArrayConstructor;
        default: never[];
    };
    /** 下拉选项的ID字段 */
    idField: {
        type: StringConstructor;
        default: string;
    };
    /** 下拉选项的值字段 */
    valueField: {
        type: StringConstructor;
        default: string;
    };
    /** 下拉选项的名称字段 */
    textField: {
        type: StringConstructor;
        default: string;
    };
    /** 下拉选项的标题字段 */
    titleField: {
        type: StringConstructor;
        default: string;
    };
    /** 占位符 */
    placeholder: {
        type: StringConstructor;
        default: string;
    };
    /** 下拉图标 */
    dropDownIcon: {
        type: StringConstructor;
        default: string;
    };
    /** 是否在选中下拉选项后自动应用选项的值到输入框 */
    autoApply: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否在输入时自动根据当前值过滤选项 */
    filterOnType: {
        type: BooleanConstructor;
        default: boolean;
    };
};
export type EditableComboProps = ExtractPropTypes<typeof editableComboProps>;
