import { SetupContext } from 'vue';
import { JsonEditorProps } from '../json-editor.props';
import { UseParameters } from './types';
export declare function useDialog(props: JsonEditorProps, context: SetupContext, useParametersComposition: UseParameters): {
    modalConfigs: {
        title: string;
        width: number;
        height: number;
        fitContent: boolean;
        showHeader: boolean;
        showCloseButton: boolean;
        showMaxButton: boolean;
        resizeable: boolean;
        draggable: boolean;
        closedCallback: () => void;
        buttons: {
            class: string;
            text: string;
            handle: () => boolean;
        }[];
    };
    beforeOpenModalDialog: () => void;
    onClear: () => void;
    changeValue: (newValue: string) => void;
};
