import { ExtractPropTypes } from 'vue';
export declare const lookupFavoriteComponentProps: {
    multiSelect: {
        type: BooleanConstructor;
        default: boolean;
    };
    idField: {
        type: StringConstructor;
        default: string;
    };
    displayType: {
        type: StringConstructor;
        default: string;
    };
    selectedIds: {
        type: ArrayConstructor;
        default: never[];
    };
    showSelections: {
        type: BooleanConstructor;
        default: boolean;
    };
    treeToList: {
        type: BooleanConstructor;
        default: boolean;
    };
    enableFavorite: {
        type: BooleanConstructor;
        default: boolean;
    };
};
export type LookupFavoriteComponentProps = ExtractPropTypes<typeof lookupFavoriteComponentProps>;
