import { Reactive, Ref } from "vue";
import { LookupHttpResult, PagerInfoSate, QueryState, SearchState } from "./types";
import { LookupProps } from "../lookup.props";
export interface LookupStates {
    pageInfoState: Reactive<Partial<PagerInfoSate>>;
    lookupState: Reactive<LookupHttpResult>;
    navigationState: Reactive<LookupHttpResult>;
    queryState: Reactive<QueryState>;
    searchState: Reactive<SearchState>;
    selectionState: Ref<any[]>;
    unSelectDataId: Ref<any>;
    lookupOptions: Reactive<Partial<LookupProps>>;
}
export declare function useLookupState(props: LookupProps): LookupStates;
