import { ExtractPropTypes, PropType } from 'vue';
import { UseTreeGridCoordinator, TargetType } from '../composition/types';
export declare const modalContainerProps: {
    targetType: {
        type: PropType<TargetType>;
        default: string;
    };
    useTreeGridCoordinatorComposition: {
        type: PropType<UseTreeGridCoordinator>;
        default: {};
    };
};
export type ModalContainerProps = ExtractPropTypes<typeof modalContainerProps>;
