import { SetupContext } from 'vue';
import { MenuLookupProps } from '../menu-lookup.props';
import { UseTreeGridCoordinator } from './types';
export declare function useDialog(menuLookupProps: MenuLookupProps, context: SetupContext, useTreeGridCoordinatorComposition: UseTreeGridCoordinator): {
    modalConfigs: {
        title: string;
        width: number;
        height: number;
        fitContent: boolean;
        showHeader: boolean;
        showCloseButton: boolean;
        showMaxButton: boolean;
        resizeable: boolean;
        draggable: boolean;
        closedCallback: () => void;
        buttons: {
            class: string;
            text: string;
            handle: () => boolean;
        }[];
    };
    changeValue: (newValue: string, rawData?: any) => void;
    onClear: () => void;
};
