import { Ref } from 'vue';
import { TreeNode } from './types';
export declare function useTreeBuilder(allNodes: Ref<TreeNode[]>): {
    orderedTreeNodes: Ref<{
        [x: string]: any;
        id: string;
        parentId?: string | undefined;
        code?: string | undefined;
        name?: string | undefined;
        hasChildren?: boolean | undefined;
        layer?: number | undefined;
        collapse?: boolean | undefined;
    }[], TreeNode[] | {
        [x: string]: any;
        id: string;
        parentId?: string | undefined;
        code?: string | undefined;
        name?: string | undefined;
        hasChildren?: boolean | undefined;
        layer?: number | undefined;
        collapse?: boolean | undefined;
    }[]>;
    getLeafDescendants: (node: TreeNode, isLeafNode: (node: TreeNode) => boolean) => TreeNode[];
    getChildNodes: (node: TreeNode) => TreeNode[];
};
