import { type App } from "vue";
import { NotifyGlobalConfig, NotifyProps, ShowNotifyParams } from "./notify.props";
export default class NotifyService {
    notifyRefs: Array<any>;
    globalConfig: Partial<NotifyGlobalConfig>;
    escapeAllHtml(htmlString: string): string;
    private createNotifyInstance;
    private getNotifyInstances;
    private updateNotifyPositionForCreate;
    private updateNotifyPositionForClose;
    show(props: Partial<NotifyProps>): App;
    private buildNotifyProps;
    info(opts: ShowNotifyParams | string): App;
    success(opts: ShowNotifyParams | string): App;
    warning(opts: ShowNotifyParams | string): App;
    error(opts: ShowNotifyParams | string): App;
    close(notifyApp: App): void;
    closeAll(): void;
}
