import { FieldConfig } from '../../../../condition';
export declare function useSolutionValidation(schemaService: any): {
    checkAndUpdateSolutionConfig: (fieldsSource: FieldConfig[], presetFieldsSource: FieldConfig[]) => {
        fields: {
            id: string;
            code: string;
            labelCode: string;
            controlType?: "" | import("../../../../dynamic-form").EditorType | undefined;
            name: string;
            $type?: string | undefined;
            $typeInfo?: any;
            editor: {
                [x: string]: any;
                type: import("../../../../dynamic-form").EditorType;
                customClass?: string | undefined;
                disabled?: boolean | undefined;
                readonly?: boolean | undefined;
                required?: boolean | undefined;
                placeholder?: string | undefined;
            };
            defaulValue?: {
                clear: () => void;
                editorType: import("../../../../dynamic-form").EditorType;
                value?: any;
                valueField?: string | undefined;
                mapFields?: any[] | undefined;
                begin?: any;
                end?: any;
                valueType: string;
                helpId?: string | undefined;
                displayFormat?: string | undefined;
                valueFormat?: string | undefined;
                enumValueType?: string | undefined;
                valueList?: {
                    value: string | number | boolean;
                    name: string;
                }[] | undefined;
                getValue: () => any;
                getDisplayText: () => any;
                setValue: (value: any) => void;
                isEmpty: () => boolean;
            } | undefined;
            isInValid?: boolean | undefined;
        }[];
        presetFields: {
            id: string;
            code: string;
            labelCode: string;
            controlType?: "" | import("../../../../dynamic-form").EditorType | undefined;
            name: string;
            $type?: string | undefined;
            $typeInfo?: any;
            editor: {
                [x: string]: any;
                type: import("../../../../dynamic-form").EditorType;
                customClass?: string | undefined;
                disabled?: boolean | undefined;
                readonly?: boolean | undefined;
                required?: boolean | undefined;
                placeholder?: string | undefined;
            };
            defaulValue?: {
                clear: () => void;
                editorType: import("../../../../dynamic-form").EditorType;
                value?: any;
                valueField?: string | undefined;
                mapFields?: any[] | undefined;
                begin?: any;
                end?: any;
                valueType: string;
                helpId?: string | undefined;
                displayFormat?: string | undefined;
                valueFormat?: string | undefined;
                enumValueType?: string | undefined;
                valueList?: {
                    value: string | number | boolean;
                    name: string;
                }[] | undefined;
                getValue: () => any;
                getDisplayText: () => any;
                setValue: (value: any) => void;
                isEmpty: () => boolean;
            } | undefined;
            isInValid?: boolean | undefined;
        }[];
    };
};
