export interface ResponseToolbarClickEvent {
    id: string;
    text: string;
    hidden: boolean;
}
export type DesignResponseToolbarItem = {
    id: string;
    children?: Array<DesignResponseToolbarItem>;
    class: string;
    dropdownClass?: string;
    text: string;
    disabled: boolean | object;
    icon?: string;
    isDP?: boolean;
    isDPItem?: boolean;
    expanded?: boolean;
    menuClass?: string;
};
export interface ResponseToolbarItemActionHandler {
    clearAllDropdown: (event?: MouseEvent) => void;
    toggleDropdownMenu: (item: any, status: any) => void;
    updateToolbarItems: () => void;
    changeSelectedId: (id: any) => void;
    renderDropdownMenu: (item: any, parent?: any) => any;
    toolbarContext: any;
    changeMenuPosition: (item: any, buttonElement: Element | null, parent?: DesignResponseToolbarItem) => any;
}
