import { ComputedRef } from "vue";
export declare class ResponseToolbarItemBase {
    /** 工具栏项标识 */
    id: string;
    /** 工具栏项自定义样式 */
    class: string;
    /** 图标 */
    icon: string;
    /** 所属分组 */
    groupId: string;
    /** 收藏顺序 */
    order: number;
    /** 是否作为下拉菜单的顶层按钮 */
    asDropDownTop: boolean;
    /** 文本 */
    text: string;
    /** 是否可用 */
    get enable(): ComputedRef<boolean>;
    /** 是否可见原值 */
    visible: boolean;
    /** 控制界面是否显示 */
    shown: boolean;
    responsed: boolean;
    /** 是否启用提示消息 */
    tipsEnable: boolean;
    /** 提示消息内容 */
    tipsText: string;
    /** 记录宽度 */
    width: number;
    /** 下拉时的样式名 */
    dropdownClass: string;
    onClick: ($event: MouseEvent, itemId: string) => void;
    options: Record<string, any>;
    [index: string]: any;
    constructor(item: Record<string, any>);
    /** 设置宽度 */
    setWidth(value: string): void;
    /** 获取宽度 */
    getWidth(): any;
}
