import { ExtractPropTypes } from "vue";
export declare const searchBoxContainerProps: {
    data: {
        type: {
            (arrayLength: number): any[];
            (...items: any[]): any[];
            new (arrayLength: number): any[];
            new (...items: any[]): any[];
            isArray(arg: any): arg is any[];
            readonly prototype: any[];
            from<T>(arrayLike: ArrayLike<T>): T[];
            from<T_1, U>(arrayLike: ArrayLike<T_1>, mapfn: (v: T_1, k: number) => U, thisArg?: any): U[];
            from<T_2>(iterable: Iterable<T_2> | ArrayLike<T_2>): T_2[];
            from<T_3, U_1>(iterable: Iterable<T_3> | ArrayLike<T_3>, mapfn: (v: T_3, k: number) => U_1, thisArg?: any): U_1[];
            of<T_4>(...items: T_4[]): T_4[];
            readonly [Symbol.species]: ArrayConstructor;
        };
        default: never[];
    };
    /** 确认结果事件 */
    onConfirmResult: {
        type: FunctionConstructor;
        default: () => void;
    };
    /** 搜索点击后返回值 */
    onSearchedValue: {
        type: FunctionConstructor;
        default: () => void;
    };
    /**
   * 可选，数据源id字段
   * 默认为`id`
   */
    idField: {
        default: string;
        type: StringConstructor;
    };
    /**
    * 可选，数据源的title
    * 默认为`name`
    */
    textField: {
        default: string;
        type: StringConstructor;
    };
    /**
   * 可选，最大高度
   * 默认`350`
   */
    maxHeight: {
        default: number;
        type: NumberConstructor;
    };
    loading: {
        default: boolean;
        type: BooleanConstructor;
    };
};
export type SearchBoxContainerProps = ExtractPropTypes<typeof searchBoxContainerProps>;
