import { ExtractPropTypes } from 'vue';
export type StepDirectionType = 'horizontal' | 'vertical';
export type StepStatus = 'active' | 'finish' | '';
export interface Step {
    id: string;
    class: string;
    description: string;
    disable: boolean;
    icon: string;
    title: string;
    status: StepStatus;
}
export declare const stepProps: Record<string, any>;
export type StepProps = ExtractPropTypes<typeof stepProps>;
export declare const propsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
