import { ExtractPropTypes } from 'vue';
export interface Tag {
    name: string;
    checked?: boolean;
    closable?: boolean;
    color?: string;
    selectable?: boolean;
    size?: string;
    tagType?: string;
    value?: string;
}
export type TagStyleType = 'default' | 'capsule';
export declare const tagsProps: Record<string, any>;
export type TagsProps = ExtractPropTypes<typeof tagsProps>;
export declare const propsResolver: (schemaValue?: Record<string, any>, mergeDefaults?: boolean) => Record<string, any>;
