/**
 * Copyright (c) 2020 - present, Inspur Genersoft Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import type { Plugin } from 'vue';
import FTooltip from './src/tooltip.component';
import FTooltipDirective from './src/tooltip.directive';
export * from './src/tooltip.props';
export { FTooltip, FTooltipDirective };
declare const _default: {
    new (...args: any[]): import("vue").CreateComponentPublicInstanceWithMixins<Readonly<{
        placement: import("./src/tooltip.props").TooltipPlacement;
        content: string;
        trigger: import("./src/tooltip.props").TooltipTriggerMode;
        horizontalRelative: string;
        verticalRelative: string;
        clickToHide: boolean;
        enable: boolean;
        overflowShown: boolean;
        customClass?: string | undefined;
        width?: string | undefined;
        reference?: Record<string, any> | undefined;
        contentTemplate?: Record<string, any> | undefined;
    }> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, import("vue").PublicProps, {
        placement: import("./src/tooltip.props").TooltipPlacement;
        content: string;
        trigger: import("./src/tooltip.props").TooltipTriggerMode;
        horizontalRelative: string;
        verticalRelative: string;
        clickToHide: boolean;
        enable: boolean;
        overflowShown: boolean;
    }, true, {}, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, {}, any, import("vue").ComponentProvideOptions, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<{
        placement: import("./src/tooltip.props").TooltipPlacement;
        content: string;
        trigger: import("./src/tooltip.props").TooltipTriggerMode;
        horizontalRelative: string;
        verticalRelative: string;
        clickToHide: boolean;
        enable: boolean;
        overflowShown: boolean;
        customClass?: string | undefined;
        width?: string | undefined;
        reference?: Record<string, any> | undefined;
        contentTemplate?: Record<string, any> | undefined;
    }> & Readonly<{}>, () => any, {}, {}, {}, {
        placement: import("./src/tooltip.props").TooltipPlacement;
        content: string;
        trigger: import("./src/tooltip.props").TooltipTriggerMode;
        horizontalRelative: string;
        verticalRelative: string;
        clickToHide: boolean;
        enable: boolean;
        overflowShown: boolean;
    }>;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & import("vue").ComponentOptionsBase<Readonly<{
    placement: import("./src/tooltip.props").TooltipPlacement;
    content: string;
    trigger: import("./src/tooltip.props").TooltipTriggerMode;
    horizontalRelative: string;
    verticalRelative: string;
    clickToHide: boolean;
    enable: boolean;
    overflowShown: boolean;
    customClass?: string | undefined;
    width?: string | undefined;
    reference?: Record<string, any> | undefined;
    contentTemplate?: Record<string, any> | undefined;
}> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {
    placement: import("./src/tooltip.props").TooltipPlacement;
    content: string;
    trigger: import("./src/tooltip.props").TooltipTriggerMode;
    horizontalRelative: string;
    verticalRelative: string;
    clickToHide: boolean;
    enable: boolean;
    overflowShown: boolean;
}, {}, string, {}, import("vue").GlobalComponents, import("vue").GlobalDirectives, string, import("vue").ComponentProvideOptions> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & Plugin;
export default _default;
