import { Ref, SetupContext } from 'vue';
import { TreeViewProps } from '../../tree-view.props';
import { UseCellPosition, UseColumn, UseDataView, UseEdit, UseHierarchy, UseRow, UseSelectHierarchyItem, UseSelection, UseVirtualScroll, UseVisualData, UseVisualDataBound, VisualData } from '../../../../data-view';
/** 渲染树状区域 */
export default function (props: TreeViewProps, context: SetupContext, visibleDatas: Ref<VisualData[]>, useCellPositionComposition: UseCellPosition, useColumnComposition: UseColumn, useDataViewComposition: UseDataView, useEditComposition: UseEdit, useHierarchyComposition: UseHierarchy, useRowComposition: UseRow, useSelectionComposition: UseSelection, useSelectHierarchyItemComposition: UseSelectHierarchyItem, useVirtualScrollComposition: UseVirtualScroll, useVisualDataComposition: UseVisualData, useVisualDataBoundComposition: UseVisualDataBound, primaryGridContentRef: Ref<any>): {
    renderTreeArea: () => any;
};
