import FUploader from './src/uploader.component';
import { IUploadServer, UploadInput, UploadOutput, UploadFile, UploadServerAPI, FUploadFileExtend } from './src/composition/type';
export * from './src/uploader.props';
export { FUploader, UploadServerAPI };
export type { IUploadServer, UploadOutput, UploadInput, UploadFile, FUploadFileExtend };
declare const _default: {
    new (...args: any[]): import("vue").CreateComponentPublicInstanceWithMixins<Readonly<{
        [x: string]: any;
    }> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, import("vue").PublicProps, {
        [x: string]: any;
    }, true, {}, {}, {
        'f-upload-progress': import("vue").DefineComponent<{
            maxWidth: number;
            showInfo: boolean;
            status: import("./src/components/sub-component.props").UploadProgressStatusType;
            percent: number;
        }, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").PublicProps, Readonly<{
            maxWidth: number;
            showInfo: boolean;
            status: import("./src/components/sub-component.props").UploadProgressStatusType;
            percent: number;
        }> & Readonly<{}>, {
            maxWidth: number;
            showInfo: boolean;
            status: import("./src/components/sub-component.props").UploadProgressStatusType;
            percent: number;
        }, {}, {}, {}, string, import("vue").ComponentProvideOptions, true, {}, any>;
        'f-preview-checkbox': import("vue").DefineComponent<{
            id: string;
            disabled: boolean;
            checked: boolean;
        }, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, "checkedChange"[], "checkedChange", import("vue").PublicProps, Readonly<{
            id: string;
            disabled: boolean;
            checked: boolean;
        }> & Readonly<{
            onCheckedChange?: ((...args: any[]) => any) | undefined;
        }>, {
            id: string;
            disabled: boolean;
            checked: boolean;
        }, {}, {}, {}, string, import("vue").ComponentProvideOptions, true, {}, any>;
        'f-file-select': import("vue").DefineComponent<{
            disabled: boolean;
            accept: string;
            options: import("./src/composition/type").UploaderOptions;
            selectText: string;
            enableMulti: boolean;
            uploadedCount: number;
            extendConfig: Record<string, any>;
            uploadServerToken: string;
        }, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").PublicProps, Readonly<{
            disabled: boolean;
            accept: string;
            options: import("./src/composition/type").UploaderOptions;
            selectText: string;
            enableMulti: boolean;
            uploadedCount: number;
            extendConfig: Record<string, any>;
            uploadServerToken: string;
        }> & Readonly<{}>, {
            disabled: boolean;
            accept: string;
            options: import("./src/composition/type").UploaderOptions;
            selectText: string;
            enableMulti: boolean;
            uploadedCount: number;
            extendConfig: Record<string, any>;
            uploadServerToken: string;
        }, {}, {}, {}, string, import("vue").ComponentProvideOptions, true, {}, any>;
    } & import("vue").GlobalComponents, import("vue").GlobalDirectives, string, {}, any, import("vue").ComponentProvideOptions, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<{
        [x: string]: any;
    }> & Readonly<{}>, () => any, {}, {}, {}, {
        [x: string]: any;
    }>;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & import("vue").ComponentOptionsBase<Readonly<{
    [x: string]: any;
}> & Readonly<{}>, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, "filePreviewEvent" | "fileDownloadEvent" | "previewMultiSelectedEvent" | "selectedEvent" | "fileRemoveEvent" | "fileRemovedEvent" | "fUploadDoneEvent" | "uploadDoneEvent", {
    [x: string]: any;
}, {}, string, {}, {
    'f-upload-progress': import("vue").DefineComponent<{
        maxWidth: number;
        showInfo: boolean;
        status: import("./src/components/sub-component.props").UploadProgressStatusType;
        percent: number;
    }, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").PublicProps, Readonly<{
        maxWidth: number;
        showInfo: boolean;
        status: import("./src/components/sub-component.props").UploadProgressStatusType;
        percent: number;
    }> & Readonly<{}>, {
        maxWidth: number;
        showInfo: boolean;
        status: import("./src/components/sub-component.props").UploadProgressStatusType;
        percent: number;
    }, {}, {}, {}, string, import("vue").ComponentProvideOptions, true, {}, any>;
    'f-preview-checkbox': import("vue").DefineComponent<{
        id: string;
        disabled: boolean;
        checked: boolean;
    }, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, "checkedChange"[], "checkedChange", import("vue").PublicProps, Readonly<{
        id: string;
        disabled: boolean;
        checked: boolean;
    }> & Readonly<{
        onCheckedChange?: ((...args: any[]) => any) | undefined;
    }>, {
        id: string;
        disabled: boolean;
        checked: boolean;
    }, {}, {}, {}, string, import("vue").ComponentProvideOptions, true, {}, any>;
    'f-file-select': import("vue").DefineComponent<{
        disabled: boolean;
        accept: string;
        options: import("./src/composition/type").UploaderOptions;
        selectText: string;
        enableMulti: boolean;
        uploadedCount: number;
        extendConfig: Record<string, any>;
        uploadServerToken: string;
    }, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").PublicProps, Readonly<{
        disabled: boolean;
        accept: string;
        options: import("./src/composition/type").UploaderOptions;
        selectText: string;
        enableMulti: boolean;
        uploadedCount: number;
        extendConfig: Record<string, any>;
        uploadServerToken: string;
    }> & Readonly<{}>, {
        disabled: boolean;
        accept: string;
        options: import("./src/composition/type").UploaderOptions;
        selectText: string;
        enableMulti: boolean;
        uploadedCount: number;
        extendConfig: Record<string, any>;
        uploadServerToken: string;
    }, {}, {}, {}, string, import("vue").ComponentProvideOptions, true, {}, any>;
} & import("vue").GlobalComponents, import("vue").GlobalDirectives, string, import("vue").ComponentProvideOptions> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & import("vue").Plugin;
export default _default;
